      subroutine acload
      implicit double precision (a-h,o-z)
c
c     this routine zeroes-out and then loads the complex coefficient
c     matrix
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      complex cval
c
c  zero y matrix and current vector
c
      call zero8(value(lvn+1),nstop+nttbr)
      call zero8(value(imvn+1),nstop+nttbr)
c
c  resistors
c
      loc=locate(1)
   20 if ((loc.eq.0).or.(nodplc(loc+8).ne.0)) go to 30
      locv=nodplc(loc+1)
      val=value(locv+1)
      locy=lynl+nodplc(loc+6)
      value(locy)=value(locy)+val
      locy=lynl+nodplc(loc+7)
      value(locy)=value(locy)+val
      locy=lynl+nodplc(loc+4)
      value(locy)=value(locy)-val
      locy=lynl+nodplc(loc+5)
      value(locy)=value(locy)-val
      loc=nodplc(loc)
      go to 20
c
c  capacitors
c
   30 loc=locate(2)
   40 if ((loc.eq.0).or.(nodplc(loc+12).ne.0)) go to 50
      locv=nodplc(loc+1)
      val=omega*value(locv+1)
      locyi=imynl+nodplc(loc+10)
      value(locyi)=value(locyi)+val
      locyi=imynl+nodplc(loc+11)
      value(locyi)=value(locyi)+val
      locyi=imynl+nodplc(loc+5)
      value(locyi)=value(locyi)-val
      locyi=imynl+nodplc(loc+6)
      value(locyi)=value(locyi)-val
      loc=nodplc(loc)
      go to 40
c
c  inductors
c
   50 loc=locate(3)
   60 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 70
      locv=nodplc(loc+1)
      val=omega*value(locv+1)
      locyi=imynl+nodplc(loc+13)
      locy=lynl+nodplc(loc+13)
      value(locy)=0.0d0
      value(locyi)=-val
      locy=lynl+nodplc(loc+6)
      locyi=imynl+nodplc(loc+6)
      value(locy)=1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+7)
      locyi=imynl+nodplc(loc+7)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+8)
      locyi=imynl+nodplc(loc+8)
      value(locy)=1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+9)
      locyi=imynl+nodplc(loc+9)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      loc=nodplc(loc)
      go to 60
c
c  mutual inductors
c
   70 loc=locate(4)
   80 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 90
      locv=nodplc(loc+1)
      val=omega*value(locv+1)
      locy=lynl+nodplc(loc+4)
      locyi=imynl+nodplc(loc+4)
      value(locy)=0.0d0
      value(locyi)=-val
      locy=lynl+nodplc(loc+5)
      locyi=imynl+nodplc(loc+5)
      value(locy)=0.0d0
      value(locyi)=-val
      loc=nodplc(loc)
      go to 80
c
c  nonlinear voltage controlled current sources
c
   90 loc=locate(5)
   95 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 100
      ndim=nodplc(loc+4)
      lmat=nodplc(loc+7)
      loct=lx0+nodplc(loc+12)+2
      do 97 i=1,ndim
      val=value(loct)
      loct=loct+2
      locy=lynl+nodplc(lmat+1)
      value(locy)=value(locy)+val
      locy=lynl+nodplc(lmat+2)
      value(locy)=value(locy)-val
      locy=lynl+nodplc(lmat+3)
      value(locy)=value(locy)-val
      locy=lynl+nodplc(lmat+4)
      value(locy)=value(locy)+val
      lmat=lmat+4
   97 continue
      loc=nodplc(loc)
      go to 95
c
c  nonlinear voltage controlled voltage sources
c
  100 loc=locate(6)
  105 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 110
      ndim=nodplc(loc+4)
      lmat=nodplc(loc+8)
      loct=lx0+nodplc(loc+13)+3
      locy=lynl+nodplc(lmat+1)
      locyi=imynl+nodplc(lmat+1)
      value(locy)=+1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(lmat+2)
      locyi=imynl+nodplc(lmat+2)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(lmat+3)
      locyi=imynl+nodplc(lmat+3)
      value(locy)=+1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(lmat+4)
      locyi=imynl+nodplc(lmat+4)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      lmat=lmat+4
      do 107 i=1,ndim
      val=value(loct)
      loct=loct+2
      locy=lynl+nodplc(lmat+1)
      value(locy)=value(locy)-val
      locy=lynl+nodplc(lmat+2)
      value(locy)=value(locy)+val
      lmat=lmat+2
  107 continue
      loc=nodplc(loc)
      go to 105
c
c  nonlinear current controlled current sources
c
  110 loc=locate(7)
  115 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 120
      ndim=nodplc(loc+4)
      lmat=nodplc(loc+7)
      loct=lx0+nodplc(loc+12)+2
      do 117 i=1,ndim
      val=value(loct)
      loct=loct+2
      locy=lynl+nodplc(lmat+1)
      locyi=imynl+nodplc(lmat+1)
      value(locy)=+val
      value(locyi)=0.0d0
      locy=lynl+nodplc(lmat+2)
      locyi=imynl+nodplc(lmat+2)
      value(locy)=-val
      value(locyi)=0.0d0
      lmat=lmat+2
  117 continue
      loc=nodplc(loc)
      go to 115
c
c  nonlinear current controlled voltage sources
c
  120 loc=locate(8)
  125 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 140
      ndim=nodplc(loc+4)
      lmat=nodplc(loc+8)
      loct=lx0+nodplc(loc+13)+3
      locy=lynl+nodplc(lmat+1)
      locyi=imynl+nodplc(lmat+1)
      value(locy)=+1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(lmat+2)
      locyi=imynl+nodplc(lmat+2)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(lmat+3)
      locyi=imynl+nodplc(lmat+3)
      value(locy)=+1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(lmat+4)
      locyi=imynl+nodplc(lmat+4)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      lmat=lmat+4
      do 127 i=1,ndim
      val=value(loct)
      loct=loct+2
      locy=lynl+nodplc(lmat+i)
      value(locy)=value(locy)-val
  127 continue
      loc=nodplc(loc)
      go to 125
c
c  voltage sources
c
  140 loc=locate(9)
  150 if ((loc.eq.0).or.(nodplc(loc+11).ne.0)) go to 160
      locv=nodplc(loc+1)
      iptr=nodplc(loc+6)
      value(lvn+iptr)=value(locv+2)
      value(imvn+iptr)=value(locv+3)
      locy=lynl+nodplc(loc+7)
      value(locy)=value(locy)+1.0d0
      locy=lynl+nodplc(loc+8)
      value(locy)=value(locy)-1.0d0
      locy=lynl+nodplc(loc+9)
      value(locy)=value(locy)+1.0d0
      locy=lynl+nodplc(loc+10)
      value(locy)=value(locy)-1.0d0
      loc=nodplc(loc)
      go to 150
c
c  current sources
c
  160 loc=locate(10)
  170 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 200
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      value(lvn+node1)=value(lvn+node1)-value(locv+2)
      value(imvn+node1)=value(imvn+node1)-value(locv+3)
      value(lvn+node2)=value(lvn+node2)+value(locv+2)
      value(imvn+node2)=value(imvn+node2)+value(locv+3)
      loc=nodplc(loc)
      go to 170
c
c  diodes
c
  200 loc=locate(11)
  210 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 250
      locv=nodplc(loc+1)
      area=value(locv+1)
      locm=nodplc(loc+5)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+11)
      gspr=value(locm+2)*area
      geq=value(loct+2)
      xceq=value(loct+4)*omega
      locy=lynl+nodplc(loc+13)
      value(locy)=value(locy)+gspr
      locy=lynl+nodplc(loc+14)
      locyi=imynl+nodplc(loc+14)
      value(locy)=value(locy)+geq
      value(locyi)=value(locyi)+xceq
      locy=lynl+nodplc(loc+15)
      locyi=imynl+nodplc(loc+15)
      value(locy)=value(locy)+geq+gspr
      value(locyi)=value(locyi)+xceq
      locy=lynl+nodplc(loc+7)
      value(locy)=value(locy)-gspr
      locy=lynl+nodplc(loc+8)
      locyi=imynl+nodplc(loc+8)
      value(locy)=value(locy)-geq
      value(locyi)=value(locyi)-xceq
      locy=lynl+nodplc(loc+9)
      value(locy)=value(locy)-gspr
      locy=lynl+nodplc(loc+10)
      locyi=imynl+nodplc(loc+10)
      value(locy)=value(locy)-geq
      value(locyi)=value(locyi)-xceq
      loc=nodplc(loc)
      go to 210
c
c  bjts
c
  250 loc=locate(12)
  260 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 300
      locv=nodplc(loc+1)
      area=value(locv+1)
      locm=nodplc(loc+8)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+22)
      gcpr=value(locm+20)*area
      gepr=value(locm+19)*area
      gpi=value(loct+4)
      gmu=value(loct+5)
      gm=value(loct+6)
      go=value(loct+7)
      xgm=0.0d0
      td=value(locm+28)
      if(td.eq.0.0d0) go to 270
      arg=td*omega
      gm=gm+go
      xgm=-gm*dsin(arg)
      gm=gm*dcos(arg)-go
  270 gx=value(loct+16)
      xcpi=value(loct+9)*omega
      xcmu=value(loct+11)*omega
      xcbx=value(loct+15)*omega
      xccs=value(loct+13)*omega
      xcmcb=value(loct+17)*omega
      locy=lynl+nodplc(loc+24)
      value(locy)=value(locy)+gcpr
      locy=lynl+nodplc(loc+25)
      locyi=imynl+nodplc(loc+25)
      value(locy)=value(locy)+gx
      value(locyi)=value(locyi)+xcbx
      locy=lynl+nodplc(loc+26)
      value(locy)=value(locy)+gepr
      locy=lynl+nodplc(loc+27)
      locyi=imynl+nodplc(loc+27)
      value(locy)=value(locy)+gmu+go+gcpr
      value(locyi)=value(locyi)+xcmu+xccs+xcbx
      locy=lynl+nodplc(loc+28)
      locyi=imynl+nodplc(loc+28)
      value(locy)=value(locy)+gx+gpi+gmu
      value(locyi)=value(locyi)+xcpi+xcmu+xcmcb
      locy=lynl+nodplc(loc+29)
      locyi=imynl+nodplc(loc+29)
      value(locy)=value(locy)+gpi+gepr+gm+go
      value(locyi)=value(locyi)+xcpi+xgm
      locy=lynl+nodplc(loc+10)
      value(locy)=value(locy)-gcpr
      locy=lynl+nodplc(loc+11)
      value(locy)=value(locy)-gx
      locy=lynl+nodplc(loc+12)
      value(locy)=value(locy)-gepr
      locy=lynl+nodplc(loc+13)
      value(locy)=value(locy)-gcpr
      locy=lynl+nodplc(loc+14)
      locyi=imynl+nodplc(loc+14)
      value(locy)=value(locy)-gmu+gm
      value(locyi)=value(locyi)-xcmu+xgm
      locy=lynl+nodplc(loc+15)
      locyi=imynl+nodplc(loc+15)
      value(locy)=value(locy)-gm-go
      value(locyi)=value(locyi)-xgm
      locy=lynl+nodplc(loc+16)
      value(locy)=value(locy)-gx
      locy=lynl+nodplc(loc+17)
      locyi=imynl+nodplc(loc+17)
      value(locy)=value(locy)-gmu
      value(locyi)=value(locyi)-xcmu-xcmcb
      locy=lynl+nodplc(loc+18)
      locyi=imynl+nodplc(loc+18)
      value(locy)=value(locy)-gpi
      value(locyi)=value(locyi)-xcpi
      locy=lynl+nodplc(loc+19)
      value(locy)=value(locy)-gepr
      locy=lynl+nodplc(loc+20)
      locyi=imynl+nodplc(loc+20)
      value(locy)=value(locy)-go
      value(locyi)=value(locyi)+xcmcb
      locy=lynl+nodplc(loc+21)
      locyi=imynl+nodplc(loc+21)
      value(locy)=value(locy)-gpi-gm
      value(locyi)=value(locyi)-xcpi-xgm-xcmcb
      locyi=imynl+nodplc(loc+31)
      value(locyi)=value(locyi)+xccs
      locyi=imynl+nodplc(loc+32)
      value(locyi)=value(locyi)-xccs
      locyi=imynl+nodplc(loc+33)
      value(locyi)=value(locyi)-xccs
      locyi=imynl+nodplc(loc+34)
      value(locyi)=value(locyi)-xcbx
      locyi=imynl+nodplc(loc+35)
      value(locyi)=value(locyi)-xcbx
      loc=nodplc(loc)
      go to 260
c
c  jfets
c
  300 loc=locate(13)
  310 if ((loc.eq.0).or.(nodplc(loc+25).ne.0)) go to 350
      locv=nodplc(loc+1)
      area=value(locv+1)
      locm=nodplc(loc+7)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+19)
      gdpr=value(locm+4)*area
      gspr=value(locm+5)*area
      gm=value(loct+5)
      gds=value(loct+6)
      ggs=value(loct+7)
      xgs=value(loct+9)*omega
      ggd=value(loct+8)
      xgd=value(loct+11)*omega
      locy=lynl+nodplc(loc+20)
      value(locy)=value(locy)+gdpr
      locy=lynl+nodplc(loc+21)
      locyi=imynl+nodplc(loc+21)
      value(locy)=value(locy)+ggd+ggs
      value(locyi)=value(locyi)+xgd+xgs
      locy=lynl+nodplc(loc+22)
      value(locy)=value(locy)+gspr
      locy=lynl+nodplc(loc+23)
      locyi=imynl+nodplc(loc+23)
      value(locy)=value(locy)+gdpr+gds+ggd
      value(locyi)=value(locyi)+xgd
      locy=lynl+nodplc(loc+24)
      locyi=imynl+nodplc(loc+24)
      value(locy)=value(locy)+gspr+gds+gm+ggs
      value(locyi)=value(locyi)+xgs
      locy=lynl+nodplc(loc+9)
      value(locy)=value(locy)-gdpr
      locy=lynl+nodplc(loc+10)
      locyi=imynl+nodplc(loc+10)
      value(locy)=value(locy)-ggd
      value(locyi)=value(locyi)-xgd
      locy=lynl+nodplc(loc+11)
      locyi=imynl+nodplc(loc+11)
      value(locy)=value(locy)-ggs
      value(locyi)=value(locyi)-xgs
      locy=lynl+nodplc(loc+12)
      value(locy)=value(locy)-gspr
      locy=lynl+nodplc(loc+13)
      value(locy)=value(locy)-gdpr
      locy=lynl+nodplc(loc+14)
      locyi=imynl+nodplc(loc+14)
      value(locy)=value(locy)-ggd+gm
      value(locyi)=value(locyi)-xgd
      locy=lynl+nodplc(loc+15)
      value(locy)=value(locy)-gds-gm
      locy=lynl+nodplc(loc+16)
      locyi=imynl+nodplc(loc+16)
      value(locy)=value(locy)-ggs-gm
      value(locyi)=value(locyi)-xgs
      locy=lynl+nodplc(loc+17)
      value(locy)=value(locy)-gspr
      locy=lynl+nodplc(loc+18)
      value(locy)=value(locy)-gds
      loc=nodplc(loc)
      go to 310
c
c  mosfets
c
  350 loc=locate(14)
  360 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 400
      locv=nodplc(loc+1)
      locm=nodplc(loc+8)
      itype=nodplc(locm+2)
      locm=nodplc(locm+1)
      devmod=value(locv+8)
      xnrm=1.0d0
      xrev=0.0d0
      if (devmod.ge.0.0d0) go to 370
      xnrm=0.0d0
      xrev=1.0d0
  370 loct=lx0+nodplc(loc+26)
      if (value(locm+7).eq.0.0d0.and.
     1   value(locm+8).eq.0.0d0) go to 375
      gdpr=value(locm+7)
      gspr=value(locm+8)
      go to 380
  375 gdpr=value(locm+16)/value(locv+13)
      gspr=value(locm+16)/value(locv+14)
  380 gm=value(loct+7)
      gds=value(loct+8)
      gmbs=value(loct+9)
      gbd=value(loct+10)
      gbs=value(loct+11)
      capbd=value(loct+24)
      capbs=value(loct+26)
cc
cc    charge oriented model parameters
cc
      xl=value(locv+1)-2.0d0*value(locm+28)
      xw=value(locv+2)
      xqco=value(locm+35)
      xqc=value(locv+15)
      covlgs=value(locm+13)*xw
      covlgd=value(locm+14)*xw
      covlgb=value(locm+15)*xl
      if (xqco.gt.0.5d0) go to 385
      cggb=value(loct+18)
      cgdb=value(loct+19)
      cgsb=value(loct+20)
      cbgb=value(loct+21)
      cbdb=value(loct+22)
      cbsb=value(loct+23)
      gcg=(cggb+cbgb)*omega
      gcd=(cgdb+cbdb)*omega
      gcs=(cgsb+cbsb)*omega
      xcgxd=-xqc*gcg
      xcgxs=-(1.0d0-xqc)*gcg
      xcdxd=-xqc*gcd
      xcdxs=-(1.0d0-xqc)*gcd
      xcsxd=-xqc*gcs
      xcsxs=-(1.0d0-xqc)*gcs
      xcdgb=xcgxd-covlgd*omega
      xcddb=xcdxd+(capbd+covlgd)*omega
      xcdsb=xcsxd
      xcsgb=xcgxs-covlgs*omega
      xcsdb=xcdxs
      xcssb=xcsxs+(capbs+covlgs)*omega
      xcggb=(cggb+covlgd+covlgs+covlgb)*omega
      xcgdb=(cgdb-covlgd)*omega
      xcgsb=(cgsb-covlgs)*omega
      xcbgb=(cbgb-covlgb)*omega
      xcbdb=(cbdb-capbd)*omega
      xcbsb=(cbsb-capbs)*omega
      go to 390
c
c     meyer"s model parameters
c
  385 xcgs=(value(loct+12)+covlgs)*omega
      xcgd=(value(loct+14)+covlgd)*omega
      xcgb=(value(loct+16)+covlgb)*omega
      xbd=capbd*omega
      xbs=capbs*omega
cc
cc    do the mapping from meyer"s model into charge oriented model
cc
      xcggb=xcgd+xcgs+xcgb
      xcgdb=-xcgd
      xcgsb=-xcgs
      xcbgb=-xcgb
      xcbdb=-xbd
      xcbsb=-xbs
      xcddb=xcgd+xbd
      xcssb=xcgs+xbs
cc    xcgsb=-xcgb
      xcdgb=-xcgd
      xcsgb=-xcgs
      xcdsb=0.0d0
      xcsdb=0.0d0
cc
  390 locyi=imynl+nodplc(loc+28)
      value(locyi)=value(locyi)+xcggb
      locyi=imynl+nodplc(loc+30)
      value(locyi)=value(locyi)-xcbgb-xcbdb-xcbsb
      locyi=imynl+nodplc(loc+31)
      value(locyi)=value(locyi)+xcddb
      locyi=imynl+nodplc(loc+32)
      value(locyi)=value(locyi)+xcssb
      locyi=imynl+nodplc(loc+11)
      value(locyi)=value(locyi)-xcggb-xcgdb-xcgsb
      locyi=imynl+nodplc(loc+12)
      value(locyi)=value(locyi)+xcgdb
      locyi=imynl+nodplc(loc+13)
      value(locyi)=value(locyi)+xcgsb
      locyi=imynl+nodplc(loc+15)
      value(locyi)=value(locyi)+xcbgb
      locyi=imynl+nodplc(loc+16)
      value(locyi)=value(locyi)+xcbdb
      locyi=imynl+nodplc(loc+17)
      value(locyi)=value(locyi)+xcbsb
      locyi=imynl+nodplc(loc+19)
      value(locyi)=value(locyi)+xcdgb
      locyi=imynl+nodplc(loc+20)
      value(locyi)=value(locyi)-xcdgb-xcddb-xcdsb
      locyi=imynl+nodplc(loc+21)
      value(locyi)=value(locyi)+xcdsb
      locyi=imynl+nodplc(loc+22)
      value(locyi)=value(locyi)+xcsgb
      locyi=imynl+nodplc(loc+24)
      value(locyi)=value(locyi)-xcsgb-xcsdb-xcssb
      locyi=imynl+nodplc(loc+25)
      value(locyi)=value(locyi)+xcsdb
      locy=lynl+nodplc(loc+27)
      value(locy)=value(locy)+gdpr
      locy=lynl+nodplc(loc+29)
      value(locy)=value(locy)+gspr
      locy=lynl+nodplc(loc+30)
      value(locy)=value(locy)+gbd+gbs
      locy=lynl+nodplc(loc+31)
      value(locy)=value(locy)+gdpr+gds+gbd+xrev*(gm+gmbs)
      locy=lynl+nodplc(loc+32)
      value(locy)=value(locy)+gspr+gds+gbs+xnrm*(gm+gmbs)
      locy=lynl+nodplc(loc+10)
      value(locy)=value(locy)-gdpr
      locy=lynl+nodplc(loc+14)
      value(locy)=value(locy)-gspr
      locy=lynl+nodplc(loc+16)
      value(locy)=value(locy)-gbd
      locy=lynl+nodplc(loc+17)
      value(locy)=value(locy)-gbs
      locy=lynl+nodplc(loc+18)
      value(locy)=value(locy)-gdpr
      locy=lynl+nodplc(loc+19)
      value(locy)=value(locy)+(xnrm-xrev)*gm
      locy=lynl+nodplc(loc+20)
      value(locy)=value(locy)-gbd+(xnrm-xrev)*gmbs
      locy=lynl+nodplc(loc+21)
      value(locy)=value(locy)-gds-xnrm*(gm+gmbs)
      locy=lynl+nodplc(loc+22)
      value(locy)=value(locy)-(xnrm-xrev)*gm
      locy=lynl+nodplc(loc+23)
      value(locy)=value(locy)-gspr
      locy=lynl+nodplc(loc+24)
      value(locy)=value(locy)-gbs-(xnrm-xrev)*gmbs
      locy=lynl+nodplc(loc+25)
      value(locy)=value(locy)-gds-xrev*(gm+gmbs)
      loc=nodplc(loc)
      go to 360
c
c  transmission lines
c
  400 loc=locate(17)
  410 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 1000
      locv=nodplc(loc+1)
      z0=value(locv+1)
      y0=1.0d0/z0
      td=value(locv+2)
      arg=-omega*td
      rval=dcos(arg)
      xval=dsin(arg)
      locy=lynl+nodplc(loc+10)
      value(locy)=value(locy)+y0
      locy=lynl+nodplc(loc+11)
      locyi=imynl+nodplc(loc+11)
      value(locy)=-y0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+12)
      locyi=imynl+nodplc(loc+12)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+13)
      value(locy)=value(locy)+y0
      locy=lynl+nodplc(loc+14)
      locyi=imynl+nodplc(loc+14)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+15)
      locyi=imynl+nodplc(loc+15)
      value(locy)=-y0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+16)
      locyi=imynl+nodplc(loc+16)
      value(locy)=+y0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+17)
      locyi=imynl+nodplc(loc+17)
      value(locy)=+1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+18)
      locyi=imynl+nodplc(loc+18)
      value(locy)=+y0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+19)
      locyi=imynl+nodplc(loc+19)
      value(locy)=+1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+20)
      locyi=imynl+nodplc(loc+20)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+21)
      locyi=imynl+nodplc(loc+21)
      value(locy)=-rval
      value(locyi)=-xval
      locy=lynl+nodplc(loc+22)
      locyi=imynl+nodplc(loc+22)
      value(locy)=+rval
      value(locyi)=+xval
      locy=lynl+nodplc(loc+23)
      locyi=imynl+nodplc(loc+23)
      value(locy)=+1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+24)
      locyi=imynl+nodplc(loc+24)
      value(locy)=-rval*z0
      value(locyi)=-xval*z0
      locy=lynl+nodplc(loc+25)
      locyi=imynl+nodplc(loc+25)
      value(locy)=-rval
      value(locyi)=-xval
      locy=lynl+nodplc(loc+26)
      locyi=imynl+nodplc(loc+26)
      value(locy)=+rval
      value(locyi)=+xval
      locy=lynl+nodplc(loc+27)
      locyi=imynl+nodplc(loc+27)
      value(locy)=-1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+28)
      locyi=imynl+nodplc(loc+28)
      value(locy)=+1.0d0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+29)
      locyi=imynl+nodplc(loc+29)
      value(locy)=-rval*z0
      value(locyi)=-xval*z0
      locy=lynl+nodplc(loc+31)
      locyi=imynl+nodplc(loc+31)
      value(locy)=-y0
      value(locyi)=0.0d0
      locy=lynl+nodplc(loc+32)
      locyi=imynl+nodplc(loc+32)
      value(locy)=-y0
      value(locyi)=0.0d0
      loc=nodplc(loc)
      go to 410
c
c  finished
c
 1000 return
      end

      subroutine newnod(nodold,nodnew,inodx,inodi,nnodi)
      implicit double precision (a-h,o-z)
c
c     this routine makes a new node number for an element which is about
c to be added to the circuit as a result of a subcircuit call.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c... inodx, inodi are arrays (see subckt)
      dimension inodx(1),inodi(1)
c
      if (nodold.ne.0) go to 5
      nodnew=1
      go to 20
    5 do 10 i=1,nnodi
      jnodx=inodx(1)
      if (nodold.ne.nodplc(jnodx+i)) go to 10
      jnodi=inodi(1)
      nodnew=nodplc(jnodi+i)
      go to 20
   10 continue
c
      call extmem(inodx(1),1)
      call extmem(inodi(1),1)
      call extmem(junode,1)
      nnodi=nnodi+1
      ncnods=ncnods+1
      jnodx=inodx(1)
      nodplc(jnodx+nnodi)=nodold
      jnodi=inodi(1)
      nodplc(jnodi+nnodi)=ncnods
      nodplc(junode+ncnods)=nodplc(junode+ncnods-1)+1
      nodnew=ncnods
   20 return
      end

c spice version 2g.6  sccsid=setup.ma 3/15/83
      subroutine setup
      implicit double precision (a-h,o-z)
c
c     this routine drives the sparse matrix setup used by spice.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      logical memptr
c
      call second(t1)
      nstop=numnod+jelcnt(3)+jelcnt(6)+jelcnt(8)+jelcnt(9)+2*jelcnt(17)
c
c     clear old tables
c
      if (memptr(irpt)) call clrmem(irpt)
      if (memptr(jcpt)) call clrmem(jcpt)
      if (memptr(irowno)) call clrmem(irowno)
      if (memptr(jcolno)) call clrmem(jcolno)
c
c  reserve matrix locations for each element
c
      call matptr
      if (nogo.ne.0) go to 1000
c
c  reorder matrix pointers
c
      nttbr=0
      do 120 i=2,nstop
      loc=i
  110 if (nodplc(jcpt+loc).eq.0) go to 120
      loc=nodplc(jcpt+loc)
      nttbr=nttbr+1
      go to 110
  120 continue
c...  add ground
      nttar=nttbr
      call reordr
      if (nogo.ne.0) go to 1000
c
c  store matrix locations
c
      call matloc
c
c  .nodeset
c
  200 call sizmem(nsnod,nic)
      if(nic.eq.0) go to 220
      call getm4(nsmat,nic)
      do 210 i=1,nic
      node=nodplc(nsnod+i)
      nodplc(nsmat+i)=indxx(node,node)
  210 continue
c
c  transient initial conditions
c
  220 call sizmem(icnod,nic)
      if(nic.eq.0) go to 300
      call getm4(icmat,nic)
      do 230 i=1,nic
      node=nodplc(icnod+i)
      nodplc(icmat+i)=indxx(node,node)
  230 continue
c
  300 call clrmem(iseq)
      call clrmem(iseq1)
      call clrmem(neqn)
      call clrmem(nodevs)
      call clrmem(ndiag)
c
c  finished
c
 1000 call second(t2)
      rstats(2)=rstats(2)+t2-t1
      return
      end

      subroutine cpytb8(itabo,itabn)
      implicit double precision (a-h,o-z)
c
c     this routine copies a table.  its use is made necessary by the
c fact that only one pointer is allowed per table.
c
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      call sizmem(nodplc(itabo),isize)
      call getm8(nodplc(itabn),isize)
      loco=nodplc(itabo)
      locn=nodplc(itabn)
      call copy8(value(loco+1),value(locn+1),isize)
      return
      end

      subroutine comcof
      implicit double precision (a-h,o-z)
c
c     this routine calculates the timestep-dependent terms used in the
c numerical integration.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
      dimension gmat(7,7)
c
c  compute coefficients for particular integration method
c
      if (method.ne.1) go to 5
      if (iord.eq.1) go to 5
c...  trapezoidal method
      ag(1)=1.0d0/delta/(1.0d0-xmu)
      ag(2)=xmu/(1.0d0-xmu)
      go to 200
c
c  construct gear coefficient matrix
c
    5 istop=iord+1
      call zero8(ag,istop)
      ag(2)=-1.0d0
      do 10 i=1,istop
      gmat(1,i)=1.0d0
   10 continue
      do 20 i=2,istop
      gmat(i,1)=0.0d0
   20 continue
      arg=0.0d0
      do 40 i=2,istop
      arg=arg+delold(i-1)
      arg1=1.0d0
      do 30 j=2,istop
      arg1=arg1*arg
      gmat(j,i)=arg1
   30 continue
   40 continue
c
c  solve for gear coefficients ag(*)
c
c
c  lu decomposition
c
      do 70 i=2,istop
      jstart=i+1
      if (jstart.gt.istop) go to 70
      do 60 j=jstart,istop
      gmat(j,i)=gmat(j,i)/gmat(i,i)
      do 50 k=jstart,istop
      gmat(j,k)=gmat(j,k)-gmat(j,i)*gmat(i,k)
   50 continue
   60 continue
   70 continue
c
c  forward substitution
c
      do 90 i=2,istop
      jstart=i+1
      if (jstart.gt.istop) go to 90
      do 80 j=jstart,istop
      ag(j)=ag(j)-gmat(j,i)*ag(i)
   80 continue
   90 continue
c
c  backward substitution
c
      ag(istop)=ag(istop)/gmat(istop,istop)
      ir=istop
      do 110 i=2,istop
      jstart=ir
      ir=ir-1
      do 100 j=jstart,istop
      ag(ir)=ag(ir)-gmat(ir,j)*ag(j)
  100 continue
      ag(ir)=ag(ir)/gmat(ir,ir)
  110 continue
c
c  finished
c
  200 return
      end

      subroutine elprnt
      implicit double precision (a-h,o-z)
c
c     this routine prints a circuit element summary.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension itab(25),astyp(6)
      dimension eltitl(4)
      data eltitl / 8hcircuit , 8helement , 8hsummary , 8h         /
      data astyp / 1h , 5hpulse, 3hsin, 3hexp, 3hpwl, 4hsffm /
      data ablnk,aoff /1h ,3hoff/
c
c  print listing of elements
c
      call title(0,lwidth,1,eltitl)
c
c  print resistors
c
      if (jelcnt(1).eq.0) go to 50
      ititle=0
   21 format(//'0**** resistors'/'0     name        nodes     value
     1  tc1        tc2'//)
      loc=locate(1)
   30 if ((loc.eq.0).or.(nodplc(loc+8).ne.0)) go to 50
      if (ititle.eq.0) write (iofile,21)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      write (iofile,31) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),value(locv+2),value(locv+3),value(locv+4)
   31 format(6x,a8,2i5,1p3d11.2)
   40 loc=nodplc(loc)
      go to 30
c
c  print capacitors and inductors
c
   50 if ((jelcnt(2)+jelcnt(3)).eq.0) go to 80
      ititle=0
   51 format(//'0**** capacitors and inductors'/'0     name        nodes
     1    in cond     value'//)
      do 70 id=2,3
      loc=locate(id)
   60 if (loc.eq.0) go to 70
      if ((id.eq.2).and.(nodplc(loc+12).ne.0)) go to 70
      if ((id.eq.3).and.(nodplc(loc+14).ne.0)) go to 70
      if (ititle.eq.0) write (iofile,51)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      if (nodplc(loc+4).ne.1) go to 62
      write (iofile,31) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),value(locv+2),value(locv+1)
      go to 65
   62 ltab=7
      if (id.eq.3) ltab=10
      call sizmem(nodplc(loc+ltab),nparam)
      ispot=nodplc(loc+ltab)+1
      write (iofile,63) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),value(locv+2)
   63 format(6x,a8,2i5,1pd11.2,'   variable')
   65 loc=nodplc(loc)
      go to 60
   70 continue
c
c  print mutual inductors
c
   80 if (jelcnt(4).eq.0) go to 100
      ititle=0
   81 format(//'0**** mutual inductors'/'0     name        coupled induc
     1tors   value'//)
      loc=locate(4)
   90 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 110
      if (ititle.eq.0) write (iofile,81)
      ititle=1
      locv=nodplc(loc+1)
      nl1=nodplc(loc+2)
      nl1=nodplc(nl1+1)
      nl2=nodplc(loc+3)
      nl2=nodplc(nl2+1)
      write (iofile,91) value(locv),value(nl1),value(nl2),value(locv+1)
   91 format(6x,a8,4x,a8,2x,a8,1pd10.2)
   95 loc=nodplc(loc)
      go to 90
c
c  print nonlinear voltage controlled sources
c
  100 if (jelcnt(5).eq.0) go to 120
      ititle=0
  101 format(//'0**** voltage-controlled current sources'/'0     name
     1     +    -   dimension   function')
      loc=locate(5)
  110 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 120
      if (ititle.eq.0) write (iofile,101)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      write (iofile,111) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),nodplc(loc+4)
  111 format(6x,a8,2i5,i8,9x,'poly')
  115 loc=nodplc(loc)
      go to 110
c
c  nonlinear voltage controlled voltage sources
c
  120 if (jelcnt(6).eq.0) go to 140
      ititle=0
  121 format(//'0**** voltage-controlled voltage sources'/'0     name
     1     +    -   dimension   function')
      loc=locate(6)
  130 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 140
      if (ititle.eq.0) write (iofile,121)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      write (iofile,111) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),nodplc(loc+4)
  135 loc=nodplc(loc)
      go to 130
c
c  nonlinear current controlled current sources
c
  140 if (jelcnt(7).eq.0) go to 160
      ititle=0
  141 format(//'0**** current-controlled current sources'/'0     name
     1     +    -   dimension   function')
      loc=locate(7)
  150 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 160
      if (ititle.eq.0) write (iofile,141)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      write (iofile,111) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),nodplc(loc+4)
  155 loc=nodplc(loc)
      go to 150
c
c  nonlinear current controlled voltage sources
c
  160 if (jelcnt(8).eq.0) go to 170
      ititle=0
  161 format(//'0**** current-controlled voltage sources'/'0     name
     1     +    -   dimension   function')
      loc=locate(8)
  165 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 170
      if (ititle.eq.0) write (iofile,161)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      write (iofile,111) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),nodplc(loc+4)
  167 loc=nodplc(loc)
      go to 165
c
c  print independent sources
c
  170 if ((jelcnt(9)+jelcnt(10)).eq.0) go to 250
      ititle=0
  171 format(//'0**** independent sources'/'0     name        nodes   dc
     1 value   ac value   ac phase   transient'//)
      do 245 id=9,10
      loc=locate(id)
  180 if (loc.eq.0) go to 245
      if ((id.eq.9).and.(nodplc(loc+11).ne.0)) go to 245
      if ((id.eq.10).and.(nodplc(loc+6).ne.0)) go to 245
      if (ititle.eq.0) write (iofile,171)
      ititle=1
      locv=nodplc(loc+1)
      locp=nodplc(loc+5)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      itype=nodplc(loc+4)+1
      anam=astyp(itype)
      write (iofile,181) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),value(locv+1),value(locv+2),
     2   value(locv+3),anam
  181 format(6x,a8,2i5,1p3d11.2,2x,a8)
      if (jtrflg.eq.0) go to 240
      jstart=locp+1
      go to (240,190,200,210,220,230), itype
  190 jstop=locp+7
      write (iofile,191) (value(j),j=jstart,jstop)
  191 format(1h0,42x,'initial value',1pd11.2,/,
     1           43x,'pulsed value.',  d11.2,/,
     2           43x,'delay time...',  d11.2,/,
     3           43x,'risetime.....',  d11.2,/,
     4           43x,'falltime.....',  d11.2,/,
     5           43x,'width........',  d11.2,/,
     6           43x,'period.......',  d11.2,/)
      go to 240
  200 jstop=locp+5
      write (iofile,201) (value(j),j=jstart,jstop)
  201 format(1h0,42x,'offset.......',1pd11.2,/,
     1           43x,'amplitude....',  d11.2,/,
     2           43x,'frequency....',  d11.2,/,
     3           43x,'delay........',  d11.2,/,
     4           43x,'theta........',  d11.2,/)
      go to 240
  210 jstop=locp+6
      write (iofile,211) (value(j),j=jstart,jstop)
  211 format(1h0,42x,'initial value',1pd11.2,/,
     1           43x,'pulsed value.',  d11.2,/,
     2           43x,'rise delay...',  d11.2,/,
     3           43x,'rise tau.....',  d11.2,/,
     4           43x,'fall delay...',  d11.2,/,
     5           43x,'fall tau.....',  d11.2,/)
      go to 240
  220 call sizmem(nodplc(loc+5),jstop)
      jstop=locp+jstop
      write (iofile,221) (value(j),j=jstart,jstop)
  221 format(1h0,49x,'time       value'//,(46x,1p2d11.2))
      write (iofile,226)
  226 format(1x)
      go to 240
  230 jstop=locp+5
      write (iofile,231) (value(j),j=jstart,jstop)
  231 format(1h0,42x,'offset.......',1pd11.2,/,
     1           43x,'amplitude....',  d11.2,/,
     2           43x,'carrier freq.',  d11.2,/,
     3           43x,'modn index...',  d11.2,/,
     4           43x,'signal freq..',  d11.2,/)
  240 loc=nodplc(loc)
      go to 180
  245 continue
c
c  print transmission lines
c
  250 if (jelcnt(17).eq.0) go to 260
      ititle=0
  251 format(//'0**** transmission lines'/'0     name             nodes
     1           z0         td'//)
      loc=locate(17)
  253 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 260
      if (ititle.eq.0) write (iofile,251)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      write (iofile,256) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),nodplc(junode+node3),
     2   nodplc(junode+node4),value(locv+1),value(locv+2)
  256 format(6x,a8,4i5,1p2d11.2)
  258 loc=nodplc(loc)
      go to 253
c
c  print diodes
c
  260 if (jelcnt(11).eq.0) go to 290
      ititle=0
  261 format(//'0**** diodes'/'0     name        +    -  model       are
     1a'//)
      loc=locate(11)
  270 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 290
      if (ititle.eq.0) write (iofile,261)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      locm=nodplc(loc+5)
      locm=nodplc(locm+1)
      aic=ablnk
      if (nodplc(loc+6).eq.1) aic=aoff
      write (iofile,271) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),value(locm),value(locv+1),aic
  271 format(6x,a8,2i5,2x,a8,f8.3,2x,a8)
  280 loc=nodplc(loc)
      go to 270
c
c  print transistors
c
  290 if (jelcnt(12).eq.0) go to 320
      ititle=0
  291 format(//'0**** bipolar junction transistors'/'0     name        c
     1    b    e    s  model       area'//)
      loc=locate(12)
  300 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 320
      if (ititle.eq.0) write (iofile,291)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      locm=nodplc(loc+8)
      locm=nodplc(locm+1)
      aic=ablnk
      if (nodplc(loc+9).eq.1) aic=aoff
      write (iofile,301) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),nodplc(junode+node3),nodplc(junode+node4),
     2   value(locm),value(locv+1),aic
  301 format(6x,a8,4i5,2x,a8,f8.3,2x,a8)
  310 loc=nodplc(loc)
      go to 300
c
c  print jfets
c
  320 if (jelcnt(13).eq.0) go to 350
      ititle=0
  321 format(//'0**** jfets'/'0     name        d    g    s  model
     1 area'//)
      loc=locate(13)
  330 if ((loc.eq.0).or.(nodplc(loc+25).ne.0)) go to 350
      if (ititle.eq.0) write (iofile,321)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      locm=nodplc(loc+7)
      locm=nodplc(locm+1)
      aic=ablnk
      if (nodplc(loc+8).eq.1) aic=aoff
      write (iofile,331) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),nodplc(junode+node3),
     2   value(locm),value(locv+1),aic
  331 format(6x,a8,3i5,2x,a8,f8.3,2x,a8)
  340 loc=nodplc(loc)
      go to 330
c
c  print mosfets
c
  350 if (jelcnt(14).eq.0) go to 400
      ititle=0
  351 format(//'0**** mosfets',/,'0name',6x,'d   g   s   b  model',6x,
     1      'w       ad       pd      rds'/
     2  37x,'l       as       ps      rss',//)
      loc=locate(14)
  360 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 400
      if (ititle.eq.0) write (iofile,351)
      ititle=1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      locm=nodplc(loc+8)
      locm=nodplc(locm+1)
      aic=ablnk
      if (nodplc(loc+9).eq.1) aic=aoff
      write (iofile,361) value(locv),nodplc(junode+node1),
     1   nodplc(junode+node2),nodplc(junode+node3),
     2   nodplc(junode+node4),value(locm),value(locv+2),
     3   value(locv+3),value(locv+11),value(locv+13),
     4   value(locv+1),value(locv+4),value(locv+12),value(locv+14),aic
  361 format(1x,a8,4i4,1x,a8,1p4d8.1,/34x,1p4d8.1,1x,a8)
  370 loc=nodplc(loc)
      go to 360
c
c  subcircuit calls
c
  400 if (jelcnt(19).eq.0) go to 500
      ititle=0
  401 format(//'0**** subcircuit calls'/'0     name     subcircuit   ext
     1ernal nodes'//)
      loc=locate(19)
  410 if (loc.eq.0) go to 500
      if (ititle.eq.0) write (iofile,401)
      ititle=1
      locv=nodplc(loc+1)
      locn=nodplc(loc+2)
      call sizmem(nodplc(loc+2),nnodx)
      locs=nodplc(loc+3)
      locsv=nodplc(locs+1)
      jstart=1
      ndprln=(lwidth-28)/5
  412 jstop=min0(nnodx,jstart+ndprln-1)
      do 414 j=jstart,jstop
      node=nodplc(locn+j)
      itab(j-jstart+1)=nodplc(junode+node)
  414 continue
      if (jstart.eq.1)
     1   write (iofile,416) value(locv),value(locsv),(itab(j),j=1,jstop)
  416 format(6x,a8,2x,a8,4x,20i5)
      if (jstart.ne.1)
     1   write (iofile,418) (itab(j-jstart+1),j=jstart,jstop)
  418 format(28x,20i5)
      jstart=jstop+1
      if (jstart.le.nnodx) go to 412
      if (nnodx.le.ndprln) go to 420
      write (iofile,226)
  420 loc=nodplc(loc)
      go to 410
c
c  finished
c
  500 return
      end

      subroutine sencal
      implicit double precision (a-h,o-z)
c
c     this routine computes the dc sensitivities of circuit elements
c with respect to user specified outputs.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension string(5),sentit(4)
      data alsrs,alsis,alsn,alsrb,alsrc,alsre / 2hrs,2his,1hn,2hrb,2hrc,
     1   2hre /
      data alsbf,alsise,alsbr,alsisc,alsne,alsnc,alsik,alsikr,alsva,alsvb
     1   / 2hbf,3hise,2hbr,3hisc,2hne,2hnc,3hikf,3hikr,3hvaf,3hvar/
      data alsjs /2hjs/
      data sentit / 8hdc sensi, 8htivity a, 8hnalysis , 8h         /
      data ablnk / 1h  /
c
c
      if (kinel.ne.0) go to 8
    4 call dcdcmp
c
c
    8 do 1000 n=1,nsens
c
c  prepare adjoint excitation vector
c
      call zero8(value(lvn+1),nstop)
      locs=nodplc(isens+n)
      ioutyp=nodplc(locs+5)
      if (ioutyp.ne.0) go to 10
c...  voltage output
      ivolts=1
      noposo=nodplc(locs+2)
      nonego=nodplc(locs+3)
      value(lvn+noposo)=-1.0d0
      value(lvn+nonego)=+1.0d0
      go to 20
c...  current output (through voltage source)
   10 iptro=nodplc(locs+2)
      ivolts=0
      iptro=nodplc(iptro+6)
      value(lvn+iptro)=-1.0d0
c
c  obtain adjoint solution by doing forward/backward substitution on
c  the transpose of the y matrix
c
   20 call asol
      value(lvn+1)=0.0d0
c
c  real solution in lvnim1;  adjoint solution in lvn ...
c
      call title(0,lwidth,1,sentit)
      ipos=1
      call outnam(locs,1,string,ipos)
      call move(string,ipos,ablnk,1,7)
      jstop=(ipos+6)/8
      write (iofile,36) (string(j),j=1,jstop)
   36 format('0dc sensitivities of output ',5a8)
      if(ivolts.ne.0) write (iofile,41)
      if(ivolts.eq.0) write(iofile,42)
   41 format(1h0,8x,'element',9x,'element',7x,'element',7x,'normalized'/
     1   10x,'name',12x,'value',6x,'sensitivity    sensitivity'/35x,
     2   ' (volts/unit) (volts/percent)'/)
   42 format(1h0,8x,'element',9x,'element',7x,'element',7x,'normalized'/
     1   10x,'name',12x,'value',6x,'sensitivity    sensitivity'/35x,
     2   '  (amps/unit)  (amps/percent)'/)
c
c  resistors
c
      loc=locate(1)
  100 if ((loc.eq.0).or.(nodplc(loc+8).ne.0)) go to 110
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      val=1.0d0/value(locv+1)
      sens=-(value(lvnim1+node1)-value(lvnim1+node2))*
     1      (value(lvn   +node1)-value(lvn   +node2))/(val*val)
      sensn=val*sens/100.0d0
      write (iofile,101) value(locv),val,sens,sensn
  101 format(10x,a8,4x,1pd10.3,5x,d10.3,5x,d10.3)
  105 loc=nodplc(loc)
      go to 100
c
c  voltage sources
c
  110 loc=locate(9)
  140 if ((loc.eq.0).or.(nodplc(loc+11).ne.0)) go to 150
      locv=nodplc(loc+1)
      val=value(locv+1)
      iptrv=nodplc(loc+6)
      sens=-value(lvn+iptrv)
      sensn=val*sens/100.0d0
      write (iofile,101) value(locv),val,sens,sensn
  145 loc=nodplc(loc)
      go to 140
c
c  current sources
c
  150 loc=locate(10)
  160 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 170
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      val=value(locv+1)
      sens=value(lvn+node1)-value(lvn+node2)
      sensn=val*sens/100.0d0
      write (iofile,101) value(locv),val,sens,sensn
  165 loc=nodplc(loc)
      go to 160
c
c  diodes
c
  170 loc=locate(11)
  180 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 210
      locv=nodplc(loc+1)
      write (iofile,181) value(locv)
  181 format(1x,a8)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      locm=nodplc(loc+5)
      locm=nodplc(locm+1)
      area=value(locv+1)
c
c  series resistance (rs)
c
      val=value(locm+2)*area
      if (val.ne.0.0d0) go to 190
      write (iofile,186) alsrs
  186 format(10x,a8,5x,2h0.,13x,2h0.,13x,2h0.)
      go to 200
  190 val=1.0d0/val
      sens=-(value(lvnim1+node1)-value(lvnim1+node3))*
     1      (value(lvn   +node1)-value(lvn   +node3))/(val*val)
      sensn=val*sens/100.0d0
      write (iofile,101) alsrs,val,sens,sensn
c
c  intrinsic parameters
c
  200 csat=value(locm+1)*area
      xn=value(locm+3)
      vbe=value(lvnim1+node3)-value(lvnim1+node2)
      vte=xn*vt
      evbe=dexp(vbe/vte)
      vabe=value(lvn+node3)-value(lvn+node2)
c
c  saturation current (is)
c
      sens=vabe*(evbe-1.0d0)
      sensn=csat*sens/100.0d0
      write (iofile,101) alsis,csat,sens,sensn
c
c  ideality factor (n)
c
      sens=-vabe*(csat/xn)*(vbe/vte)*evbe
      if (dabs(sens).lt.1.0d-30) sens=0.0d0
      sensn=xn*sens/100.0d0
      write (iofile,101) alsn,xn,sens,sensn
  205 loc=nodplc(loc)
      go to 180
c
c  bipolar junction transistors
c
  210 loc=locate(12)
  220 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 1000
      locv=nodplc(loc+1)
      write (iofile,181) value(locv)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      locm=nodplc(loc+8)
      type=nodplc(locm+2)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+22)
      area=value(locv+1)
c
c  base resistance (rb)
c
      val=value(loct+16)
      if (val.ne.0.0d0) go to 230
      write (iofile,186) alsrb
      go to 240
  230 val=1.0d0/val
      sens=-(value(lvnim1+node2)-value(lvnim1+node5))*
     1      (value(lvn   +node2)-value(lvn   +node5))/(val*val)
      sensn=val*sens/100.0d0
      write (iofile,101) alsrb,val,sens,sensn
c
c  collector resistance (rc)
c
  240 val=value(locm+20)*area
      if (val.ne.0.0d0) go to 250
      write (iofile,186) alsrc
      go to 260
  250 val=1.0d0/val
      sens=-(value(lvnim1+node1)-value(lvnim1+node4))*
     1      (value(lvn   +node1)-value(lvn   +node4))/(val*val)
      sensn=val*sens/100.0d0
      write (iofile,101) alsrc,val,sens,sensn
c
c  emitter resistance (re)
c
  260 val=value(locm+19)*area
      if (val.ne.0.0d0) go to 270
      write (iofile,186) alsre
      go to 280
  270 val=1.0d0/val
      sens=-(value(lvnim1+node3)-value(lvnim1+node6))*
     1      (value(lvn   +node3)-value(lvn   +node6))/(val*val)
      sensn=val*sens/100.0d0
      write (iofile,101) alsre,val,sens,sensn
c
c  intrinsic parameters
c
  280 bf=value(locm+2)
      br=value(locm+8)
      csat=value(locm+1)*area
      ova=value(locm+4)
      ovb=value(locm+10)
      oik=value(locm+5)/area
      ise=value(locm+6)*area
      xne=value(locm+7)
      vte=xne*vt
      oikr=value(locm+11)/area
      isc=value(locm+12)*area
      xnc=value(locm+13)
      vtc=xnc*vt
      vbe=type*(value(lvnim1+node5)-value(lvnim1+node6))
      vbc=type*(value(lvnim1+node5)-value(lvnim1+node4))
      vabe=type*(value(lvn+node5)-value(lvn+node6))
      vabc=type*(value(lvn+node5)-value(lvn+node4))
      vace=vabe-vabc
      if (vbe.le.-vt) go to 320
      evbe=dexp(vbe/vt/value(locm+3))
      cbe=csat*(evbe-1.0d0)
      gbe=csat*evbe/vt/value(locm+3)
      if (ise.ne.0.0d0) go to 310
      cben=0.0d0
      gben=0.0d0
      go to 350
  310 evben=dexp(vbe/vte)
      cben=ise     *(evben-1.0d0)
      gben=ise     *evben/vte
      go to 350
  320 gbe=-csat/vbe
      cbe=gbe*vbe
      gben=-ise/vbe
      cben=gben*vbe
  350 if (vbc.le.-vt) go to 370
      evbc=dexp(vbc/vt/value(locm+9))
      cbc=csat*(evbc-1.0d0)
      gbc=csat*evbc/vt/value(locm+9)
      if (isc.ne.0.0d0) go to 360
      cbcn=0.0d0
      gbcn=0.0d0
      go to 400
  360 evbcn=dexp(vbc/vtc)
      cbcn=isc     *(evbcn-1.0d0)
      gbcn=isc     *evbcn/vtc
      go to 400
  370 gbc=-csat/vbc
      cbc=gbc*vbc
      gbcn=-isc/vbc
      cbcn=gbcn*vbc
  400 q1=1.0d0/(1.0d0-ova*vbc-ovb*vbe)
      q2=oik*cbe+oikr*cbc
      sqarg=dsqrt(1.0d0+4.0d0*q2)
      qb=q1*(1.0d0+sqarg)/2.0d0
      dqb=(cbe-cbc)/(qb*qb)
      sqarg=dsqrt(1.0d0+4.0d0*q2)
      dq1=dqb*(1.0d0+sqarg)/2.0d0
      dq2=q1*dqb/sqarg
c
c  compute sensitivities
c
c...  bf
      sens=-vabe*cbe/bf/bf
      sensn=bf*sens/100.0d0
      write (iofile,101) alsbf,bf,sens,sensn
c...  ise
      if (ise.ne.0.0d0) go to 430
      write (iofile,186) alsise
      go to 440
  430 sens=vabe*cben/ise
      sensn=ise*sens/100.0d0
      write (iofile,101) alsise,ise,sens,sensn
c...  br
  440 sens=-vabc*cbc/br/br
      sensn=br*sens/100.0d0
      write (iofile,101) alsbr,br,sens,sensn
c...  isc
      if (isc.ne.0.0d0) go to 450
      write (iofile,186) alsisc
      go to 460
  450 sens=vabc*cbcn/isc
      sensn=isc*sens/100.0d0
      write (iofile,101) alsisc,isc,sens,sensn
c...  is
  460 sens=(vabe*(cbe/bf)+vabc*(cbc/br)
     1   +vace*(dqb*qb-dq2*q2))/csat
      sensn=csat*sens/100.0d0
      write (iofile,101) alsjs,csat,sens,sensn
c...  ne
      sens=-vabe*gben*vbe/xne
      sensn=xne*sens/100.0d0
      write (iofile,101) alsne,xne,sens,sensn
c...  nc
      sens=-vabc*gbcn*vbc/xnc
      sensn=xnc*sens/100.0d0
      write (iofile,101) alsnc,xnc,sens,sensn
c...  ik
      if (oik.ne.0.0d0) go to 470
      write (iofile,186) alsik
      go to 480
  470 val=1.0d0/oik
      sens=vace*dq2*cbe/(val*val)
      sensn=val*sens/100.0d0
      write (iofile,101) alsik,val,sens,sensn
c...  ikr
  480 if (oikr.ne.0.0d0) go to 490
      write (iofile,186) alsikr
      go to 500
  490 val=1.0d0/oikr
      sens=vace*dq2*cbc/(val*val)
      sensn=val*sens/100.0d0
      write (iofile,101) alsikr,val,sens,sensn
c...  va
  500 if (ova.ne.0.0d0) go to 510
      write (iofile,186) alsva
      go to 520
  510 va=1.0d0/ova
      sens=vace*q1*q1*dq1*vbc/(va*va)
      sensn=va*sens/100.0d0
      write (iofile,101) alsva,va,sens,sensn
c...  vb
  520 if (ovb.ne.0.0d0) go to 530
      write (iofile,186) alsvb
      go to 540
  530 vb=1.0d0/ovb
      sens=vace*q1*q1*dq1*vbe/(vb*vb)
      sensn=vb*sens/100.0d0
      write (iofile,101) alsvb,vb,sens,sensn
c
c
  540 loc=nodplc(loc)
      go to 220
c
c  finished
c
 1000 continue
      return
      end

      subroutine title(ifold,len,icom,coment)
      implicit double precision (a-h,o-z)
c
c     this routine writes a title on the output file.  ifold indicates
c whether the page eject should be to the next concave, convex, or any
c page fold depending on whether its value is <0, >0, or =0.  the page
c eject is suppressed (as is much of the heading) if the variable nopage
c is nonzero.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension coment(4)
c
c
      if(nopage.eq.1) go to 150
c
   30 if (len.le.80) go to 100
      write (iofile,31) adate,aprog,atime,(atitle(i),i=1,10)
   31 format(1h1,16(1h*),a8,1x,24(1h*),3a8,24(1h*),a8,16(1h*),//1h0,
     1   15a8/)
      if (icom.eq.0) go to 40
      write (iofile,36) coment,value(itemps+itemno)
   36 format(5h0****,17x,4a8,21x,'temperature =',f9.3,' deg c'/)
   40 write (iofile,41)
   41 format(1h0,121(1h*)//)
      go to 200
c
c
  100 write (iofile,101) adate,aprog,atime,(atitle(i),i=1,10)
  101 format(1h1,7(1h*),a8,1x,8(1h*),3a8,8(1h*),a8,5(1h*)//1h0,10a8/)
      if (icom.eq.0) go to 110
      write (iofile,106) coment,value(itemps+itemno)
  106 format(10h0****     ,4a8,' temperature =',f9.3,' deg c'/)
  110 write (iofile,111)
  111 format(1h0,71(1h*)//)
      go to 200
c
c
  150 if (icom.eq.0) go to 160
      write (iofile,106) coment,value(itemps+itemno)
      go to 200
  160 write (iofile,161) aprog
  161 format(1h0,3a8,/)
c
c  finished
c
  200 return
      end

      subroutine acdcmp
      implicit double precision (a-h,o-z)
c
c     this routine performs an lu factorization of the circuit equation
c coefficient matrix.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      n=1
   10 n=n+1
      nxti=n
      nxtj=n
c
c     calculate contribution from (nxti,nxtj)
c
      if (n.ge.nstop) return
      n1=nodplc(irswpf+nxti)
      n2=nodplc(icswpf+nxtj)
      locnn=indxx(n1,n2)
      gdiag=dabs(value(lynl+locnn))+dabs(value(imynl+locnn))
      if (gdiag.ge.pivtol) go to 20
      value(lynl+locnn)=pivtol
      value(imynl+locnn)=0.0d0
      write(iofile,11) n
   11 format(1h0,' underflow occured at step n= ',i5)
c
c     down col j
c
   20 locr=nodplc(irpt+locnn)
   25 if (locr.eq.0) go to 10
      i=nodplc(irowno+locr)
      call cdiv(value(lynl+locr),value(imynl+locr),value(lynl+locnn),
     1     value(imynl+locnn),value(lynl+locr),value(imynl+locr))
      locc=nodplc(jcpt+locnn)
c
c     for each element look up row nxti
c
   30 if (locc.eq.0) go to 70
      j=nodplc(jcolno+locc)
c
c     locate element (i,j)
c
   35 if (j.lt.i) go to 45
      locij=locc
   40 locij=nodplc(irpt+locij)
      if (nodplc(irowno+locij).eq.i) go to 55
      go to 40
   45 locij=locr
   50 locij=nodplc(jcpt+locij)
      if (nodplc(jcolno+locij).eq.j) go to 55
      go to 50
   55 call cmult(value(lynl+locc),value(imynl+locc),
     1     value(lynl+locr),value(imynl+locr),xreal,ximag)
      value(lynl+locij)=value(lynl+locij)-xreal
      value(imynl+locij)=value(imynl+locij)-ximag
      locc=nodplc(jcpt+locc)
      go to 30
   70 locr=nodplc(irpt+locr)
      go to 25
      end

      subroutine pnjlim(vnew,vold,vt,vcrit,icheck)
      implicit double precision (a-h,o-z)
c
c     this routine limits the change-per-iteration of device pn-junction
c voltages.
c
      if (vnew.le.vcrit) go to 30
      vlim=vt+vt
      delv=vnew-vold
      if (dabs(delv).le.vlim) go to 30
      if (vold.le.0.0d0) go to 20
      arg=1.0d0+delv/vt
      if (arg.le.0.0d0) go to 10
      vnew=vold+vt*dlog(arg)
      go to 100
   10 vnew=vcrit
      go to 100
   20 vnew=vt*dlog(vnew/vt)
      go to 100
   30 icheck=0
c
c  finished
c
  100 return
      end

      subroutine addelt(loce,loc,id,inodx,inodi,nnodi)
      implicit double precision (a-h,o-z)
c
c     this routine adds an element to the nominal circuit definition
c lists.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c... inodx(1), inodi(1) are arrays (see subckt)
      dimension inodx(1),inodi(1)
c
      dimension lnod(50),lval(50),nnods(50)
      data lnod /10,14,16, 8,15,16,15,16,13, 8,
     1           18,38,27,35, 8, 8,35, 5, 5, 5,
     2            5, 5, 5, 5, 0, 0, 0, 0, 0, 0,
     3           21,21,21,21,21,21,21,21,21,21,
     4            8, 8, 8, 8, 8, 0, 0, 0, 0, 0 /
      data lval / 5, 4, 4, 2, 1, 1, 1, 1, 4, 4,
     1            3, 4, 4,16, 1, 1, 9, 2, 1, 1,
     2           19,55,17,46, 0, 0, 0, 0, 0, 0,
     3            1, 1, 1, 1, 1,17,17,17,17,17,
     4            1, 1, 1, 1, 1, 0, 0, 0, 0, 0 /
      data nnods / 2, 2, 2, 0, 2, 2, 2, 2, 2, 2,
     1             2, 4, 3, 4, 4, 4, 4, 0, 1, 0,
     2             0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     3             0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     4             2, 2, 2, 0, 0, 0, 0, 0, 0, 0 /
c
c  copy integer part
c
      nword=lnod(id)-3
      if (nword.le.0) go to 10
      call copy4(nodplc(loc+2),nodplc(loce+2),nword)
c
c  set nodes
c
   10 if (id.ge.21) go to 100
      if (nnods(id).eq.0) go to 100
      if (id.le.4) go to 20
      if (id.le.8) go to 40
      if (id.eq.19) go to 70
   20 jstop=nnods(id)
      do 30 j=1,jstop
      call newnod(nodplc(loc+j+1),nodplc(loce+j+1),inodx(1),
     1  inodi(1),nnodi)
   30 continue
      go to 100
   40 call newnod(nodplc(loc+2),nodplc(loce+2),inodx(1),inodi(1),nnodi)
      call newnod(nodplc(loc+3),nodplc(loce+3),inodx(1),inodi(1),nnodi)
      if (id.ge.7) go to 100
      nlocp=loc+id+1
      nssnod=2*nodplc(loc+4)
      call getm4(nodplc(loce+id+1),nssnod)
      nlocpe=loce+id+1
   50 do 60 j=1,nssnod
      locp=nodplc(nlocp)
      nodold=nodplc(locp+j)
      call newnod(nodold,nodnew,inodx(1),inodi(1),nnodi)
      locpe=nodplc(nlocpe)
      nodplc(locpe+j)=nodnew
   60 continue
      go to 100
   70 nlocp=loc+2
      call sizmem(nodplc(loc+2),nssnod)
      call getm4(nodplc(loce+2),nssnod)
      nlocpe=loce+2
      go to 50
c
c  copy real part
c
  100 if (nogo.ne.0) go to 300
      locv=nodplc(loc+1)
      locve=nodplc(loce+1)
      call copy8(value(locv),value(locve),lval(id))
c
c  treat non-node tables specially
c
  200 if (id.ge.11) go to 300
      go to (300,210,220,300,230,240,230,240,260,260), id
  210 if (nodplc(loc+4).eq.1) go to 300
      call cpytb8(loc+7,loce+7)
      go to 300
  220 if (nodplc(loc+4).eq.1) go to 300
      call cpytb8(loc+10,loce+10)
      go to 300
  230 itab=5
      go to 250
  240 itab=6
  250 if (id.le.6) go to 255
      call cpytb4(loc+itab+1,loce+itab+1)
  255 call cpytb4(loc+itab+2,loce+itab+2)
      call cpytb8(loc+itab+3,loce+itab+3)
      call cpytb8(loc+itab+4,loce+itab+4)
      call cpytb4(loc+itab+5,loce+itab+5)
      call cpytb8(loc+itab+6,loce+itab+6)
      go to 300
  260 call cpytb8(loc+5,loce+5)
c
c
  300 return
      end

      double precision function alias(anam)
      implicit double precision (a-h,o-z)
      dimension anam1(14),anam2(14)
      data anam1 /3hva ,3hvb ,3hccs,3hns ,3hc2 ,3hpt ,3hc4 ,
     1            3hpe ,3hme ,3hpc ,3hmc ,3hps ,3hms ,3hik /
      data anam2 /3hvaf,3hvar,3hcjs,3hnss,3hise,3hxti,3hisc,
     1            3hvje,3hmje,3hvjc,3hmjc,3hvjs,3hmjs,3hikf/
c
c  this function returns the mgp equivalent of the gp parameters
c  (those which apply)
c
      iknt=0
      alias=anam
   10 iknt=iknt+1
      if(iknt.gt.14) return
      if(anam1(iknt).ne.anam) go to 10
      alias=anam2(iknt)
      return
      end

      subroutine moseq1(vds,vbs,vgs,gm,gds,gmbs)
      implicit double precision (a-h,o-z)
c
c     this routine evaluates the drain current and its derivatives
c     using the shichman-hodges model and the charges associated
c     with the gate, channel and bulk for mosfets
c
c spice version 2g.6  sccsid=mosarg 3/15/83
      common /mosarg/ vto,beta,gamma,phi,phib,cox,xnsub,xnfs,xd,xj,xld,
     1   xlamda,uo,uexp,vbp,utra,vmax,xneff,xl,xw,vbi,von,vdsat,qspof,
     2   beta0,beta1,cdrain,xqco,xqc,fnarrw,fshort,lev
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
      vbd=vbs-vds
      vgb=vgs-vbs
c
c
      if (vbs.gt.0.0d0) go to 102
      sarg=dsqrt(phi-vbs)
      go to 104
  102 sarg=dsqrt(phi)
      sarg=sarg-vbs/(sarg+sarg)
      sarg=dmax1(0.0d0,sarg)
  104 von=vbi+gamma*sarg
      vgst=vgs-von
      vdsat=dmax1(vgst,0.0d0)
      if (sarg.gt.0.0d0) go to 105
      arg=0.0d0
      go to 108
  105 arg=gamma/(sarg+sarg)
  108 if (vgst.gt.0.0d0) go to 110
c
c     cutoff region
c
      cdrain=0.0d0
      gm=0.0d0
      gds=0.0d0
      gmbs=0.0d0
      go to 1000
c
c     saturation region
c
  110 betap=beta*(1.0d0+xlamda*vds)
      if (vgst.gt.vds) go to 120
      cdrain=betap*vgst*vgst*0.5d0
      gm=betap*vgst
      gds=xlamda*beta*vgst*vgst*0.5d0
      gmbs=gm*arg
      go to 1000
c
c     linear region
c
  120 cdrain=betap*vds*(vgst-0.5d0*vds)
      gm=betap*vds
      gds=betap*(vgst-vds)+xlamda*beta*vds*(vgst-0.5d0*vds)
      gmbs=gm*arg
c
c     finished
c
 1000 return
      end

      SUBROUTINE ushift(LINE)
C
C..   THIS ROUTINE UPSHIFTS AN INPUT LINE
C
      INTEGER*2 ICHAR1,ICHAR2,LINE(40)
      DO 3 I=1,40
      ICHAR1 = LINE(I) / 256
C..   IF THE TOP BYTE IS BETWEEN 'a' AND 'z', UPSHIFTS IT ...
      IF(.NOT.(ICHAR1 .GE. 97 .AND. ICHAR1 .LE.122)) GOTO 1
      ICHAR1 = ICHAR1 - 32
    1 ICHAR2 = LINE(I) - 256 * (LINE(I) / 256)
C..   IF THE BOTTOM BYTE IS BETWEEN 'a' AND 'z', UPSHIFTS IT ...
      IF(.NOT.(ICHAR2 .GE. 97 .AND. ICHAR2 .LE.122)) GOTO 2
      ICHAR2 = ICHAR2 - 32
    2 LINE(I) = (256 * ICHAR1) + ICHAR2
    3 CONTINUE
      RETURN
      END

      logical function memptr(ipntr)
      implicit double precision (a-h,o-z)
c
c      this routine checks whether *ipntr* is a valid block pointer.
c if it is valid, *ltab* is set to point to the corresponding entry in
c the block table.
c
c... ipntr is an array to avoid 'call by value' problems (see setmem)
      dimension ipntr(1)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      memptr=.false.
      ltab=loctab
      locpnt=locf(ipntr(1))
      do 20 i=1,numblk
      if (locpnt.ne.istack(ltab+4)) go to 10
      if (ipntr(1)*istack(ltab+5).ne.istack(ltab+1)) go to 10
      memptr=.true.
      go to 30
   10 ltab=ltab+ntab
   20 continue
   30 return
      end

      subroutine fndnam(anam,jsbptr,ispot,id)
      implicit double precision (a-h,o-z)
c
c     this routine searches for an element with id 'id' by tracing back
c up the subcircuit definition list.  if the element is not found, the
c nominal element list is searched.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
      integer xxor
c
c
      isbptr=nodplc(jsbptr)
   10 if (isbptr.eq.0) go to 50
      isub=nodplc(isbptr+3)
      loc=nodplc(isub+3)
   20 if (loc.eq.0) go to 40
      if (id.ne.nodplc(loc-1)) go to 30
      locv=nodplc(loc+1)
      if (xxor(anam,value(locv)).ne.0) go to 30
      if (id.ne.20) go to 50
      go to 65
   30 loc=nodplc(loc)
      go to 20
   40 isbptr=nodplc(isbptr-1)
      go to 10
c
   50 loc=locate(id)
   60 if (loc.eq.0) go to 90
      if (nodplc(loc-1).ne.isbptr) go to 70
      locv=nodplc(loc+1)
      if (xxor(anam,value(locv)).ne.0) go to 70
   65 nodplc(ispot)=loc
      go to 100
   70 loc=nodplc(loc)
      go to 60
   90 write (iofile,91) anam
   91 format('0*error*:  unable to find ',a8/)
      nogo=1
  100 return
      end

c spice version 2g.6  sccsid=dcop.ma 3/15/83
      subroutine dcop
      implicit double precision (a-h,o-z)
c
c     this routine prints out the operating points of the nonlinear
c circuit elements.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
      logical memptr
c
c
      dimension optitl(4)
      dimension anam(12),av1(12),ai1(12),req(12)
      dimension amod(12),vd(12),cap(12)
      dimension cb(12),cc(12),vbe(12),vbc(12),vce(12),rpi(12),
     1   ro(12),cpi(12),cmu(12),betadc(12),betaac(12),ft(12),
     2   ccs(12),cbx(12),rx(12)
      dimension cg(12),vgs(12),vds(12),gds(12),vbs(12),cbd(12),cbs(12),
     2  cgsov(12),cgdov(12),cgbov(12),vth(12),vdsat(12),cd(12),gm(12),
     3  cggb(12),cgdb(12),cgsb(12),cbgb(12),cbdb(12),cbsb(12),
     4  gmb(12)
      dimension cgs(12),cgd(12),cgb(12),cds(12)
      equivalence(cb(1),cg(1)),(cc(1),vgs(1)),(vbe(1),vds(1)),
     1(vbc(1),gds(1)),(vce(1),vbs(1)),(rpi(1),cbd(1)),
     2(ro(1),cbs(1)),(cpi(1),cgsov(1)),(cmu(1),cgdov(1)),
     3(betadc(1),cgbov(1)),(betaac(1),vth(1)),(ft(1),vdsat(1)),
     4(ccs(1),cd(1)),(cbx(1),cggb(1)),(rx(1),cgdb(1))
      equivalence(vd(1),cg(1)),(cap(1),vgs(1)),(av1(1),vds(1)),
     1  (ai1(1),gds(1)),(req(1),vbs(1))
      equivalence (cgs(1),cggb(1)),(cgd(1),cgdb(1)),(cgb(1),cgsb(1)),
     1  (cds(1),cbgb(1))
      dimension afmt1(3),afmt2(2),afmt3(3),afmt4(3)
      data optitl / 8hoperatin, 8hg point , 8hinformat, 8hion      /
      data av,avd,avbe,avbc,avce,avgs,avds,avbs / 1hv,2hvd,3hvbe,3hvbc,
     1   3hvce,3hvgs,3hvds,3hvbs /
      data acntrv,acntri,asrcv,asrci,atrang,atranr,avgain,aigain /
     1   8hv-contrl, 8hi-contrl, 8hv-source, 8hi-source,
     2   8htrans-g , 8htrans-r , 8hv gain  , 8hi gain   /
      data ai,aid,aib,aic,aig / 1hi,2hid,2hib,2hic,2hig /
      data areq,arpi,aro / 3hreq,3hrpi,2hro /
      data acap,acpi,acmu,acgs,acgd,acbd,acbs / 3hcap,3hcpi,3hcmu,3hcgs,
     1   3hcgd,3hcbd,3hcbs /
      data acgsov,acgdov,acgbov /6hcgsovl,6hcgdovl,6hcgbovl/
      data acggb,acgdb,acgsb,acbgb,acbdb,acbsb /7hdqgdvgb,7hdqgdvdb,
     1  7hdqgdvsb,7hdqbdvgb,7hdqbdvdb,7hdqbdvsb/
      data acgb,acds / 3hcgb,3hcds /
      data avth, avdsat / 3hvth, 5hvdsat /
      data agm,agds / 2hgm,3hgds /
      data agmb / 4hgmb /
      data accs,acbx,arx /3hccs,3hcbx,2hrx/
      data abetad,abetaa / 6hbetadc,6hbetaac /
      data aft / 2hft /
c
      data ablnk /1h /
      data afmt1 /8h(//1h0,1,8h0x,  (2x,8h,a8))   /
      data afmt2 /8h(1h ,a8,,8h  f10.3)/
      data afmt3 /8h(1h ,a8,,8h1p  e10.,8h2)      /
      data afmt4 /8h('0model,8h   ',  (,8h2x,a8)) /
c
c.. fix-up the format statements
c
      kntr=12
      if(lwidth.le.80) kntr=7
      ipos=12
      call move(afmt1,ipos,ablnk,1,2)
      call alfnum(kntr,afmt1,ipos)
      ipos=9
      call move(afmt2,ipos,ablnk,1,2)
      call alfnum(kntr,afmt2,ipos)
      ipos=11
      call move(afmt3,ipos,ablnk,1,2)
      call alfnum(kntr,afmt3,ipos)
      ipos=14
      call move(afmt4,ipos,ablnk,1,2)
      call alfnum(kntr,afmt4,ipos)
c
c  compute voltage source currents and power dissipation
c
      call second(t1)
      if ((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 700
      power=0.0d0
      if (jelcnt(9).eq.0) go to 50
      ititle=0
   11 format (////5x,'voltage source currents'//5x,'name',
     1   7x,'current'/)
      loc=locate(9)
   20 if ((loc.eq.0).or.(nodplc(loc+11).ne.0)) go to 50
      locv=nodplc(loc+1)
      iptr=nodplc(loc+6)
      creal=value(lvnim1+iptr)
      power=power-creal*value(locv+1)
      if (ititle.eq.0) write (iofile,11)
      ititle=1
      write (iofile,21) value(locv),creal
   21 format (/5x,a8,1x,1pd10.3)
   30 loc=nodplc(loc)
      go to 20
   50 loc=locate(10)
   60 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 90
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      power=power-value(locv+1)
     1   *(value(lvnim1+node1)-value(lvnim1+node2))
      loc=nodplc(loc)
      go to 60
   90 write (iofile,91) power
   91 format (//5x,'total power dissipation  ',1pd9.2,'  watts')
c
c  small signal device parameters
c
      numdev=jelcnt(5)+jelcnt(6)+jelcnt(7)+jelcnt(8)+jelcnt(11)
     1   +jelcnt(12)+jelcnt(13)+jelcnt(14)
      if (numdev.eq.0) go to 600
      call title(0,lwidth,1,optitl)
      kntlim=lwidth/11
c
c  nonlinear voltage controlled current sources
c
      if (jelcnt(5).eq.0) go to 175
      ititle=0
  111 format(1h0,/,'0**** voltage-controlled current sources')
      loc=locate(5)
      kntr=0
  120 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 140
      kntr=kntr+1
      locv=nodplc(loc+1)
      loct=lx0+nodplc(loc+12)
      anam(kntr)=value(locv)
      ai1(kntr)=value(loct)
      if (kntr.ge.kntlim) go to 150
  130 loc=nodplc(loc)
      go to 120
  140 if (kntr.eq.0) go to 175
  150 if (ititle.eq.0) write (iofile,111)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt3) asrci,(ai1(i),i=1,kntr)
      kntr=0
      if ((loc.ne.0).and.(nodplc(loc+13).eq.0)) go to 130
c
c  nonlinear voltage controlled voltage sources
c
  175 if (jelcnt(6).eq.0) go to 186
      ititle=0
  176 format(1h0,/,'0**** voltage-controlled voltage sources')
      loc=locate(6)
      kntr=0
  178 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 182
      kntr=kntr+1
      locv=nodplc(loc+1)
      loct=lx0+nodplc(loc+13)
      anam(kntr)=value(locv)
      av1(kntr)=value(loct)
      ai1(kntr)=value(loct+1)
      if (kntr.ge.kntlim) go to 184
  180 loc=nodplc(loc)
      go to 178
  182 if (kntr.eq.0) go to 186
  184 if (ititle.eq.0) write (iofile,176)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt2) asrcv,(av1(i),i=1,kntr)
      write (iofile,afmt3) asrci,(ai1(i),i=1,kntr)
      kntr=0
      if ((loc.ne.0).and.(nodplc(loc+14).eq.0)) go to 180
c
c  nonlinear current controlled current sources
c
  186 if (jelcnt(7).eq.0) go to 196
      ititle=0
  187 format(1h0,/,'0**** current-controlled current sources')
      loc=locate(7)
      kntr=0
  188 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 192
      kntr=kntr+1
      locv=nodplc(loc+1)
      loct=lx0+nodplc(loc+12)
      anam(kntr)=value(locv)
      ai1(kntr)=value(loct)
      if (kntr.ge.kntlim) go to 194
  190 loc=nodplc(loc)
      go to 188
  192 if (kntr.eq.0) go to 196
  194 if (ititle.eq.0) write (iofile,187)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt3) asrci,(ai1(i),i=1,kntr)
      kntr=0
      if ((loc.ne.0).and.(nodplc(loc+13).eq.0)) go to 190
c
c  nonlinear current controlled voltage sources
c
  196 if (jelcnt(8).eq.0) go to 210
      ititle=0
  197 format(1h0,/,'0**** current-controlled voltage sources')
      loc=locate(8)
      kntr=0
  198 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 202
      kntr=kntr+1
      locv=nodplc(loc+1)
      loct=lx0+nodplc(loc+13)
      anam(kntr)=value(locv)
      av1(kntr)=value(loct)
      ai1(kntr)=value(loct+1)
      if (kntr.ge.kntlim) go to 204
  200 loc=nodplc(loc)
      go to 198
  202 if (kntr.eq.0) go to 210
  204 if (ititle.eq.0) write (iofile,197)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt2) asrcv,(av1(i),i=1,kntr)
      write (iofile,afmt3) asrci,(ai1(i),i=1,kntr)
      kntr=0
      if ((loc.ne.0).and.(nodplc(loc+14).eq.0)) go to 200
c
c  diodes
c
  210 if (jelcnt(11).eq.0) go to 300
      ititle=0
  211 format(1h0,/,'0**** diodes')
      loc=locate(11)
      kntr=0
  220 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 240
      kntr=kntr+1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      locm=nodplc(loc+5)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+11)
      anam(kntr)=value(locv)
      amod(kntr)=value(locm)
      cd(kntr)=value(loct+1)
      vd(kntr)=value(lvnim1+node1)-value(lvnim1+node2)
      if (modedc.ne.1) go to 225
      req(kntr)=1.0d0/value(loct+2)
      cap(kntr)=value(loct+4)
  225 if (kntr.ge.kntlim) go to 250
  230 loc=nodplc(loc)
      go to 220
  240 if (kntr.eq.0) go to 300
  250 if (ititle.eq.0) write (iofile,211)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt4) (amod(i),i=1,kntr)
      write (iofile,afmt3) aid,(cd(i),i=1,kntr)
      write (iofile,afmt2) avd,(vd(i),i=1,kntr)
      if (modedc.ne.1) go to 260
      write (iofile,afmt3) areq,(req(i),i=1,kntr)
      write (iofile,afmt3) acap,(cap(i),i=1,kntr)
  260 kntr=0
      if ((loc.ne.0).and.(nodplc(loc+16).eq.0)) go to 230
c
c  bipolar junction transistors
c
  300 if (jelcnt(12).eq.0) go to 400
      ititle=0
  301 format(1h0,/,'0**** bipolar junction transistors')
      loc=locate(12)
      kntr=0
  320 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 340
      kntr=kntr+1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      locm=nodplc(loc+8)
      type=nodplc(locm+2)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+22)
      anam(kntr)=value(locv)
      amod(kntr)=value(locm)
      cb(kntr)=type*value(loct+3)
      cc(kntr)=type*value(loct+2)
      vbe(kntr)=value(lvnim1+node2)-value(lvnim1+node3)
      vbc(kntr)=value(lvnim1+node2)-value(lvnim1+node1)
      vce(kntr)=vbe(kntr)-vbc(kntr)
      betadc(kntr)=cc(kntr)/dsign(dmax1(dabs(cb(kntr)),1.0d-20),
     1  cb(kntr))
      if (modedc.ne.1) go to 325
      rx(kntr)=0.0d0
      if(value(loct+16).ne.0.0d0) rx(kntr)=1.0d0/value(loct+16)
      ccs(kntr)=value(loct+13)
      cbx(kntr)=value(loct+15)
      rpi(kntr)=1.0d0/value(loct+4)
      gm(kntr)=value(loct+6)
      ro(kntr)=1.0d0/value(loct+7)
      cpi(kntr)=value(loct+9)
      cmu(kntr)=value(loct+11)
      betaac(kntr)=gm(kntr)*rpi(kntr)
      ft(kntr)=gm(kntr)/(twopi*dmax1(cpi(kntr)+cmu(kntr)+cbx(kntr),
     1  1.0d-20))
  325 if (kntr.ge.kntlim) go to 350
  330 loc=nodplc(loc)
      go to 320
  340 if (kntr.eq.0) go to 400
  350 if (ititle.eq.0) write (iofile,301)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt4) (amod(i),i=1,kntr)
      write (iofile,afmt3) aib,(cb(i),i=1,kntr)
      write (iofile,afmt3) aic,(cc(i),i=1,kntr)
      write (iofile,afmt2) avbe,(vbe(i),i=1,kntr)
      write (iofile,afmt2) avbc,(vbc(i),i=1,kntr)
      write (iofile,afmt2) avce,(vce(i),i=1,kntr)
      write (iofile,afmt2) abetad,(betadc(i),i=1,kntr)
      if (modedc.ne.1) go to 360
      write (iofile,afmt3) agm,(gm(i),i=1,kntr)
      write (iofile,afmt3) arpi,(rpi(i),i=1,kntr)
      write (iofile,afmt3) arx,(rx(i),i=1,kntr)
      write (iofile,afmt3) aro,(ro(i),i=1,kntr)
      write (iofile,afmt3) acpi,(cpi(i),i=1,kntr)
      write (iofile,afmt3) acmu,(cmu(i),i=1,kntr)
      write (iofile,afmt3) acbx,(cbx(i),i=1,kntr)
      write (iofile,afmt3) accs,(ccs(i),i=1,kntr)
      write (iofile,afmt2) abetaa,(betaac(i),i=1,kntr)
      write (iofile,afmt3) aft,(ft(i),i=1,kntr)
  360 kntr=0
      if ((loc.ne.0).and.(nodplc(loc+36).eq.0)) go to 330
c
c  jfets
c
  400 if (jelcnt(13).eq.0) go to 500
      ititle=0
  401 format(1h0,/,'0**** jfets')
      loc=locate(13)
      kntr=0
  420 if ((loc.eq.0).or.(nodplc(loc+25).ne.0)) go to 440
      kntr=kntr+1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      locm=nodplc(loc+7)
      type=nodplc(locm+2)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+19)
      anam(kntr)=value(locv)
      amod(kntr)=value(locm)
      cd(kntr)=type*(value(loct+3)-value(loct+4))
      vgs(kntr)=value(lvnim1+node2)-value(lvnim1+node3)
      vds(kntr)=value(lvnim1+node1)-value(lvnim1+node3)
      if (modedc.ne.1) go to 425
      gm(kntr)=value(loct+5)
      gds(kntr)=value(loct+6)
      cgs(kntr)=value(loct+9)
      cgd(kntr)=value(loct+11)
  425 if (kntr.ge.kntlim) go to 450
  430 loc=nodplc(loc)
      go to 420
  440 if (kntr.eq.0) go to 500
  450 if (ititle.eq.0) write (iofile,401)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt4) (amod(i),i=1,kntr)
      write (iofile,afmt3) aid,(cd(i),i=1,kntr)
      write (iofile,afmt2) avgs,(vgs(i),i=1,kntr)
      write (iofile,afmt2) avds,(vds(i),i=1,kntr)
      if (modedc.ne.1) go to 460
      write (iofile,afmt3) agm,(gm(i),i=1,kntr)
      write (iofile,afmt3) agds,(gds(i),i=1,kntr)
      write (iofile,afmt3) acgs,(cgs(i),i=1,kntr)
      write (iofile,afmt3) acgd,(cgd(i),i=1,kntr)
  460 kntr=0
      if ((loc.ne.0).and.(nodplc(loc+25).eq.0)) go to 430
c
c  mosfets
c
  500 if (jelcnt(14).eq.0) go to 600
      ititle=0
  501 format(1h0,/,'0**** mosfets')
      loc=locate(14)
      kntr=0
  520 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 540
      kntr=kntr+1
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      locm=nodplc(loc+8)
      type=nodplc(locm+2)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+26)
      anam(kntr)=value(locv)
      amod(kntr)=value(locm)
      cd(kntr)=type*value(loct+4)
      vgs(kntr)=value(lvnim1+node2)-value(lvnim1+node3)
      vds(kntr)=value(lvnim1+node1)-value(lvnim1+node3)
      vbs(kntr)=value(lvnim1+node4)-value(lvnim1+node3)
      if (modedc.ne.1) go to 525
      xl=value(locv+1)-2.0d0*value(locm+28)
      xw=value(locv+2)
      covlgs=value(locm+13)*xw
      covlgd=value(locm+14)*xw
      covlgb=value(locm+15)*xl
      xqco=value(locm+35)
      devmod=value(locv+8)
      vdsat(kntr)=value(locv+10)
      vth(kntr)=value(locv+9)
      gm(kntr)=value(loct+7)
      gds(kntr)=value(loct+8)
      gmb(kntr)=value(loct+9)
      if(devmod.gt.0.0d0) go to 521
      vth(kntr)=value(locv+9)
  521 cbd(kntr)=value(loct+24)
      cbs(kntr)=value(loct+26)
      cgsov(kntr)=covlgs
      cgdov(kntr)=covlgd
      cgbov(kntr)=covlgb
      if (xqco.gt.0.5d0) go to 522
      cggb(kntr)=value(loct+18)
      cgdb(kntr)=value(loct+19)
      cgsb(kntr)=value(loct+20)
      cbgb(kntr)=value(loct+21)
      cbdb(kntr)=value(loct+22)
      cbsb(kntr)=value(loct+23)
      go to 525
  522 cgs(kntr)=value(loct+12)
      cgd(kntr)=value(loct+14)
      cgb(kntr)=value(loct+16)
  525 if (kntr.ge.kntlim) go to 550
  530 loc=nodplc(loc)
      go to 520
  540 if (kntr.eq.0) go to 600
  550 if (ititle.eq.0) write (iofile,501)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt4) (amod(i),i=1,kntr)
      if(type.eq.0.0d0) go to 555
      write (iofile,afmt3) aid,(cd(i),i=1,kntr)
      write (iofile,afmt2) avgs,(vgs(i),i=1,kntr)
      write (iofile,afmt2) avds,(vds(i),i=1,kntr)
      write (iofile,afmt2) avbs,(vbs(i),i=1,kntr)
      if (modedc.ne.1) go to 560
      write (iofile,afmt2) avth,(vth(i),i=1,kntr)
      write (iofile,afmt2) avdsat,(vdsat(i),i=1,kntr)
      write (iofile,afmt3) agm,(gm(i),i=1,kntr)
      write (iofile,afmt3) agds,(gds(i),i=1,kntr)
      write (iofile,afmt3) agmb,(gmb(i),i=1,kntr)
      write (iofile,afmt3) acbd,(cbd(i),i=1,kntr)
      write (iofile,afmt3) acbs,(cbs(i),i=1,kntr)
      write (iofile,afmt3) acgsov,(cgsov(i),i=1,kntr)
      write (iofile,afmt3) acgdov,(cgdov(i),i=1,kntr)
      write (iofile,afmt3) acgbov,(cgbov(i),i=1,kntr)
      if (xqco.gt.0.5d0) go to 552
      write (iofile,551)
  551 format(' derivatives of gate (dqgdvx) and bulk (dqbdvx) charges')
      write (iofile,afmt3) acggb,(cggb(i),i=1,kntr)
      write (iofile,afmt3) acgdb,(cgdb(i),i=1,kntr)
      write (iofile,afmt3) acgsb,(cgsb(i),i=1,kntr)
      write (iofile,afmt3) acbgb,(cbgb(i),i=1,kntr)
      write (iofile,afmt3) acbdb,(cbdb(i),i=1,kntr)
      write (iofile,afmt3) acbsb,(cbsb(i),i=1,kntr)
      go to 560
  552 write (iofile,afmt3) acgs,(cgs(i),i=1,kntr)
      write (iofile,afmt3) acgd,(cgd(i),i=1,kntr)
      write (iofile,afmt3) acgb,(cgb(i),i=1,kntr)
      go to 560
  555 write (iofile,afmt3) aid,(cd(i),i=1,kntr)
      write (iofile,afmt3) aig,(cg(i),i=1,kntr)
      write (iofile,afmt2) avgs,(vgs(i),i=1,kntr)
      write (iofile,afmt2) avds,(vds(i),i=1,kntr)
      write (iofile,afmt2) avbs,(vbs(i),i=1,kntr)
      if (modedc.ne.1) go to 560
      write (iofile,afmt3) agm,(gm(i),i=1,kntr)
      write (iofile,afmt3) agds,(gds(i),i=1,kntr)
      write (iofile,afmt3) acgs,(cgs(i),i=1,kntr)
      write (iofile,afmt3) acgd,(cgd(i),i=1,kntr)
      write (iofile,afmt3) acgb,(cgb(i),i=1,kntr)
      write (iofile,afmt3) acds,(cds(i),i=1,kntr)
  560 kntr=0
      if ((loc.ne.0).and.(nodplc(loc+33).eq.0)) go to 530
c
c  operating point analyses
c
  600 if (modedc.ne.1) go to 700
      if (kinel.eq.0) go to 610
      call sstf
  610 if (nsens.eq.0) go to 700
      call sencal
c
c  finished
c
  700 if (modedc.eq.2) go to 710
      if (jacflg.ne.0) go to 705
      call clrmem(lvnim1)
      call clrmem(lx0)
  705 call clrmem(lvn)
      call clrmem(lvntmp)
      if (memptr(macins)) call clrmem(macins)
  710 call second(t2)
      rstats(5)=rstats(5)+t2-t1
      return
      end

      integer function xxor(a,b)
      implicit double precision (a-h,o-z)
c
c     this routine computes a single-precision integer result which is
c the result of exclusive-or*ing the two real-valued arguments a and b
c together.
c
      xxor=1
      if(a.eq.b) xxor=0
      return
      end

      subroutine memory
      implicit double precision (a-h,o-z)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
      if(icore.le.maxmem) go to 10
    5 memerr=4
      return
   10 continue
c
c  set job field length to 'icore+locf(istack(ifwa))'
c
      return
      end

c spice version 2g.6  sccsid=errchk.ma 3/15/83
      subroutine errchk
      implicit double precision (a-h,o-z)
c
c
c     this routine drives the pre-processing and general error-checking
c of input performed by spice.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=cje 3/15/83
      common /cje/ maxtim,itime,icost
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension titlop(4)
      dimension nnods(50),aname(2)
      data aname / 4htrap, 4hgear /
      data titlop / 8hoption s, 8hummary  , 8h        , 8h         /
      data ndefin / 2h.u /
      data nnods / 2, 2, 2, 0, 2, 2, 2, 2, 2, 2,
     1             2, 4, 3, 4, 0, 0, 4, 0, 1, 0,
     2             0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     3             0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     4             2, 2, 2, 0, 0, 0, 0, 0, 0, 0 /
      data aelmt,amodel,aoutpt /7helement,5hmodel,6houtput/
      data alsdc,alstr,alsac / 2hdc, 4htran, 2hac /
c
c
      call second(t1)
      do 60 id=1,50
      loc=locate(id)
   10 if (loc.eq.0) go to 60
      if (nodplc(loc+2).ne.ndefin) go to 50
      nogo=1
      locv=nodplc(loc+1)
      if (id.ge.21) go to 20
      anam=aelmt
      go to 40
   20 if (id.ge.31) go to 30
      anam=amodel
      go to 40
   30 anam=aoutpt
   40 write (iofile,41) anam,value(locv)
   41 format('0*error*:  ',2a8,' has been referenced but not defined'/)
   50 loc=nodplc(loc)
      go to 10
   60 continue
      if (nogo.ne.0) go to 2000
c
c  construct ordered list of user specified nodes
c
      call getm4(junode,1)
      nodplc(junode+1)=0
      nunods=1
      do 180 id=1,50
      if (nnods(id).eq.0) go to 180
      loc=locate(id)
  110 if (loc.eq.0) go to 180
      if (id.le.4) go to 120
      if (id.le.8) go to 150
      if (id.eq.19) go to 165
      if (id.le.40) go to 120
      if (id.le.43) go to 170
  120 jstop=loc+nnods(id)-1
      do 130 j=loc,jstop
      call putnod(nodplc(j+2))
  130 continue
      go to 170
  150 call putnod(nodplc(loc+2))
      call putnod(nodplc(loc+3))
      if (id.ge.7) go to 170
      locp=nodplc(loc+id+1)
      nssnod=2*nodplc(loc+4)
  155 do 160 j=1,nssnod
      call putnod(nodplc(locp+j))
  160 continue
      go to 170
  165 locp=nodplc(loc+2)
      call sizmem(nodplc(loc+2),nssnod)
      go to 155
  170 loc=nodplc(loc)
      go to 110
  180 continue
      if (nogo.ne.0) go to 2000
      ncnods=nunods
c
c  assign program nodes
c
  200 do 280 id=1,50
      if (nnods(id).eq.0) go to 280
      loc=locate(id)
  210 if (loc.eq.0) go to 280
      if (id.le.4) go to 220
      if (id.le.8) go to 250
      if (id.eq.19) go to 265
      if (id.le.40) go to 220
      if (id.le.43) go to 240
  220 jstop=loc+nnods(id)-1
      do 230 j=loc,jstop
      call getnod(nodplc(j+2))
  230 continue
      go to 270
  240 if (nodplc(loc+5).eq.0) go to 220
      go to 270
  250 call getnod(nodplc(loc+2))
      call getnod(nodplc(loc+3))
      if (id.ge.7) go to 270
      locp=nodplc(loc+id+1)
      nssnod=2*nodplc(loc+4)
  255 do 260 j=1,nssnod
      call getnod(nodplc(locp+j))
  260 continue
      go to 270
  265 locp=nodplc(loc+2)
      call sizmem(nodplc(loc+2),nssnod)
      go to 255
  270 loc=nodplc(loc)
      go to 210
  280 continue
c
c  check and set .nodeset nodes to their internal values
c
      call sizmem(nsnod,nic)
      if(nic.eq.0) go to 300
      do 290 i=1,nic
      call getnod(nodplc(nsnod+i))
  290 continue
c
c   check and set .ic nodes to their internal values
c
  300 call sizmem(icnod,nic)
      if(nic.eq.0) go to 320
      do 310 i=1,nic
      call getnod(nodplc(icnod+i))
  310 continue
  320 if (nogo.ne.0) go to 2000
c
c  expand subcircuit calls
c
      call subckt
      if (nogo.ne.0) go to 2000
      if (ncnods.ge.2) go to 400
      write (iofile,321)
  321 format('0*error*:  circuit has no nodes'/)
      nogo=1
      go to 2000
  400 numnod=ncnods
c
c  link unsatisfied references
c
      call lnkref
      if (nogo.ne.0) go to 2000
c
c  generate subcircuit element names
c
      if (jelcnt(19).eq.0) go to 530
      do 520 id=1,24
      loc=locate(id)
  510 if (loc.eq.0) go to 520
      call subnam(loc)
      loc=nodplc(loc)
      go to 510
  520 continue
c
c  translate node initial conditions to device initial conditions
c  (capacitance, diode, bjt, jfet and mosfet only) when uic is
c  specified on the .tran card
c
  530 if (nosolv.le.0) go to 600
      call sizmem(icnod,nic)
      if(nic.eq.0) go to 600
      call getm8(lvnim1,numnod)
      call zero8(value(lvnim1+1),numnod)
      do 535 i=1,nic
      node=nodplc(icnod+i)
  535 value(lvnim1+node)=value(icval+i)
      loc=locate(2)
  540 if(loc.eq.0) go to 550
      locv=nodplc(loc+1)
      if(value(locv+2).ne.0.0d0) go to 545
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      value(locv+2)=value(lvnim1+node1)-value(lvnim1+node2)
  545 loc=nodplc(loc)
      go to 540
  550 loc=locate(11)
  555 if(loc.eq.0) go to 565
      locv=nodplc(loc+1)
      if(value(locv+2).ne.0.0d0) go to 560
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      value(locv+2)=value(lvnim1+node1)-value(lvnim1+node2)
  560 loc=nodplc(loc)
      go to 555
  565 loc=locate(12)
  570 if(loc.eq.0) go to 580
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      if(value(locv+2).eq.0.0d0) value(locv+2)=value(lvnim1+node2)-
     1  value(lvnim1+node3)
      if(value(locv+3).eq.0.0d0) value(locv+3)=value(lvnim1+node1)-
     1  value(lvnim1+node3)
      loc=nodplc(loc)
      go to 570
  580 loc=locate(13)
  585 if(loc.eq.0) go to 590
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      if(value(locv+2).eq.0.0d0) value(locv+2)=value(lvnim1+node1)-
     1  value(lvnim1+node3)
      if(value(locv+3).eq.0.0d0) value(locv+3)=value(lvnim1+node2)-
     1  value(lvnim1+node3)
      loc=nodplc(loc)
      go to 585
  590 loc=locate(14)
  595 if(loc.eq.0) go to 598
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      if(value(locv+5).eq.0.0d0) value(locv+5)=value(lvnim1+node1)-
     1  value(lvnim1+node3)
      if(value(locv+6).eq.0.0d0) value(locv+6)=value(lvnim1+node2)-
     1  value(lvnim1+node3)
      if(value(locv+7).eq.0.0d0) value(locv+7)=value(lvnim1+node4)-
     1  value(lvnim1+node3)
      loc=nodplc(loc)
      go to 595
  598 call clrmem(lvnim1)
c
c  process sources
c
  600 if (jtrflg.eq.0) go to 700
      do 690 id=9,10
      loc=locate(id)
  610 if (loc.eq.0) go to 690
      locv=nodplc(loc+1)
      locp=nodplc(loc+5)
      jtype=nodplc(loc+4)+1
      go to (680,620,630,640,650,675), jtype
  620 value(locp+3)=dmax1(value(locp+3),0.0d0)
      if (value(locp+4).le.0.0d0) value(locp+4)=tstep
      if (value(locp+5).le.0.0d0) value(locp+5)=tstep
      if (value(locp+6).le.0.0d0) value(locp+6)=tstop
      if (value(locp+7).le.0.0d0) value(locp+7)=tstop
      temp=value(locp+4)+value(locp+5)+value(locp+6)
      value(locp+7)=dmax1(value(locp+7),temp)
      value(locv+1)=value(locp+1)
      go to 680
  630 if (value(locp+3).le.0.0d0) value(locp+3)=1.0d0/tstop
      value(locp+4)=dmax1(value(locp+4),0.0d0)
      value(locv+1)=value(locp+1)
      go to 680
  640 value(locp+3)=dmax1(value(locp+3),0.0d0)
      if (value(locp+4).le.0.0d0) value(locp+4)=tstep
      if (value(locp+5).le.value(locp+3))
     1   value(locp+5)=value(locp+3)+tstep
      if (value(locp+6).le.0.0d0) value(locp+6)=tstep
      value(locv+1)=value(locp+1)
      go to 680
  650 value(locp+1)=dmin1(dmax1(value(locp+1),0.0d0),tstop)
      iknt=1
      call sizmem(nodplc(loc+5),nump)
  660 temp=value(locp+iknt)
      if (value(locp+iknt+2).eq.0.0d0) go to 670
      if (value(locp+iknt+2).ge.tstop) go to 670
      value(locp+iknt+2)=dmax1(value(locp+iknt+2),temp)
      if(temp.ne.value(locp+iknt+2)) go to 665
      write(iofile,661) value(locv)
  661 format('0*error*:  element ',a8,' piecewise linear source table no
     1t increasing in time')
      nogo=1
  665 iknt=iknt+2
      if (iknt.lt.nump) go to 660
  670 value(locp+iknt+2)=tstop
      value(locv+1)=value(locp+2)
      call relmem(nodplc(loc+5),nump-iknt-3)
      go to 680
  675 if (value(locp+3).le.0.0d0) value(locp+3)=1.0d0/tstop
      if (value(locp+5).le.0.0d0) value(locp+5)=1.0d0/tstop
      value(locv+1)=value(locp+1)
  680 loc=nodplc(loc)
      go to 610
  690 continue
c
c  use default values for mos device geometries if not specified
c
  700 loc=locate(14)
  710 if(loc.eq.0) go to 720
      locv=nodplc(loc+1)
      if(value(locv+1).le.0.0d0) value(locv+1)=defl
      if(value(locv+2).le.0.0d0) value(locv+2)=defw
      if(value(locv+3).le.0.0d0) value(locv+3)=defad
      if(value(locv+4).le.0.0d0) value(locv+4)=defas
      loc=nodplc(loc)
      go to 710
c
c  print listing of elements, process device models,
c  and check topology
c
  720 if (iprntl.eq.0) go to 730
      call elprnt
  730 call topchk
      call modchk
      if (nogo.ne.0) go to 2000
c
c  invert resistance values
c
  800 loc=locate(1)
  810 if (loc.eq.0) go to 900
      locv=nodplc(loc+1)
      value(locv+1)=1.0d0/value(locv+2)
      loc=nodplc(loc)
      go to 810
c
c  process mutual inductors
c
  900 loc=locate(4)
  910 if (loc.eq.0) go to 1000
      locv=nodplc(loc+1)
      nl1=nodplc(loc+2)
      lptr1=nodplc(nl1+1)
      nl2=nodplc(loc+3)
      lptr2=nodplc(nl2+1)
      value(locv+1)=value(locv+1)*dsqrt(value(lptr1+1)*value(lptr2+1))
      loc=nodplc(loc)
      go to 910
c
c  limit delmax  if transmission lines in circuit
c
 1000 if (jtrflg.eq.0) go to 1200
      tdmax=0.0d0
      loc=locate(17)
 1010 if (loc.eq.0) go to 1200
      locv=nodplc(loc+1)
      delmax=dmin1(delmax,value(locv+2)/2.0d0)
      tdmax=dmax1(tdmax,value(locv+2))
      loc=nodplc(loc)
      go to 1010
c
c  process source parameters
c
 1200 numbkp=0
      if (jtrflg.eq.0) go to 1205
      tol=1.0d-2*delmax
      numbkp=2
      call getm8(lsbkpt,numbkp)
      value(lsbkpt+1)=0.0d0
      value(lsbkpt+2)=tstop
 1205 do 1290 id=9,10
      loc=locate(id)
 1210 if (loc.eq.0) go to 1290
      locv=nodplc(loc+1)
      locp=nodplc(loc+5)
      temp=value(locv+3)/rad
      value(locv+3)=value(locv+2)*dsin(temp)
      value(locv+2)=value(locv+2)*dcos(temp)
      if (jtrflg.eq.0) go to 1280
      jtype=nodplc(loc+4)+1
      go to (1280,1220,1230,1235,1240,1260), jtype
 1220 value(locp+4)=value(locp+4)+value(locp+3)
      temp=value(locp+5)
      value(locp+5)=value(locp+4)+value(locp+6)
      value(locp+6)=value(locp+5)+temp
      time=0.0d0
 1225 call extmem(lsbkpt,4)
      value(lsbkpt+numbkp+1)=value(locp+3)+time
      value(lsbkpt+numbkp+2)=value(locp+4)+time
      value(lsbkpt+numbkp+3)=value(locp+5)+time
      value(lsbkpt+numbkp+4)=value(locp+6)+time
      numbkp=numbkp+4
      time=time+value(locp+7)
      if (time.ge.tstop) go to 1280
      go to 1225
 1230 value(locp+3)=value(locp+3)*twopi
      call extmem(lsbkpt,1)
 1231 value(lsbkpt+numbkp+1)=value(locp+4)
      numbkp=numbkp+1
      go to 1280
 1235 call extmem(lsbkpt,2)
      value(lsbkpt+numbkp+1)=value(locp+3)
      value(lsbkpt+numbkp+2)=value(locp+5)
      numbkp=numbkp+2
      go to 1280
 1240 iknt=1
      call sizmem(nodplc(loc+5),nump)
 1250 call extmem(lsbkpt,1)
      value(lsbkpt+numbkp+1)=value(locp+iknt)
      numbkp=numbkp+1
      iknt=iknt+2
      if (iknt.le.nump) go to 1250
      go to 1280
 1260 value(locp+3)=value(locp+3)*twopi
      value(locp+5)=value(locp+5)*twopi
 1280 loc=nodplc(loc)
      go to 1210
 1290 continue
c
c  augment breakpoint table for transmission line delays
c
      if (jtrflg.eq.0) go to 1300
      loc=locate(17)
 1292 if (loc.eq.0) go to 1300
      locv=nodplc(loc+1)
      td=value(locv+2)
      ntemp=numbkp
      do 1296 ibkp=1,ntemp
      time=value(lsbkpt+ibkp)
 1294 time=time+td
      if (time.ge.tstop) go to 1296
      call extmem(lsbkpt,1)
      value(lsbkpt+numbkp+1)=time
      numbkp=numbkp+1
      go to 1294
 1296 continue
      call shlsrt(value(lsbkpt+1),numbkp)
      nbkpt=1
      do 1298 i=2,numbkp
      if ((value(lsbkpt+i)-value(lsbkpt+nbkpt)).lt.tol) go to 1298
      nbkpt=nbkpt+1
      value(lsbkpt+nbkpt)=value(lsbkpt+i)
      if (value(lsbkpt+nbkpt).ge.tstop) go to 1299
 1298 continue
 1299 call relmem(lsbkpt,numbkp-nbkpt)
      numbkp=nbkpt
      value(lsbkpt+numbkp)=dmax1(value(lsbkpt+numbkp),tstop)
      loc=nodplc(loc)
      go to 1292
c
c  finish breakpoint table
c
 1300 if (jtrflg.eq.0) go to 1600
      call extmem(lsbkpt,1)
      value(lsbkpt+numbkp+1)=tstop
      numbkp=numbkp+1
      call shlsrt(value(lsbkpt+1),numbkp)
      nbkpt=1
      do 1310 i=2,numbkp
      if ((value(lsbkpt+i)-value(lsbkpt+nbkpt)).lt.tol) go to 1310
      nbkpt=nbkpt+1
      value(lsbkpt+nbkpt)=value(lsbkpt+i)
      if (value(lsbkpt+nbkpt).ge.tstop) go to 1320
 1310 continue
 1320 call relmem(lsbkpt,numbkp-nbkpt)
      numbkp=nbkpt
      value(lsbkpt+numbkp)=dmax1(value(lsbkpt+numbkp),tstop)
c
c  print option summary
c
 1600 if (iprnto.eq.0) go to 1700
      call title(0,lwidth,1,titlop)
      write (iofile,1601) gmin,reltol,abstol,vntol,lvlcod,itl1,itl2
 1601 format('0dc analysis -',/,
     1   '0    gmin   = ',1pd10.3,/,
     2   '     reltol = ',  d10.3,/,
     3   '     abstol = ',  d10.3,/,
     4   '     vntol  = ',  d10.3,/,
     5   '     lvlcod = ',     i6,/,
     6   '     itl1   = ',     i6,/,
     7   '     itl2   = ',     i6,/)
      write (iofile,1605) pivtol,pivrel
 1605 format(
     1   '     pivtol = ',1pd10.3,/,
     2   '     pivrel = ',  d10.3)
      write (iofile,1611) aname(method),maxord,chgtol,trtol,lvltim,xmu,
     1   itl3,itl4,itl5
 1611 format('0transient analysis -',/,
     1   '0    method =  ',a8,/,
     2   '     maxord = ',     i6,/,
     3   '     chgtol = ',1pd10.3,/,
     4   '     trtol  = ',  d10.3,/,
     5   '     lvltim = ',     i6,/,
     6   '     mu     = ',0pf10.3,/,
     7   '     itl3   = ',     i6,/,
     8   '     itl4   = ',     i6,/,
     9   '     itl5   = ',     i6,/)
      write (iofile,1621) limpts,limtim,maxtim,numdgt,value(itemps+1),
     1   defl,defw,defad,defas
 1621 format('0miscellaneous -',/,
     1   '0    limpts = ',     i6,/,
     2   '     limtim = ',     i6,/,
     3   '     cptime = ',     i9,/,
     4   '     numdgt = ',     i6,/,
     5   '     tnom   = ',0pf10.3,/,
     6   '     defl   = ',1pd10.3,/,
     7   '     defw   = ',d10.3,/,
     8   '     defad  = ',d10.3,/,
     9   '     defas  = ',d10.3)
c
c  miscellaneous error checking
c
 1700 if (icvflg.eq.0) go to 1720
      if (icvflg.le.limpts) go to 1710
      icvflg=0
      write (iofile,1701) limpts,alsdc
 1701 format('0warning:  more than ',i5,' points for ',a4,' analysis,',/
     11x,'analysis omitted.  this limit may be overridden using the ',/
     21x,'limpts parameter on the .option card'/)
      go to 1720
 1710 if ((jelcnt(31)+jelcnt(36)).gt.0) go to 1720
      if(ipostp.ne.0) go to 1720
      icvflg=0
      write (iofile,1711) alsdc
 1711 format('0warning:  no ',a4,' outputs specified .',
     1  '.. analysis omitted'/)
 1720 if (jtrflg.eq.0) go to 1740
      if (method.eq.1) maxord=2
      if ((method.eq.2).and.(maxord.ge.3)) lvltim=2
      if (jtrflg.le.limpts) go to 1730
      jtrflg=0
      write (iofile,1701) limpts,alstr
      go to 1740
 1730 if ((jelcnt(32)+jelcnt(37)+nfour).gt.0) go to 1735
      if(ipostp.ne.0) go to 1735
      jtrflg=0
      write (iofile,1711) alstr
      go to 1740
 1735 if (nfour.eq.0) go to 1740
      forprd=1.0d0/forfre
      if ((tstop-forprd).ge.(tstart-1.0d-12)) go to 1740
      nfour=0
      call clrmem(ifour)
      write (iofile,1736)
 1736 format('0warning:  fourier analysis fundamental frequency is incom
     1patible with'/11x,'transient analysis print interval ... fourier a
     2nalysis omitted'/)
 1740 if (jacflg.eq.0) go to 1800
      if (jacflg.le.limpts) go to 1750
      jacflg=0
      write (iofile,1701) limpts,alsac
      go to 1800
 1750 if ((jelcnt(33)+jelcnt(34)+jelcnt(35)+jelcnt(38)+jelcnt(39)
     1   +jelcnt(40)+idist+inoise).gt.0) go to 1800
      if(ipostp.ne.0) go to 1800
      jacflg=0
      write (iofile,1711) alsac
c
c  sequence through the output lists
c
 1800 do 1820 id=41,45
      if (id.le.43) numout=1
      loc=locate(id)
 1810 if (loc.eq.0) go to 1820
      numout=numout+1
      nodplc(loc+4)=numout
      loc=nodplc(loc)
      go to 1810
 1820 continue
c
c   increase number of .prints if too many outputs for output line-width
c
      ifwdth=max0(numdgt-1,0)+9
      noprln=min0(8,(lwidth-12)/ifwdth)
      do 1860 id=31,35
      loc=locate(id)
 1830 if(loc.eq.0) go to 1860
      noprex=nodplc(loc+3)-noprln
      if(noprex.le.0) go to 1850
      nodplc(loc+3)=noprln
      call find(dble(jelcnt(id)),id,locnew,1)
      nodplc(locnew+2)=nodplc(loc+2)
      nodplc(locnew+3)=noprex
      call copy4(nodplc(loc+2*noprln+4),nodplc(locnew+4),2*noprex)
 1850 loc=nodplc(loc)
      go to 1830
 1860 continue
c
c  exit
c
 2000 call second(t2)
      rstats(1)=rstats(1)+t2-t1
      return
      end

      subroutine disto(loco)
      implicit double precision (a-h,o-z)
c
c     this routine performs the small-signal distortion analysis.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      complex difvn1,difvn2,difvn3,difvi1,difvi2,difvi3,dsgo2,dsgm2,
     1   dsgmu2,dsgpi2,dscb1,dscb1r,dscje1,dscjc1,disto1,disto2,disto3,
     2   dsgmo2,dgm2o3,dgmo23,bew,cew,bcw,be2w,ce2w,bc2w,bew2,cew2,
     3   bcw2,bew12,cew12,bcw12,dscdb1,dscdj1,dsg2,cvabe,cvabc,cvace,
     4   cvout,cvdist
      dimension distit(4)
      dimension vdo(2,12)
      complex cvdo(12)
      real vdo
      equivalence (cvdo(1),vdo(1,1))
      data distit / 8hdistorti, 8hon analy, 8hsis     , 8h        /
c
c
      icvw1=ld1
      icv2w1=icvw1+nstop
      icvw2=icv2w1+nstop
      icvw12=icvw2+nstop
      icvadj=icvw12+nstop
      iprnt=0
      if (icalc.ge.2) go to 10
      idnp=nodplc(idist+2)
      idnn=nodplc(idist+3)
      locv=nodplc(idist+1)
      rload=1.0d0/value(locv+1)
      kntr=1
   10 if (idprt.eq.0) go to 30
      if (kntr.gt.icalc) go to 30
      iprnt=1
      kntr=kntr+idprt
      call title(0,lwidth,1,distit)
   30 freq1=dble(real(cvalue(loco+1)))
      freq2=skw2*freq1
      call copy16(cvalue(lcvn+1),cvalue(icvw1+1),nstop)
      cvout=cvalue(icvw1+idnp)-cvalue(icvw1+idnn)
      call magphs(cvout,omag,ophase)
c
c  begin the distortion analysis
c
      do 1000 kdisto=1,7
      cvdist=cmplx(0.0e0,0.0e0)
      go to (1000,110,120,130,140,160,170),kdisto
  110 freqd=2.0d0*freq1
      arg=dsqrt(2.0d0*rload*refprl)/(omag*omag)
      if (iprnt.eq.0) go to 200
      write (iofile,111) freq1,freqd,omag,ophase
  111 format (///5x,'2nd harmonic distortion',30x,'freq1 = ',1pd9.2,
     1   '  hz'//5x,'distortion frequency  ',d9.2,'  hz',16x,
     2   'mag ',d9.3,3x,'phs ',0pf7.2)
      go to 200
  120 freqd=3.0d0*freq1
      arg=2.0d0*rload*refprl/(omag*omag*omag)
      if (iprnt.eq.0) go to 200
      write (iofile,121) freq1,freqd,omag,ophase
  121 format (1h1,4x,'3rd harmonic distortion',30x,'freq1 = ',1pd9.2,
     1   '  hz'//5x,'distortion frequency  ',d9.2,'  hz',16x,
     2   'mag ',d9.3,3x,'phs ',0pf7.2)
      go to 200
  130 freqd=freq2
      go to 200
  140 freqd=freq1-freq2
      arg=dsqrt(2.0d0*rload*refprl)*spw2/(omag*omag)
      if (iprnt.eq.0) go to 200
      write (iofile,151) freq1,freq2,freqd,omag,ophase,ow2mag,ow2phs
  151 format (1h1,4x,'2nd order intermodulation difference component',
     1   7x,'freq1 = ',1pd9.2,'  hz',15x,'freq2 = ',d9.2,'  hz'//
     2   5x,'distortion frequency  ',d9.2,'  hz',16x,'mag ',
     3   d9.3,3x,'phs ',0pf7.2,9x,'mag ',1pd9.3,3x,'phs ',0pf7.2)
      go to 200
  160 freqd=freq1+freq2
      arg=dsqrt(2.0d0*rload*refprl)*spw2/(omag*omag)
      if (iprnt.eq.0) go to 200
      write (iofile,161) freq1,freq2,freqd,omag,ophase,ow2mag,ow2phs
  161 format (1h1,4x,'2nd order intermodulation sum component',
     1   14x,'freq1 = ',1pd9.2,'  hz',15x,'freq2 = ',d9.2,'  hz'//
     2   5x,'distortion frequency  ',d9.2,'  hz',16x,'mag ',
     3   d9.3,3x,'phs ',0pf7.2,9x,'mag ',1pd9.3,3x,'phs ',0pf7.2)
      go to 200
  170 freqd=2.0d0*freq1-freq2
      arg=2.0d0*rload*refprl*spw2/(omag*omag*omag)
      if (iprnt.eq.0) go to 200
      write (iofile,171) freq1,freq2,freqd,omag,ophase,ow2mag,ow2phs
  171 format (1h1,4x,'3rd order intermodulation difference component',
     1   7x,'freq1 = ',1pd9.2,'  hz',15x,'freq2 = ',d9.2,'  hz'//
     2   5x,'distortion frequency  ',d9.2,'  hz',16x,'mag ',
     3   d9.3,3x,'phs ',0pf7.2,9x,'mag ',1pd9.3,3x,'phs ',0pf7.2)
c
c  load and decompose y matrix
c
  200 omega=twopi*freqd
      igoof=0
      call acload
      call acdcmp
      if (igoof.eq.0) go to 220
      write (iofile,211) igoof,freqd
  211 format('0warning:  underflow ',i4,' time(s) in distortion analysis
     1 at freq = ',1pd9.3,' hz')
      igoof=0
  220 if (kdisto.eq.4) go to 710
c
c  obtain adjoint solution
c
      call zero8(value(lvn+1),nstop)
      call zero8(value(imvn+1),nstop)
      value(lvn+idnp)=-1.0d0
      value(lvn+idnn)=+1.0d0
      call acasol
      call copy16(cvalue(lcvn+1),cvalue(icvadj+1),nstop)
      call zero8(value(lvn+1),nstop)
      call zero8(value(imvn+1),nstop)
c
c  bjts
c
      if (jelcnt(12).eq.0) go to 500
      ititle=0
  301 format (////1x,'bjt distortion components'//1x,'name',11x,'gm',
     1   8x,'gpi',7x,'go',8x,'gmu',6x,'gmo2',7x,'cb',8x,'cbr',7x,'cje',
     2   7x,'cjc',6x,'total')
  311 format (////1x,'bjt distortion components'//1x,'name',11x,'gm',
     1   8x,'gpi',7x,'go',8x,'gmu',6x,'gmo2',7x,'cb',8x,'cbr',7x,'cje',
     2   7x,'cjc',6x,'gm203',5x,'gmo23',5x,'total')
  320 loc=locate(12)
  330 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 500
      locv=nodplc(loc+1)
      loct=lx0+nodplc(loc+22)
      locd=ld0+nodplc(loc+23)
      node1=nodplc(loc+5)
      node2=nodplc(loc+6)
      node3=nodplc(loc+7)
      cje1=value(locd)
      cje2=value(locd+1)
      cjc1=value(locd+2)
      cjc2=value(locd+3)
      go2=value(locd+4)
      gmo2=value(locd+5)
      gm2=value(locd+6)
      gmu2=value(locd+7)
      gpi2=value(locd+8)
      cb1=value(locd+11)
      cb1r=value(locd+12)
      go3=value(locd+13)
      gmo23=value(locd+14)
      gm2o3=value(locd+15)
      gm3=value(locd+16)
      gmu3=value(locd+17)
      gpi3=value(locd+18)
      cb2=value(locd+19)
      cb2r=value(locd+20)
      bew=cvalue(icvw1+node2)-cvalue(icvw1+node3)
      cew=cvalue(icvw1+node1)-cvalue(icvw1+node3)
      bcw=cvalue(icvw1+node2)-cvalue(icvw1+node1)
      if (kdisto.eq.2) go to 370
      be2w=cvalue(icv2w1+node2)-cvalue(icv2w1+node3)
      ce2w=cvalue(icv2w1+node1)-cvalue(icv2w1+node3)
      bc2w=cvalue(icv2w1+node2)-cvalue(icv2w1+node1)
      if (kdisto.eq.3) go to 380
      bew2=cvalue(icvw2+node2)-cvalue(icvw2+node3)
      cew2=cvalue(icvw2+node1)-cvalue(icvw2+node3)
      bcw2=cvalue(icvw2+node2)-cvalue(icvw2+node1)
      if (kdisto.eq.5) go to 390
      if (kdisto.eq.6) go to 400
      bew12=cvalue(icvw12+node2)-cvalue(icvw12+node3)
      cew12=cvalue(icvw12+node1)-cvalue(icvw12+node3)
      bcw12=cvalue(icvw12+node2)-cvalue(icvw12+node1)
      go to 410
c
c  calculate hd2 current generators
c
  370 difvn1=0.5d0*cew*cew
      difvn2=0.5d0*bew*bew
      difvn3=0.5d0*bcw*bcw
      dsgmo2=gmo2*0.5d0*bew*cew
      go to 420
c
c  calculate hd3 current generators
c
  380 difvi1=0.50d0*cew*ce2w
      difvn1=0.25d0*cew*cew*cew
      difvi2=0.50d0*bew*be2w
      difvn2=0.25d0*bew*bew*bew
      difvi3=0.50d0*bcw*bc2w
      difvn3=0.25d0*bcw*bcw*bcw
      dsgmo2=gmo2*(bew*ce2w+be2w*cew)*0.5d0
      go to 430
c
c  calculate im2d current generators
c
  390 difvn1=cew*conjg(cew2)
      difvn2=bew*conjg(bew2)
      difvn3=bcw*conjg(bcw2)
      dsgmo2=gmo2*0.5d0*(bew*conjg(cew2)+cew*conjg(bew2))
      go to 420
c
c  calculate im2s current generators
c
  400 difvn1=cew*cew2
      difvn2=bew*bew2
      difvn3=bcw*bcw2
      dsgmo2=gmo2*0.5d0*(bew*cew2+bew2*cew)
      go to 420
c
c  calculate im3 current generators
c
  410 difvi1=0.5d0*(ce2w*conjg(cew2)+cew*cew12)
      difvi2=0.5d0*(be2w*conjg(bew2)+bew*bew12)
      difvi3=0.5d0*(bc2w*conjg(bcw2)+bcw*bcw12)
      difvn1=cew*cew*conjg(cew2)*0.75d0
      difvn2=bew*bew*conjg(bew2)*0.75d0
      difvn3=bcw*bcw*conjg(bcw2)*0.75d0
      dsgmo2=gmo2*0.5d0*(conjg(bew2)*ce2w+bew*cew12+conjg(cew2)*be2w+
     1   cew*bew12)
      go to 430
c
  420 dsgo2=go2*difvn1
      dsgm2=gm2*difvn2
      dsgmu2=gmu2*difvn3
      dsgpi2=gpi2*difvn2
      dscb1=0.5d0*cb1*omega*cmplx(-aimag(difvn2),real(difvn2))
      dscb1r=0.5d0*cb1r*omega*cmplx(-aimag(difvn3),real(difvn3))
      dscje1=0.5d0*cje1*omega*cmplx(-aimag(difvn2),real(difvn2))
      dscjc1=0.5d0*cjc1*omega*cmplx(-aimag(difvn3),real(difvn3))
      go to 440
c
  430 dsgo2=2.0d0*go2*difvi1+go3*difvn1
      dsgm2=2.0d0*gm2*difvi2+gm3*difvn2
      dsgmu2=2.0d0*gmu2*difvi3+gmu3*difvn3
      dsgpi2=2.0d0*gpi2*difvi2+gpi3*difvn2
      dscb1=omega*(cb1*difvi2+cb2*difvn2/3.0d0)
      dscb1=cmplx(-aimag(dscb1),real(dscb1))
      dscb1r=omega*(cb1r*difvi3+cb2r*difvn3/3.0d0)
      dscb1r=cmplx(-aimag(dscb1r),real(dscb1r))
      dscje1=omega*(cje1*difvi2+cje2*difvn2/3.0d0)
      dscje1=cmplx(-aimag(dscje1),real(dscje1))
      dscjc1=omega*(cjc1*difvi3+cjc2*difvn3/3.0d0)
      dscjc1=cmplx(-aimag(dscjc1),real(dscjc1))
c
c  determine contribution of each distortion source
c
  440 cvabe=cvalue(icvadj+node2)-cvalue(icvadj+node3)
      cvabc=cvalue(icvadj+node2)-cvalue(icvadj+node1)
      cvace=cvalue(icvadj+node1)-cvalue(icvadj+node3)
      disto1=dsgm2+dsgo2+dsgmo2
      disto2=dsgpi2+dscb1+dscje1
      disto3=dsgmu2+dscb1r+dscjc1
      cvdo(1)=dsgm2*cvace*arg
      cvdo(2)=dsgpi2*cvabe*arg
      cvdo(3)=dsgo2*cvace*arg
      cvdo(4)=dsgmu2*cvabc*arg
      cvdo(5)=dsgmo2*cvace*arg
      cvdo(6)=dscb1*cvabe*arg
      cvdo(7)=dscb1r*cvabc*arg
      cvdo(8)=dscje1*cvabe*arg
      cvdo(9)=dscjc1*cvabc*arg
      if (kdisto.eq.3) go to 450
      if (kdisto.eq.7) go to 460
      cvdo(10)=cvdo(1)+cvdo(2)+cvdo(3)+cvdo(4)+cvdo(5)+cvdo(6)+cvdo(7)+
     1   cvdo(8)+cvdo(9)
      cvdist=cvdist+cvdo(10)
      if (iprnt.eq.0) go to 480
      do 445 j=1,10
      call magphs(cvdo(j),xmag,xphs)
      cvdo(j)=cmplx(sngl(xmag),sngl(xphs))
  445 continue
      if (ititle.eq.0) write (iofile,301)
      ititle=1
      write (iofile,446) value(locv),(vdo(1,j),j=1,10)
  446 format(1h0,a8,'mag',1p12d10.3)
      write (iofile,447) (vdo(2,j),j=1,10)
  447 format(9x,'phs',12(1x,f7.2,2x))
      go to 480
  450 dgm2o3=gm2o3*cew*bew*bew*0.25d0
      dgmo23=gmo23*bew*cew*cew*0.25d0
      go to 470
  460 dgm2o3=gm2o3*(0.5d0*bew*conjg(bew2)*cew+0.25d0*bew*bew*
     1  conjg(cew2))
      dgmo23=gmo23*(0.5d0*cew*conjg(cew2)*bew+0.25d0*cew*cew*
     1  conjg(bew2))
  470 disto1=disto1+dgm2o3+dgmo23
      cvdo(10)=dgm2o3*cvace*arg
      cvdo(11)=dgmo23*cvace*arg
      cvdo(12)=cvdo(1)+cvdo(2)+cvdo(3)+cvdo(4)+cvdo(5)+cvdo(6)+cvdo(7)+
     1   cvdo(8)+cvdo(9)+cvdo(10)+cvdo(11)
      cvdist=cvdist+cvdo(12)
      if (iprnt.eq.0) go to 480
      do 475 j=1,12
      call magphs(cvdo(j),xmag,xphs)
      cvdo(j)=cmplx(sngl(xmag),sngl(xphs))
  475 continue
      if (ititle.eq.0) write (iofile,311)
      ititle=1
      write (iofile,446) value(locv),(vdo(1,j),j=1,12)
      write (iofile,447) (vdo(2,j),j=1,12)
  480 value(lvn+node1)=value(lvn+node1)
     1  -real(disto1-disto3)
      value(lvn+node2)=value(lvn+node2)
     1  -real(disto2+disto3)
      value(lvn+node3)=value(lvn+node3)
     1  +real(disto1+disto2)
      value(imvn+node1)=value(imvn+node1)
     1  -aimag(disto1-disto3)
      value(imvn+node2)=value(imvn+node2)
     1  -aimag(disto2+disto3)
      value(imvn+node3)=value(imvn+node3)
     1  +aimag(disto1+disto2)
      loc=nodplc(loc)
      go to 330
c
c   junction diodes
c
  500 if (jelcnt(11).eq.0) go to 700
      ititle=0
  501 format (////1x,'diode distortion components'//1x,'name',
     1   11x,'geq',7x,'cb',8x,'cj',7x,'total')
  510 loc=locate(11)
  520 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 700
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      locm=nodplc(loc+5)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+11)
      locd=ld0+nodplc(loc+12)
      cdj1=value(locd)
      cdj2=value(locd+1)
      cdb1=value(locd+3)
      geq2=value(locd+4)
      geq3=value(locd+5)
      cdb2=value(locd+6)
      bew=cvalue(icvw1+node3)-cvalue(icvw1+node2)
      if (kdisto.eq.2) go to 540
      be2w=cvalue(icv2w1+node3)-cvalue(icv2w1+node2)
      if (kdisto.eq.3) go to 550
      bew2=cvalue(icvw2+node3)-cvalue(icvw2+node2)
      if (kdisto.eq.5) go to 560
      if (kdisto.eq.6) go to 570
      bew12=cvalue(icvw12+node3)-cvalue(icvw12+node2)
      go to 580
c
c    calculate hd2 current generators
c
  540 difvn1=0.5d0*bew*bew
      go to 590
c
c    calculate hd3 current generators
c
  550 difvi1=0.5d0*bew*be2w
      difvn1=0.25d0*bew*bew*bew
      go to 600
c
c    calculate im2d current generators
c
  560 difvn1=bew*conjg(bew2)
      go to 590
c
c    calculate im2s current generators
c
  570 difvn1=bew*bew2
      go to 590
c
c    calculate im3 current generators
c
  580 difvi1=0.5d0*(be2w*conjg(bew2)+bew*bew12)
      difvn1=bew*bew*conjg(bew2)*0.75d0
      go to 600
  590 dsg2=geq2*difvn1
      dscdb1=0.5d0*cdb1*omega*cmplx(-aimag(difvn1),real(difvn1))
      dscdj1=0.5d0*cdj1*omega*cmplx(-aimag(difvn1),real(difvn1))
      go to 610
c
  600 dsg2=2.0d0*geq2*difvi1+geq3*difvn1
      dscdb1=omega*(cdb1*difvi1+cdb2*difvn1/3.0d0)
      dscdb1=cmplx(-aimag(dscdb1),real(dscdb1))
      dscdj1=omega*(cdj1*difvi1+cdj2*difvn1/3.0d0)
      dscdj1=cmplx(-aimag(dscdj1),real(dscdj1))
c
c  determine contribution of each distortion source
c
  610 cvabe=cvalue(icvadj+node3)-cvalue(icvadj+node2)
      disto1=dsg2+dscdb1+dscdj1
      cvdo(1)=dsg2*cvabe*arg
      cvdo(2)=dscdb1*cvabe*arg
      cvdo(3)=dscdj1*cvabe*arg
      cvdo(4)=cvdo(1)+cvdo(2)+cvdo(3)
      cvdist=cvdist+cvdo(4)
      if (iprnt.eq.0) go to 680
      do 670 j=1,4
      call magphs(cvdo(j),xmag,xphs)
      cvdo(j)=cmplx(sngl(xmag),sngl(xphs))
  670 continue
      if (ititle.eq.0) write (iofile,501)
      ititle=1
      write (iofile,446) value(locv),(vdo(1,j),j=1,4)
      write (iofile,447) (vdo(2,j),j=1,4)
  680 value(lvn+node2)=value(lvn+node2)+real(disto1)
      value(lvn+node3)=value(lvn+node3)-real(disto1)
      value(imvn+node2)=value(imvn+node2)+aimag(disto1)
      value(imvn+node3)=value(imvn+node3)-aimag(disto1)
      loc=nodplc(loc)
      go to 520
c
c  obtain total distortion solution if necessary
c
  700 go to (1000,710,790,710,710,840,860),kdisto
  710 call acsol
c
c  store solution, print and store answers
c
  760 go to (1000,770,790,800,820,840,860),kdisto
  770 call copy16(cvalue(lcvn+1),cvalue(icv2w1+1),nstop)
      call magphs(cvdist,o2mag,o2phs)
      if (iprnt.eq.0) go to 900
      o2log=20.0d0*dlog10(o2mag)
      write (iofile,781) o2mag,o2phs,o2log
  781 format (///5x,'hd2     magnitude  ',1pd10.3,5x,'phase  ',0pf7.2,
     1   5x,'=  ',f7.2,'  db')
      go to 900
  790 call magphs(cvdist,o3mag,o3phs)
      if (iprnt.eq.0) go to 900
      o3log=20.0d0*dlog10(o3mag)
      write (iofile,791) o3mag,o3phs,o3log
  791 format (///5x,'hd3     magnitude  ',1pd10.3,5x,'phase  ',0pf7.2,
     1   5x,'=  ',f7.2,'  db')
      go to 900
  800 call copy16(cvalue(lcvn+1),cvalue(icvw2+1),nstop)
      cvout=cvalue(icvw2+idnp)-cvalue(icvw2+idnn)
      call magphs(cvout,ow2mag,ow2phs)
      go to 1000
  820 call copy16(cvalue(lcvn+1),cvalue(icvw12+1),nstop)
  840 call magphs(cvdist,o12mag,o12phs)
      if (iprnt.eq.0) go to 900
      o12log=20.0d0*dlog10(o12mag)
      if (kdisto.eq.6) go to 850
      write (iofile,841) o12mag,o12phs,o12log
  841 format (///5x,'im2d    magnitude  ',1pd10.3,5x,'phase  ',0pf7.2,
     1   5x,'=  ',f7.2,'  db')
      go to 900
  850 write (iofile,851) o12mag,o12phs,o12log
  851 format (///5x,'im2s    magnitude  ',1pd10.3,5x,'phase  ',0pf7.2,
     1   5x,'=  ',f7.2,'  db')
      go to 900
  860 call magphs(cvdist,o21mag,o21phs)
      if (iprnt.eq.0) go to 900
      o21log=20.0d0*dlog10(o21mag)
      write (iofile,861) o21mag,o21phs,o21log
  861 format (///5x,'im3     magnitude  ',1pd10.3,5x,'phase  ',0pf7.2,
     1   5x,'=  ',f7.2,'  db')
      cma=dabs(4.0d0*o21mag*dcos((o21phs-ophase)/rad))
      cma=dmax1(cma,1.0d-20)
      cmp=dabs(4.0d0*o21mag*dsin((o21phs-ophase)/rad))
      cmp=dmax1(cmp,1.0d-20)
      cmalog=20.0d0*dlog10(cma)
      cmplog=20.0d0*dlog10(cmp)
      write (iofile,866)
  866 format (////5x,'approximate cross modulation components')
      write (iofile,871) cma,cmalog
  871 format (/5x,'cma     magnitude  ',1pd10.3,24x,'=  ',0pf7.2,'  db')
      write (iofile,881) cmp,cmplog
  881 format (/5x,'cmp     magnitude  ',1pd10.3,24x,'=  ',0pf7.2,'  db')
c
c  save distortion outputs
c
  900 iflag=kdisto+2
      if (iflag.ge.7) iflag=iflag-1
      loc=locate(45)
  910 if (loc.eq.0) go to 1000
      if (nodplc(loc+5).ne.iflag) go to 920
      iseq=nodplc(loc+4)
      cvalue(loco+iseq)=cvdist
  920 loc=nodplc(loc)
      go to 910
 1000 continue
c
c  finished
c
 2000 return
      end

      subroutine sstf
      implicit double precision (a-h,o-z)
c
c     this routine computes the value of the small-signal transfer
c function specified by the user.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension string(5),save(3)
      data aslash, ablnk / 1h/, 1h  /
c
c  setup current vector for input resistance and transfer function
c
      call zero8(value(lvn+1),nstop)
      if (kidin.eq.10) go to 5
c...  voltage source input
      iptri=nodplc(kinel+6)
      value(lvn+iptri)=+1.0d0
      go to 20
c...  current source input
    5 noposi=nodplc(kinel+2)
      nonegi=nodplc(kinel+3)
      value(lvn+noposi)=-1.0d0
      value(lvn+nonegi)=+1.0d0
c
c  lu decompose and solve the system of circuit equations
c
c...  reorder the right-hand side
   20 call dcdcmp
      call dcsol
      value(lvn+1)=0.0d0
      do 25 i=1,nstop
      j=nodplc(icswpr+i)
      k=nodplc(irswpf+j)
      value(lvntmp+i)=value(lvn+k)
   25 continue
      call copy8(value(lvntmp+1),value(lvn+1),nstop)
c
c  evaluate transfer function
c
      if (nodplc(kovar+5).ne.0) go to 30
c...  voltage output
      noposo=nodplc(kovar+2)
      nonego=nodplc(kovar+3)
      trfn=value(lvn+noposo)-value(lvn+nonego)
      go to 40
c...  current output (through voltage source)
   30 iptro=nodplc(kovar+2)
      iptro=nodplc(iptro+6)
      trfn=value(lvn+iptro)
c
c  evaluate input resistance
c
   40 if (kidin.eq.9) go to 50
c...  current source input
      zin=value(lvn+nonegi)-value(lvn+noposi)
      go to 70
c...  voltage source input
   50 creal=value(lvn+iptri)
      if (dabs(creal).ge.1.0d-20) go to 60
      zin=1.0d20
      go to 70
   60 zin=-1.0d0/creal
c
c  setup current vector for output resistance
c
   70 call zero8(value(lvn+1),nstop)
      if (nodplc(kovar+5).ne.0) go to 80
c...  voltage output
      value(lvn+noposo)=-1.0d0
      value(lvn+nonego)=+1.0d0
      go to 90
   80 if (nodplc(kovar+2).ne.kinel) go to 85
      zout=zin
      go to 200
c...  current output (through voltage source)
   85 value(lvn+iptro)=+1.0d0
c
c  perform new forward and backward substitution
c
c...  reorder the right-hand side
   90 call dcsol
      value(lvn+1)=0.0d0
      do 95 i=1,nstop
      j=nodplc(icswpr+i)
      k=nodplc(irswpf+j)
      value(lvntmp+i)=value(lvn+k)
   95 continue
      call copy8(value(lvntmp+1),value(lvn+1),nstop)
c
c  evaluate output resistance
c
  100 if (nodplc(kovar+5).ne.0) go to 110
c...  voltage output
      zout=value(lvn+nonego)-value(lvn+noposo)
      go to 200
c...  current output (through voltage source)
  110 creal=value(lvn+iptro)
      if (dabs(creal).ge.1.0d-20) go to 120
      zout=1.0d20
      go to 200
  120 zout=-1.0d0/creal
c
c  print results
c
  200 do 210 i=1,5
      string(i)=ablnk
  210 continue
      ipos=1
      call outnam(kovar,1,string,ipos)
      call copy8(string,save,3)
      call move(string,ipos,aslash,1,1)
      ipos=ipos+1
      locv=nodplc(kinel+1)
      anam=value(locv)
      call move(string,ipos,anam,1,8)
      write (iofile,231) string,trfn,anam,zin,save,zout
  231 format(////,'0****     small-signal characteristics'//,
     1   1h0,5x,5a8,3h = ,1pd10.3,/,
     2   1h0,5x,'input resistance at ',a8,12x,3h = ,d10.3,/,
     3   1h0,5x,'output resistance at ',2a8,a3,3h = ,d10.3)
      return
      end

      subroutine bjt
      implicit double precision (a-h,o-z)
c
c     this routine processes bjts for dc and transient analyses.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension vbeo(1),vbco(1),cco(1),cbo(1),gpio(1),gmuo(1),gmo(1),
     1   goo(1),qbe(1),cqbe(1),qbc(1),cqbc(1),qcs(1),cqcs(1),qbx(1),
     2   cqbx(1),gxo(1),cexbc(1),geqcbo(1)
      equivalence (vbeo(1),value(1)),(vbco(1),value(2)),
     1   (cco(1),value(3)),(cbo(1),value(4)),(gpio(1),value(5)),
     2   (gmuo(1),value(6)),(gmo(1),value(7)),(goo(1),value(8)),
     3   (qbe(1),value(9)),(cqbe(1),value(10)),(qbc(1),value(11)),
     4   (cqbc(1),value(12)),(qcs(1),value(13)),(cqcs(1),value(14)),
     5   (qbx(1),value(15)),(cqbx(1),value(16)),(gxo(1),value(17)),
     6   (cexbc(1),value(18)),(geqcbo(1),value(19))
c
c
      loc=locate(12)
   10 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) return
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      node7=nodplc(loc+30)
      locm=nodplc(loc+8)
      ioff=nodplc(loc+9)
      type=nodplc(locm+2)
      locm=nodplc(locm+1)
      loct=nodplc(loc+22)
      gccs=0.0d0
      ceqcs=0.0d0
      geqbx=0.0d0
      ceqbx=0.0d0
      geqcb=0.0d0
c
c  dc model paramters
c
      area=value(locv+1)
      bfm=value(locm+2)
      brm=value(locm+8)
      csat=value(locm+1)*area
      rbpr=value(locm+18)/area
      rbpi=value(locm+16)/area-rbpr
      gcpr=value(locm+20)*area
      gepr=value(locm+19)*area
      ova=value(locm+4)
      ovb=value(locm+10)
      oik=value(locm+5)/area
      c2=value(locm+6)*area
      vte=value(locm+7)*vt
      oikr=value(locm+11)/area
      c4=value(locm+12)*area
      vtc=value(locm+13)*vt
      vcrit=value(locm+54)
      td=value(locm+28)
      xjrb=value(locm+17)*area
c
c  initialization
c
      icheck=1
      go to (100,20,30,50,60,70),initf
   20 if(mode.ne.1.or.modedc.ne.2.or.nosolv.eq.0) go to 25
      vbe=type*value(locv+2)
      vce=type*value(locv+3)
      vbc=vbe-vce
      vbx=vbc
      vcs=0.0d0
      go to 300
   25 if(ioff.ne.0) go to 40
      vbe=vcrit
      vbc=0.0d0
      go to 300
   30 if (ioff.eq.0) go to 100
   40 vbe=0.0d0
      vbc=0.0d0
      go to 300
   50 vbe=vbeo(lx0+loct)
      vbc=vbco(lx0+loct)
      vbx=type*(value(lvnim1+node2)-value(lvnim1+node4))
      vcs=type*(value(lvnim1+node7)-value(lvnim1+node4))
      go to 300
   60 vbe=vbeo(lx1+loct)
      vbc=vbco(lx1+loct)
      vbx=type*(value(lvnim1+node2)-value(lvnim1+node4))
      vcs=type*(value(lvnim1+node7)-value(lvnim1+node4))
      if(mode.ne.2.or.nosolv.eq.0) go to 300
      vbx=type*(value(locv+2)-value(locv+3))
      vcs=0.0d0
      go to 300
   70 xfact=delta/delold(2)
      vbeo(lx0+loct)=vbeo(lx1+loct)
      vbe=(1.0d0+xfact)*vbeo(lx1+loct)-xfact*vbeo(lx2+loct)
      vbco(lx0+loct)=vbco(lx1+loct)
      vbc=(1.0d0+xfact)*vbco(lx1+loct)-xfact*vbco(lx2+loct)
      cco(lx0+loct)=cco(lx1+loct)
      cbo(lx0+loct)=cbo(lx1+loct)
      gpio(lx0+loct)=gpio(lx1+loct)
      gmuo(lx0+loct)=gmuo(lx1+loct)
      gmo(lx0+loct)=gmo(lx1+loct)
      goo(lx0+loct)=goo(lx1+loct)
      gxo(lx0+loct)=gxo(lx1+loct)
      go to 110
c
c  compute new nonlinear branch voltages
c
  100 vbe=type*(value(lvnim1+node5)-value(lvnim1+node6))
      vbc=type*(value(lvnim1+node5)-value(lvnim1+node4))
  110 delvbe=vbe-vbeo(lx0+loct)
      delvbc=vbc-vbco(lx0+loct)
      vbx=type*(value(lvnim1+node2)-value(lvnim1+node4))
      vcs=type*(value(lvnim1+node7)-value(lvnim1+node4))
      cchat=cco(lx0+loct)+(gmo(lx0+loct)+goo(lx0+loct))*delvbe
     1   -(goo(lx0+loct)+gmuo(lx0+loct))*delvbc
      cbhat=cbo(lx0+loct)+gpio(lx0+loct)*delvbe+gmuo(lx0+loct)*delvbc
c
c   bypass if solution has not changed
c
      if (initf.eq.6) go to 200
      tol=reltol*dmax1(dabs(vbe),dabs(vbeo(lx0+loct)))+vntol
      if (dabs(delvbe).ge.tol) go to 200
      tol=reltol*dmax1(dabs(vbc),dabs(vbco(lx0+loct)))+vntol
      if (dabs(delvbc).ge.tol) go to 200
      tol=reltol*dmax1(dabs(cchat),dabs(cco(lx0+loct)))+abstol
      if (dabs(cchat-cco(lx0+loct)).ge.tol) go to 200
      tol=reltol*dmax1(dabs(cbhat),dabs(cbo(lx0+loct)))+abstol
      if (dabs(cbhat-cbo(lx0+loct)).ge.tol) go to 200
      vbe=vbeo(lx0+loct)
      vbc=vbco(lx0+loct)
      cc=cco(lx0+loct)
      cb=cbo(lx0+loct)
      gpi=gpio(lx0+loct)
      gmu=gmuo(lx0+loct)
      gm=gmo(lx0+loct)
      go=goo(lx0+loct)
      gx=gxo(lx0+loct)
      geqcb=geqcbo(lx0+loct)
      if (mode.ne.1) go to 800
      go to 900
c
c  limit nonlinear branch voltages
c
  200 ichk1=1
      call pnjlim(vbe,vbeo(lx0+loct),vt,vcrit,icheck)
      call pnjlim(vbc,vbco(lx0+loct),vt,vcrit,ichk1)
      if (ichk1.eq.1) icheck=1
c
c  determine dc current and derivitives
c
  300 vtn=vt*value(locm+3)
      if(vbe.le.-5.0d0*vtn) go to 320
      evbe=dexp(vbe/vtn)
      cbe=csat*(evbe-1.0d0)+gmin*vbe
      gbe=csat*evbe/vtn+gmin
      if (c2.ne.0.0d0) go to 310
      cben=0.0d0
      gben=0.0d0
      go to 350
  310 evben=dexp(vbe/vte)
      cben=c2*(evben-1.0d0)
      gben=c2*evben/vte
      go to 350
  320 gbe=-csat/vbe+gmin
      cbe=gbe*vbe
      gben=-c2/vbe
      cben=gben*vbe
  350 vtn=vt*value(locm+9)
      if(vbc.le.-5.0d0*vtn) go to 370
      evbc=dexp(vbc/vtn)
      cbc=csat*(evbc-1.0d0)+gmin*vbc
      gbc=csat*evbc/vtn+gmin
      if (c4.ne.0.0d0) go to 360
      cbcn=0.0d0
      gbcn=0.0d0
      go to 400
  360 evbcn=dexp(vbc/vtc)
      cbcn=c4*(evbcn-1.0d0)
      gbcn=c4*evbcn/vtc
      go to 400
  370 gbc=-csat/vbc+gmin
      cbc=gbc*vbc
      gbcn=-c4/vbc
      cbcn=gbcn*vbc
c
c  determine base charge terms
c
  400 q1=1.0d0/(1.0d0-ova*vbc-ovb*vbe)
      if (oik.ne.0.0d0) go to 405
      if (oikr.ne.0.0d0) go to 405
      qb=q1
      dqbdve=q1*qb*ovb
      dqbdvc=q1*qb*ova
      go to 410
  405 q2=oik*cbe+oikr*cbc
      arg=dmax1(0.0d0,1.0d0+4.0d0*q2)
      sqarg=1.0d0
      if(arg.ne.0.0d0) sqarg=dsqrt(arg)
      qb=q1*(1.0d0+sqarg)/2.0d0
      dqbdve=q1*(qb*ovb+oik*gbe/sqarg)
      dqbdvc=q1*(qb*ova+oikr*gbc/sqarg)
c
c  weil's approx. for excess phase applied with backward-
c  euler integration
c
  410 cc=0.0d0
      cex=cbe
      gex=gbe
      if(mode.eq.1) go to 420
      if(td.eq.0.0d0) go to 420
      arg1=delta/td
      arg2=3.0d0*arg1
      arg1=arg2*arg1
      denom=1.0d0+arg1+arg2
      arg3=arg1/denom
      if(initf.ne.5) go to 411
      cexbc(lx1+loct)=cbe/qb
      cexbc(lx2+loct)=cexbc(lx1+loct)
  411 cc=(cexbc(lx1+loct)*(1.0d0+delta/delold(2)+arg2)
     1  -cexbc(lx2+loct)*delta/delold(2))/denom
      cex=cbe*arg3
      gex=gbe*arg3
      cexbc(lx0+loct)=cc+cex/qb
c
c  determine dc incremental conductances
c
  420 cc=cc+(cex-cbc)/qb-cbc/brm-cbcn
      cb=cbe/bfm+cben+cbc/brm+cbcn
      gx=rbpr+rbpi/qb
      if(xjrb.eq.0.0d0) go to 430
      arg1=dmax1(cb/xjrb,1.0d-9)
      arg2=(-1.0d0+dsqrt(1.0d0+14.59025d0*arg1))/2.4317d0/dsqrt(arg1)
      arg1=dtan(arg2)
      gx=rbpr+3.0d0*rbpi*(arg1-arg2)/arg2/arg1/arg1
  430 if(gx.ne.0.0d0) gx=1.0d0/gx
      gpi=gbe/bfm+gben
      gmu=gbc/brm+gbcn
      go=(gbc+(cex-cbc)*dqbdvc/qb)/qb
      gm=(gex-(cex-cbc)*dqbdve/qb)/qb-go
      if (mode.ne.1) go to 500
      if ((modedc.eq.2).and.(nosolv.ne.0)) go to 500
      if (initf.eq.4) go to 500
      go to 700
c
c  charge storage elements
c
  500 tf=value(locm+24)
      tr=value(locm+33)
      czbe=value(locm+21)*area
      pe=value(locm+22)
      xme=value(locm+23)
      cdis=value(locm+32)
      ctot=value(locm+29)*area
      czbc=ctot*cdis
      czbx=ctot-czbc
      pc=value(locm+30)
      xmc=value(locm+31)
      fcpe=value(locm+46)
      czcs=value(locm+38)*area
      ps=value(locm+39)
      xms=value(locm+40)
      xtf=value(locm+25)
      ovtf=value(locm+26)
      xjtf=value(locm+27)*area
      if(tf.eq.0.0d0) go to 505
      if(vbe.le.0.0d0) go to 505
      argtf=0.0d0
      arg2=0.0d0
      arg3=0.0d0
      if(xtf.eq.0.0d0) go to 504
      argtf=xtf
      if(ovtf.ne.0.0d0) argtf=argtf*dexp(vbc*ovtf)
      arg2=argtf
      if(xjtf.eq.0.0d0) go to 503
      temp=cbe/(cbe+xjtf)
      argtf=argtf*temp*temp
      arg2=argtf*(3.0d0-temp-temp)
  503 arg3=cbe*argtf*ovtf
  504 cbe=cbe*(1.0d0+argtf)/qb
      gbe=(gbe*(1.0d0+arg2)-cbe*dqbdve)/qb
      geqcb=tf*(arg3-cbe*dqbdvc)/qb
  505 if (vbe.ge.fcpe) go to 510
      arg=1.0d0-vbe/pe
      sarg=dexp(-xme*dlog(arg))
      qbe(lx0+loct)=tf*cbe+pe*czbe*(1.0d0-arg*sarg)/(1.0d0-xme)
      capbe=tf*gbe+czbe*sarg
      go to 520
  510 f1=value(locm+47)
      f2=value(locm+48)
      f3=value(locm+49)
      czbef2=czbe/f2
      qbe(lx0+loct)=tf*cbe+czbe*f1+czbef2*(f3*(vbe-fcpe)
     1   +(xme/(pe+pe))*(vbe*vbe-fcpe*fcpe))
      capbe=tf*gbe+czbef2*(f3+xme*vbe/pe)
  520 fcpc=value(locm+50)
      f1=value(locm+51)
      f2=value(locm+52)
      f3=value(locm+53)
      if (vbc.ge.fcpc) go to 530
      arg=1.0d0-vbc/pc
      sarg=dexp(-xmc*dlog(arg))
      qbc(lx0+loct)=tr*cbc+pc*czbc*(1.0d0-arg*sarg)/(1.0d0-xmc)
      capbc=tr*gbc+czbc*sarg
      go to 540
  530 czbcf2=czbc/f2
      qbc(lx0+loct)=tr*cbc+czbc*f1+czbcf2*(f3*(vbc-fcpc)
     1   +(xmc/(pc+pc))*(vbc*vbc-fcpc*fcpc))
      capbc=tr*gbc+czbcf2*(f3+xmc*vbc/pc)
  540 if(vbx.ge.fcpc) go to 550
      arg=1.0d0-vbx/pc
      sarg=dexp(-xmc*dlog(arg))
      qbx(lx0+loct)=pc*czbx*(1.0d0-arg*sarg)/(1.0d0-xmc)
      capbx=czbx*sarg
      go to 560
  550 czbxf2=czbx/f2
      qbx(lx0+loct)=czbx*f1+czbxf2*(f3*(vbx-fcpc)+(xmc/(pc+pc))*
     1   (vbx*vbx-fcpc*fcpc))
      capbx=czbxf2*(f3+xmc*vbx/pc)
  560 if(vcs.ge.0.0d0) go to 570
      arg=1.0d0-vcs/ps
      sarg=dexp(-xms*dlog(arg))
      qcs(lx0+loct)=ps*czcs*(1.0d0-arg*sarg)/(1.0d0-xms)
      capcs=czcs*sarg
      go to 580
  570 qcs(lx0+loct)=vcs*czcs*(1.0d0+xms*vcs/(2.0d0*ps))
      capcs=czcs*(1.0d0+xms*vcs/ps)
c
c  store small-signal parameters
c
  580 if ((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 700
      if (initf.ne.4) go to 600
      value(lx0+loct+9)=capbe
      value(lx0+loct+11)=capbc
      value(lx0+loct+13)=capcs
      value(lx0+loct+15)=capbx
      value(lx0+loct+17)=geqcb
      go to 1000
c
c  transient analysis
c
  600 if (initf.ne.5) go to 610
      qbe(lx1+loct)=qbe(lx0+loct)
      qbc(lx1+loct)=qbc(lx0+loct)
      qbx(lx1+loct)=qbx(lx0+loct)
      qcs(lx1+loct)=qcs(lx0+loct)
  610 call intgr8(geq,ceq,capbe,loct+8)
      geqcb=geqcb*ag(1)
      gpi=gpi+geq
      cb=cb+cqbe(lx0+loct)
      call intgr8(geq,ceq,capbc,loct+10)
      gmu=gmu+geq
      cb=cb+cqbc(lx0+loct)
      cc=cc-cqbc(lx0+loct)
      if (initf.ne.5) go to 700
      cqbe(lx1+loct)=cqbe(lx0+loct)
      cqbc(lx1+loct)=cqbc(lx0+loct)
c
c  check convergence
c
  700 if (initf.ne.3) go to 710
      if (ioff.eq.0) go to 710
      go to 750
  710 if (icheck.eq.1) go to 720
      tol=reltol*dmax1(dabs(cchat),dabs(cc))+abstol
      if (dabs(cchat-cc).gt.tol) go to 720
      tol=reltol*dmax1(dabs(cbhat),dabs(cb))+abstol
      if (dabs(cbhat-cb).le.tol) go to 750
  720 noncon=noncon+1
  750 vbeo(lx0+loct)=vbe
      vbco(lx0+loct)=vbc
      cco(lx0+loct)=cc
      cbo(lx0+loct)=cb
      gpio(lx0+loct)=gpi
      gmuo(lx0+loct)=gmu
      gmo(lx0+loct)=gm
      goo(lx0+loct)=go
      gxo(lx0+loct)=gx
      geqcbo(lx0+loct)=geqcb
      if (mode.eq.1) go to 900
c
c     charge storage for c-s and b-x junctions
c
  800 call intgr8(gccs,ceq,capcs,loct+12)
      ceqcs=type*(cqcs(lx0+loct)-vcs*gccs)
      call intgr8(geqbx,ceq,capbx,loct+14)
      ceqbx=type*(cqbx(lx0+loct)-vbx*geqbx)
      if (initf.ne.5) go to 900
      cqbx(lx1+loct)=cqbx(lx0+loct)
      cqcs(lx1+loct)=cqcs(lx0+loct)
c
c  load current excitation vector
c
  900 ceqbe=type*(cc+cb-vbe*(gm+go+gpi)+vbc*(go-geqcb))
      ceqbc=type*(-cc+vbe*(gm+go)-vbc*(gmu+go))
      value(lvn+node2)=value(lvn+node2)-ceqbx
      value(lvn+node4)=value(lvn+node4)+ceqcs+ceqbx+ceqbc
      value(lvn+node5)=value(lvn+node5)-ceqbe-ceqbc
      value(lvn+node6)=value(lvn+node6)+ceqbe
      value(lvn+node7)=value(lvn+node7)-ceqcs
c
c  load y matrix
c
      locy=lvn+nodplc(loc+24)
      value(locy)=value(locy)+gcpr
      locy=lvn+nodplc(loc+25)
      value(locy)=value(locy)+gx+geqbx
      locy=lvn+nodplc(loc+26)
      value(locy)=value(locy)+gepr
      locy=lvn+nodplc(loc+27)
      value(locy)=value(locy)+gmu+go+gcpr+gccs+geqbx
      locy=lvn+nodplc(loc+28)
      value(locy)=value(locy)+gx  +gpi+gmu+geqcb
      locy=lvn+nodplc(loc+29)
      value(locy)=value(locy)+gpi+gepr+gm+go
      locy=lvn+nodplc(loc+10)
      value(locy)=value(locy)-gcpr
      locy=lvn+nodplc(loc+11)
      value(locy)=value(locy)-gx
      locy=lvn+nodplc(loc+12)
      value(locy)=value(locy)-gepr
      locy=lvn+nodplc(loc+13)
      value(locy)=value(locy)-gcpr
      locy=lvn+nodplc(loc+14)
      value(locy)=value(locy)-gmu+gm
      locy=lvn+nodplc(loc+15)
      value(locy)=value(locy)-gm-go
      locy=lvn+nodplc(loc+16)
      value(locy)=value(locy)-gx
      locy=lvn+nodplc(loc+17)
      value(locy)=value(locy)-gmu-geqcb
      locy=lvn+nodplc(loc+18)
      value(locy)=value(locy)-gpi
      locy=lvn+nodplc(loc+19)
      value(locy)=value(locy)-gepr
      locy=lvn+nodplc(loc+20)
      value(locy)=value(locy)-go+geqcb
      locy=lvn+nodplc(loc+21)
      value(locy)=value(locy)-gpi-gm-geqcb
      locy=lvn+nodplc(loc+31)
      value(locy)=value(locy)+gccs
      locy=lvn+nodplc(loc+32)
      value(locy)=value(locy)-gccs
      locy=lvn+nodplc(loc+33)
      value(locy)=value(locy)-gccs
      locy=lvn+nodplc(loc+34)
      value(locy)=value(locy)-geqbx
      locy=lvn+nodplc(loc+35)
      value(locy)=value(locy)-geqbx
 1000 loc=nodplc(loc)
      go to 10
      end

      subroutine evpoly(result,itype,lcoef,ncoef,larg,
     1  narg,lexp)
      implicit double precision (a-h,o-z)
c
c     this routine evaluates a polynomial.  lcoef points to the coef-
c ficients, and larg points to the values of the polynomial argument(s).
c
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      if (itype) 100,200,300
c
c  integration (polynomial *must* be one-dimensional)
c
  100 result=0.0d0
      arg=1.0d0
      arg1=value(larg+1)
      do 110 i=1,ncoef
      arg=arg*arg1
      result=result+value(lcoef+i)*arg/dble(i)
  110 continue
      go to 1000
c
c  evaluation of the polynomial
c
  200 result=value(lcoef+1)
      if (ncoef.eq.1) go to 1000
      call zero4(nodplc(lexp+1),narg)
      do 220 i=2,ncoef
      call nxtpwr(nodplc(lexp+1),narg)
      if (value(lcoef+i).eq.0.0d0) go to 220
      arg=1.0d0
      do 210 j=1,narg
      call evterm(val,value(larg+j),nodplc(lexp+j))
      arg=arg*val
  210 continue
      result=result+value(lcoef+i)*arg
  220 continue
      go to 1000
c
c  partial derivative with respect to the itype*th variable
c
  300 result=0.0d0
      if (ncoef.eq.1) go to 1000
      call zero4(nodplc(lexp+1),narg)
      do 330 i=2,ncoef
      call nxtpwr(nodplc(lexp+1),narg)
      if (nodplc(lexp+itype).eq.0) go to 330
      if (value(lcoef+i).eq.0.0d0) go to 330
      arg=1.0d0
      do 320 j=1,narg
      if (j.eq.itype) go to 310
      call evterm(val,value(larg+j),nodplc(lexp+j))
      arg=arg*val
      go to 320
  310 call evterm(val,value(larg+j),nodplc(lexp+j)-1)
      arg=arg*dble(nodplc(lexp+j))*val
  320 continue
      result=result+value(lcoef+i)*arg
  330 continue
c
c  finished
c
 1000 return
      end

      subroutine iter8(itlim)
      implicit double precision (a-h,o-z)
c
c     this routine drives the newton-raphson iteration technique used to
c solve the set of nonlinear circuit equations.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      igoof=0
      iterno=0
      ndrflo=0
      noncon=0
      ipass=0
c
c  construct linear equations and check convergence
c
   10 ivmflg=0
      call load
   15 if ((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 300
      iterno=iterno+1
      go to (20,30,40,60,50,60),initf
   20 if(mode.ne.1) go to 22
      call sizmem(nsnod,nic)
      if (nic.eq.0) go to 22
      if (ipass.ne.0) noncon=ipass
      ipass=0
   22 if (noncon.eq.0) go to 300
      go to 100
   30 initf=3
      if(lvlcod.eq.3) lvlcod=2
      ipiv=1
   40 if (noncon.eq.0) initf=1
      ipass=1
      go to 100
   50 if (iterno.gt.1) go to 60
      ipiv=1
      if (lvlcod.eq.3) lvlcod=2
   60 initf=1
c
c  solve equations for next iteration
c
  100 if (iterno.ge.itlim) go to 200
  102 call dcdcmp
      if (igoof.ne.0) go to 400
      if (lvlcod.eq.1) go to 105
  105 call dcsol
      go to 120
  120 if (igoof.eq.0) go to 130
      igoof=0
      if (lvlcod.ne.1) lvlcod=2
      ipiv=1
      call load
      go to 102
  130 value(lvn+1)=0.0d0
      do 135 i=1,nstop
      j=nodplc(icswpr+i)
      k=nodplc(irswpf+j)
      value(lvntmp+k)=value(lvnim1+i)
  135 continue
      call copy8(value(lvntmp+1),value(lvnim1+1),nstop)
      ntemp=noncon
      noncon=0
      if (ntemp.gt.0) go to 150
      if (iterno.eq.1) go to 150
      do 140 i=2,numnod
      vold=value(lvnim1+i)
      vnew=value(lvn+i)
      tol=reltol*dmax1(dabs(vold),dabs(vnew))+vntol
      if (dabs(vold-vnew).le.tol) go to 140
      noncon=noncon+1
  140 continue
  150 do 160 i=1,nstop
      j=nodplc(icswpr+i)
      k=nodplc(irswpf+j)
      value(lvnim1+i)=value(lvn+k)
  160 continue
c     write(iofile,151) (value(lvn+k),k=1,nstop)
c 151 format(' solution: '/1p12d10.3)
      go to 10
c
c  no convergence
c
  200 igoof=1
  300 if (ndrflo.eq.0) go to 400
      write (iofile,301) ndrflo
  301 format('0warning:  underflow occurred ',i4,' time(s)')
c
c  finished
c
  400 return
      end

      subroutine topchk
      implicit double precision (a-h,o-z)
c
c     this routine constructs the element node table.  it also checks
c for voltage source/inductor loops, current source/capacitor cutsets,
c and that every node has a dc (conductive) path to ground
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
      integer change
c
c
      dimension atable(12),aide(20),nnods(20)
      dimension idlist(4),idlis2(4)
      dimension toptit(4)
      data toptit / 8helement , 8hnode tab, 8hle      , 8h         /
      data idlist / 3, 6, 8, 9 /
      data idlis2 /14,14,14,11 /
      data aide / 1hr,0.0d0,1hl,2*0.0d0,1he,0.0d0,1hh,1hv,0.0d0,1hd,
     1   1hq,1hj,1hm,0.0d0,0.0d0,1ht,0.0d0,0.0d0,0.0d0 /
      data nnods / 2,2,2,0,2,2,2,2,2,2,2,4,3,4,4,4,4,0,0,0 /
      data ablnk /1h /
c
c  allocate storage
c
      call getm4(iorder,ncnods)
      call getm4(iur,ncnods+1)
c
c  construct node table
c
      kntlim=lwidth/11
 1300 call getm4(itable,0)
      call getm4(itabid,0)
      istop=ncnods+1
      do 1310 i=1,istop
 1310 nodplc(iur+i)=1
      do 1370 id=1,18
      if (nnods(id).eq.0) go to 1370
      loc=locate(id)
 1320 if (loc.eq.0) go to 1370
      nloc=loc+1
      jstop=nnods(id)
 1330 do 1360 j=1,jstop
      node=nodplc(nloc+j)
      ispot=nodplc(iur+node+1)
      k=nodplc(iur+ncnods+1)
      call extmem(itable,1)
      call extmem(itabid,1)
      if (k.le.ispot) go to 1340
      call copy4(nodplc(itable+ispot),nodplc(itable+ispot+1),k-ispot)
      call copy4(nodplc(itabid+ispot),nodplc(itabid+ispot+1),k-ispot)
 1340 nodplc(itable+ispot)=loc
      nodplc(itabid+ispot)=id
c...  treat the substrate node of a mosfet as if it were a transmission
c...  line node, i.e. let it dangle if desired
      if(id.eq.14.and.j.eq.4) nodplc(itabid+ispot)=17
      k=node
      kstop=ncnods+1
 1350 k=k+1
      if (k.gt.kstop) go to 1360
      nodplc(iur+k)=nodplc(iur+k)+1
      go to 1350
 1360 continue
      loc=nodplc(loc)
      go to 1320
 1370 continue
c
c  check that every node has a dc path to ground
c
      call zero4(nodplc(iorder+1),ncnods)
      nodplc(iorder+1)=1
 1420 iflag=0
      do 1470 i=2,ncnods
      if (nodplc(iorder+i).eq.1) go to 1470
      jstart=nodplc(iur+i)
      jstop=nodplc(iur+i+1)-1
      if (jstart.gt.jstop) go to 1470
      do 1450 j=jstart,jstop
      loc=nodplc(itable+j)
      id=nodplc(itabid+j)
      if (aide(id).eq.0.0d0) go to 1450
      if (id.eq.17) go to 1445
      kstop=loc+nnods(id)-1
      do 1440 k=loc,kstop
      node=nodplc(k+2)
      if (nodplc(iorder+node).eq.1) go to 1460
 1440 continue
      go to 1450
 1445 if (nodplc(loc+2).eq.i) node=nodplc(loc+3)
      if (nodplc(loc+3).eq.i) node=nodplc(loc+2)
      if (nodplc(loc+4).eq.i) node=nodplc(loc+5)
      if (nodplc(loc+5).eq.i) node=nodplc(loc+4)
      if (nodplc(iorder+node).eq.1) go to 1460
 1450 continue
      go to 1470
 1460 nodplc(iorder+i)=1
      iflag=1
 1470 continue
      if (iflag.eq.1) go to 1420
c
c  print node table and topology error messages
c
      if (iprntn.eq.0) go to 1510
      call title(0,lwidth,1,toptit)
 1510 do 1590 i=1,ncnods
      jstart=nodplc(iur+i)
      jstop=nodplc(iur+i+1)-1
      if (iprntn.eq.0) go to 1550
      if (jstart.le.jstop) go to 1520
      write (iofile,1511) nodplc(junode+i)
 1511 format(1h0,i7)
      go to 1550
 1520 kntr=0
      jflag=1
      do 1540 j=jstart,jstop
      loc=nodplc(itable+j)
      locv=nodplc(loc+1)
      kntr=kntr+1
      atable(kntr)=value(locv)
      if (kntr.lt.kntlim) go to 1540
      if (jflag.eq.0) go to 1525
      jflag=0
      write (iofile,1521) nodplc(junode+i),(atable(k),k=1,kntr)
 1521 format(1h0,i7,3x,12(1x,a8))
      go to 1530
 1525 write (iofile,1526) (atable(k),k=1,kntr)
 1526 format(11x,12(1x,a8))
 1530 kntr=0
 1540 continue
      if (kntr.eq.0) go to 1550
      if (jflag.eq.0) go to 1545
      write (iofile,1521) nodplc(junode+i),(atable(k),k=1,kntr)
      go to 1550
 1545 write (iofile,1526) (atable(k),k=1,kntr)
 1550 if (jstart-jstop) 1560,1552,1556
c
c  allow node with only one connection iff element is a t-line
c
 1552 if (nodplc(itabid+jstart).eq.17) go to 1560
 1556 nogo=1
      write (iofile,1557) nodplc(junode+i)
 1557 format('0*error*:  less than 2 connections at node ',i6/)
      go to 1590
 1560 if (nodplc(iorder+i).eq.1) go to 1590
      nogo=1
      write (iofile,1561) nodplc(junode+i)
 1561 format('0*error*:  no dc path to ground from node ',i6/)
 1590 continue
c
c  check for inductor/voltage source loops
c
      do 1700 i=1,ncnods
      call zero4(nodplc(iorder+1),ncnods)
      nodplc(iorder+i)=-1
 1605 change=0
      do 1690 idcntr=1,4
      id=idlist(idcntr)
      loc=locate(id)
 1610 if ((loc.eq.0).or.(nodplc(loc+idlis2(idcntr)).ne.0)) go to 1690
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      if (nodplc(iorder+node1).eq.loc.or.
     1   nodplc(iorder+node2).eq.loc) go to 1680
      if (nodplc(iorder+node1)) 1620,1640,1630
 1620 nodplc(iorder+node1)=loc
      change=1
 1630 node=node2
      go to 1670
 1640 if (nodplc(iorder+node2)) 1650,1680,1660
 1650 nodplc(iorder+node2)=loc
      change=1
 1660 node=node1
 1670 if (nodplc(iorder+node).ne.0) go to 1710
      nodplc(iorder+node)=loc
      change=1
 1680 loc=nodplc(loc)
      go to 1610
 1690 continue
      if (change.eq.1) go to 1605
 1700 continue
      go to 1900
c ... loop found
 1710 locv=nodplc(loc+1)
      write (iofile,1711) value(locv)
 1711 format('0*error*:  inductor/voltage source loop found, containing
     1',a8/)
      nogo=1
c
c
 1900 call clrmem(iorder)
      call clrmem(iur)
      call clrmem(itable)
      call clrmem(itabid)
 2000 return
      end

      subroutine nlcsrc
      implicit double precision (a-h,o-z)
c
c     this routine loads the nonlinear controlled sources into the
c coefficient matrix.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c  nonlinear voltage-controlled current sources
c
      loc=locate(5)
   10 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 100
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      lnod=nodplc(loc+6)
      lmat=nodplc(loc+7)
      lcoef=nodplc(loc+8)
      call sizmem(nodplc(loc+8),ncoef)
      larg=nodplc(loc+9)
      lexp=nodplc(loc+10)
      lic=nodplc(loc+11)
      loct=nodplc(loc+12)+1
      icheck=0
      do 20 i=1,ndim
      call update(value(lic+i),loct,nodplc(lnod+1),nodplc(lnod+2),2,
     1   icheck)
      value(larg+i)=value(lx0+loct)
      loct=loct+2
      lnod=lnod+2
   20 continue
      call evpoly(cold,0,lcoef,ncoef,larg,ndim,lexp)
      loct=nodplc(loc+12)
      if (icheck.eq.1) go to 30
      if (initf.eq.6) go to 30
      tol=reltol*dmax1(dabs(cold),dabs(value(lx0+loct)))+abstol
      if (dabs(cold-value(lx0+loct)).lt.tol) go to 40
   30 noncon=noncon+1
   40 value(lx0+loct)=cold
      ceq=cold
      do 50 i=1,ndim
      call evpoly(geq,i,lcoef,ncoef,larg,ndim,lexp)
      loct=loct+2
      value(lx0+loct)=geq
      ceq=ceq-geq*value(larg+i)
      locy=lvn+nodplc(lmat+1)
      value(locy)=value(locy)+geq
      locy=lvn+nodplc(lmat+2)
      value(locy)=value(locy)-geq
      locy=lvn+nodplc(lmat+3)
      value(locy)=value(locy)-geq
      locy=lvn+nodplc(lmat+4)
      value(locy)=value(locy)+geq
      lmat=lmat+4
   50 continue
      value(lvn+node1)=value(lvn+node1)-ceq
      value(lvn+node2)=value(lvn+node2)+ceq
      loc=nodplc(loc)
      go to 10
c
c  nonlinear voltage controlled voltage sources
c
  100 loc=locate(6)
  110 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 200
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      iptr=nodplc(loc+6)
      lnod=nodplc(loc+7)
      lmat=nodplc(loc+8)
      lcoef=nodplc(loc+9)
      call sizmem(nodplc(loc+9),ncoef)
      larg=nodplc(loc+10)
      lexp=nodplc(loc+11)
      lic=nodplc(loc+12)
      loct=nodplc(loc+13)+2
      icheck=0
      do 120 i=1,ndim
      call update(value(lic+i),loct,nodplc(lnod+1),nodplc(lnod+2),2,
     1   icheck)
      value(larg+i)=value(lx0+loct)
      loct=loct+2
      lnod=lnod+2
  120 continue
      call evpoly(volt,0,lcoef,ncoef,larg,ndim,lexp)
      loct=nodplc(loc+13)
      if (icheck.eq.1) go to 130
      if (initf.eq.6) go to 130
      tol=reltol*dmax1(dabs(volt),dabs(value(lx0+loct)))+vntol
      if (dabs(volt-value(lx0+loct)).lt.tol) go to 140
  130 noncon=noncon+1
  140 value(lx0+loct)=volt
      value(lx0+loct+1)=value(lvnim1+iptr)
      veq=volt
      locy=lvn+nodplc(lmat+1)
      value(locy)=+1.0d0
      locy=lvn+nodplc(lmat+2)
      value(locy)=-1.0d0
      locy=lvn+nodplc(lmat+3)
      value(locy)=+1.0d0
      locy=lvn+nodplc(lmat+4)
      value(locy)=-1.0d0
      lmat=lmat+4
      loct=loct+1
      do 150 i=1,ndim
      call evpoly(vgain,i,lcoef,ncoef,larg,ndim,lexp)
      loct=loct+2
      value(lx0+loct)=vgain
      veq=veq-vgain*value(larg+i)
      locy=lvn+nodplc(lmat+1)
      value(locy)=value(locy)-vgain
      locy=lvn+nodplc(lmat+2)
      value(locy)=value(locy)+vgain
      lmat=lmat+2
  150 continue
      value(lvn+iptr)=veq
      loc=nodplc(loc)
      go to 110
c
c  nonlinear current-controlled current sources
c
  200 loc=locate(7)
  210 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 300
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      lvs=nodplc(loc+6)
      lmat=nodplc(loc+7)
      lcoef=nodplc(loc+8)
      call sizmem(nodplc(loc+8),ncoef)
      larg=nodplc(loc+9)
      lexp=nodplc(loc+10)
      lic=nodplc(loc+11)
      loct=nodplc(loc+12)+1
      icheck=0
      do 220 i=1,ndim
      iptr=nodplc(lvs+i)
      iptr=nodplc(iptr+6)
      call update(value(lic+i),loct,iptr,1,2,icheck)
      value(larg+i)=value(lx0+loct)
      loct=loct+2
  220 continue
      call evpoly(csrc,0,lcoef,ncoef,larg,ndim,lexp)
      loct=nodplc(loc+12)
      if (icheck.eq.1) go to 230
      if (initf.eq.6) go to 230
      tol=reltol*dmax1(dabs(csrc),dabs(value(lx0+loct)))+abstol
      if (dabs(csrc-value(lx0+loct)).lt.tol) go to 240
  230 noncon=noncon+1
  240 value(lx0+loct)=csrc
      ceq=csrc
      do 250 i=1,ndim
      call evpoly(cgain,i,lcoef,ncoef,larg,ndim,lexp)
      loct=loct+2
      value(lx0+loct)=cgain
      ceq=ceq-cgain*value(larg+i)
      locy=lvn+nodplc(lmat+1)
      value(locy)=value(locy)+cgain
      locy=lvn+nodplc(lmat+2)
      value(locy)=value(locy)-cgain
      lmat=lmat+2
  250 continue
      value(lvn+node1)=value(lvn+node1)-ceq
      value(lvn+node2)=value(lvn+node2)+ceq
      loc=nodplc(loc)
      go to 210
c
c  nonlinear current controlled voltage sources
c
  300 loc=locate(8)
  310 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 1000
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      ibr=nodplc(loc+6)
      lvs=nodplc(loc+7)
      lmat=nodplc(loc+8)
      lcoef=nodplc(loc+9)
      call sizmem(nodplc(loc+9),ncoef)
      larg=nodplc(loc+10)
      lexp=nodplc(loc+11)
      lic=nodplc(loc+12)
      loct=nodplc(loc+13)+2
      icheck=0
      do 320 i=1,ndim
      iptr=nodplc(lvs+i)
      iptr=nodplc(iptr+6)
      call update(value(lic+i),loct,iptr,1,2,icheck)
      value(larg+i)=value(lx0+loct)
      loct=loct+2
  320 continue
      call evpoly(volt,0,lcoef,ncoef,larg,ndim,lexp)
      loct=nodplc(loc+13)
      if (icheck.eq.1) go to 330
      if (initf.eq.6) go to 330
      tol=reltol*dmax1(dabs(volt),dabs(value(lx0+loct)))+vntol
      if (dabs(volt-value(lx0+loct)).lt.tol) go to 340
  330 noncon=noncon+1
  340 value(lx0+loct)=volt
      value(lx0+loct+1)=value(lvnim1+ibr)
      veq=volt
      locy=lvn+nodplc(lmat+1)
      value(locy)=+1.0d0
      locy=lvn+nodplc(lmat+2)
      value(locy)=-1.0d0
      locy=lvn+nodplc(lmat+3)
      value(locy)=+1.0d0
      locy=lvn+nodplc(lmat+4)
      value(locy)=-1.0d0
      lmat=lmat+4
      loct=loct+1
      do 350 i=1,ndim
      call evpoly(transr,i,lcoef,ncoef,larg,ndim,lexp)
      loct=loct+2
      value(lx0+loct)=transr
      veq=veq-transr*value(larg+i)
      locy=lvn+nodplc(lmat+i)
      value(locy)=value(locy)-transr
  350 continue
      value(lvn+ibr)=veq
      loc=nodplc(loc)
      go to 310
c
c  finished
c
 1000 return
      end

      integer function nxtmem(memwds)
c
c.. function returns the in nxtmem the next available memory size
c.. (which must be evenly divisible by 'nwd4, nwd8, and nwd16' as
c.. defined in setmem
c
      nxtmem=((memwds+1999)/2000)*2000
      return
      end

      subroutine lnkref
      implicit double precision (a-h,o-z)
c
c     this routine resolves all unsatisfied name references.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c  mutual inductors
c
      loc=locate(4)
  100 if (loc.eq.0) go to 200
      iref=nodplc(loc+2)
      call fndnam(value(iunsat+iref),loc-1,loc+2,3)
      iref=nodplc(loc+3)
      call fndnam(value(iunsat+iref),loc-1,loc+3,3)
      loc=nodplc(loc)
      go to 100
c
c  current-controlled current source
c
  200 loc=locate(7)
  210 if (loc.eq.0) go to 300
      nump=nodplc(loc+4)
      locp=nodplc(loc+6)
      do 220 i=1,nump
      iref=nodplc(locp+i)
      call fndnam(value(iunsat+iref),loc-1,locp+i,9)
  220 continue
      loc=nodplc(loc)
      go to 210
c
c  current-controlled voltage sources
c
  300 loc=locate(8)
  310 if (loc.eq.0) go to 400
      nump=nodplc(loc+4)
      locp=nodplc(loc+7)
      do 320 i=1,nump
      iref=nodplc(locp+i)
      call fndnam(value(iunsat+iref),loc-1,locp+i,9)
  320 continue
      loc=nodplc(loc)
      go to 310
c
c  diodes
c
  400 loc=locate(11)
  410 if (loc.eq.0) go to 500
      iref=nodplc(loc+5)
      call fndnam(value(iunsat+iref),loc-1,loc+5,21)
      loc=nodplc(loc)
      go to 410
c
c  bjts
c
  500 loc=locate(12)
  510 if (loc.eq.0) go to 600
      iref=nodplc(loc+8)
      call fndnam(value(iunsat+iref),loc-1,loc+8,22)
      loc=nodplc(loc)
      go to 510
c
c  jfets
c
  600 loc=locate(13)
  610 if (loc.eq.0) go to 700
      iref=nodplc(loc+7)
      call fndnam(value(iunsat+iref),loc-1,loc+7,23)
      loc=nodplc(loc)
      go to 610
c
c  mosfets
c
  700 loc=locate(14)
  710 if (loc.eq.0) go to 1000
      iref=nodplc(loc+8)
      call fndnam(value(iunsat+iref),loc-1,loc+8,24)
      loc=nodplc(loc)
      go to 710
c
c  finished
c
 1000 call clrmem(iunsat)
      return
      end

      integer function locf(ivar)
      implicit double precision (a-h,o-z)
      external loc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
      dimension ivar(1)
      iabsa=loc(ivar)
      locf=iabsa/4
      if (iabsa.eq.4*locf) return
      write(iofile,100) iabsa
  100 format ('0*error*: system error, address ',i10,
     1   ' is not on 4-byte boundary')
      return
      end

      subroutine dcsol
      implicit double precision (a-h,o-z)
c
c     this routine solves the system of circuit equations by performing
c a forward and backward substitution step using the previously-computed
c lu factors.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c  forward substitution
c
      call second(t1)
      do 20 i=2,nstop
      loc=i
      iord=nodplc(irswpf+i)
   10 loc=nodplc(jcpt+loc)
      if (nodplc(jcolno+loc).ge.i) go to 20
      j=nodplc(jcolno+loc)
      jord=nodplc(irswpf+j)
      value(lvn+iord)=value(lvn+iord)-
     1           value(lvn+loc)*value(lvn+jord)
      go to 10
   20 continue
c
c     back substitution
c
      i=nstop
      iord=nodplc(irswpf+i)
      jord=nodplc(icswpf+i)
      locnn=indxx(iord,jord)
   30 value(lvn+iord)=value(lvn+iord)/value(lvn+locnn)
      i=i-1
      if (i.le.1) go to 100
      iord=nodplc(irswpf+i)
      loc=i
   35 loc=nodplc(jcpt+loc)
   40 if (nodplc(jcolno+loc).ne.i) go to 35
      locnn=loc
   50 loc=nodplc(jcpt+loc)
      if (loc.eq.0) go to 30
      j=nodplc(jcolno+loc)
      jord=nodplc(irswpf+j)
      value(lvn+iord)=value(lvn+iord)-
     1           value(lvn+loc)*value(lvn+jord)
      go to 50
  100 call second(t2)
      rstats(46)=rstats(46)+t2-t1
      return
      end

      subroutine scale(xmin,xmax,n,xminp,xmaxp,del)
      implicit double precision (a-h,o-z)
c
c     this routine determines the 'optimal' scale to use for the plot of
c some output variable.
c
c
c  adapted from algorithm 463 of 'collected algorithms of the cacm'
c
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
      integer xxor
      dimension vint(5)
      data vint / 1.0d0,2.0d0,5.0d0,10.0d0,20.0d0 /
      data eps / 1.0d-12 /
c
c
c...  trap too-small data spread
c***********************************************************
c  temporily check 'equality' this way
      if(xmin.eq.0.0d0.and.xmax.eq.0.0d0) go to 4
      if(dabs((xmax-xmin)/dmax1(dabs(xmin),dabs(xmax))).ge.1.0d-4)
     1  go to 10
    4 continue
      if (xmin.ge.0.0d0) go to 5
      xmax=0.5d0*xmin+eps
      xmin=1.5d0*xmin-eps
      go to 10
    5 xmax=1.5d0*xmin+eps
      xmin=0.5d0*xmin-eps
c...  find approximate interval size, normalized to [1,10]
   10 a=(xmax-xmin)/dble(n)
      nal=idint(dlog10(a))
      if (a.lt.1.0d0) nal=nal-1
      xfact=dexp(xlog10*dble(nal))
      b=a/xfact
c...  find closest permissible interval size
      do 20 i=1,3
      if (b.lt.(vint(i)+eps)) go to 30
   20 continue
      i=4
c...  compute interval size
   30 del=vint(i)*xfact
      fm1=xmin/del
      m1=fm1
      if (fm1.lt.0.0d0) m1=m1-1
      if (dabs(dble(m1)+1.0d0-fm1).lt.eps) m1=m1+1
c...  compute new maximum and minimum limits
      xminp=del*dble(m1)
      fm2=xmax/del
      m2=fm2+1.0d0
      if (fm2.lt.(-1.0d0)) m2=m2-1
      if (dabs(fm2+1.0d0-dble(m2)).lt.eps) m2=m2-1
      xmaxp=del*dble(m2)
      np=m2-m1
c...  check whether another loop required
      if (np.le.n) go to 40
      i=i+1
      go to 30
c...  do final adjustments and correct for roundoff error(s)
   40 nx=(n-np)/2
      xminp=dmin1(xmin,xminp-dble(nx)*del)
      xmaxp=dmax1(xmax,xminp+dble(n)*del)
      return
      end

      subroutine card
      implicit double precision (a-h,o-z)
c
c     this routine scans the input lines, storing each field into the
c tables ifield, idelim, icolum, and icode.  with the exception of the
c '.end' line, card always reads the next line to check for a possible
c continuation before it exits.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=line 3/15/83
      common /line/ achar,afield(15),oldlin(15),kntrc,kntlim
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      dimension adigit(10)
      data adigit / 1h0,1h1,1h2,1h3,1h4,1h5,1h6,1h7,1h8,1h9 /
      data ablnk,aper,aplus,aminus,astk / 1h , 1h., 1h+, 1h-, 1h* /
      data bg,ak,au,an,ap,ae,am,af,at /1hg,1hk,1hu,1hn,1hp,1he,1hm,
     1  1hf,1ht/
      data ai / 1hi /
      data alprn, arprn, aequal / 1h(, 1h), 1h= /
      data aend / 4h.end /
c
c      note:  the value of the function *nxtchr* (used extensively in
c this routine) is as follows:
c
c                    <0:  end-of-line
c                    =0:  delimiter found
c                    >0:  non-delimiter found
c
      numfld=0
      nofld=10
      go to 20
c
c  read next card
c
   10 nofld=10
      call getlin
      if (keof.eq.0) go to 20
c...  error:  unexpected end-of-file condition on input
   15 keof=1
      nofld=1
      numfld=0
      igoof=1
      write (iofile,16)
   16 format('0*error*:  .end card missing'/)
      go to 1000
c
c  eliminate trailing blanks rapidly
c
   20 if (afield(nofld).ne.ablnk) go to 40
      if (nofld.eq.1) go to 30
      nofld=nofld-1
      go to 20
c...  write blank card
   30 write (iofile,31)
   31 format(1x)
      go to 10
c...  copy the card to output listing
   40 write (iofile,41) (afield(i),i=1,nofld)
   41 format(1x,10a8)
c
c  initialization for new card
c
   45 kntrc=0
      kntlim=min0(8*nofld,iwidth)
c
c  fetch first non-delimiter (see routine *nxtchr* for list)
c
   50 if (nxtchr(0)) 600,50,60
c...  check for comment (leading asterisk)
   60 if (achar.eq.astk) go to 10
      go to 100
c
c  fetch next character
c
   70 if (nxtchr(0)) 600,80,100
c
c  two consecutive delimiters imply numeric zero unless the delimiter
c  is a blank or parenthesis.
c
   80 if (achar.eq.ablnk) go to 70
      if (achar.eq.alprn) go to 70
      if (achar.eq.arprn) go to 70
      if (achar.eq.aequal) go to 70
c...  check for sufficient space in storage arrays
      if (numfld.lt.insize-1) go to 90
      call extmem(ifield,50)
      call extmem(icode,50)
      call extmem(idelim,50)
      call extmem(icolum,50)
      insize=insize+50
   90 numfld=numfld+1
      value(ifield+numfld)=0.0d0
      nodplc(icode+numfld)=0
      value(idelim+numfld)=achar
      nodplc(icolum+numfld)=kntrc
      go to 70
c
c  check for sufficient space in storage arrays
c
  100 if (numfld.lt.insize-1) go to 110
      call extmem(ifield,50)
      call extmem(icode,50)
      call extmem(idelim,50)
      call extmem(icolum,50)
      insize=insize+50
c
c  begin scan of next field
c
c...  initialization
  110 jdelim=0
      xsign=1.0d0
      xmant=0.0d0
      idec=0
      iexp=0
c...  check for leading plus or minus sign
      if (achar.eq.aplus) go to 210
      if (achar.eq.aminus) go to 200
c...  finish initialization
      anam=ablnk
      kchr=1
c...  an isolated period indicates that a continuation card follows
      if (achar.ne.aper) go to 120
c...  alter initialization slightly if leading period found
      idec=1
      iexp=-1
      anam=aper
      kchr=2
c...  now take a look at the next character
      if (nxtchr(0)) 10,10,120
c
c  test for number (any digit)
c
  120 do 130 i=1,10
      if (achar.ne.adigit(i)) go to 130
      xmant=dble(i-1)
      go to 210
  130 continue
c
c  assemble name
c
      numfld=numfld+1
      call move(anam,kchr,achar,1,1)
      kchr=kchr+1
      do 150 i=kchr,8
      if (nxtchr(0)) 160,160,140
  140 call move(anam,i,achar,1,1)
  150 continue
      go to 170
  160 jdelim=1
  170 value(ifield+numfld)=anam
      nodplc(icode+numfld)=1
      nodplc(icolum+numfld)=kntrc
c...  no '+' format continuation possible for .end card
      if (numfld.ge.2) go to 400
      if (anam.ne.aend) go to 400
      nodplc(icode+numfld+1)=-1
      go to 1000
c
c  process number
c
c...  take note of leading minus sign
  200 xsign=-1.0d0
c...  take a look at the next character
  210 if (nxtchr(0)) 335,335,220
c...  test for digit
  220 do 230 i=1,10
      if (achar.ne.adigit(i)) go to 230
      xmant=xmant*10.0d0+dble(i-1)
      if (idec.eq.0) go to 210
      iexp=iexp-1
      go to 210
  230 continue
c
c  check for decimal point
c
      if (achar.ne.aper) go to 240
c...  make certain that this is the first one found
      if (idec.ne.0) go to 500
      idec=1
      go to 210
c
c  test for exponent
c
  240 if (achar.ne.ae) go to 300
      if (nxtchr(0)) 335,335,250
  250 itemp=0
      isign=1
c...  check for possible leading sign on exponent
      if (achar.eq.aplus) go to 260
      if (achar.ne.aminus) go to 270
      isign=-1
  260 if (nxtchr(0)) 285,285,270
c...  test for digit
  270 do 280 i=1,10
      if (achar.ne.adigit(i)) go to 280
      itemp=itemp*10+i-1
      go to 260
  280 continue
      go to 290
  285 jdelim=1
c...  correct internal exponent
  290 iexp=iexp+isign*itemp
      go to 340
c
c  test for scale factor
c
  300 if (achar.ne.am) go to 330
c...  special check for *me* (as distinguished from *m*)
      if (nxtchr(0)) 320,320,310
  310 if (achar.ne.ae) go to 315
      iexp=iexp+6
      go to 340
  315 if (achar.ne.ai) go to 325
      xmant=xmant*25.4d-6
      go to 340
  320 jdelim=1
  325 iexp=iexp-3
      go to 340
  330 if (achar.eq.at) iexp=iexp+12
      if (achar.eq.bg) iexp=iexp+9
      if (achar.eq.ak) iexp=iexp+3
      if (achar.eq.au) iexp=iexp-6
      if (achar.eq.an) iexp=iexp-9
      if (achar.eq.ap) iexp=iexp-12
      if (achar.eq.af) iexp=iexp-15
      go to 340
  335 jdelim=1
c
c  assemble the final number
c
  340 if (xmant.eq.0.0d0) go to 350
      if (iexp.eq.0) go to 350
      if (iabs(iexp).ge.201) go to 500
      xmant=xmant*dexp(dble(iexp)*xlog10)
      if (xmant.gt.1.0d+35) go to 500
      if (xmant.lt.1.0d-35) go to 500
  350 numfld=numfld+1
      value(ifield+numfld)=dsign(xmant,xsign)
      nodplc(icode+numfld)=0
      nodplc(icolum+numfld)=kntrc
c
c  skip to non-blank delimiter (if necessary)
c
  400 if (jdelim.eq.0) go to 440
  410 value(idelim+numfld)=achar
      if (achar.ne.ablnk) go to 70
      if (nxtchr(0)) 450,410,420
  420 kntrc=kntrc-1
      go to 70
  440 if (nxtchr(0)) 450,410,440
  450 value(idelim+numfld)=achar
      go to 600
c
c  errors
c
  500 write (iofile,501) kntrc
  501 format('0*error*:  illegal number -- scan stopped at column ',i3/)
      igoof=1
      numfld=numfld+1
      value(ifield+numfld)=0.0d0
      nodplc(icode+numfld)=0
      value(idelim+numfld)=achar
      nodplc(icolum+numfld)=kntrc
c
c  finished
c
  600 nodplc(icode+numfld+1)=-1
c
c  check next line for possible continuation
c
  610 call getlin
      if (keof.eq.1) go to 15
      nofld=10
  620 if (afield(nofld).ne.ablnk) go to 630
      if (nofld.eq.1) go to 650
      nofld=nofld-1
      go to 620
  630 kntrc=0
      kntlim=min0(8*nofld,iwidth)
c...  continuation line has a '+' as first non-delimiter on card
  632 if(nxtchr(0)) 650,632,634
  634 if(achar.ne.aplus) go to 640
      write(iofile,41) (afield(i),i=1,nofld)
      go to 70
  640 if (achar.ne.astk) go to 1000
  650 write (iofile,41) (afield(i),i=1,nofld)
      go to 610
 1000 return
      end

      subroutine dmpmat(anam)
      implicit double precision (a-h,o-z)
c
c      this routine dumps out the matrix and associated pointers.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=line 3/15/83
      common /line/ achar,afield(15),oldlin(15),kntrc,kntlim
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=mosarg 3/15/83
      common /mosarg/ vto,beta,gamma,phi,phib,cox,xnsub,xnfs,xd,xj,xld,
     1   xlamda,uo,uexp,vbp,utra,vmax,xneff,xl,xw,vbi,von,vdsat,qspof,
     2   beta0,beta1,cdrain,xqco,xqc,fnarrw,fshort,lev
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=cje 3/15/83
      common /cje/ maxtim,itime,icost
c spice version 2g.6  sccsid=debug 3/15/83
      common/debug/ idebug(20)
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      write (iofile,10) anam,mode,modedc,
     1 time,delta,icalc,iterno,initf,ipiv,iord,noncon,igoof,nogo
   10 format('0*debug*:  dmpmt called by ',a8,/,
     1   ' *debug*:  mode, mdc, time, delta, icalc, itr#, initf,',
     2             ' piv, ord, ncon, igoof, nogo =',/,
     3   ' *debug*:  ',2i5,1p2d10.2,8i5)
      call dmpmem(5hdmpmt)
c
c  dump out the *whole* thing
c
      call sizmem(irpt,irpts)
      write (iofile,16) nstop,nttbr,irpts
   16 format(' *debug*:  nstop, nttbr, size(irpt) = ',3i6,/,
     1   ' *debug*:   index  irpt  irow  jcol  jcpt       value',
     2          10x,' index  irpt  irow  jcol  jcpt       value')
      j=(irpts+1)/2
      istop=j
      do 30 i=1,istop
      j=j+1
      write (iofile,26)
     1   i,nodplc(irpt+i),nodplc(irowno+i),nodplc(jcolno+i),
     2   nodplc(jcpt+i),value(lvn+i),
     3   j,nodplc(irpt+j),nodplc(irowno+j),nodplc(jcolno+j),
     4   nodplc(jcpt+j),value(lvn+j)
   26 format(' *debug*:  ',5i6,1pd12.4,10x,5i6,1pd12.4)
   30 continue
cc 51 format(" *debug*:  irpt   = ",18i6)
cc    write (iofile,56) (nodplc(irowno+i),i=1,irpts)
cc 56 format(" *debug*:  irowno = ",18i6)
cc    write (iofile,61) (nodplc(jcolno+i),i=1,irpts)
cc 61 format(" *debug*:  jcolno = ",18i6)
cc    write (iofile,66) (nodplc(jcpt  +i),i=1,irpts)
cc 66 format(" *debug*:  jcpt   = ",18i6)
      write (iofile,71) (nodplc(irswpf+i),i=1,nstop)
   71 format(' *debug*:  irswpf = ',18i6)
      write (iofile,76) (nodplc(irswpr+i),i=1,nstop)
   76 format(' *debug*:  irswpr = ',18i6)
      write (iofile,81) (nodplc(icswpf+i),i=1,nstop)
   81 format(' *debug*:  icswpf = ',18i6)
      write (iofile,86) (nodplc(icswpr+i),i=1,nstop)
   86 format(' *debug*:  icswpr = ',18i6)
c
c
  500 return
      end

      subroutine fouran
      implicit double precision (a-h,o-z)
c
c     this routine determines the fourier coefficients of a transient
c analysis waveform.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension sinco(9),cosco(9)
      dimension fortit(4)
      data fortit / 8hfourier , 8hanalysis, 8h        , 8h         /
      data ablnk / 1h  /
c
c
      forprd=1.0d0/forfre
      xstart=tstop-forprd
      kntr=1
cc    xn=101.0d0
      xincr=forprd/npoint
cc    npoint=xn
      call getm8(locx,npoint)
      call getm8(locy,npoint)
      do 105 nknt=1,nfour
      itab(1)=nodplc(ifour+nknt)
      kfrout=itab(1)
      call ntrpl8(locx,locy,numpnt)
      dcco=0.0d0
      call zero8(sinco,9)
      call zero8(cosco,9)
      loct=locy+1
      ipnt=0
   10 yvr=value(loct+ipnt)
      dcco=dcco+yvr
      forfac=dble(ipnt)*twopi/npoint
      arg=0.0d0
      do 20 k=1,9
      arg=arg+forfac
      sinco(k)=sinco(k)+yvr*dsin(arg)
      cosco(k)=cosco(k)+yvr*dcos(arg)
   20 continue
      ipnt=ipnt+1
      if (ipnt.ne.npoint) go to 10
      dcco=dcco/npoint
      forfac=2.0d0/npoint
      do 30 k=1,9
      sinco(k)=sinco(k)*forfac
      cosco(k)=cosco(k)*forfac
   30 continue
      call title(0,72,1,fortit)
      ipos=1
      call outnam(kfrout,1,string,ipos)
      call move(string,ipos,ablnk,1,7)
      jstop=(ipos+6)/8
      write (iofile,61) (string(j),j=1,jstop)
   61 format(' fourier components of transient response ',5a8///)
      write (iofile,71) dcco
   71 format('0dc component =',1pd12.3/,
     1   '0harmonic   frequency    fourier    normalized    phase     no
     2rmalized'/,
     3   '    no         (hz)     component    component    (deg)    pha
     4se (deg)'//)
      iknt=1
      freq1=forfre
      xnharm=1.0d0
      call magphs(cmplx(sngl(sinco(1)),sngl(cosco(1))),xnorm,pnorm)
      phasen=0.0d0
      write (iofile,81) iknt,freq1,xnorm,xnharm,pnorm,phasen
   81 format(i6,1pd15.3,d12.3,0pf13.6,f10.3,f12.3/)
      thd=0.0d0
      do 90 iknt=2,9
      freq1=dble(iknt)*forfre
      call magphs(cmplx(sngl(sinco(iknt)),sngl(cosco(iknt))),
     1   harm,phase)
      xnharm=harm/xnorm
      phasen=phase-pnorm
      thd=thd+xnharm*xnharm
      write (iofile,81) iknt,freq1,harm,xnharm,phase,phasen
   90 continue
      thd=100.0d0*dsqrt(thd)
      write (iofile,101) thd
  101 format (//5x,'total harmonic distortion =  ',f12.6,'  percent')
  105 continue
      call clrmem(locx)
      call clrmem(locy)
  110 return
      end

      subroutine alfnum(number,string,ipos)
      implicit double precision (a-h,o-z)
c
c     this routine converts number into character form, storing the
c characters in the character array string, beginning with the position
c indicated by ipos.
c
c **** note that the 'ipos' variable is changed to indicate the position
c      of the next unwritten character.  this could clobber constants if
c      ipos is not a variable in the calling program
c
      dimension string(1)
      dimension adigit(10)
      data adigit / 1h0,1h1,1h2,1h3,1h4,1h5,1h6,1h7,1h8,1h9 /
      data aminus / 1h- /
c
c
      num=number
c
c  check for number < 0
c
      if (num.ge.0) go to 10
      num=-num
c...  negative number:  insert minus sign
      call move(string,ipos,aminus,1,1)
      ipos=ipos+1
c
c  convert number one digit at a time, in reverse order
c
   10 istart=ipos
   20 numtmp=num/10
      idigit=num-numtmp*10
      call move(string,ipos,adigit(idigit+1),1,1)
      ipos=ipos+1
      num=numtmp
      if (num.ne.0) go to 20
      istop=ipos-1
c
c  now reverse the order of the digits
c
   30 if (istop.le.istart) go to 40
      call move(tmpdgt,1,string,istart,1)
      call move(string,istart,string,istop,1)
      call move(string,istop,tmpdgt,1,1)
      istart=istart+1
      istop=istop-1
      go to 30
c
c  conversion complete
c
   40 return
      end

      subroutine mosq3(vds,vbs,vgs,vdsat,vth,vbin,gamasd,cox,phi,
     1   qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      implicit double precision (a-h,o-z)
c
      equivalence (xlamda,alpha),(vbp,theta),(uexp,eta),(utra,xkappa)
c
c     charge equations are referenced to bulk
c
      vgb=vgs-vbs
      vfb=vbi-phi
      onxl=1.0d0/xl
      phibs=sqphbs*sqphbs
c
c     body effect
c
      gammas=gamma*fshort
      fbodys=gammas/(sqphbs+sqphbs)*0.5d0
      fbody=fbodys+fnarrw
      onfbdy=1.0d0/(1.0d0+fbody)
      dfbdvb=-fbodys*dsqdvb/sqphbs+fbodys*dfsdvb/fshort
      qbonco=gammas*sqphbs+fnarrw*phibs
      dqbdvb=gammas*dsqdvb+gamma*dfsdvb*sqphbs-fnarrw
c
c.....static feedback effect
c
      vbix=vbi-eta*vds
c
c.....threshold voltage
c
      vth=vbix+qbonco
      dvtdvd=-eta
      dvtdvb=dqbdvb
c
c     branch according to region of operation
c
      if (vgs.le.vth) go to 800
      vgsx=dmax1(vgs,von)
c
c     branch on vds=0.0d0
c
      vdsx=dmin1(vds,vdsat)
      if ( vdsx.eq.0.0d0 ) go to 900
      cdo=vgsx-vth-0.5d0*(1.0d0+fbody)*vdsx
      dcodvg=1.0d0
      if (vds.lt.vdsat) dcodvd=-dvtdvd-0.5d0*(1.0d0+fbody)
      dcodvb=-dvtdvb-0.5d0*dfbdvb*vdsx
c
c.....charge terms
c
420   continue
      arga=(1.0d0+fbody)*vdsx*vdsx/(12.0d0*cdo)
      dadco=-arga/cdo
      if (vds.lt.vdsat) dadvd=arga/vdsx
      dadfb=arga*onfbdy
c
c.....gate charge
c
      qg=cox*(vgs-vbix-0.5d0*vdsx+arga)
      cggb=cox*(1.0d0+dadco*dcodvg)
      if (vds.lt.vdsat) cgdb=cox*(-dvtdvd-0.5d0+dadvd+dadco*dcodvd)
      cgsb=-cggb-cgdb-cox*(dadco*dcodvb+dadfb*dfbdvb)
c
c.....bulk charge
c
      arga=arga*fbody
      dadco=dadco*fbody
      if (vds.lt.vdsat) dadvd=dadvd*fbody
      dadfb=dadfb*(1.0d0+fbody+fbody)
c
      qb=-cox*(qbonco+0.5d0*fbody*vdsx-arga)
      cbgb=cox*dadco*dcodvg
      if (vds.lt.vdsat) cbdb=-cox*(0.5d0*fbody-dadvd-dadco*dcodvd)
      cbsb=-cbgb-cbdb
     1          +cox*(dqbdvb+(0.5d0*vdsx-dadfb)*dfbdvb-dadco*dcodvb)
      go to 1000
c
c.....charge terms of vgs<vth
c
800   continue
      if ( vgb.gt.vfb ) go to 810
      qg=cox*(vgb-vfb)
      cggb=cox
      go to  820
810   continue
      gamma2=gammas*0.5d0
      arga=dsqrt(gamma2*gamma2+(vgb-vfb))
      qg=gammas*cox*(arga-gamma2)
      cggb=0.5d0*cox*gammas/arga
820   continue
      qb=-qg
      cbgb=-cggb
      cgdb=0.0d0
      cgsb=0.0d0
      cbdb=0.0d0
      cbsb=0.0d0
      go to 1000
c
c     special case vds=0.0d0
c
  900 qg=cox*(vgs-vbi)
      qb=-cox*qbonco
      cggb=cox
      cgdb=-cox*(0.5d0+dvtdvd)
      cgsb=-cox*(0.5d0-dvtdvb)
      cbgb=0.0d0
      cbdb=-0.5d0*cox*fbody
      cbsb=cox*(dqbdvb+0.5d0*fbody)
c
c     done
c
 1000 qc=-(qg+qb)
      return
      end

      subroutine noise(loco)
      implicit double precision (a-h,o-z)
c
c     this routine computes the noise due to various circuit elements.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension vno1(12),vno2(12),vno3(12),vno4(12),vno5(12),vno6(12)
      dimension vntot(12),anam(12),string(5)
      real v,vreal,vimag
      dimension titln(4),v(2)
      dimension afmt1(3),afmt2(3)
      complex cval,c(1)
      equivalence (c(1),v(1),cval)
      equivalence (v(1),vreal),(v(2),vimag)
      data titln / 8hnoise an, 8halysis  , 8h        , 8h         /
      data alsrb,alsrc,alsre,alsrs,alsrd / 2hrb,2hrc,2hre,2hrs,2hrd /
      data alsib,alsic,alsid,alsfn / 2hib,2hic,2hid,2hfn /
      data alstot / 5htotal /
      data aslash,ablnk / 1h/, 1h  /
      data afmt1 /8h(////,11,8hx,  (2x,,8ha8))    /
      data afmt2 /8h(1h0,a8,,8h1p  d10.,8h3)      /
c
c
c.. fix-up formats
      kntr=12
      if(lwidth.le.80) kntr=7
      ipos=11
      call move(afmt1,ipos,ablnk,1,2)
      call alfnum(kntr,afmt1,ipos)
      ipos=11
      call move(afmt2,ipos,ablnk,1,2)
      call alfnum(kntr,afmt2,ipos)
      nprnt=0
      freq=omega/twopi
      if (icalc.ge.2) go to 10
      fourkt=4.0d0*charge*vt
      twoq=2.0d0*charge
      noposo=nodplc(nosout+2)
      nonego=nodplc(nosout+3)
      kntlim=lwidth/11
      nkntr=1
   10 if (nosprt.eq.0) go to 30
      if (nkntr.gt.icalc) go to 30
      nprnt=1
      nkntr=nkntr+nosprt
      call title(0,lwidth,1,titln)
      write (iofile,16) freq
   16 format('0    frequency = ',1pd10.3,' hz'/)
c
c  obtain adjoint circuit solution
c
   30 vnrms=0.0d0
      cval=cvalue(lcvn+noposo)-cvalue(lcvn+nonego)
      vout=dsqrt(dble(vreal*vreal)+dble(vimag*vimag))
      vout=dmax1(vout,1.0d-20)
      call zero8(value(lvn+1),nstop)
      call zero8(value(imvn+1),nstop)
      value(lvn+noposo)=-1.0d0
      value(lvn+nonego)=+1.0d0
      call acasol
c
c  resistors
c
      if (jelcnt(1).eq.0) go to 200
      ititle=0
   91 format(//'0**** resistor squared noise voltages (sq v/hz)')
  100 loc=locate(1)
      kntr=0
  110 if ((loc.eq.0).or.(nodplc(loc+8).ne.0)) go to 130
      kntr=kntr+1
      locv=nodplc(loc+1)
      anam(kntr)=value(locv)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      cval=cvalue(lcvn+node1)-cvalue(lcvn+node2)
      vntot(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))
     1   *fourkt*value(locv+1)
      vnrms=vnrms+vntot(kntr)
      if (kntr.ge.kntlim) go to 140
  120 loc=nodplc(loc)
      go to 110
  130 if (kntr.eq.0) go to 200
  140 if (nprnt.eq.0) go to 160
      if (ititle.eq.0) write (iofile,91)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt2) alstot,(vntot(i),i=1,kntr)
  160 kntr=0
      if (loc.ne.0) go to 120
c
c  diodes
c
  200 if (jelcnt(11).eq.0) go to 300
      ititle=0
  201 format(//'0**** diode squared noise voltages (sq v/hz)')
  210 loc=locate(11)
      kntr=0
  220 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 240
      kntr=kntr+1
      locv=nodplc(loc+1)
      anam(kntr)=value(locv)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      locm=nodplc(loc+5)
      locm=nodplc(locm+1)
      loct=nodplc(loc+11)
      area=value(locv+1)
      fnk=value(locm+10)
      fna=value(locm+11)
c
c  ohmic resistance
c
      cval=cvalue(lcvn+node1)-cvalue(lcvn+node3)
      vno1(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))
     1   *fourkt*value(locm+2)*area
c
c  junction shot noise and flicker noise
c
      cval=cvalue(lcvn+node3)-cvalue(lcvn+node2)
      vtemp=dble(vreal*vreal)+dble(vimag*vimag)
      arg=dmax1(dabs(value(lx0+loct+1)),1.0d-20)
      vno2(kntr)=vtemp*twoq*arg
      vno3(kntr)=vtemp*fnk*dexp(fna*dlog(arg))/freq
      vntot(kntr)=vno1(kntr)+vno2(kntr)+vno3(kntr)
      vnrms=vnrms+vntot(kntr)
      if (kntr.ge.kntlim) go to 250
  230 loc=nodplc(loc)
      go to 220
  240 if (kntr.eq.0) go to 300
  250 if (nprnt.eq.0) go to 260
      if (ititle.eq.0) write (iofile,201)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt2) alsrs,(vno1(i),i=1,kntr)
      write (iofile,afmt2) alsid,(vno2(i),i=1,kntr)
      write (iofile,afmt2) alsfn,(vno3(i),i=1,kntr)
      write (iofile,afmt2) alstot,(vntot(i),i=1,kntr)
  260 kntr=0
      if (loc.ne.0) go to 230
c
c  bipolar junction transistors
c
  300 if (jelcnt(12).eq.0) go to 400
      ititle=0
  301 format(//'0**** transistor squared noise voltages (sq v/hz)')
  310 loc=locate(12)
      kntr=0
  320 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 340
      kntr=kntr+1
      locv=nodplc(loc+1)
      anam(kntr)=value(locv)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      locm=nodplc(loc+8)
      locm=nodplc(locm+1)
      loct=nodplc(loc+22)
      area=value(locv+1)
      fnk=value(locm+44)
      fna=value(locm+45)
c
c  extrinsic resistances
c
c...  base resistance
      cval=cvalue(lcvn+node2)-cvalue(lcvn+node5)
      vno1(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))
     1  *fourkt*value(lx0+loct+16)
c...  collector resistance
      cval=cvalue(lcvn+node1)-cvalue(lcvn+node4)
      vno2(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))
     1   *fourkt*value(locm+20)*area
c...  emitter resistance
      cval=cvalue(lcvn+node3)-cvalue(lcvn+node6)
      vno3(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))
     1   *fourkt*value(locm+19)*area
c
c  base current shot noise and flicker noise
c
      cval=cvalue(lcvn+node5)-cvalue(lcvn+node6)
      vtemp=dble(vreal*vreal)+dble(vimag*vimag)
      arg=dmax1(dabs(value(lx0+loct+3)),1.0d-20)
      vno4(kntr)=vtemp*twoq*arg
      vno5(kntr)=vtemp*fnk*dexp(fna*dlog(arg))/freq
c
c  collector current shot noise
c
      cval=cvalue(lcvn+node4)-cvalue(lcvn+node6)
      vno6(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))
     1   *twoq*dabs(value(lx0+loct+2))
      vntot(kntr)=vno1(kntr)+vno2(kntr)+vno3(kntr)+vno4(kntr)+vno5(kntr)
     1   +vno6(kntr)
      vnrms=vnrms+vntot(kntr)
      if (kntr.ge.kntlim) go to 350
  330 loc=nodplc(loc)
      go to 320
  340 if (kntr.eq.0) go to 400
  350 if (nprnt.eq.0) go to 360
      if (ititle.eq.0) write (iofile,301)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt2) alsrb,(vno1(i),i=1,kntr)
      write (iofile,afmt2) alsrc,(vno2(i),i=1,kntr)
      write (iofile,afmt2) alsre,(vno3(i),i=1,kntr)
      write (iofile,afmt2) alsib,(vno4(i),i=1,kntr)
      write (iofile,afmt2) alsic,(vno6(i),i=1,kntr)
      write (iofile,afmt2) alsfn,(vno5(i),i=1,kntr)
      write (iofile,afmt2) alstot,(vntot(i),i=1,kntr)
  360 kntr=0
      if (loc.ne.0) go to 330
c
c  jfets
c
  400 if (jelcnt(13).eq.0) go to 500
      ititle=0
  401 format(//'0**** jfet squared noise voltages (sq v/hz)')
  410 loc=locate(13)
      kntr=0
  420 if ((loc.eq.0).or.(nodplc(loc+25).ne.0)) go to 440
      kntr=kntr+1
      locv=nodplc(loc+1)
      anam(kntr)=value(locv)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      locm=nodplc(loc+7)
      locm=nodplc(locm+1)
      loct=nodplc(loc+19)
      area=value(locv+1)
      fnk=value(locm+10)
      fna=value(locm+11)
c
c  extrinsic resistances
c
c...  drain resistance
      cval=cvalue(lcvn+node1)-cvalue(lcvn+node4)
      vno1(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))
     1   *fourkt*value(locm+4)*area
c...  source resistance
      cval=cvalue(lcvn+node3)-cvalue(lcvn+node5)
      vno2(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))
     1   *fourkt*value(locm+5)*area
c
c  drain current shot noise and flicker noise
c
      cval=cvalue(lcvn+node4)-cvalue(lcvn+node5)
      vtemp=dble(vreal*vreal)+dble(vimag*vimag)
      vno3(kntr)=vtemp*fourkt*2.0d0*dabs(value(lx0+loct+5))/3.0d0
      arg=dmax1(dabs(value(lx0+loct+3)),1.0d-20)
      vno4(kntr)=vtemp*fnk*dexp(fna*dlog(arg))/freq
      vntot(kntr)=vno1(kntr)+vno2(kntr)+vno3(kntr)+vno4(kntr)
      vnrms=vnrms+vntot(kntr)
      if (kntr.ge.kntlim) go to 450
  430 loc=nodplc(loc)
      go to 420
  440 if (kntr.eq.0) go to 500
  450 if (nprnt.eq.0) go to 460
      if (ititle.eq.0) write (iofile,401)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt2) alsrd,(vno1(i),i=1,kntr)
      write (iofile,afmt2) alsrs,(vno2(i),i=1,kntr)
      write (iofile,afmt2) alsid,(vno3(i),i=1,kntr)
      write (iofile,afmt2) alsfn,(vno4(i),i=1,kntr)
      write (iofile,afmt2) alstot,(vntot(i),i=1,kntr)
  460 kntr=0
      if (loc.ne.0) go to 430
c
c  mosfets
c
  500 if (jelcnt(14).eq.0) go to 600
      ititle=0
  501 format(//'0**** mosfet squared noise voltages (sq v/hz)')
  510 loc=locate(14)
      kntr=0
  520 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 540
      kntr=kntr+1
      locv=nodplc(loc+1)
      anam(kntr)=value(locv)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      locm=nodplc(loc+8)
      itype=nodplc(locm+2)
      loct=nodplc(loc+26)
      locm=nodplc(locm+1)
      xl=value(locv+1)-2.0d0*value(locm+28)
      xw=value(locv+2)
      cox=value(locm+22)
      if (cox.le.0.0d0) cox=epsox/1.0d-7
      fnk=value(locm+36)
      fna=value(locm+37)
c
c  extrinsic resistances
c
      if ((value(locm+7).le.0.0d0).and.
     1   (value(locm+8).le.0.0d0)) go to 522
      gdpr=value(locm+7)
      gspr=value(locm+8)
      go to 524
  522 gdpr=value(locm+16)/value(locv+13)
      gspr=value(locm+16)/value(locv+14)
c...  drain resistance
  524 cval=cvalue(lcvn+node1)-cvalue(lcvn+node5)
      vno1(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))*fourkt*gdpr
c...  source resistance
      cval=cvalue(lcvn+node3)-cvalue(lcvn+node6)
      vno2(kntr)=(dble(vreal*vreal)+dble(vimag*vimag))*fourkt*gspr
c
c  drain current shot noise and flicker noise
c
      cval=cvalue(lcvn+node5)-cvalue(lcvn+node6)
      vtemp=dble(vreal*vreal)+dble(vimag*vimag)
      gm=value(lx0+loct+7)
      arg=dmax1(dabs(value(lx0+loct+4)),1.0d-20)
      vno3(kntr)=vtemp*fourkt*dabs(gm)/1.5d0
      vno4(kntr)=vtemp*fnk*dexp(fna*dlog(arg))/(freq*cox*xl*xl)
  525 vntot(kntr)=vno1(kntr)+vno2(kntr)+vno3(kntr)+vno4(kntr)
      vnrms=vnrms+vntot(kntr)
      if (kntr.ge.kntlim) go to 550
  530 loc=nodplc(loc)
      go to 520
  540 if (kntr.eq.0) go to 600
  550 if (nprnt.eq.0) go to 560
      if (ititle.eq.0) write (iofile,501)
      ititle=1
      write (iofile,afmt1) (anam(i),i=1,kntr)
      write (iofile,afmt2) alsrd,(vno1(i),i=1,kntr)
      write (iofile,afmt2) alsrs,(vno2(i),i=1,kntr)
      write (iofile,afmt2) alsid,(vno3(i),i=1,kntr)
      write (iofile,afmt2) alsfn,(vno4(i),i=1,kntr)
      write (iofile,afmt2) alstot,(vntot(i),i=1,kntr)
  560 kntr=0
      if (loc.ne.0) go to 530
c
c  compute equivalent input noise voltage
c
  600 vnout=dsqrt(vnrms)
      vnin=vnout/vout
      if (nprnt.eq.0) go to 620
      do 610 i=1,5
      string(i)=ablnk
  610 continue
      ioutyp=1
      ipos=1
      call outnam(nosout,ioutyp,string,ipos)
      call move(string,ipos,aslash,1,1)
      ipos=ipos+1
      locv=nodplc(nosin+1)
      anam1=value(locv)
      call move(string,ipos,anam1,1,8)
      write (iofile,611) vnrms,vnout,string,vout,anam1,vnin
  611 format(////,
     1   '0**** total output noise voltage',9x,'= ',1pd10.3,' sq v/hz'/,
     2   1h0,40x,'= ',d10.3,' v/rt hz'/,
     3   '0     transfer function value:',/,
     4   1h0,7x,4a8,a1,'= ',d10.3,/,
     5   '0     equivalent input noise at ',a8,' = ',d10.3,' /rt hz')
c
c  save noise outputs
c
  620 loc=locate(44)
  630 if (loc.eq.0) go to 1000
      iseq=nodplc(loc+4)
      if (nodplc(loc+5).ne.2) go to 640
      cvalue(loco+iseq)=vnout
      go to 650
  640 cvalue(loco+iseq)=vnin
  650 loc=nodplc(loc)
      go to 630
c
c  finished
c
 1000 return
      end

      subroutine mqspof(vds,vbs,vgs,vpof,vdsat1,vth,vbin,gamasd,
     $qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      implicit double precision (a-h,o-z)
c
c spice version 2g.6  sccsid=mosarg 3/15/83
      common /mosarg/ vto,beta,gamma,phi,phib,cox,xnsub,xnfs,xd,xj,xld,
     1   xlamda,uo,uexp,vbp,utra,vmax,xneff,xl,xw,vbi,von,vdsat,qspof,
     2   beta0,beta1,cdrain,xqco,xqc,fnarrw,fshort,lev
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c
c     vdsat1=dmax1(vds,vdsat1)+1.0d-3
      if( lev .eq. 3 ) goto 50
      if( lev .ne. 2 ) goto 1000
      call mosq2(vds,vbs,vgs,vdsat,vth,vbin,gamasd,cox,phi,
     $qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      if (vds.ge.vdsat) go to 80
      call mosq2(vds,vbs,vpof,vdsat1,vth,vbin, gamasd,cox,phi,
     $qg1,qcpof1,qb1,cggb1,cgdb1,cgsb1,cbgb1,cbdb1,cbsb1)
      call mosq2(vdsat,vbs,vgs,vdsat,vth,vbin, gamasd,cox,phi,
     $qg2,qcpof2,qb2,cggb2,cgdb2,cgsb2,cbgb2,cbdb2,cbsb2)
      goto 75
   50 call mosq3(vds,vbs,vpof,vdsat1,vth,vbin, gamasd,cox,phi,
     $qg,qcpof,qb,cggb1,cgdb1,cgsb1,cbgb1,cbdb1,cbsb1)
      call mosq3(vds,vbs,vgs,vdsat,vth,vbin,gamasd,cox,phi,
     $qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
   75 if(vgs.gt.vpof. or .vds.lt.vdsat) goto 100
   80 xqc = xqco
      goto 1000
c
c     tangential limiting of qs
c
  100 csgb1=-(1.0d0-xqco)*(cggb1+cbgb1)
      qs=csgb1*(vgs-vpof)
     1   +(1.0d0-xqco)*qcpof1
c      write(iofile,*) "vgs,vds,qc,cggb,cgdb,cgsb,cbgb,cbdb,cbsb =",
c    1   vgs,vds,qc,cggb,cgdb,cgsb,cbgb,cbdb,cbsb
c      write(iofile,*) "vpof,vdsat,vdsat1,qcpof1,qcpof2,qs,csgb1 =",
c    1   vpof,vdsat,vdsat1,qcpof1,qcpof2,qs,csgb1
      qspof2=(1.0d0-xqco)*qcpof2
      if (dabs(qs) .lt. dabs(qspof2)) qs=qspof2
      if( dabs( qs ) .ge. 0.5d0 * dabs( qc ) ) goto 200
c     csdb=-0.25d0*(cgdb+cbdb)
c     qs=qs+csdb*(vdsat-vds)
c     xqc=dmin1(0.5d0,(qc-qs)/qc)
      xqc=0.5d0
c      write(iofile,*) "qs,xqc =",
c    1   qs,xqc
      goto 1000
  200 qd = qc - qs
      xqc = qd / qc
c     write(iofile,*) "200,qs,qd,xqc =",
c    1   qs,qd,xqc
c
c     constant limiting of qs
c
c 100 qdpof = qcpof * xqco
c     qspof = qcpof - qdpof
c     if( dabs( qspof ) .gt. 0.5d0 * dabs( qc ) ) goto 200
c     xqc = 0.5d0
c     goto 1000
c 200 qd = qc - qspof
c     qs = qspof
c     xqc = qd / qc
 1000 return
      end

      subroutine crunch
      implicit double precision (a-h,o-z)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      call comprs(0,ldval)
      call memadj
      return
      end

      subroutine cmult(xr,xi,yr,yi,cr,ci)
c.. ok if cr and ci are really xr and xi or yr and yi
      implicit double precision (a-h,o-z)
      xrtemp=xr
      xitemp=xi
      yrtemp=yr
      yitemp=yi
      cr=xrtemp*yrtemp-xitemp*yitemp
      ci=xitemp*yrtemp+xrtemp*yitemp
      return
      end

      subroutine plot(numpnt,locx,locy,locv)
      implicit double precision (a-h,o-z)
c
c     this routine generates the line-printer plots.
c
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      integer xxor
      dimension ycoor(5,8),icoor(8),delplt(8)
      dimension agraph(13),aplot(13)
      dimension asym(2),pmin(8),jcoor(8)
      data ablnk, aletx, aper / 1h , 1hx, 1h. /
      data asym1, asym2, arprn / 8h(-------, 8h--------, 1h) /
      data pltsym / 8h*+=$0<>? /
c
c
      iwide=1
      nwide=101
      nwide4=25
      if(lwidth.gt.80) go to 3
      iwide=0
      nwide=57
      nwide4=14
    3 if (numpnt.le.0) go to 400
      do 5 i=1,13
      agraph(i)=ablnk
    5 continue
      do 7 i=1,5
      ispot=1+nwide4*(i-1)
      call move(agraph,ispot,aper,1,1)
    7 continue
      locyt=locy
      lspot=locv-1
      mltscl=0
      if (value(locv).eq.0.0d0) mltscl=1
      do 235 k=1,kntr
      lspot=lspot+2
      ymin=value(lspot)
      ymax=value(lspot+1)
      if (ymin.ne.0.0d0) go to 10
      if (ymax.ne.0.0d0) go to 10
      go to 100
   10 ymin1=dmin1(ymin,ymax)
      ymax1=dmax1(ymin,ymax)
   30 if (ilogy(k).eq.1) go to 40
      ymin1=dlog10(dmax1(ymin1,1.0d-20))
      ymax1=dlog10(dmax1(ymax1,1.0d-20))
      del=dmax1(ymax1-ymin1,0.0001d0)/4.0d0
      go to 50
   40 del=dmax1(ymax1-ymin1,1.0d-20)/4.0d0
   50 ymin=ymin1
      ymax=ymax1
      go to 200
c
c  determine max and min values
c
  100 ymax1=value(locyt+1)
      ymin1=ymax1
      if (numpnt.eq.1) go to 150
      do 110 i=2,numpnt
      ymin1=dmin1(ymin1,value(locyt+i))
      ymax1=dmax1(ymax1,value(locyt+i))
  110 continue
c
c  scaling
c
  150 call scale(ymin1,ymax1,4,ymin,ymax,del)
c
c  determine coordinates
c
  200 ycoor(1,k)=ymin
      pmin(k)=ymin
      small=del*1.0d-4
      if (dabs(ycoor(1,k)).le.small) ycoor(1,k)=0.0d0
      do 210 i=1,4
      ycoor(i+1,k)=ycoor(i,k)+del
      if (dabs(ycoor(i+1,k)).le.small) ycoor(i+1,k)=0.0d0
  210 continue
      if (ilogy(k).eq.1) go to 230
      do 220 i=1,5
  220 ycoor(i,k)=dexp(xlog10*ycoor(i,k))
  230 delplt(k)=del/dble(nwide4)
      locyt=locyt+npoint
  235 continue
c
c  count distinct coordinates
c
      icoor(1)=1
      jcoor(1)=1
      numcor=1
      if (kntr.eq.1) go to 290
      do 250 i=2,kntr
      do 245 j=1,numcor
      l=jcoor(j)
c...  coordinates are *equal* if the most significant 24 bits agree
      do 240 k=1,5
c*****************************************************************
c  temporarily check 'equality' this way
      y1=ycoor(k,i)
      y2=ycoor(k,l)
      if(y1.eq.0.0d0.and.y2.eq.0.0d0) go to 240
      if(dabs((y1-y2)/dmax1(dabs(y1),dabs(y2))).ge.1.0d-7) go to 245
  240 continue
      icoor(i)=l
      go to 250
  245 continue
      icoor(i)=i
      numcor=numcor+1
      jcoor(numcor)=i
  250 continue
c
c  print coordinates
c
  260 do 280 i=1,numcor
      asym(1)=asym1
      asym(2)=asym2
      ipos=2
      do 270 j=1,kntr
      if (icoor(j).ne.jcoor(i)) go to 270
      call move(asym,ipos,pltsym,j,1)
      ipos=ipos+1
  270 continue
      call move(asym,ipos,arprn,1,1)
      k=jcoor(i)
      if(iwide.ne.0) write(iofile,271) asym,(ycoor(j,k),j=1,5)
  271 format(/2a8,4h----,1pd12.3,4(15x,d10.3)/26x,51(2h -))
      if(iwide.eq.0) write(iofile,273) asym,(ycoor(j,k),j=1,5)
  273 format(/2a8,1x,1pd10.3,3(4x,d10.3),1x,d10.3/22x,29(2h -))
  280 continue
      go to 300
  290 if(iwide.ne.0) write(iofile,291) (ycoor(j,1),j=1,5)
  291 format(/20x,1pd12.3,4(15x,d10.3)/26x,51(2h -))
      if(iwide.eq.0) write(iofile,293) (ycoor(j,1),j=1,5)
  293 format(/15x,1pd12.3,3(4x,d10.3),1x,d10.3/22x,29(2h -))
c
c  plotting
c
  300 aspot=ablnk
      do 320 i=1,numpnt
      xvar=value(locx+i)
      locyt=locy
      call copy8(agraph,aplot,13)
      do 310 k=1,kntr
      yvr=value(locyt+i)
      ktmp=icoor(k)
      ymin1=pmin(ktmp)
      jpoint=idint((yvr-ymin1)/delplt(k)+0.5d0)+1
      if (jpoint.le.0) go to 306
      if (jpoint.gt.nwide) go to 306
      call move(aspot,1,aplot,jpoint,1)
      if (aspot.eq.ablnk) go to 303
      if (aspot.eq.aper) go to 303
      call move(aplot,jpoint,aletx,1,1)
      go to 306
  303 call move(aplot,jpoint,pltsym,k,1)
  306 locyt=locyt+npoint
  310 continue
      yvr=value(locy+i)
      if (ilogy(1).eq.1) go to 315
      yvr=dexp(xlog10*yvr)
  315 if(iwide.ne.0) write(iofile,316) xvar,yvr,aplot
  316 format(1pd10.3,3x,d10.3,3x,13a8)
      if(iwide.eq.0) write(iofile,317) xvar,yvr,(aplot(k),k=1,8)
  317 format(1pd10.3,1x,d10.3,1x,7a8,a1)
  320 continue
c
c  finished
c
      if(iwide.ne.0) write(iofile,331)
  331 format(26x,51(2h -)//)
      if(iwide.eq.0) write(iofile,332)
  332 format(22x,29(2h -)//)
      go to 500
c
c  too few points
c
  400 write (iofile,401)
  401 format('0warning:  too few points for plotting'/)
  500 write (iofile,501)
  501 format(1hy)
      return
      end

      subroutine setprn(loc)
      implicit double precision (a-h,o-z)
c
c     this routine formats the column headers for tabular listings of
c output variables.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      data ablnk, atimex, afreq / 1h , 6h  time, 6h  freq /
c
c  set limits depending upon the analysis mode
c
      if (mode-2) 10,20,30
   10 xstart=tcstar(1)
      xincr=tcincr(1)
      npoint=icvflg
      itemp=itcelm(1)
      loce=nodplc(itemp+1)
      asweep=value(loce)
      go to 40
   20 xstart=tstart
      xincr=tstep
      npoint=jtrflg
      asweep=atimex
      go to 40
   30 xstart=fstart
      xincr=fincr
      npoint=icalc
      asweep=afreq
c
c  construct and print the output variable names
c
   40 loct=loc+2
      ipos=1
      npos=ipos+numdgt+8
      do 90 i=1,kntr
      loct=loct+2
      itab(i)=nodplc(loct)
      itype(i)=nodplc(loct+1)
      call outnam(itab(i),itype(i),string,ipos)
      if (ipos.ge.npos) go to 70
      do 60 j=ipos,npos
      call move(string,j,ablnk,1,1)
   60 continue
      ipos=npos
      go to 80
   70 call move(string,ipos,ablnk,1,1)
      ipos=ipos+1
   80 npos=npos+numdgt+8
   90 continue
      call move(string,ipos,ablnk,1,7)
      jstop=(ipos+6)/8
      write (iofile,91) asweep,(string(j),j=1,jstop)
   91 format(/3x,a8,5x,14a8,a4)
      write (iofile,101)
  101 format(1hx/1h )
      return
      end

      subroutine nxtpwr(pwrseq,pdim)
      implicit double precision (a-h,o-z)
c
c     this routine determines the 'next' set of exponents for the
c different dimensions of a polynomial.
c
      integer pwrseq(1),pdim,psum
c
c
      if (pdim.eq.1) go to 80
      k=pdim
   10 if (pwrseq(k).ne.0) go to 20
      k=k-1
      if (k.ne.0) go to 10
      go to 80
   20 if (k.eq.pdim) go to 30
      pwrseq(k)=pwrseq(k)-1
      pwrseq(k+1)=pwrseq(k+1)+1
      go to 100
   30 km1=k-1
      do 40 i=1,km1
      if (pwrseq(i).ne.0) go to 50
   40 continue
      pwrseq(1)=pwrseq(pdim)+1
      pwrseq(pdim)=0
      go to 100
   50 psum=1
      k=pdim
   60 if (pwrseq(k-1).ge.1) go to 70
      psum=psum+pwrseq(k)
      pwrseq(k)=0
      k=k-1
      go to 60
   70 pwrseq(k)=pwrseq(k)+psum
      pwrseq(k-1)=pwrseq(k-1)-1
      go to 100
   80 pwrseq(1)=pwrseq(1)+1
c
c  finished
c
  100 return
      end

c spice version 2g.6  sccsid=acan.ma 3/15/83
      subroutine acan
      implicit double precision (a-h,o-z)
c
c     this routine drives the small-signal analyses.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=cje 3/15/83
      common /cje/ maxtim,itime,icost
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      complex cendor
      equivalence (value(1),nodplc(1),cvalue(1))
      call second(t1)
c.. post-processor initialization
      if(ipostp.eq.0) go to 1
      numcur=jelcnt(9)
      numpos=nunods+numcur
      call getm16(ibuff,numpos)
      numpos=numpos*4
      if(numcur.eq.0) go to 1
      loc=locate(9)
      loccur=nodplc(loc+6)-1
c
c  allocate storage
c
    1 call getm8(ndiag,2*nstop)
      call getm8(lvn,nstop+nttbr)
      call getm8(imvn,nstop+nttbr)
      call getm16(lcvn,nstop)
      if (idist.ne.0) call dinit
      nandd=0
      if (inoise.eq.0) go to 10
      if (idist.eq.0) go to 10
      nandd=1
      call getm16(lvntmp,nstop)
   10 call getm16(loutpt,0)
      call crunch
      numout=jelcnt(43)+jelcnt(44)+jelcnt(45)+1
      lynl=lvn
      imynl=imvn
      lcvntp=lvntmp
      icalc=0
      if (ipostp.ne.0) call pheadr(atitle)
      freq=fstart
c
c  load y matrix and c vector, solve for v vector
c
  100 call getcje
      if ((maxtim-itime).le.limtim) go to 900
      omega=twopi*freq
      call acload
  110 call acdcmp
      call acsol
      if (igoof.eq.0) go to 200
      write (iofile,121) igoof,freq
  121 format('0warning:  underflow ',i4,' time(s) in ac analysis at freq
     1 = ',1pd9.3,' hz')
      igoof=0
c
c  store outputs
c
  200 call extmem(loutpt,numout)
      loco=loutpt+icalc*numout
      icalc=icalc+1
      cvalue(loco+1)=cmplx(sngl(freq),sngl(omega))
      loc=locate(43)
  310 if (loc.eq.0) go to 350
      if (nodplc(loc+5).ne.0) go to 320
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      iseq=nodplc(loc+4)
      cvalue(loco+iseq)=cvalue(lcvn+node1)-cvalue(lcvn+node2)
      loc=nodplc(loc)
      go to 310
  320 iptr=nodplc(loc+2)
      iptr=nodplc(iptr+6)
      iseq=nodplc(loc+4)
      cvalue(loco+iseq)=cvalue(lcvn+iptr)
      loc=nodplc(loc)
      go to 310
  350 if(ipostp.eq.0) go to 400
      cvalue(ibuff+1)=cmplx(sngl(freq),0.0e0)
      call copy16(cvalue(lcvn+2),cvalue(ibuff+2),nunods-1)
      if(numcur.ne.0) call copy16(cvalue(lcvn+loccur+1),
     1  cvalue(ibuff+nunods+1),numcur)
      call dblsgl(cvalue(ibuff+1),numpos)
      call fwrite(cvalue(ibuff+1),numpos)
c
c  noise and distortion analyses
c
  400 if (nandd.eq.0) go to 410
      call copy16(cvalue(lcvn+1),cvalue(lcvntp+1),nstop)
  410 if (inoise.ne.0) call noise(loco)
      if (nandd.eq.0) go to 420
      call copy16(cvalue(lcvntp+1),cvalue(lcvn+1),nstop)
  420 if (idist.ne.0) call disto(loco)
c
c  increment frequency
c
      if (icalc.ge.jacflg) go to 1000
      if (idfreq.ge.3) go to 510
      freq=freq*fincr
      go to 100
  510 freq=freq+fincr
      go to 100
c
c  finished
c
  900 write (iofile,901)
  901 format('0*error*:  cpu time limit exceeded ... analysis stopped'/)
      nogo=1
 1000 if(ipostp.eq.0) go to 1010
      if (ipostp.ne.0) call clsraw
      if(ipostp.ne.0) call clrmem(ibuff)
 1010 call clrmem(lvnim1)
      call clrmem(lx0)
      call clrmem(lvn)
      call clrmem(imvn)
      call clrmem(lcvn)
      call clrmem(ndiag)
      if (idist.eq.0) go to 1020
      call clrmem(ld0)
      call clrmem(ld1)
 1020 if (nandd.eq.0) go to 1040
      call clrmem(lvntmp)
 1040 call second(t2)
      rstats(7)=rstats(7)+t2-t1
      rstats(8)=rstats(8)+icalc
      return
      end

      subroutine magphs(cvar,xmag,xphs)
      implicit double precision (a-h,o-z)
c
c     this routine computes the magnitude and phase of its complex arg-
c ument cvar, storing the results in xmag and xphs.
c
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
      complex cvar
c
c
      xreal=dble(real(cvar))
      ximag=dble(aimag(cvar))
      xmag=dsqrt(xreal*xreal+ximag*ximag)
      if (xmag.ge.1.0d-20) go to 10
      xmag=1.0d-20
      xphs=0.0d0
      return
   10 xphs=rad*datan2(ximag,xreal)
      return
      end

      subroutine cdiv(xr,xi,yr,yi,cr,ci)
c.. ok if cr and ci are really xr and xi or yr and yi
      implicit double precision (a-h,o-z)
      xrtemp=xr
      xitemp=xi
      yrtemp=yr
      yitemp=yi
      amag2=yrtemp*yrtemp+yitemp*yitemp
      cr=(xrtemp*yrtemp+xitemp*yitemp)/amag2
      ci=(xitemp*yrtemp-xrtemp*yitemp)/amag2
      return
      end

      subroutine ptrmem(ipntr,ipntr2)
      implicit double precision (a-h,o-z)
      dimension ipntr(1),ipntr2(1)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      logical memptr
c
c***  ptrmem - reset memory pointer
c
c...  verify that pointer is valid
      if (memptr(ipntr(1))) go to 10
      memerr=5
      call errmem(4,memerr,ipntr(1))
c...  reset block pointer to be *ipntr2*
   10 ipntr2(1)=ipntr(1)
      istack(ltab+4)=locf(ipntr2(1))
      call memadj
      return
      end

      subroutine errmem(inam,ierror,ipntr)
      implicit double precision (a-h,o-z)
      dimension ipntr(1)
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      dimension errnam(7)
      data errnam /6hclrmem,6hextmem,6hgetmem,6hptrmem,6hrelmem,
     1   6hsetmem,6hsizmem/
c
      go to (200,410,420,300,510,530),ierror
c
c*** error(s) found ***
c
c.. nxtevn and/or nxtmem incompatible with nwd4, nwd8, and nwd16
c
  200 write(iofile,201)
  201 format('0memory manager variables nwd4-8-16 incompatible with nxte
     1vn and nxtmem')
      go to 900
c
c...  memory needs exceed maximum available space
  300 write (iofile,301) maxmem
  301 format('0*error*:  memory requirement exceeds machine capacity',
     1/'0 memory needs exceed',i6)
      go to 900
c...    *isize* < 0
  410 write(iofile,411)
  411 format('0size parameter negative')
      go to 900
c...  getmem:  attempt to reallocate existing block
  420 write(iofile,421)
  421 format('0attempt to reallocate existing table')
      go to 900
c...    *ipntr* invalid
  510 write(iofile,511)
  511 format('0table pointer invalid')
      go to 900
c...  relmem:  *isize* larger than indicated block
  530 write(iofile,531)
  531 format('0attempt to release more than total table')
c...  issue error message
  900 write (iofile,901) errnam(inam)
  901 format('0*abort*:  internal memory manager error at entry ',
     1  a7)
  950 call dmpmem(ipntr(1))
 1000 stop
      end

      subroutine matptr
      implicit double precision (a-h,o-z)
c
c     this routine (by calls to the routine reserve) establishes the
c nonzero-element structure of the circuit equation coefficient matrix.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c  allocate and initialize storage
c
      call getm4(isr,nstop+1)
      numvs=jelcnt(3)+jelcnt(6)+jelcnt(8)+jelcnt(9)+2*jelcnt(17)
      call getm4(iseq,numvs)
      call getm4(iseq1,numvs)
      call getm4(neqn,numvs)
      call getm4(nodevs,numnod)
      call getm4(ndiag,nstop)
      call getm4(nmoffc,nstop)
      call getm4(numoff,nstop)
      call getm4(irpt,nstop)
      call getm4(jcpt,nstop)
      call getm4(irowno,nstop)
      call getm4(jcolno,nstop)
      call slpmem(irpt,nstop)
      call slpmem(jcpt,nstop)
      call slpmem(irowno,nstop)
      call slpmem(jcolno,nstop)
      call crunch
c
      call zero4(nodplc(irpt+1),nstop)
      call zero4(nodplc(jcpt+1),nstop)
      call zero4(nodplc(irowno+1),nstop)
      call zero4(nodplc(jcolno+1),nstop)
      call zero4(nodplc(iseq1+1),numvs)
      call zero4(nodplc(nodevs+1),numnod)
      call zero4(nodplc(ndiag+1),nstop)
      call zero4(nodplc(nmoffc+1),nstop)
      call zero4(nodplc(numoff+1),nstop)
c
      numvs=0
      nxtrm=0
      ndist=0
      ntlin=1
      ibr=numnod
c
c  resistors
c
      loc=locate(1)
  110 if ((loc.eq.0).or.(nodplc(loc+8).ne.0)) go to 120
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      call reserv(node1,node1)
      call reserv(node1,node2)
      call reserv(node2,node1)
      call reserv(node2,node2)
      loc=nodplc(loc)
      go to 110
c
c  capacitors
c
  120 loc=locate(2)
  130 if ((loc.eq.0).or.(nodplc(loc+12).ne.0)) go to 400
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      call reserv(node1,node2)
      call reserv(node2,node1)
      ntemp=nodplc(ndiag+node1)
      call reserv(node1,node1)
      nodplc(ndiag+node1)=ntemp
      ntemp=nodplc(ndiag+node2)
      call reserv(node2,node2)
      nodplc(ndiag+node2)=ntemp
      nodplc(loc+8)=nxtrm+1
      nxtrm=nxtrm+2
      loc=nodplc(loc)
      go to 130
c
c  inductors
c
  400 loc=locate(3)
  430 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 440
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ibr=ibr+1
      nodplc(loc+5)=ibr
      call reserv(node1,ibr)
      call reserv(node2,ibr)
      call reserv(ibr,node1)
      call reserv(ibr,node2)
      ntemp=nodplc(ndiag+ibr)
      call reserv(ibr,ibr)
      nodplc(ndiag+ibr)=ntemp
      numvs=numvs+1
      nodplc(iseq+numvs)=loc
      nodplc(neqn+numvs)=ibr
      nodplc(nodevs+node1)=nodplc(nodevs+node1)+1
      nodplc(nodevs+node2)=nodplc(nodevs+node2)+1
      nodplc(loc+11)=nxtrm+1
      nxtrm=nxtrm+2
      loc=nodplc(loc)
      go to 430
c
c  mutual inductors
c
  440 loc=locate(4)
  450 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 460
      nl1=nodplc(loc+2)
      nl2=nodplc(loc+3)
      nl1=nodplc(nl1+5)
      nl2=nodplc(nl2+5)
      call reserv(nl1,nl2)
      call reserv(nl2,nl1)
      loc=nodplc(loc)
      go to 450
c
c  nonlinear voltage-controlled current sources
c
  460 loc=locate(5)
  462 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 464
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      ndim2=ndim+ndim
      locn=nodplc(loc+6)
      do 463 i=1,ndim2
      node=nodplc(locn+i)
      call reserv(node1,node)
      call reserv(node2,node)
  463 continue
      nodplc(loc+12)=nxtrm+1
      nxtrm=nxtrm+1+ndim2
      loc=nodplc(loc)
      go to 462
c
c  nonlinear voltage controlled voltage sources
c
  464 loc=locate(6)
  466 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 468
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ibr=ibr+1
      nodplc(loc+6)=ibr
      call reserv(node1,ibr)
      call reserv(node2,ibr)
      call reserv(ibr,node1)
      call reserv(ibr,node2)
      numvs=numvs+1
      nodplc(iseq+numvs)=loc
      nodplc(neqn+numvs)=ibr
      nodplc(nodevs+node1)=nodplc(nodevs+node1)+1
      nodplc(nodevs+node2)=nodplc(nodevs+node2)+1
      ndim=nodplc(loc+4)
      ndim2=ndim+ndim
      locn=nodplc(loc+7)
      do 467 i=1,ndim2
      node=nodplc(locn+i)
      call reserv(ibr,node)
  467 continue
      nodplc(loc+13)=nxtrm+1
      nxtrm=nxtrm+2+ndim2
      loc=nodplc(loc)
      go to 466
c
c  voltage sources
c
  468 loc=locate(9)
  470 if ((loc.eq.0).or.(nodplc(loc+11).ne.0)) go to 472
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ibr=ibr+1
      nodplc(loc+6)=ibr
      call reserv(node1,ibr)
      call reserv(node2,ibr)
      call reserv(ibr,node1)
      call reserv(ibr,node2)
      numvs=numvs+1
      nodplc(iseq+numvs)=loc
      nodplc(neqn+numvs)=ibr
      nodplc(nodevs+node1)=nodplc(nodevs+node1)+1
      nodplc(nodevs+node2)=nodplc(nodevs+node2)+1
      loc=nodplc(loc)
      go to 470
c
c  nonlinear current controlled current sources
c
  472 loc=locate(7)
  474 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 476
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      locvs=nodplc(loc+6)
      do 475 i=1,ndim
      locvst=nodplc(locvs+i)
      kbr=nodplc(locvst+6)
      call reserv(node1,kbr)
      call reserv(node2,kbr)
  475 continue
      nodplc(loc+12)=nxtrm+1
      nxtrm=nxtrm+1+ndim+ndim
      loc=nodplc(loc)
      go to 474
c
c  nonlinear current controlled voltage sources
c
  476 loc=locate(8)
  478 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 500
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ibr=ibr+1
      nodplc(loc+6)=ibr
      call reserv(node1,ibr)
      call reserv(node2,ibr)
      call reserv(ibr,node1)
      call reserv(ibr,node2)
      numvs=numvs+1
      nodplc(iseq+numvs)=loc
      nodplc(neqn+numvs)=ibr
      nodplc(nodevs+node1)=nodplc(nodevs+node1)+1
      nodplc(nodevs+node2)=nodplc(nodevs+node2)+1
      ndim=nodplc(loc+4)
      locvs=nodplc(loc+7)
      do 479 i=1,ndim
      locvst=nodplc(locvs+i)
      kbr=nodplc(locvst+6)
      call reserv(ibr,kbr)
  479 continue
      nodplc(loc+13)=nxtrm+1
      nxtrm=nxtrm+2+ndim+ndim
      loc=nodplc(loc)
      go to 478
c
c  diodes
c
  500 loc=locate(11)
  510 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 520
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      call reserv(node1,node1)
      call reserv(node2,node2)
      call reserv(node3,node3)
      call reserv(node1,node3)
      call reserv(node2,node3)
      call reserv(node3,node1)
      call reserv(node3,node2)
      nodplc(loc+11)=nxtrm+1
      nxtrm=nxtrm+5
      nodplc(loc+12)=ndist+1
      ndist=ndist+7
      loc=nodplc(loc)
      go to 510
c
c  transistors
c
  520 loc=locate(12)
  530 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 540
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      node7=nodplc(loc+30)
      locm=nodplc(loc+8)
      locm=nodplc(locm+1)
      cdis=value(locm+32)
      call reserv(node1,node1)
      call reserv(node2,node2)
      call reserv(node3,node3)
      call reserv(node4,node4)
      call reserv(node5,node5)
      call reserv(node6,node6)
      call reserv(node1,node4)
      call reserv(node2,node5)
      call reserv(node3,node6)
      call reserv(node4,node5)
      call reserv(node4,node6)
      call reserv(node5,node6)
      call reserv(node4,node1)
      call reserv(node5,node2)
      call reserv(node6,node3)
      call reserv(node5,node4)
      call reserv(node6,node4)
      call reserv(node6,node5)
      call reserv(node7,node7)
      call reserv(node4,node7)
      call reserv(node7,node4)
      if (cdis.lt.1.0d0) call reserv(node2,node4)
      if (cdis.lt.1.0d0) call reserv(node4,node2)
      nodplc(loc+22)=nxtrm+1
      nxtrm=nxtrm+19
      nodplc(loc+23)=ndist+1
      ndist=ndist+21
      loc=nodplc(loc)
      go to 530
c
c  jfets
c
  540 loc=locate(13)
  550 if ((loc.eq.0).or.(nodplc(loc+25).ne.0)) go to 560
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      call reserv(node1,node1)
      call reserv(node2,node2)
      call reserv(node3,node3)
      call reserv(node4,node4)
      call reserv(node5,node5)
      call reserv(node1,node4)
      call reserv(node2,node4)
      call reserv(node2,node5)
      call reserv(node3,node5)
      call reserv(node4,node5)
      call reserv(node4,node1)
      call reserv(node4,node2)
      call reserv(node5,node2)
      call reserv(node5,node3)
      call reserv(node5,node4)
      nodplc(loc+19)=nxtrm+1
      nxtrm=nxtrm+13
      loc=nodplc(loc)
      go to 550
c
c  mosfets
c
  560 loc=locate(14)
  570 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 600
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      call reserv(node1,node1)
      call reserv(node2,node2)
      call reserv(node3,node3)
      call reserv(node4,node4)
      call reserv(node5,node5)
      call reserv(node6,node6)
      call reserv(node1,node5)
      call reserv(node2,node4)
      call reserv(node2,node5)
      call reserv(node2,node6)
      call reserv(node3,node6)
      call reserv(node4,node5)
      call reserv(node4,node6)
      call reserv(node5,node6)
      call reserv(node5,node1)
      call reserv(node4,node2)
      call reserv(node5,node2)
      call reserv(node6,node2)
      call reserv(node6,node3)
      call reserv(node5,node4)
      call reserv(node6,node4)
      call reserv(node6,node5)
      nodplc(loc+26)=nxtrm+1
      nxtrm=nxtrm+28
      loc=nodplc(loc)
      go to 570
c
c  transmission lines
c
  600 loc=locate(17)
  610 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 1000
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      ni1=nodplc(loc+6)
      ni2=nodplc(loc+7)
      ibr1=ibr+1
      ibr2=ibr+2
      ibr=ibr+2
      nodplc(loc+8)=ibr1
      nodplc(loc+9)=ibr2
      call reserv(node1,node1)
      call reserv(node1,ni1)
      call reserv(node2,ibr1)
      call reserv(node3,node3)
      call reserv(node4,ibr2)
      call reserv(ni1,node1)
      call reserv(ni1,ni1)
      call reserv(ni1,ibr1)
      call reserv(ni2,ni2)
      call reserv(ni2,ibr2)
      call reserv(ibr1,node2)
      call reserv(ibr1,node3)
      call reserv(ibr1,node4)
      call reserv(ibr1,ni1)
      call reserv(ibr1,ibr2)
      call reserv(ibr2,node1)
      call reserv(ibr2,node2)
      call reserv(ibr2,node4)
      call reserv(ibr2,ni2)
      call reserv(ibr2,ibr1)
      call reserv(node3,ni2)
      call reserv(ni2,node3)
      numvs=numvs+1
      nodplc(iseq+numvs)=loc
      nodplc(iseq1+numvs)=1
      nodplc(neqn+numvs)=ibr1
      nodplc(nodevs+ni1)=nodplc(nodevs+ni1)+1
      nodplc(nodevs+node2)=nodplc(nodevs+node2)+1
      numvs=numvs+1
      nodplc(iseq+numvs)=loc
      nodplc(iseq1+numvs)=2
      nodplc(neqn+numvs)=ibr2
      nodplc(nodevs+ni2)=nodplc(nodevs+ni2)+1
      nodplc(nodevs+node4)=nodplc(nodevs+node4)+1
      nodplc(loc+30)=ntlin+1
      ntlin=ntlin+2
      loc=nodplc(loc)
      go to 610
c
c  finished
c
 1000 return
      end

      subroutine evterm(val,arg,iexp)
      implicit double precision (a-h,o-z)
c
c     this routine evaluates one term of a polynomial.
c
      jexp=iexp+1
      if (jexp.ge.6) go to 60
      go to (10,20,30,40,50), jexp
   10 val=1.0d0
      go to 100
   20 val=arg
      go to 100
   30 val=arg*arg
      go to 100
   40 val=arg*arg*arg
      go to 100
   50 val=arg*arg
      val=val*val
      go to 100
   60 if (arg.eq.0.0d0) go to 70
      argexp=dble(iexp)*dlog(dabs(arg))
      if (argexp.lt.-200.0d0) go to 70
      val=dexp(argexp)
      if((iexp/2)*2.eq.iexp) go to 100
      val=dsign(val,arg)
      go to 100
   70 val=0.0d0
c
c  finished
c
  100 return
      end

      subroutine dinit
      implicit double precision (a-h,o-z)
c
c     this routine performs storage-allocation and one-time computation
c needed to do the small-signal distortion analysis.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      call getm8(ld0,ndist)
      call getm16(ld1,5*nstop)
c
c  bipolar junction transistors
c
      loc=locate(12)
  100 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 200
      locv=nodplc(loc+1)
      area=value(locv+1)
      locm=nodplc(loc+8)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+22)
      locd=ld0+nodplc(loc+23)
      csat=value(locm+1)*area
      ova=value(locm+4)
      tf=value(locm+24)
      tr=value(locm+33)
      czbe=value(locm+21)*area
      czbc=value(locm+29)*area
      pe=value(locm+22)
      xme=value(locm+23)
      pc=value(locm+30)
      xmc=value(locm+31)
      fcpe=value(locm+46)
      fcpc=value(locm+50)
      vbe=value(loct)
      vbc=value(loct+1)
      gpi=value(loct+4)
      go=value(loct+7)
      gm=value(loct+6)
      gmu=value(loct+5)
      if (vbe.gt.0.0d0) go to 110
      evbe=1.0d0
      cbe=csat*vbe/vt
      go to 120
  110 evbe=dexp(vbe/vt)
      cbe=csat*(evbe-1.0d0)
  120 if (vbc.gt.0.0d0) go to 130
      evbc=1.0d0
      cbc=csat*vbc/vt
      arg=1.0d0-vbc/pc
      go to 140
  130 evbc=dexp(vbc/vt)
      cbc=csat*(evbc-1.0d0)
  140 if (vbe.ge.fcpe) go to 150
      arg=1.0d0-vbe/pe
      sarg=dexp(xme*dlog(arg))
      cjeo=czbe/sarg
      argbe=pe-vbe
      cje1=xme*cjeo/argbe
      cje2=(1.0d0+xme)*cje1/argbe
      go to 160
  150 denom=dexp((1.0d0+xme)*dlog(1.0d0-fcpe))
      cjeo=czbe*(1.0d0-fcpe*(1.0d0+xme)+xme*vbe/pe)/denom
      cje1=czbe*xme/(denom*pe)
      cje2=0.0d0
  160 if (vbc.ge.fcpc) go to 170
      arg=1.0d0-vbc/pc
      sarg=dexp(xmc*dlog(arg))
      cjco=czbc/sarg
      argbc=pc-vbc
      cjc1=xmc*cjco/argbc
      cjc2=(1.0d0+xmc)*cjc1/argbc
      go to 180
  170 denom=dexp((1.0d0+xmc)*dlog(1.0d0-fcpc))
      cjco=czbc*(1.0d0-fcpc*(1.0d0+xmc)+xmc*vbc/pc)/denom
      cjc1=czbc*xmc/(denom*pc)
      cjc2=0.0d0
  180 twovt=vt+vt
      go2=(-go+csat*(evbe+evbc)*ova)/twovt
      gmo2=(cbe+csat)*ova/vt-2.0d0*go2
      gm2=(gm+go)/twovt-gmo2-go2
      gmu2=gmu/twovt
      if (vbc.le.0.0d0) gmu2=0.0d0
      gpi2=gpi/twovt
      if (vbe.le.0.0d0) gpi2=0.0d0
      cbo=tf*csat*evbe/vt
      cbor=tr*csat*evbc/vt
      cb1=cbo/vt
      cb1r=cbor/vt
      trivt=3.0d0*vt
      go3=-(go2+(cbc+csat)*ova/twovt)/trivt
      gmo23=-3.0d0*go3
      gm2o3=-gmo23+(cbe+csat)*ova/(vt*twovt)
      gm3=(gm2-(cbe-cbc)*ova/twovt)/trivt
      gmu3=gmu2/trivt
      gpi3=gpi2/trivt
      cb2=cb1/twovt
      cb2r=cb1r/twovt
      value(locd)=cje1
      value(locd+1)=cje2
      value(locd+2)=cjc1
      value(locd+3)=cjc2
      value(locd+4)=go2
      value(locd+5)=gmo2
      value(locd+6)=gm2
      value(locd+7)=gmu2
      value(locd+8)=gpi2
      value(locd+9)=cbo
      value(locd+10)=cbor
      value(locd+11)=cb1
      value(locd+12)=cb1r
      value(locd+13)=go3
      value(locd+14)=gmo23
      value(locd+15)=gm2o3
      value(locd+16)=gm3
      value(locd+17)=gmu3
      value(locd+18)=gpi3
      value(locd+19)=cb2
      value(locd+20)=cb2r
      loc=nodplc(loc)
      go to 100
c
c  diodes
c
  200 loc=locate(11)
  210 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 300
      locv=nodplc(loc+1)
      area=value(locv+1)
      locm=nodplc(loc+5)
      locm=nodplc(locm+1)
      loct=lx0+nodplc(loc+11)
      locd=ld0+nodplc(loc+12)
      csat=value(locm+1)*area
      vte=value(locm+3)*vt
      tau=value(locm+4)
      czero=value(locm+5)*area
      phib=value(locm+6)
      xm=value(locm+7)
      fcpb=value(locm+12)
      vd=value(loct)
      geq=value(loct+2)
      evd=1.0d0
      if (vd.ge.0.0d0) evd=dexp(vd/vte)
      if (vd.ge.fcpb) go to 220
      arg=1.0d0-vd/phib
      sarg=dexp(xm*dlog(arg))
      cdjo=czero/sarg
      argd=phib-vd
      cdj1=xm*cdjo/argd
      cdj2=(1.0d0+xm)*cdj1/argd
      go to 230
  220 denom=dexp((1.0d0+xm)*dlog(1.0d0-fcpb))
      cdjo=czero*(1.0d0-fcpb*(1.0d0+xm)+xm*vd/phib)/denom
      cdj1=czero*xm/(denom*phib)
      cdj2=0.0d0
      cdj2=0.0d0
  230 cdbo=tau*csat*evd/vte
      cdb1=cdbo/vte
      twovte=2.0d0*vte
      geq2=geq/twovte
      if (vd.le.0.0d0) geq2=0.0d0
      trivte=3.0d0*vte
      geq3=geq2/trivte
      cdb2=cdb1/twovte
      value(locd)=cdj1
      value(locd+1)=cdj2
      value(locd+2)=cdbo
      value(locd+3)=cdb1
      value(locd+4)=geq2
      value(locd+5)=geq3
      value(locd+6)=cdb2
      loc=nodplc(loc)
      go to 210
c
c  finished
c
  300 return
      end

      subroutine comprs(icode,limit)
      implicit double precision (a-h,o-z)
c
c      this routine compresses all available memory into a single block.
c if *icode* is zero, compression of memory from word 1 to *limit* is
c done;  otherwise, compression from *ldval* down to *limit* is done.
c
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      if (icode.ne.0) go to 100
      nblk=numblk
      ltab2=loctab
   10 ltab1=ltab2
      if (ltab1.ge.limit) go to 200
      if (nblk.eq.1) go to 200
      nblk=nblk-1
      ltab2=ltab1+ntab
      morg=istack(ltab1+1)
      msiz=istack(ltab1+2)
      muse=nxtevn(istack(ltab1+3))
      mslp=istack(ltab1+6)
      if ((msiz-muse).le.mslp) go to 10
      muse=muse+mslp
c...  move succeeding block down
      morg2=istack(ltab2+1)
      muse2=istack(ltab2+3)
      madr2=istack(ltab2+4)
      iwsize=istack(ltab2+5)
      if (madr2.ne.0) go to 15
      if (muse2.eq.0) go to 20
   15 cpyknt=cpyknt+dble(muse2)
      call copy4(istack(nwoff+morg2+1),istack(nwoff+morg+muse+1),muse2)
      istack(lorg+madr2)=(morg+muse)/iwsize
   20 istack(ltab1+2)=muse
      istack(ltab2+1)=morg+muse
      istack(ltab2+2)=istack(ltab2+2)+(msiz-muse)
      go to 10
c
c
  100 nblk=numblk
      ltab2=ldval-ntab
  110 ltab1=ltab2
      if (ltab1.le.limit) go to 200
      if (nblk.eq.1) go to 200
      nblk=nblk-1
      ltab2=ltab1-ntab
      morg=istack(ltab1+1)
      msiz=istack(ltab1+2)
      muser=istack(ltab1+3)
      muse=nxtevn(muser)
      madr=istack(ltab1+4)
      iwsize=istack(ltab1+5)
      mslp=istack(ltab1+6)
      if ((msiz-muse).le.mslp) go to 110
      muse=muse+mslp
      mspc=msiz-muse
      cpyknt=cpyknt+dble(muser)
      call copy4(istack(nwoff+morg+1),istack(nwoff+morg+mspc+1),muser)
      istack(ltab1+1)=morg+mspc
      istack(ltab1+2)=muse
      istack(ltab2+2)=istack(ltab2+2)+mspc
      if (madr.eq.0) go to 110
      istack(lorg+madr)=(morg+mspc)/iwsize
      go to 110
c...  all done
  200 return
      end

      subroutine getlin
      implicit double precision (a-h,o-z)
c
c     this routine reads the next line of input into the array afield.
c if end-of-file is found, the variable keof is set to 1.
c
c spice version 2g.6  sccsid=line 3/15/83
      common /line/ achar,afield(15),oldlin(15),kntrc,kntlim
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c
c
      call copy8(afield,oldlin,15)
      read(5,6,end=10) (afield(i),i=1,10)
      go to 100
    6 format(10a8)
   10 keof=1
  100 call ushift(afield)
      return
      end

      subroutine relmem(ipntr,ksize)
      implicit double precision (a-h,o-z)
      dimension ipntr(1)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      logical memptr
c
c***  relmem - release part of block
c
c
c...  check for valid pointer
      if (memptr(ipntr(1))) go to 10
      memerr=5
      call errmem(5,memerr,ipntr(1))
   10 isize=ksize*istack(ltab+5)
c...  check for valid size
      if (isize.ge.0) go to 20
      memerr=2
      call errmem(5,memerr,ipntr(1))
   20 jsize=istack(ltab+3)
      if (isize.le.jsize) go to 30
      memerr=6
      call errmem(5,memerr,ipntr(1))
   30 istack(ltab+3)=istack(ltab+3)-isize
      memavl=memavl+(nxtevn(jsize)-nxtevn(istack(ltab+3)))
      call memadj
      return
      end

      subroutine moscap(vgd,vgs,vgb,covlgd,covlgs,covlgb,
     1   capbd,capbs,cggb,cgdb,cgsb,cbgb,cbdb,cbsb,
     2   gcggb,gcgdb,gcgsb,gcbgb,gcbdb,gcbsb,
     3   gcdgb,gcddb,gcdsb,gcsgb,gcsdb,gcssb,
     4   qgate,qchan,qbulk,qdrn,qsrc)
      implicit double precision (a-h,o-z)
c spice version 2g.6  sccsid=mosarg 3/15/83
      common /mosarg/ vto,beta,gamma,phi,phib,cox,xnsub,xnfs,xd,xj,xld,
     1   xlamda,uo,uexp,vbp,utra,vmax,xneff,xl,xw,vbi,von,vdsat,qspof,
     2   beta0,beta1,cdrain,xqco,xqc,fnarrw,fshort,lev
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c     compute equivalent conductances
c     divide up the channel charge (1-xqc)/xqc to source and drain
c
      gcg=(cggb+cbgb)*ag(1)
      gcd=(cgdb+cbdb)*ag(1)
      gcs=(cgsb+cbsb)*ag(1)
      gcgxd=-xqc*gcg
      gcgxs=-(1.0d0-xqc)*gcg
      gcdxd=-xqc*gcd
      gcdxs=-(1.0d0-xqc)*gcd
      gcsxd=-xqc*gcs
      gcsxs=-(1.0d0-xqc)*gcs
      gcdgb=gcgxd-covlgd*ag(1)
      gcddb=gcdxd+(capbd+covlgd)*ag(1)
      gcdsb=gcsxd
      gcsgb=gcgxs-covlgs*ag(1)
      gcsdb=gcdxs
      gcssb=gcsxs+(capbs+covlgs)*ag(1)
      gcggb=(cggb+covlgd+covlgs+covlgb)*ag(1)
      gcgdb=(cgdb-covlgd)*ag(1)
      gcgsb=(cgsb-covlgs)*ag(1)
      gcbgb=(cbgb-covlgb)*ag(1)
      gcbdb=(cbdb-capbd)*ag(1)
      gcbsb=(cbsb-capbs)*ag(1)
c
c     compute total terminal charges
c
      qgd=covlgd*vgd
      qgs=covlgs*vgs
      qgb=covlgb*vgb
      qgate=qgate+qgd+qgs+qgb
      qbulk=qbulk-qgb
      qdrn=xqc*qchan-qgd
      qsrc=(1.0d0-xqc)*qchan-qgs
c
c     finished
c
      return
      end

      integer function nxtchr(int)
      implicit double precision (a-h,o-z)
c
c     this routine advances the current line scan pointer one column
c     and checks whether or not the next character is a delimiter
c
c spice version 2g.6  sccsid=line 3/15/83
      common /line/ achar,afield(15),oldlin(15),kntrc,kntlim
c
      dimension adelim(5)
      data adelim / 1h , 1h,, 1h=, 1h(, 1h) /
      data ablnk / 1h  /
      data ichar /0/
c
c  advance scan pointer (kntrc)
c
      kntrc=kntrc+1
      if (kntrc.gt.kntlim) go to 30
      call move(achar,1,afield,kntrc,1)
    5 do 10 i=1,5
      if (achar.eq.adelim(i)) go to 20
   10 continue
c
c  non-delimiter
c
      nxtchr=1
      return
c
c  delimiter
c
   20 nxtchr=0
      return
c
c  end-of-line
c
   30 nxtchr=-1
      achar=ablnk
      return
      end

      subroutine sizmem(ipntr,ksize)
      implicit double precision (a-h,o-z)
      dimension ipntr(1)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      logical memptr
c
c***  sizmem - determine size of existing block
c
c
c...  check for valid pointer
      if (memptr(ipntr(1))) go to 10
      memerr=5
      call errmem(7,memerr,ipntr(1))
   10 ksize=istack(ltab+3)/istack(ltab+5)
      return
      end

      subroutine trunc(delnew)
      implicit double precision (a-h,o-z)
c
c     this routine determines the new transient stepsize by either
c calling terr to estimate the local truncation error, or by checking
c on the number of iterations needed to converge at the last timepoint.
c
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      if (lvltim.ne.0) go to 5
      delnew=dmin1(tstep,delmax)
      return
    5 if (lvltim.ne.1) go to 10
      delnew=delta
      if (iterno.gt.itl3) return
      delnew=dmin1(2.0d0*delta,tstep,delmax)
      return
c
c  capacitors
c
   10 delnew=1.0d20
      loc=locate(2)
   20 if ((loc.eq.0).or.(nodplc(loc+12).ne.0)) go to 30
      loct=nodplc(loc+8)
      call terr(loct,delnew)
      loc=nodplc(loc)
      go to 20
c
c  inductors
c
   30 loc=locate(3)
   40 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 50
      loct=nodplc(loc+11)
      call terr(loct,delnew)
      loc=nodplc(loc)
      go to 40
c
c  diodes
c
   50 loc=locate(11)
   60 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 70
      loct=nodplc(loc+11)
      call terr(loct+3,delnew)
      loc=nodplc(loc)
      go to 60
c
c  bjts
c
   70 loc=locate(12)
   80 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 90
      loct=nodplc(loc+22)
      call terr(loct+8,delnew)
      call terr(loct+10,delnew)
      call terr(loct+12,delnew)
      loc=nodplc(loc)
      go to 80
c
c  jfets
c
   90 loc=locate(13)
  100 if ((loc.eq.0).or.(nodplc(loc+25).ne.0)) go to 110
      loct=nodplc(loc+19)
      call terr(loct+9,delnew)
      call terr(loct+11,delnew)
      loc=nodplc(loc)
      go to 100
c
c  mosfets
c
  110 loc=locate(14)
  120 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 200
      loct=nodplc(loc+26)
      call terr(loct+12,delnew)
      call terr(loct+14,delnew)
      call terr(loct+16,delnew)
      loc=nodplc(loc)
      go to 120
c
c  delta is allowed only to double at each timepoint
c
  200 delnew=dmin1(2.0d0*delta,delnew,delmax)
      return
      end

      subroutine dmpmem(ipntr)
      implicit double precision (a-h,o-z)
c
c      this routine prints out the current memory allocation map.
c *ipntr* is the table pointer of the current memory manager call
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      dimension ipntr(1)
      dimension aptr(75)
      data aptr /6hielmnt,6hisbckt,6hnsbckt,6hiunsat,6hnunsat,6hitemps,
     1 6hnumtem,6hisens ,6hnsens ,6hifour ,6hnfour ,6hifield,
     2 6hicode ,6hidelim,6hicolum,6hinsize,
     3 6hjunode,6hlsbkpt,6hnumbkp,6hiorder,6hjmnode,
     4 6hiur   ,6hiuc   ,6hilc   ,6hilr   ,6hnumoff,6hisr   ,
     5 6hnmoffc,6hiseq  ,6hiseq1  ,6hneqn  ,6hnodevs,
     6 6hndiag ,6hiswap ,6hiequa ,6hmacins,6hlvnim1,
     7 6hlx0   ,6hlvn   ,6hlynl  ,6hlyu   ,6hlyl   ,
     8 6hlx1   ,6hlx2   ,6hlx3   ,6hlx4   ,6hlx5   ,6hlx6   ,
     9 6hlx7   ,6hld0   ,6hld1   ,6hltd   ,6himynl ,6himvn  ,6hlcvn  ,
     * 6hnsnod ,6hnsmat ,6hnsval ,6hicnod ,6hicmat ,6hicval ,6hloutpt,
     * 6hlpol  ,6hlzer  ,6hirswpf,6hirswpr,6hicswpf,6hicswpr,6hirpt  ,
     * 6hjcpt  ,6hirowno,6hjcolno,6hnttbr ,6hnttar ,6hlvntmp/
      data ablnk /1h /
c
      iaddr=locf(ielmnt)-1
      itemp=locf(ipntr(1))-iaddr
      anam=ablnk
      if(itemp.gt.0.and.itemp.le.75) anam=aptr(itemp)
      iadr=locf(ipntr(1))
      write (iofile,5) anam,iadr,icore,maxmem,memavl,ldval
    5 format('0current pointer ',a6,'@ = z',i6,/' corsiz=',i7,
     1  /' maxmem=',i7,/' avlspc=',i7,/' ldval=',i7,
     2  /1h0,24x,'memory allocation map'/14x,'blknum memorg memsiz',
     3  '  memuse usrptr  addr    name')
      ltab1=loctab
      do 20 i=1,numblk
      morg=istack(ltab1+1)
      msiz=istack(ltab1+2)
      muse=istack(ltab1+3)
      madr=istack(ltab1+4)
      anam=ablnk
      ndex=madr-iaddr
      if(ndex.gt.0.and.ndex.le.75) anam=aptr(ndex)
      jptr=0
      if (madr.gt.0) jptr=istack(lorg+madr)
      write (iofile,11) i,morg,msiz,muse,jptr,madr,anam
   11 format(13x,5i7,3x,i7,'z',1x,a6)
      ltab1=ltab1+ntab
   20 continue
      write (iofile,21)
   21 format(1h0,24x,'end of allocation map'/)
      return
      end

      subroutine load
      implicit double precision (a-h,o-z)
c
c     this routine zeroes-out and then loads the coefficient matrix.
c the active devices and the controlled sources are loaded by separate
c subroutines.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension qcap(1),ccap(1)
      equivalence (qcap(1),value(1)),(ccap(1),value(2))
      dimension find(1),vind(1)
      equivalence (find(1),value(1)),(vind(1),value(2))
c
      call second(t1)
c
c  zero y matrix and current vector
c
      call zero8(value(lvn+1),nstop+nttbr)
c
c  resistors
c
      loc=locate(1)
   20 if ((loc.eq.0).or.(nodplc(loc+8).ne.0)) go to 30
      locv=nodplc(loc+1)
      val=value(locv+1)
      locy=lvn+nodplc(loc+6)
      value(locy)=value(locy)+val
      locy=lvn+nodplc(loc+7)
      value(locy)=value(locy)+val
      locy=lvn+nodplc(loc+4)
      value(locy)=value(locy)-val
      locy=lvn+nodplc(loc+5)
      value(locy)=value(locy)-val
      loc=nodplc(loc)
      go to 20
c
c  capacitors
c
   30 loc=locate(2)
      if ((mode.eq.1).and.(modedc.ne.2)) go to 100
   40 if ((loc.eq.0).or.(nodplc(loc+12).ne.0)) go to 100
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      loct=nodplc(loc+8)
      ipoly=nodplc(loc+4)
      if (ipoly.eq.1) go to 43
      lcoef=nodplc(loc+7)
      call sizmem(nodplc(loc+7),ncoef)
   43 vcap=value(locv+2)
      if ((mode.eq.1).and.(initf.eq.2)) go to 45
      if ((nosolv.ne.0).and.(initf.eq.5)) go to 45
      vcap=value(lvnim1+node1)-value(lvnim1+node2)
   45 value(locv+3)=vcap
      if (mode.eq.1) go to 60
   47 if (initf.ne.6) go to 50
      qcap(lx0+loct)=qcap(lx1+loct)
      go to 60
   50 if (ipoly.eq.0) go to 53
      qcap(lx0+loct)=value(locv+1)*vcap
      if (initf.ne.5) go to 60
      if (nosolv.ne.0) qcap(lx0+loct)=value(locv+1)*value(locv+2)
      qcap(lx1+loct)=qcap(lx0+loct)
      go to 60
   53 call evpoly(qcap(lx0+loct),-1,lcoef,ncoef,locv+2,1,loc+8)
      if (initf.ne.5) go to 60
      if (nosolv.eq.0) go to 55
      vcap=value(locv+2)
      value(locv+3)=vcap
      call evpoly(qcap(lx0+loct),-1,lcoef,ncoef,locv+2,1,loc+8)
   55 qcap(lx1+loct)=qcap(lx0+loct)
   60 if (ipoly.eq.1) go to 62
      call evpoly(value(locv+1),0,lcoef,ncoef,locv+2,1,loc+8)
   62 if (mode.eq.1) go to 90
      call intgr8(geq,ceq,value(locv+1),loct)
      if (ipoly.eq.1) go to 65
      ceq=ceq-geq*vcap+ag(1)*qcap(lx0+loct)
   65 if(initf.ne.5) go to 70
      ccap(lx1+loct)=ccap(lx0+loct)
   70 locy=lvn+nodplc(loc+10)
      value(locy)=value(locy)+geq
      locy=lvn+nodplc(loc+11)
      value(locy)=value(locy)+geq
      locy=lvn+nodplc(loc+5)
      value(locy)=value(locy)-geq
      locy=lvn+nodplc(loc+6)
      value(locy)=value(locy)-geq
      value(lvn+node1)=value(lvn+node1)-ceq
      value(lvn+node2)=value(lvn+node2)+ceq
   90 loc=nodplc(loc)
      go to 40
c
c  inductors
c
  100 if (jelcnt(3).eq.0) go to 400
      if (mode.eq.1) go to 150
      if (initf.eq.6) go to 150
      loc=locate(3)
  110 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 120
      locv=nodplc(loc+1)
      iptr=nodplc(loc+5)
      loct=nodplc(loc+11)
      ipoly=nodplc(loc+4)
      if (ipoly.eq.0) go to 115
      find(lx0+loct)=value(locv+1)*value(lvnim1+iptr)
      if ((initf.eq.5).and.(nosolv.ne.0))
     1   find(lx0+loct)=value(locv+1)*value(locv+2)
      go to 118
  115 lcoef=nodplc(loc+10)
      call sizmem(nodplc(loc+10),ncoef)
      cind=value(lvnim1+iptr)
      if ((initf.eq.5).and.(nosolv.ne.0)) cind=value(locv+2)
      value(locv+3)=cind
      call evpoly(find(lx0+loct),-1,lcoef,ncoef,locv+2,1,loc+11)
  118 loc=nodplc(loc)
      go to 110
  120 loc=locate(4)
  130 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 150
      locv=nodplc(loc+1)
      nl1=nodplc(loc+2)
      nl2=nodplc(loc+3)
      iptr1=nodplc(nl1+5)
      iptr2=nodplc(nl2+5)
      loct1=nodplc(nl1+11)
      loct2=nodplc(nl2+11)
      find(lx0+loct1)=find(lx0+loct1)+value(locv+1)*value(lvnim1+iptr2)
      find(lx0+loct2)=find(lx0+loct2)+value(locv+1)*value(lvnim1+iptr1)
      loc=nodplc(loc)
      go to 130
  150 loc=locate(3)
  160 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 300
      locv=nodplc(loc+1)
      iptr=nodplc(loc+5)
      loct=nodplc(loc+11)
      ipoly=nodplc(loc+4)
      if (ipoly.eq.1) go to 170
      lcoef=nodplc(loc+10)
      call sizmem(nodplc(loc+10),ncoef)
  170 cind=value(lvnim1+iptr)
      if ((nosolv.ne.0).and.(initf.eq.5)) cind=value(locv+2)
      value(locv+3)=cind
  180 if (mode.ne.1) go to 200
      veq=0.0d0
      req=0.0d0
      go to 210
  200 if (initf.ne.6) go to 205
      find(lx0+loct)=find(lx1+loct)
      go to 210
  205 if (initf.ne.5) go to 210
      find(lx1+loct)=find(lx0+loct)
  210 if (ipoly.eq.1) go to 220
      call evpoly(value(locv+1),0,lcoef,ncoef,locv+2,1,loc+11)
  220 if (mode.eq.1) go to 250
      call intgr8(req,veq,value(locv+1),loct)
      if (ipoly.eq.1) go to 250
      veq=veq-req*cind+ag(1)*find(lx0+loct)
  250 value(lvn+iptr)=veq
      if(initf.ne.5) go to 260
      vind(lx1+loct)=vind(lx0+loct)
  260 locy=lvn+nodplc(loc+13)
      value(locy)=-req
      locy=lvn+nodplc(loc+6)
      value(locy)=1.0d0
      locy=lvn+nodplc(loc+7)
      value(locy)=-1.0d0
      locy=lvn+nodplc(loc+8)
      value(locy)=1.0d0
      locy=lvn+nodplc(loc+9)
      value(locy)=-1.0d0
      loc=nodplc(loc)
      go to 160
c
c  mutual inductances
c
  300 loc=locate(4)
  310 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 400
      locv=nodplc(loc+1)
      req=ag(1)*value(locv+1)
      locy=lvn+nodplc(loc+4)
      value(locy)=-req
      locy=lvn+nodplc(loc+5)
      value(locy)=-req
      loc=nodplc(loc)
      go to 310
c
c  nonlinear controlled sources
c
  400 call nlcsrc
c
c  voltage sources
c
      loc=locate(9)
  610 if ((loc.eq.0).or.(nodplc(loc+11).ne.0)) go to 700
      locv=nodplc(loc+1)
      iptr=nodplc(loc+6)
      value(lvn+iptr)=value(locv+1)*sfactr
      locy=lvn+nodplc(loc+7)
      value(locy)=value(locy)+1.0d0
      locy=lvn+nodplc(loc+8)
      value(locy)=value(locy)-1.0d0
      locy=lvn+nodplc(loc+9)
      value(locy)=value(locy)+1.0d0
      locy=lvn+nodplc(loc+10)
      value(locy)=value(locy)-1.0d0
      loc=nodplc(loc)
      go to 610
c
c  current sources
c
  700 loc=locate(10)
  710 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 800
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      val=value(locv+1)*sfactr
      value(lvn+node1)=value(lvn+node1)-val
      value(lvn+node2)=value(lvn+node2)+val
      loc=nodplc(loc)
      go to 710
c
c  call device model routines
c
  800 call diode
      call bjt
      call jfet
      call mosfet
c
c  transmission lines
c
      loc=locate(17)
  910 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 980
      locv=nodplc(loc+1)
      z0=value(locv+1)
      y0=1.0d0/z0
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      ibr1=nodplc(loc+8)
      ibr2=nodplc(loc+9)
      locy=lvn+nodplc(loc+10)
      value(locy)=value(locy)+y0
      locy=lvn+nodplc(loc+11)
      value(locy)=-y0
      locy=lvn+nodplc(loc+12)
      value(locy)=-1.0d0
      locy=lvn+nodplc(loc+13)
      value(locy)=value(locy)+y0
      locy=lvn+nodplc(loc+14)
      value(locy)=-1.0d0
      locy=lvn+nodplc(loc+15)
      value(locy)=-y0
      locy=lvn+nodplc(loc+16)
      value(locy)=+y0
      locy=lvn+nodplc(loc+17)
      value(locy)=+1.0d0
      locy=lvn+nodplc(loc+18)
      value(locy)=+y0
      locy=lvn+nodplc(loc+19)
      value(locy)=+1.0d0
      locy=lvn+nodplc(loc+20)
      value(locy)=-1.0d0
      locy=lvn+nodplc(loc+23)
      value(locy)=+1.0d0
      locy=lvn+nodplc(loc+27)
      value(locy)=-1.0d0
      locy=lvn+nodplc(loc+28)
      value(locy)=+1.0d0
      locy=lvn+nodplc(loc+31)
      value(locy)=-y0
      locy=lvn+nodplc(loc+32)
      value(locy)=-y0
      if (mode.ne.1) go to 920
      locy=lvn+nodplc(loc+21)
      value(locy)=-1.0d0
      locy=lvn+nodplc(loc+22)
      value(locy)=+1.0d0
      locy=lvn+nodplc(loc+24)
      value(locy)=-(1.0d0-gmin)*z0
      locy=lvn+nodplc(loc+25)
      value(locy)=-1.0d0
      locy=lvn+nodplc(loc+26)
      value(locy)=+1.0d0
      locy=lvn+nodplc(loc+29)
      value(locy)=-(1.0d0-gmin)*z0
      go to 950
  920 if (initf.ne.5) go to 930
      if (nosolv.ne.0) go to 925
      value(locv+3)=value(lvnim1+node3)-value(lvnim1+node4)
     1   +value(lvnim1+ibr2)*z0
      value(locv+4)=value(lvnim1+node1)-value(lvnim1+node2)
     1   +value(lvnim1+ibr1)*z0
      go to 930
  925 value(locv+3)=value(locv+7)+value(locv+8)*z0
      value(locv+4)=value(locv+5)+value(locv+6)*z0
  930 value(lvn+ibr1)=value(locv+3)
      value(lvn+ibr2)=value(locv+4)
  950 loc=nodplc(loc)
      go to 910
c
c  initialize nodes
c
  980 if(mode.ne.1) go to 995
      if(initf.ne.3.and.initf.ne.2) go to 995
      call sizmem(nsnod,nic)
      if(nic.eq.0) go to 995
      call sizmem(icnod,ntest)
      if(modedc.eq.2.and.ntest.ne.0) go to 995
      g=1.0d0
      do 990 i=1,nic
      locy=lvn+nodplc(nsmat+i)
      value(locy)=value(locy)+g
      node=nodplc(nsnod+i)
      value(lvn+node)=value(lvn+node)+value(nsval+i)*g
  990 continue
c
c  transient initial conditions (uic not specified)
c
  995 if(mode.ne.1) go to 1000
      if(modedc.ne.2) go to 1000
      if(nosolv.ne.0) go to 1000
      call sizmem(icnod,nic)
      if(nic.eq.0) go to 1000
      g=1.0d0
      do 996 i=1,nic
      locy=lvn+nodplc(icmat+i)
      value(locy)=value(locy)+g
      node=nodplc(icnod+i)
      value(lvn+node)=value(lvn+node)+value(icval+i)*g
  996 continue
c
c  finished
c
 1000 call second(t2)
      rstats(45)=rstats(45)+t2-t1
      return
      end

      subroutine extnam(aname,index)
      implicit double precision (a-h,o-z)
c
c     this routine adds 'aname' to the list of 'unsatisfied' names (that
c is, names which can only be resolved after subcircuit expansion).
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
      integer xxor
c
c
      anam=aname
      if (nunsat.eq.0) go to 20
      do 10 index=1,nunsat
      if (xxor(anam,value(iunsat+index)).eq.0) go to 30
   10 continue
c
   20 call extmem(iunsat,1)
      nunsat=nunsat+1
      index=nunsat
      value(iunsat+index)=anam
   30 return
      end

      subroutine jfet
      implicit double precision (a-h,o-z)
c
c     this routine processes jfets for dc and transient analyses.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension vgso(1),vgdo(1),cgo(1),cdo(1),cgdo(1),gmo(1),gdso(1),
     1   ggso(1),ggdo(1),qgs(1),cqgs(1),qgd(1),cqgd(1)
      equivalence (vgso(1),value( 1)),(vgdo(1),value( 2)),
     1            (cgo (1),value( 3)),(cdo (1),value( 4)),
     2            (cgdo(1),value( 5)),(gmo (1),value( 6)),
     3            (gdso(1),value( 7)),(ggso(1),value( 8)),
     4            (ggdo(1),value( 9)),(qgs (1),value(10)),
     5            (cqgs(1),value(11)),(qgd (1),value(12)),
     6            (cqgd(1),value(13))
c
c
      loc=locate(13)
   10 if ((loc.eq.0).or.(nodplc(loc+25).ne.0)) return
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      locm=nodplc(loc+7)
      ioff=nodplc(loc+8)
      type=nodplc(locm+2)
      locm=nodplc(locm+1)
      loct=nodplc(loc+19)
c
c  dc model parameters
c
      area=value(locv+1)
      vto=value(locm+1)
      beta=value(locm+2)*area
      xlamb=value(locm+3)
      gdpr=value(locm+4)*area
      gspr=value(locm+5)*area
      csat=value(locm+9)*area
      vcrit=value(locm+16)
c
c  initialization
c
      icheck=1
      go to (100,20,30,50,60,70), initf
   20 if(mode.ne.1.or.modedc.ne.2.or.nosolv.eq.0) go to 25
      vds=type*value(locv+2)
      vgs=type*value(locv+3)
      vgd=vgs-vds
      go to 300
   25 if(ioff.ne.0) go to 40
      vgs=-1.0d0
      vgd=-1.0d0
      go to 300
   30 if (ioff.eq.0) go to 100
   40 vgs=0.0d0
      vgd=0.0d0
      go to 300
   50 vgs=vgso(lx0+loct)
      vgd=vgdo(lx0+loct)
      go to 300
   60 vgs=vgso(lx1+loct)
      vgd=vgdo(lx1+loct)
      go to 300
   70 xfact=delta/delold(2)
      vgso(lx0+loct)=vgso(lx1+loct)
      vgs=(1.0d0+xfact)*vgso(lx1+loct)-xfact*vgso(lx2+loct)
      vgdo(lx0+loct)=vgdo(lx1+loct)
      vgd=(1.0d0+xfact)*vgdo(lx1+loct)-xfact*vgdo(lx2+loct)
      cgo(lx0+loct)=cgo(lx1+loct)
      cdo(lx0+loct)=cdo(lx1+loct)
      cgdo(lx0+loct)=cgdo(lx1+loct)
      gmo(lx0+loct)=gmo(lx1+loct)
      gdso(lx0+loct)=gdso(lx1+loct)
      ggso(lx0+loct)=ggso(lx1+loct)
      ggdo(lx0+loct)=ggdo(lx1+loct)
      go to 110
c
c  compute new nonlinear branch voltages
c
  100 vgs=type*(value(lvnim1+node2)-value(lvnim1+node5))
      vgd=type*(value(lvnim1+node2)-value(lvnim1+node4))
  110 delvgs=vgs-vgso(lx0+loct)
      delvgd=vgd-vgdo(lx0+loct)
      delvds=delvgs-delvgd
      cghat=cgo(lx0+loct)+ggdo(lx0+loct)*delvgd+ggso(lx0+loct)*delvgs
      cdhat=cdo(lx0+loct)+gmo(lx0+loct)*delvgs+gdso(lx0+loct)*delvds
     1   -ggdo(lx0+loct)*delvgd
c
c  bypass if solution has not changed
c
      if (initf.eq.6) go to 200
      tol=reltol*dmax1(dabs(vgs),dabs(vgso(lx0+loct)))+vntol
      if (dabs(delvgs).ge.tol) go to 200
      tol=reltol*dmax1(dabs(vgd),dabs(vgdo(lx0+loct)))+vntol
      if (dabs(delvgd).ge.tol) go to 200
      tol=reltol*dmax1(dabs(cghat),dabs(cgo(lx0+loct)))+abstol
      if (dabs(cghat-cgo(lx0+loct)).ge.tol) go to 200
      tol=reltol*dmax1(dabs(cdhat),dabs(cdo(lx0+loct)))+abstol
      if (dabs(cdhat-cdo(lx0+loct)).ge.tol) go to 200
      vgs=vgso(lx0+loct)
      vgd=vgdo(lx0+loct)
      vds=vgs-vgd
      cg=cgo(lx0+loct)
      cd=cdo(lx0+loct)
      cgd=cgdo(lx0+loct)
      gm=gmo(lx0+loct)
      gds=gdso(lx0+loct)
      ggs=ggso(lx0+loct)
      ggd=ggdo(lx0+loct)
      go to 900
c
c  limit nonlinear branch voltages
c
  200 ichk1=1
      call pnjlim(vgs,vgso(lx0+loct),vt,vcrit,icheck)
      call pnjlim(vgd,vgdo(lx0+loct),vt,vcrit,ichk1)
      if (ichk1.eq.1) icheck=1
      call fetlim(vgs,vgso(lx0+loct),vto)
      call fetlim(vgd,vgdo(lx0+loct),vto)
c
c  determine dc current and derivatives
c
  300 vds=vgs-vgd
      if (vgs.gt.-5.0d0*vt) go to 310
      ggs=-csat/vgs+gmin
      cg=ggs*vgs
      go to 320
  310 evgs=dexp(vgs/vt)
      ggs=csat*evgs/vt+gmin
      cg=csat*(evgs-1.0d0)+gmin*vgs
  320 if (vgd.gt.-5.0d0*vt) go to 330
      ggd=-csat/vgd+gmin
      cgd=ggd*vgd
      go to 340
  330 evgd=dexp(vgd/vt)
      ggd=csat*evgd/vt+gmin
      cgd=csat*(evgd-1.0d0)+gmin*vgd
  340 cg=cg+cgd
c
c  compute drain current and derivitives for normal mode
c
  400 if (vds.lt.0.0d0) go to 450
      vgst=vgs-vto
c
c  normal mode, cutoff region
c
      if (vgst.gt.0.0d0) go to 410
      cdrain=0.0d0
      gm=0.0d0
      gds=0.0d0
      go to 490
c
c  normal mode, saturation region
c
  410 betap=beta*(1.0d0+xlamb*vds)
      twob=betap+betap
      if (vgst.gt.vds) go to 420
      cdrain=betap*vgst*vgst
      gm=twob*vgst
      gds=xlamb*beta*vgst*vgst
      go to 490
c
c  normal mode, linear region
c
  420 cdrain=betap*vds*(vgst+vgst-vds)
      gm=twob*vds
      gds=twob*(vgst-vds)+xlamb*beta*vds*(vgst+vgst-vds)
      go to 490
c
c  compute drain current and derivitives for inverse mode
c
  450 vgdt=vgd-vto
c
c  inverse mode, cutoff region
c
      if (vgdt.gt.0.0d0) go to 460
      cdrain=0.0d0
      gm=0.0d0
      gds=0.0d0
      go to 490
c
c  inverse mode, saturation region
c
  460 betap=beta*(1.0d0-xlamb*vds)
      twob=betap+betap
      if (vgdt.gt.-vds) go to 470
      cdrain=-betap*vgdt*vgdt
      gm=-twob*vgdt
      gds=xlamb*beta*vgdt*vgdt-gm
      go to 490
c
c  inverse mode, linear region
c
  470 cdrain=betap*vds*(vgdt+vgdt+vds)
      gm=twob*vds
      gds=twob*vgdt-xlamb*beta*vds*(vgdt+vgdt+vds)
c
c  compute equivalent drain current source
c
  490 cd=cdrain-cgd
      if (mode.ne.1) go to 500
      if ((modedc.eq.2).and.(nosolv.ne.0)) go to 500
      if (initf.eq.4) go to 500
      go to 700
c
c  charge storage elements
c
  500 czgs=value(locm+6)*area
      czgd=value(locm+7)*area
      phib=value(locm+8)
      twop=phib+phib
      fcpb=value(locm+12)
      fcpb2=fcpb*fcpb
      f1=value(locm+13)
      f2=value(locm+14)
      f3=value(locm+15)
      czgsf2=czgs/f2
      czgdf2=czgd/f2
      if (vgs.ge.fcpb) go to 510
      sarg=dsqrt(1.0d0-vgs/phib)
      qgs(lx0+loct)=twop*czgs*(1.0d0-sarg)
      capgs=czgs/sarg
      go to 520
  510 qgs(lx0+loct)=czgs*f1+czgsf2*(f3*(vgs-fcpb)
     1   +(vgs*vgs-fcpb2)/(twop+twop))
      capgs=czgsf2*(f3+vgs/twop)
  520 if (vgd.ge.fcpb) go to 530
      sarg=dsqrt(1.0d0-vgd/phib)
      qgd(lx0+loct)=twop*czgd*(1.0d0-sarg)
      capgd=czgd/sarg
      go to 560
  530 qgd(lx0+loct)=czgd*f1+czgdf2*(f3*(vgd-fcpb)
     1   +(vgd*vgd-fcpb2)/(twop+twop))
      capgd=czgdf2*(f3+vgd/twop)
c
c  store small-signal parameters
c
  560 if ((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 700
      if (initf.ne.4) go to 600
      value(lx0+loct+9)=capgs
      value(lx0+loct+11)=capgd
      go to 1000
c
c  transient analysis
c
  600 if (initf.ne.5) go to 610
      qgs(lx1+loct)=qgs(lx0+loct)
      qgd(lx1+loct)=qgd(lx0+loct)
  610 call intgr8(geq,ceq,capgs,loct+9)
      ggs=ggs+geq
      cg=cg+cqgs(lx0+loct)
      call intgr8(geq,ceq,capgd,loct+11)
      ggd=ggd+geq
      cg=cg+cqgd(lx0+loct)
      cd=cd-cqgd(lx0+loct)
      cgd=cgd+cqgd(lx0+loct)
      if (initf.ne.5) go to 700
      cqgs(lx1+loct)=cqgs(lx0+loct)
      cqgd(lx1+loct)=cqgd(lx0+loct)
c
c  check convergence
c
  700 if (initf.ne.3) go to 710
      if (ioff.eq.0) go to 710
      go to 750
  710 if (icheck.eq.1) go to 720
      tol=reltol*dmax1(dabs(cghat),dabs(cg))+abstol
      if (dabs(cghat-cg).ge.tol) go to 720
      tol=reltol*dmax1(dabs(cdhat),dabs(cd))+abstol
      if (dabs(cdhat-cd).le.tol) go to 750
  720 noncon=noncon+1
  750 vgso(lx0+loct)=vgs
      vgdo(lx0+loct)=vgd
      cgo(lx0+loct)=cg
      cdo(lx0+loct)=cd
      cgdo(lx0+loct)=cgd
      gmo(lx0+loct)=gm
      gdso(lx0+loct)=gds
      ggso(lx0+loct)=ggs
      ggdo(lx0+loct)=ggd
c
c  load current vector
c
  900 ceqgd=type*(cgd-ggd*vgd)
      ceqgs=type*((cg-cgd)-ggs*vgs)
      cdreq=type*((cd+cgd)-gds*vds-gm*vgs)
      value(lvn+node2)=value(lvn+node2)-ceqgs-ceqgd
      value(lvn+node4)=value(lvn+node4)-cdreq+ceqgd
      value(lvn+node5)=value(lvn+node5)+cdreq+ceqgs
c
c  load y matrix
c
      locy=lvn+nodplc(loc+20)
      value(locy)=value(locy)+gdpr
      locy=lvn+nodplc(loc+21)
      value(locy)=value(locy)+ggd+ggs
      locy=lvn+nodplc(loc+22)
      value(locy)=value(locy)+gspr
      locy=lvn+nodplc(loc+23)
      value(locy)=value(locy)+gdpr+gds+ggd
      locy=lvn+nodplc(loc+24)
      value(locy)=value(locy)+gspr+gds+gm+ggs
      locy=lvn+nodplc(loc+9)
      value(locy)=value(locy)-gdpr
      locy=lvn+nodplc(loc+10)
      value(locy)=value(locy)-ggd
      locy=lvn+nodplc(loc+11)
      value(locy)=value(locy)-ggs
      locy=lvn+nodplc(loc+12)
      value(locy)=value(locy)-gspr
      locy=lvn+nodplc(loc+13)
      value(locy)=value(locy)-gdpr
      locy=lvn+nodplc(loc+14)
      value(locy)=value(locy)+gm-ggd
      locy=lvn+nodplc(loc+15)
      value(locy)=value(locy)-gds-gm
      locy=lvn+nodplc(loc+16)
      value(locy)=value(locy)-ggs-gm
      locy=lvn+nodplc(loc+17)
      value(locy)=value(locy)-gspr
      locy=lvn+nodplc(loc+18)
      value(locy)=value(locy)-gds
 1000 loc=nodplc(loc)
      go to 10
      end

      subroutine sorupd
      implicit double precision (a-h,o-z)
c
c     this routine updates the independent voltage and current sources
c used in the circuit.  it also updates the ltd table (which contains
c previous (delayed) values of the sources used to model transmission
c lines).
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      do 500 id=9,10
      loc=locate(id)
   10 if (loc.eq.0) go to 500
      if ((id.eq.9).and.(nodplc(loc+11).ne.0)) go to 500
      if ((id.eq.10).and.(nodplc(loc+6).ne.0)) go to 500
      locv=nodplc(loc+1)
      locp=nodplc(loc+5)
      itype=nodplc(loc+4)+1
      go to (490,100,200,300,400,450), itype
c
c  pulse source
c
  100 v1=value(locp+1)
      v2=value(locp+2)
      t1=value(locp+3)
      t2=value(locp+4)
      t3=value(locp+5)
      t4=value(locp+6)
      period=value(locp+7)
      time1=time
      if (time1.le.0.0d0) go to 160
  110 if (time1.lt.t1+period) go to 120
      time1=time1-period
      go to 110
  120 if (time1.lt.t4) go to 130
      value(locv+1)=v1
      go to 490
  130 if (time1.lt.t3) go to 140
      value(locv+1)=v2+(time1-t3)*(v1-v2)/(t4-t3)
      go to 490
  140 if (time1.lt.t2) go to 150
      value(locv+1)=v2
      go to 490
  150 if (time1.lt.t1) go to 160
      value(locv+1)=v1+(time1-t1)*(v2-v1)/(t2-t1)
      go to 490
  160 value(locv+1)=v1
      go to 490
c
c  sinusoidal source
c
  200 v1=value(locp+1)
      v2=value(locp+2)
      omeg=value(locp+3)
      t1=value(locp+4)
      theta=value(locp+5)
      time1=time-t1
      if (time1.gt.0.0d0) go to 210
      value(locv+1)=v1
      go to 490
  210 if (theta.ne.0.0d0) go to 220
      value(locv+1)=v1+v2*dsin(omeg*time1)
      go to 490
  220 value(locv+1)=v1+v2*dsin(omeg*time1)*dexp(-time1*theta)
      go to 490
c
c  exponential source
c
  300 v1=value(locp+1)
      v2=value(locp+2)
      t1=value(locp+3)
      tau1=value(locp+4)
      t2=value(locp+5)
      tau2=value(locp+6)
      time1=time
      if (time1.gt.t1) go to 310
      value(locv+1)=v1
      go to 490
  310 if (time1.gt.t2) go to 320
      value(locv+1)=v1+(v2-v1)*(1.0d0-dexp((t1-time1)/tau1))
      go to 490
  320 value(locv+1)=v1+(v2-v1)*(1.0d0-dexp((t1-time1)/tau1))
     1   +(v1-v2)*(1.0d0-dexp((t2-time1)/tau2))
      go to 490
c
c  piecewise-linear source
c
  400 t1=value(locp+1)
      v1=value(locp+2)
      t2=value(locp+3)
      v2=value(locp+4)
      iknt=4
  410 if (time.le.t2) go to 420
      t1=t2
      v1=v2
      t2=value(locp+iknt+1)
      v2=value(locp+iknt+2)
      iknt=iknt+2
      go to 410
  420 value(locv+1)=v1+((time-t1)/(t2-t1))*(v2-v1)
      go to 490
c
c  single-frequency fm
c
  450 v1=value(locp+1)
      v2=value(locp+2)
      omegc=value(locp+3)
      xmod=value(locp+4)
      omegs=value(locp+5)
      value(locv+1)=v1+v2*dsin(omegc*time+xmod*dsin(omegs*time))
  490 loc=nodplc(loc)
      go to 10
  500 continue
c
c  update transmission line sources
c
      if (jelcnt(17).eq.0) go to 1000
      if (mode.ne.2) go to 1000
      call sizmem(ltd,ltdsiz)
      numtd=ltdsiz/ntlin
      if (numtd.lt.3) go to 900
      loc=locate(17)
  610 if (loc.eq.0) go to 1000
      locv=nodplc(loc+1)
      td=value(locv+2)
      baktim=time-td
      if (baktim.lt.0.0d0) go to 640
      ltdptr=nodplc(loc+30)
      icntr=2
      l1=ltd
      l2=l1+ntlin
      l3=l2+ntlin
      t1=value(l1+1)
      t2=value(l2+1)
  620 t3=value(l3+1)
      icntr=icntr+1
      if (baktim.le.t3) go to 630
      if (icntr.eq.numtd) go to 900
      l1=l2
      l2=l3
      l3=l2+ntlin
      t1=t2
      t2=t3
      go to 620
  630 dt1t2=t1-t2
      dt1t3=t1-t3
      dt2t3=t2-t3
      tdnom1=1.0d0/(dt1t2*dt1t3)
      tdnom2=-1.0d0/(dt1t2*dt2t3)
      tdnom3=1.0d0/(dt2t3*dt1t3)
      dtt1=baktim-t1
      dtt2=baktim-t2
      dtt3=baktim-t3
      tfact1=dtt2*dtt3*tdnom1
      tfact2=dtt1*dtt3*tdnom2
      tfact3=dtt1*dtt2*tdnom3
      value(locv+3)=value(l1+ltdptr+0)*tfact1+value(l2+ltdptr+0)*tfact2
     1   +value(l3+ltdptr+0)*tfact3
      value(locv+4)=value(l1+ltdptr+1)*tfact1+value(l2+ltdptr+1)*tfact2
     1   +value(l3+ltdptr+1)*tfact3
  640 loc=nodplc(loc)
      go to 610
c
c  internal logic error:  less than 3 entries in ltd
c
  900 nogo=1
      write (iofile,901) numtd,icntr
  901 format('0*abort*:  internal spice error:  sorupd:  ',2i5/)
c
c  finished
c
 1000 return
      end

      subroutine reordr
      implicit double precision (a-h,o-z)
c
c     this routine swaps rows in the coefficient matrix to eliminate
c singularity problems which can be recognized by examining the circuit
c topology.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c  allocate and initialize storage
c
      call getm4(irswpf,nstop)
      call getm4(irswpr,nstop)
      call getm4(icswpf,nstop)
      call getm4(icswpr,nstop)
c
      do 10 i=1,nstop
      nodplc(irswpf+i)=i
   10 continue
      call copy4(nodplc(irswpf+1),nodplc(irswpr+1),nstop)
      call copy4(nodplc(irswpf+1),nodplc(icswpf+1),nstop)
      call copy4(nodplc(irswpf+1),nodplc(icswpr+1),nstop)
c
c  swap current equations into admittance part of equation matrix
c
      nextv=1
c
c  find suitable voltage source
c
  100 if (nextv.gt.numvs) go to 600
      ix=0
      do 130 i=nextv,numvs
      loc=nodplc(iseq+i)
      node=nodplc(loc+2)
      nflag=nodplc(iseq1+i)
      if (nflag.eq.1) node=nodplc(loc+6)
      if (nflag.eq.2) node=nodplc(loc+7)
      if (node.eq.1) go to 110
      if (nodplc(nodevs+node).ge.2) go to 110
      if (nodplc(ndiag+node).eq.0) go to 145
      ix=i
      locx=loc
      nodex=node
  110 node=nodplc(loc+3)
      if (nflag.eq.2) node=nodplc(loc+5)
      if (node.eq.1) go to 130
      if (nodplc(nodevs+node).ge.2) go to 130
  120 if (nodplc(ndiag+node).eq.0) go to 145
      ix=i
      locx=loc
      nodex=node
  130 continue
      if (ix.eq.0) go to 590
      i=ix
      loc=locx
      node=nodex
c
c  resequence voltage sources
c
  145 nodplc(iseq+i)=nodplc(iseq+nextv)
      nodplc(iseq+nextv)=loc
      ltemp=nodplc(iseq1+i)
      nodplc(iseq1+i)=nodplc(iseq1+nextv)
      nodplc(iseq1+nextv)=ltemp
      ibr=nodplc(neqn+i)
      nodplc(neqn+i)=nodplc(neqn+nextv)
      nodplc(neqn+nextv)=ibr
      node1=nodplc(loc+2)
      if (ltemp.eq.1) node1=nodplc(loc+6)
      if (ltemp.eq.2) node1=nodplc(loc+7)
      node2=nodplc(loc+3)
      if (ltemp.eq.1) node2=nodplc(loc+3)
      if (ltemp.eq.2) node2=nodplc(loc+5)
      nodplc(nodevs+node1)=nodplc(nodevs+node1)-1
      nodplc(nodevs+node2)=nodplc(nodevs+node2)-1
c
c  set row swap indicators
c
      l=nodplc(irswpf+ibr)
      j=nodplc(irswpr+node)
      nodplc(irswpf+j)=l
      nodplc(irswpr+l)=j
      nodplc(irswpf+ibr)=node
      nodplc(irswpr+node)=ibr
      call swapij(ibr,j,1,1)
      nextv=nextv+1
      go to 100
c
c
c  error - voltage-source/inductor/transmission-line loop detected ...
c
  590 nogo=1
      write (iofile,591)
c...  loop should have been detected in topchk
  591 format('0*abort*:  spice internal error in reordr'/)
c
c  finished
c
  600 return
      end

      subroutine intgr8(geq,ceq,capval,loct)
      implicit double precision (a-h,o-z)
c
c     this routine performs the actual numerical integration for each
c circuit element.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension qcap(1),ccap(1)
      equivalence (qcap(1),value(1)),(ccap(1),value(2))
c
c
      if (method.eq.2) go to 100
c
c  trapezoidal algorithm
c
      if (iord.eq.1) go to 100
      ccap(lx0+loct)=-ccap(lx1+loct)*ag(2)
     1   +ag(1)*(qcap(lx0+loct)-qcap(lx1+loct))
      go to 190
c
c  gears algorithm
c
  100 go to (110,120,130,140,150,160), iord
  110 ccap(lx0+loct)=ag(1)*qcap(lx0+loct)+ag(2)*qcap(lx1+loct)
      go to 190
  120 ccap(lx0+loct)=ag(1)*qcap(lx0+loct)+ag(2)*qcap(lx1+loct)
     1              +ag(3)*qcap(lx2+loct)
      go to 190
  130 ccap(lx0+loct)=ag(1)*qcap(lx0+loct)+ag(2)*qcap(lx1+loct)
     1              +ag(3)*qcap(lx2+loct)+ag(4)*qcap(lx3+loct)
      go to 190
  140 ccap(lx0+loct)=ag(1)*qcap(lx0+loct)+ag(2)*qcap(lx1+loct)
     1              +ag(3)*qcap(lx2+loct)+ag(4)*qcap(lx3+loct)
     2              +ag(5)*qcap(lx4+loct)
      go to 190
  150 ccap(lx0+loct)=ag(1)*qcap(lx0+loct)+ag(2)*qcap(lx1+loct)
     1              +ag(3)*qcap(lx2+loct)+ag(4)*qcap(lx3+loct)
     2              +ag(5)*qcap(lx4+loct)+ag(6)*qcap(lx5+loct)
      go to 190
  160 ccap(lx0+loct)=ag(1)*qcap(lx0+loct)+ag(2)*qcap(lx1+loct)
     1              +ag(3)*qcap(lx2+loct)+ag(4)*qcap(lx3+loct)
     2              +ag(5)*qcap(lx4+loct)+ag(6)*qcap(lx5+loct)
     3              +ag(7)*qcap(lx6+loct)
c... ceq is the equivalent current applicable to linear capacitance
c    (inductance) only, i.e. q=c*v
  190 ceq=ccap(lx0+loct)-ag(1)*qcap(lx0+loct)
      geq=ag(1)*capval
      return
      end

      subroutine tmpupd
      implicit double precision (a-h,o-z)
c
c     this routine updates the temperature-dependent parameters in the
c device models.  it also updates the values of temperature-dependent
c resistors.  the updated values are printed.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension tmptit(4)
      data tmptit / 8htemperat, 8hure-adju, 8hsted val, 8hues      /
c
c
      reftmp=27.0d0+ctok
      temp1=value(itemps+itemno-1)+ctok
      temp2=value(itemps+itemno)+ctok
      xkt=boltz*temp2
      oldvt=vt
      vt=xkt/charge
      oldeg=egfet
      egfet=1.16d0-(7.02d-4*temp2*temp2)/(temp2+1108.0d0)
      arg=-egfet/(xkt+xkt)+1.1150877d0/(boltz*(reftmp+reftmp))
      ratio=temp2/temp1
      ratlog=dlog(ratio)
      ratio1=ratio-1.0d0
      dtemp=temp2-reftmp
      delt=value(itemps+itemno)-value(itemps+1)
      deltsq=delt*delt
      fact2=temp2/reftmp
      xni=1.45d16*fact2*dsqrt(fact2)*dexp(charge*arg)
      pbfact=-2*vt*(1.5d0*dlog(fact2)+charge*arg)
      xkt1=boltz*temp1
      vt1=xkt1/charge
      egfet1=1.16d0-(7.02d-4*temp1*temp1)/(temp1+1108.0d0)
      arg1=-egfet1/(xkt1+xkt1)+1.1150877d0/(boltz*(reftmp+reftmp))
      fact1=temp1/reftmp
      pbfat1=-2*vt1*(1.5d0*dlog(fact1)+charge*arg1)
    5 call title(0,lwidth,1,tmptit)
c
c  resistors
c
      loc=locate(1)
      ititle=0
   10 if (loc.eq.0) go to 100
      locv=nodplc(loc+1)
      tc1=value(locv+3)
      tc2=value(locv+4)
      if (tc1.ne.0.0d0) go to 20
      if (tc2.eq.0.0d0) go to 40
   20 if (ititle.ne.0) go to 30
      write (iofile,21)
   21 format(//'0**** resistors',/,'0name',8x,'value',//)
      ititle=1
   30 rnew=value(locv+2)*(1.0d0+tc1*delt+tc2*deltsq)
      value(locv+1)=1.0d0/rnew
      write (iofile,31) value(locv),rnew
   31 format(1x,a8,1p6d11.3)
   40 loc=nodplc(loc)
      go to 10
c
c  diode model
c
  100 loc=locate(21)
      if (loc.eq.0) go to 200
      write (iofile,101)
  101 format(//'0**** diode model parameters',/,'0name',9x,'is',9x,'vj',
     1   8x,'cjo',//)
  110 if (loc.eq.0) go to 200
      locv=nodplc(loc+1)
c...  is(t2)=is(t1)*dexp(eg/(n*vt)*(t2/t1-1))*(t2/t1)**(xti/n)
      xn=value(locv+3)
      factor=ratio1*value(locv+8)/(xn*vt)+value(locv+9)/xn*ratlog
      factor=dexp(factor)
      value(locv+1)=value(locv+1)*factor
      oldpb=value(locv+6)
      pbo=(value(locv+6)-pbfat1)/fact1
      gmaold=(oldpb-pbo)/pbo
      value(locv+5)=value(locv+5)/(1.0d0+value(locv+7)
     1     *(400.0d-6*(temp1-reftmp)-gmaold))
  120 value(locv+6)=fact2*pbo+pbfact
      gmanew=(value(locv+6)-pbo)/pbo
      value(locv+5)=value(locv+5)
     1   *(1.0d0+value(locv+7)*(400.0d-6*dtemp-gmanew))
      pbrat=value(locv+6)/oldpb
      value(locv+12)=value(locv+12)*pbrat
      value(locv+15)=value(locv+15)*pbrat
      vte=value(locv+3)*vt
      value(locv+18)=vte*dlog(vte/(root2*value(locv+1)))
      write (iofile,31) value(locv),value(locv+1),value(locv+6),
     1                  value(locv+5)
      loc=nodplc(loc)
      go to 110
c
c  bipolar transistor model
c
  200 loc=locate(22)
      if (loc.eq.0) go to 300
      write (iofile,201)
  201 format(//'0**** bjt model parameters',/,'0name',9x,'js',8x,'bf ',
     1   7x,'ise',7x,'br ',7x,'isc',7x,'vje',7x,'cje',7x,'vjc',
     2   7x,'cjc',//)
  210 if (loc.eq.0) go to 300
      locv=nodplc(loc+1)
c...  is(t2)=is(t1)*dexp(eg/vt*(t2/t1-1))*(t2/t1)**xti
      factln=ratio1*value(locv+42)/vt+value(locv+43)*ratlog
      factor=dexp(factln)
      value(locv+1)=value(locv+1)*factor
      tb=value(locv+41)
      bfactr=dexp(tb*ratlog)
      value(locv+2)=value(locv+2)*bfactr
      value(locv+8)=value(locv+8)*bfactr
      value(locv+6)=value(locv+6)*dexp(factln/value(locv+7))/bfactr
      value(locv+12)=value(locv+12)*dexp(factln/value(locv+13))
     1               /bfactr
      oldpb=value(locv+22)
      pbo=(value(locv+22)-pbfat1)/fact1
      gmaold=(oldpb-pbo)/pbo
      value(locv+21)=value(locv+21)/(1.0d0+value(locv+23)
     1     *(400.0d-6*(temp1-reftmp)-gmaold))
  220 value(locv+22)=fact2*pbo+pbfact
      gmanew=(value(locv+22)-pbo)/pbo
      value(locv+21)=value(locv+21)
     1   *(1.0d0+value(locv+23)*(400.0d-6*dtemp-gmanew))
      pbrat=value(locv+22)/oldpb
      value(locv+46)=value(locv+46)*pbrat
      value(locv+47)=value(locv+47)*pbrat
      oldpb=value(locv+30)
      pbo=(value(locv+30)-pbfat1)/fact1
      gmaold=(oldpb-pbo)/pbo
      value(locv+29)=value(locv+29)/(1.0d0+value(locv+31)
     1     *(400.0d-6*(temp1-reftmp)-gmaold))
  230 value(locv+30)=fact2*pbo+pbfact
      gmanew=(value(locv+30)-pbo)/pbo
      value(locv+29)=value(locv+29)
     1   *(1.0d0+value(locv+31)*(400.0d-6*dtemp-gmanew))
      pbrat=value(locv+30)/oldpb
      value(locv+50)=value(locv+50)*pbrat
      value(locv+51)=value(locv+51)*pbrat
      value(locv+54)=vt*dlog(vt/(root2*value(locv+1)))
      write (iofile,211) value(locv),value(locv+1),value(locv+2),
     1   value(locv+6),value(locv+8),value(locv+12),value(locv+22),
     2   value(locv+21),value(locv+30),value(locv+29)
  211 format(1x,a8,1p9d10.3)
      loc=nodplc(loc)
      go to 210
c
c  jfet model
c
  300 loc=locate(23)
      if (loc.eq.0) go to 400
      write (iofile,301)
  301 format(//'0**** jfet model parameters',/,'0name',9x,'is',9x,'pb',
     1   8x,'cgs',8x,'cgd',//)
  310 if (loc.eq.0) go to 400
      locv=nodplc(loc+1)
      value(locv+9)=value(locv+9)*dexp(ratio1*1.11d0/vt)
      oldpb=value(locv+8)
      pbo=(value(locv+8)-pbfat1)/fact1
      gmaold=(oldpb-pbo)/pbo
      oldcjf=1.0d0+0.5d0*(400.0d-6*(temp1-reftmp)-gmaold)
      value(locv+6)=value(locv+6)/oldcjf
      value(locv+7)=value(locv+7)/oldcjf
  320 value(locv+8)=fact2*pbo+pbfact
      gmanew=(value(locv+8)-pbo)/pbo
      cjfact=1.0d0+0.5d0*(400.0d-6*dtemp-gmanew)
      value(locv+6)=value(locv+6)*cjfact
      value(locv+7)=value(locv+7)*cjfact
      pbrat=value(locv+8)/oldpb
      value(locv+12)=value(locv+12)*pbrat
      value(locv+13)=value(locv+13)*pbrat
      value(locv+16)=vt*dlog(vt/(root2*value(locv+9)))
      write (iofile,31) value(locv),value(locv+9),value(locv+8),
     1   value(locv+6),value(locv+7)
      loc=nodplc(loc)
      go to 310
c
c  mosfet model
c
  400 loc=locate(24)
      iprnt=1
  410 if (loc.eq.0) go to 1000
      locv=nodplc(loc+1)
      type=nodplc(loc+2)
      if(iprnt.ne.0) write (iofile,401)
  401 format(//'0**** mosfet model parameters',/,'0name',8x,'vto',8x,
     1   'phi',9x,'pb',7x,'is(js)',7x,'kp',9x,'uo'//)
      iprnt=0
      ratio4=ratio*dsqrt(ratio)
      value(locv+3)=value(locv+3)/ratio4
      value(locv+29)=value(locv+29)/ratio4
      oldphi=value(locv+5)
      phio=(value(locv+5)-pbfat1)/fact1
  415 value(locv+5)=fact2*phio+pbfact
      phi=value(locv+5)
      vfb=value(locv+44)-type*0.5d0*oldphi
      vfb=vfb+0.5d0*(oldeg-egfet)
      value(locv+44)=vfb+type*0.5d0*phi
      value(locv+2)=value(locv+44)+type*value(locv+4)*dsqrt(phi)
      value(locv+11)=value(locv+11)*dexp(-egfet/vt+oldeg/oldvt)
      value(locv+21)=value(locv+21)*dexp(-egfet/vt+oldeg/oldvt)
      oldpb=value(locv+12)
      pbo=(value(locv+12)-pbfat1)/fact1
      gmaold=(oldpb-pbo)/pbo
      coeold=1.0d0+value(locv+18)*(400.0d-6*(temp1-reftmp)-gmaold)
      value(locv+9)=value(locv+9)/coeold
      value(locv+10)=value(locv+10)/coeold
      value(locv+17)=value(locv+17)/coeold
      value(locv+19)=value(locv+19)/(1.0d0+value(locv+20)
     1     *(400.0d-6*(temp1-reftmp)-gmaold))
  420 value(locv+12)=fact2*pbo+pbfact
      gmanew=(value(locv+12)-pbo)/pbo
      coenew=1.0d0+value(locv+18)*(400.0d-6*dtemp-gmanew)
      value(locv+9)=value(locv+9)*coenew
      value(locv+10)=value(locv+10)*coenew
      value(locv+17)=value(locv+17)*coenew
      value(locv+19)=value(locv+19)*
     1   (1.0d0+value(locv+20)*(400.0d-6*dtemp-gmanew))
      pbrat=value(locv+12)/oldpb
      value(locv+37)=value(locv+37)*pbrat
      value(locv+38)=value(locv+38)*pbrat
      csat=dmax1(value(locv+11),value(locv+21))
      write (iofile,31) value(locv),value(locv+2),value(locv+5),
     1   value(locv+12),csat,value(locv+3),value(locv+29)
  430 loc=nodplc(loc)
      go to 410
c
c  finished
c
 1000 return
      end

      subroutine find(aname,id,loc,iforce)
      implicit double precision (a-h,o-z)
c
c     this routine searches the list with number 'id' for an element
c with name 'aname'.  loc is set to point to the element.  if iforce is
c nonzero, then find expects to have to add the element to the list, and
c reports a fatal error if the element is found.  if subcircuit defini-
c tion is in progress (nonzero value for nsbckt), then find searches the
c current subcircuit definition list rather than the nominal element
c list.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c  index to the contents of the various lists:
c
c        list      contents
c        ----      --------
c
c          1       resistors
c          2       nonlinear capacitors
c          3       nonlinear inductors
c          4       mutual inductors
c          5       nonlinear voltage controlled current sources
c          6       nonlinear voltage controlled voltage sources
c          7       nonlinear current controlled current sources
c          8       nonlinear current controlled voltage sources
c          9       independent voltage sources
c         10       independent current sources
c         11       diodes
c         12       bipolar junction transistors
c         13       junction field-effect transistors (jfets)
c         14       metal-oxide-semiconductor junction fets (mosfets)
c         15       s-parameter 2-port network
c         16       y-parameter 2-port network
c         17       transmission lines
c         18       used for temperature sweeping
c         19       subcircuit calls
c         20       subcircuit definitions
c         21       diode model
c         22       bjt model
c         23       jfet model
c         24       mosfet model
c      25-30       <unused>
c         31       .print dc
c         32       .print tran
c         33       .print ac
c         34       .print noise
c         35       .print distortion
c         36       .plot dc
c         37       .plot tr
c         38       .plot ac
c         39       .plot noise
c         40       .plot distortion
c         41       outputs for dc
c         42       outputs for transient
c         43       outputs for ac
c         44       outputs for noise
c         45       outputs for distortion
c      46-50       <unused>
c
      integer xxor
      dimension lnod(50),lval(50)
      data lnod /10,14,16, 8,15,16,15,16,13, 8,
     1           18,38,27,35, 8, 8,35, 5, 5, 5,
     2            5, 5, 5, 5, 0, 0, 0, 0, 0, 0,
     3           21,21,21,21,21,21,21,21,21,21,
     4            8, 8, 8, 8, 8, 0, 0, 0, 0, 0 /
      data lval / 5, 4, 4, 2, 1, 1, 1, 1, 4, 4,
     1            3, 4, 4,16, 1, 1, 9, 2, 1, 1,
     2           19,55,17,46, 0, 0, 0, 0, 0, 0,
     3            1, 1, 1, 1, 1,17,17,17,17,17,
     4            1, 1, 1, 1, 1, 0, 0, 0, 0, 0 /
      data ndefin /2h.u/
c
c
      anam=aname
      call sizmem(ielmnt,isize)
      locn=ielmnt+isize+2
      if (nsbckt.eq.0) go to 10
      loct=nodplc(isbckt+nsbckt)
      loc=nodplc(loct+3)
      if (loc.ne.0) go to 20
      nodplc(loct+3)=locn
      go to 60
   10 loc=locate(id)
      if (loc.ne.0) go to 20
      locate(id)=locn
      go to 50
c
c  search list for a name match
c
   20 locv=nodplc(loc+1)
      if (xxor(anam,value(locv)).ne.0) go to 30
      if (numalt.ne.0) go to 30
      if (nsbckt.eq.0) go to 25
      if (nodplc(loc-1).ne.id) go to 30
   25 if (nodplc(loc+2).eq.ndefin) go to 200
      if (iforce.eq.0) go to 200
      write (iofile,26) anam
   26 format('0*error*:  above line attempts to redefine ',a8/)
      nogo=1
   30 if (nodplc(loc).eq.0) go to 40
      loc=nodplc(loc)
      go to 20
c
c  reserve space for this element
c
   40 nodplc(loc)=locn
      if (nsbckt.ne.0) go to 60
   50 if (numalt.eq.0) jelcnt(id)=jelcnt(id)+1
   60 loc=locn
      itemp=loc+lnod(id)*nwd4-1
      locv=nxtevn(itemp-1)+1
      itemp=locv-itemp
      ktmp=lnod(id)*nwd4+lval(id)*nwd8+itemp
      call extmem(ielmnt,ktmp)
      locv=(locv-1)/nwd8+1
      iptr=0
      if (nsbckt.eq.0) go to 80
      iptr=id
   80 if (id.le.24) nodplc(loc+lnod(id)-2)=numalt
      nodplc(loc-1)=iptr
      nodplc(loc)=0
      nodplc(loc+1)=locv
      value(locv)=anam
c
c  background storage
c
  100 nodplc(loc+2)=ndefin
      nword=lnod(id)-4
      if (id.le.24) nword=nword-1
      if (nword.lt.1) go to 120
      call zero4(nodplc(loc+3),nword)
  120 nword=lval(id)-1
      if (nword.lt.1) go to 200
      call zero8(value(locv+1),nword)
      if ((id.ge.21).and.(id.le.24)) call undefi(value(locv+1),nword)
c
c  exit
c
  200 return
      end

      subroutine getnod(node)
      implicit double precision (a-h,o-z)
c
c     this routine converts from the user node number to the internal
c (compact) node number.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      if (nogo.ne.0) go to 100
      jknt=0
   10 jknt=jknt+1
      if (jknt.gt.nunods) go to 20
      if (nodplc(junode+jknt).ne.node) go to 10
      node=jknt
      go to 100
c
c  unknown node -- must be implied by .print and/or .plot
c
   20 if (node.eq.0) go to 30
      write (iofile,21) node
   21 format('0warning:  attempt to reference undefined node ',i5,
     1   ' -- node reset to 0'/)
   30 node=1
c
c  finished
c
  100 return
      end

      subroutine matloc
      implicit double precision (a-h,o-z)
c
c     this routine stores the locations of the various matrix terms to
c which the different circuit elements contribute.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c  resistors
c
      loc=locate(1)
  690 if ((loc.eq.0).or.(nodplc(loc+8).ne.0)) go to 700
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      nodplc(loc+4)=indxx(node1,node2)
      nodplc(loc+5)=indxx(node2,node1)
      nodplc(loc+6)=indxx(node1,node1)
      nodplc(loc+7)=indxx(node2,node2)
      loc=nodplc(loc)
      go to 690
c
c  capacitors
c
  700 loc=locate(2)
  710 if ((loc.eq.0).or.(nodplc(loc+12).ne.0)) go to 720
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      nodplc(loc+5)=indxx(node1,node2)
      nodplc(loc+6)=indxx(node2,node1)
      nodplc(loc+10)=indxx(node1,node1)
      nodplc(loc+11)=indxx(node2,node2)
      loc=nodplc(loc)
      go to 710
c
c  inductors
c
  720 loc=locate(3)
  730 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 740
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ibr=nodplc(loc+5)
      nodplc(loc+6)=indxx(node1,ibr)
      nodplc(loc+7)=indxx(node2,ibr)
      nodplc(loc+8)=indxx(ibr,node1)
      nodplc(loc+9)=indxx(ibr,node2)
      nodplc(loc+13)=indxx(ibr,ibr)
      loc=nodplc(loc)
      go to 730
c
c  mutual inductances
c
  740 loc=locate(4)
  750 if ((loc.eq.0).or.(nodplc(loc+6).ne.0)) go to 760
      nl1=nodplc(loc+2)
      nl2=nodplc(loc+3)
      ibr1=nodplc(nl1+5)
      ibr2=nodplc(nl2+5)
      nodplc(loc+4)=indxx(ibr1,ibr2)
      nodplc(loc+5)=indxx(ibr2,ibr1)
      loc=nodplc(loc)
      go to 750
c
c  nonlinear voltage controlled current sources
c
  760 loc=locate(5)
  762 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 764
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      lnod=nodplc(loc+6)
      lmat=nodplc(loc+7)
      do 763 i=1,ndim
      node3=nodplc(lnod+1)
      node4=nodplc(lnod+2)
      lnod=lnod+2
      nodplc(lmat+1)=indxx(node1,node3)
      nodplc(lmat+2)=indxx(node1,node4)
      nodplc(lmat+3)=indxx(node2,node3)
      nodplc(lmat+4)=indxx(node2,node4)
      lmat=lmat+4
  763 continue
      loc=nodplc(loc)
      go to 762
c
c  nonlinear voltage controlled voltage sources
c
  764 loc=locate(6)
  766 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 768
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      ibr=nodplc(loc+6)
      lnod=nodplc(loc+7)
      lmat=nodplc(loc+8)
      nodplc(lmat+1)=indxx(node1,ibr)
      nodplc(lmat+2)=indxx(node2,ibr)
      nodplc(lmat+3)=indxx(ibr,node1)
      nodplc(lmat+4)=indxx(ibr,node2)
      lmat=lmat+4
      do 767 i=1,ndim
      node3=nodplc(lnod+1)
      node4=nodplc(lnod+2)
      lnod=lnod+2
      nodplc(lmat+1)=indxx(ibr,node3)
      nodplc(lmat+2)=indxx(ibr,node4)
      lmat=lmat+2
  767 continue
      loc=nodplc(loc)
      go to 766
c
c  nonlinear current controlled current sources
c
  768 loc=locate(7)
  770 if ((loc.eq.0).or.(nodplc(loc+13).ne.0)) go to 772
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      locvs=nodplc(loc+6)
      lmat=nodplc(loc+7)
      do 771 i=1,ndim
      locvst=nodplc(locvs+i)
      ibr=nodplc(locvst+6)
      nodplc(lmat+1)=indxx(node1,ibr)
      nodplc(lmat+2)=indxx(node2,ibr)
      lmat=lmat+2
  771 continue
      loc=nodplc(loc)
      go to 770
c
c  nonlinear current controlled voltage sources
c
  772 loc=locate(8)
  774 if ((loc.eq.0).or.(nodplc(loc+14).ne.0)) go to 780
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      ndim=nodplc(loc+4)
      ibr=nodplc(loc+6)
      locvs=nodplc(loc+7)
      lmat=nodplc(loc+8)
      nodplc(lmat+1)=indxx(node1,ibr)
      nodplc(lmat+2)=indxx(node2,ibr)
      nodplc(lmat+3)=indxx(ibr,node1)
      nodplc(lmat+4)=indxx(ibr,node2)
      lmat=lmat+4
      do 775 i=1,ndim
      locvst=nodplc(locvs+i)
      kbr=nodplc(locvst+6)
      nodplc(lmat+i)=indxx(ibr,kbr)
  775 continue
      loc=nodplc(loc)
      go to 774
c
c  voltage sources
c
  780 loc=locate(9)
  790 if ((loc.eq.0).or.(nodplc(loc+11).ne.0)) go to 800
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      iptr=nodplc(loc+6)
      nodplc(loc+7)=indxx(node1,iptr)
      nodplc(loc+8)=indxx(node2,iptr)
      nodplc(loc+9)=indxx(iptr,node1)
      nodplc(loc+10)=indxx(iptr,node2)
      loc=nodplc(loc)
      go to 790
c
c  diodes
c
  800 loc=locate(11)
  810 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 820
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      nodplc(loc+7)=indxx(node1,node3)
      nodplc(loc+8)=indxx(node2,node3)
      nodplc(loc+9)=indxx(node3,node1)
      nodplc(loc+10)=indxx(node3,node2)
      nodplc(loc+13)=indxx(node1,node1)
      nodplc(loc+14)=indxx(node2,node2)
      nodplc(loc+15)=indxx(node3,node3)
      loc=nodplc(loc)
      go to 810
c
c  transistors
c
  820 loc=locate(12)
  830 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 840
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      node7=nodplc(loc+30)
      nodplc(loc+10)=indxx(node1,node4)
      nodplc(loc+11)=indxx(node2,node5)
      nodplc(loc+12)=indxx(node3,node6)
      nodplc(loc+13)=indxx(node4,node1)
      nodplc(loc+14)=indxx(node4,node5)
      nodplc(loc+15)=indxx(node4,node6)
      nodplc(loc+16)=indxx(node5,node2)
      nodplc(loc+17)=indxx(node5,node4)
      nodplc(loc+18)=indxx(node5,node6)
      nodplc(loc+19)=indxx(node6,node3)
      nodplc(loc+20)=indxx(node6,node4)
      nodplc(loc+21)=indxx(node6,node5)
      nodplc(loc+24)=indxx(node1,node1)
      nodplc(loc+25)=indxx(node2,node2)
      nodplc(loc+26)=indxx(node3,node3)
      nodplc(loc+27)=indxx(node4,node4)
      nodplc(loc+28)=indxx(node5,node5)
      nodplc(loc+29)=indxx(node6,node6)
      nodplc(loc+31)=indxx(node7,node7)
      nodplc(loc+32)=indxx(node4,node7)
      nodplc(loc+33)=indxx(node7,node4)
      nodplc(loc+34)=indxx(node2,node4)
      nodplc(loc+35)=indxx(node4,node2)
      loc=nodplc(loc)
      go to 830
c
c  jfets
c
  840 loc=locate(13)
  850 if ((loc.eq.0).or.(nodplc(loc+25).ne.0)) go to 860
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      nodplc(loc+9)=indxx(node1,node4)
      nodplc(loc+10)=indxx(node2,node4)
      nodplc(loc+11)=indxx(node2,node5)
      nodplc(loc+12)=indxx(node3,node5)
      nodplc(loc+13)=indxx(node4,node1)
      nodplc(loc+14)=indxx(node4,node2)
      nodplc(loc+15)=indxx(node4,node5)
      nodplc(loc+16)=indxx(node5,node2)
      nodplc(loc+17)=indxx(node5,node3)
      nodplc(loc+18)=indxx(node5,node4)
      nodplc(loc+20)=indxx(node1,node1)
      nodplc(loc+21)=indxx(node2,node2)
      nodplc(loc+22)=indxx(node3,node3)
      nodplc(loc+23)=indxx(node4,node4)
      nodplc(loc+24)=indxx(node5,node5)
      loc=nodplc(loc)
      go to 850
c
c  mosfets
c
  860 loc=locate(14)
  870 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 900
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      nodplc(loc+10)=indxx(node1,node5)
      nodplc(loc+11)=indxx(node2,node4)
      nodplc(loc+12)=indxx(node2,node5)
      nodplc(loc+13)=indxx(node2,node6)
      nodplc(loc+14)=indxx(node3,node6)
      nodplc(loc+15)=indxx(node4,node2)
      nodplc(loc+16)=indxx(node4,node5)
      nodplc(loc+17)=indxx(node4,node6)
      nodplc(loc+18)=indxx(node5,node1)
      nodplc(loc+19)=indxx(node5,node2)
      nodplc(loc+20)=indxx(node5,node4)
      nodplc(loc+21)=indxx(node5,node6)
      nodplc(loc+22)=indxx(node6,node2)
      nodplc(loc+23)=indxx(node6,node3)
      nodplc(loc+24)=indxx(node6,node4)
      nodplc(loc+25)=indxx(node6,node5)
      nodplc(loc+27)=indxx(node1,node1)
      nodplc(loc+28)=indxx(node2,node2)
      nodplc(loc+29)=indxx(node3,node3)
      nodplc(loc+30)=indxx(node4,node4)
      nodplc(loc+31)=indxx(node5,node5)
      nodplc(loc+32)=indxx(node6,node6)
      loc=nodplc(loc)
      go to 870
c
c  transmission lines
c
  900 loc=locate(17)
  910 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 1000
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      ni1=nodplc(loc+6)
      ni2=nodplc(loc+7)
      ibr1=nodplc(loc+8)
      ibr2=nodplc(loc+9)
      nodplc(loc+10)=indxx(node1,node1)
      nodplc(loc+11)=indxx(node1,ni1)
      nodplc(loc+12)=indxx(node2,ibr1)
      nodplc(loc+13)=indxx(node3,node3)
      nodplc(loc+14)=indxx(node4,ibr2)
      nodplc(loc+15)=indxx(ni1,node1)
      nodplc(loc+16)=indxx(ni1,ni1)
      nodplc(loc+17)=indxx(ni1,ibr1)
      nodplc(loc+18)=indxx(ni2,ni2)
      nodplc(loc+19)=indxx(ni2,ibr2)
      nodplc(loc+20)=indxx(ibr1,node2)
      nodplc(loc+21)=indxx(ibr1,node3)
      nodplc(loc+22)=indxx(ibr1,node4)
      nodplc(loc+23)=indxx(ibr1,ni1)
      nodplc(loc+24)=indxx(ibr1,ibr2)
      nodplc(loc+25)=indxx(ibr2,node1)
      nodplc(loc+26)=indxx(ibr2,node2)
      nodplc(loc+27)=indxx(ibr2,node4)
      nodplc(loc+28)=indxx(ibr2,ni2)
      nodplc(loc+29)=indxx(ibr2,ibr1)
      nodplc(loc+31)=indxx(node3,ni2)
      nodplc(loc+32)=indxx(ni2,node3)
      loc=nodplc(loc)
      go to 910
c
c  finished
c
 1000 return
      end

      subroutine subnam(loce)
      implicit double precision (a-h,o-z)
c
c     this routine constructs the names of elements added as a result of
c subcircuit expansion.  the full element names are of the form
c                  name.xn. --- xd.xc.xb.xa
c where 'name' is the nominal element name, and the 'x'*s denote the
c sequence of subcircuit calls (from top or circuit level down through
c nested subcircuit calls) which caused the particular element to be
c added.  at present, spice restricts all element names to be 8 charac-
c ters or less.  therefore, the name used consists of the leftmost 8
c characters of the full element name, with the rightmost character
c replaced by an asterisk ('*') if the full element name is longer than
c 8 characters.
c
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      data ablank, aper, astk / 1h , 1h., 1h* /
c
c  construct subcircuit element name
c
      if (nodplc(loce-1).eq.0) go to 100
      locve=nodplc(loce+1)
      loc=loce
      nchar=0
      sname=ablank
      achar=ablank
   10 locv=nodplc(loc+1)
      elname=value(locv)
      do 20 ichar=1,8
      call move(achar,1,elname,ichar,1)
      if (achar.eq.ablank) go to 30
      if (nchar.eq.8) go to 40
      nchar=nchar+1
      call move(sname,nchar,achar,1,1)
   20 continue
   30 loc=nodplc(loc-1)
      if (loc.eq.0) go to 60
      if (nchar.eq.8) go to 40
      nchar=nchar+1
      call move(sname,nchar,aper,1,1)
      go to 10
c
c  name is longer than 8 characters:  flag with asterisk
c
   40 call move(sname,8,astk,1,1)
   60 value(locve)=sname
c
c  finished
c
  100 return
      end

      subroutine ntrpl8(locx,locy,numpnt)
      implicit double precision (a-h,o-z)
c
c     this routine interpolates the analysis data to obtain the values
c printed and/or plotted, using linear interpolation.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
c  for dc transfer curve, no interpolation necessary
c
      if(mode.ne.1) go to 4
      numpnt=icalc
      loco=loutpt
      do 3 i=1,numpnt
      locyt=locy
      value(locx+i)=value(loco+1)
      do 2 k=1,kntr
      iseq=itab(k)
      iseq=nodplc(iseq+4)
      value(locyt+i)=value(loco+iseq)
      locyt=locyt+npoint
    2 continue
      loco=loco+numout
    3 continue
      return
    4 continue
      xvar=xstart
      xvtol=xincr*1.0d-5
      ippnt=0
      icpnt=2
      loco1=loutpt
      loco2=loco1+numout
      if (icalc.lt.2) go to 50
   10 x1=value(loco1+1)
      x2=value(loco2+1)
      dx1x2=x1-x2
   20 if (xincr.lt.0.0d0) go to 24
      if (xvar.le.(x2+xvtol)) go to 30
      go to 28
   24 if (xvar.ge.(x2+xvtol)) go to 30
   28 if (icpnt.ge.icalc) go to 100
      icpnt=icpnt+1
      loco1=loco2
      loco2=loco1+numout
      go to 10
   30 ippnt=ippnt+1
      value(locx+ippnt)=xvar
      dxx1=xvar-x1
      locyt=locy
      do 40 i=1,kntr
      iseq=itab(i)
      iseq=nodplc(iseq+4)
      v1=value(loco1+iseq)
      v2=value(loco2+iseq)
      yvr=v1+(v1-v2)*dxx1/dx1x2
      tol=dmin1(dabs(v1),dabs(v2))*1.0d-10
      if (dabs(yvr).le.tol) yvr=0.0d0
      value(locyt+ippnt)=yvr
      locyt=locyt+npoint
   40 continue
      if (ippnt.ge.npoint) go to 100
      xvar=xstart+dble(ippnt)*xincr
      if (dabs(xvar).ge.dabs(xvtol)) go to 20
      xvar=0.0d0
      go to 20
c
c  special handling if icalc = 1
c
c...  icalc=1;  just copy over the single point and return
   50 ippnt=1
      value(locx+ippnt)=xvar
      locyt=locy
      do 60 i=1,kntr
      iseq=itab(i)
      iseq=nodplc(iseq+4)
      value(locyt+ippnt)=value(loco1+iseq)
      locyt=locyt+npoint
   60 continue
      go to 100
c
c  return
c
  100 numpnt=ippnt
      return
      end

      subroutine mosq2(vds,vbs,vgs,vdsat,vth,vbin,gamasd,cox,phi,
     1   qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      implicit double precision (a-h,o-z)
c
c     initialize charges;
c     change reference voltages for charge computation
c
      qg=0.0d0
      qb=0.0d0
      vbd=vbs-vds
      vgb=vgs-vbs
      vd=dmax1(phi-vbd,1.0d-8)
      vs=dmax1(phi-vbs,1.0d-8)
      vg=vgb-vbin+phi
      vsp5=dsqrt(vs)
c
c     determine operating region
c
      if (vgs.le.vth) go to 1100
c
c     compute charges for "on" region
c
 1020 vsat=vdsat+vs
      vs2=vs*vs
      vs3=vs2*vs
      vs5=vs3*vs2
      vs1p5=vs*vsp5
      vs2p5=vs1p5*vs
 1025 if (vd.ge.vsat) go to 1035
      ve=vd
 1030 dvedvd=1.0d0
      dvedvg=0.0d0
      go to 1040
 1035 ve=vsat
      dvedvd=0.0d0
      dvedvg=0.0d0
 1040 ve2=ve*ve
      ve3=ve2*ve
      ve5=ve2*ve3
      vep5=dsqrt(ve)
      ve1p5=ve*vep5
      ve2p5=ve1p5*ve
      term0=ve+vs
      term1=vep5+vsp5
      term2=vep5*vsp5
      term3=ve2+vs2
      term4=ve*vs
      term5=term0*term1
      term6=(term3+term4)+term2*term0
      term7=(term3+term4)*term1
      term10=vep5+0.5d0*vsp5
      term11=1.5d0*ve+vsp5*term10
      term12=2.0d0*ve1p5+vsp5*term11
      term20=0.5d0*vep5+vsp5
      term21=1.5d0*vs+vep5*term20
      term22=2.0d0*vs1p5+vep5*term21
      argn=0.5d0*vg*term5-0.4d0*gamasd*term6-term7/3.0d0
      argd=vg*term1-gamasd*(term0+term2)/1.5d0-0.5d0*term1*term0
      argd2=argd*argd
      qg=cox*(vg-argn/argd)
      dgndve=0.5d0*vg*term11-0.4d0*gamasd*term12-
     1   (2.5d0*ve2+vsp5*term12)/3.0d0
      dddve=0.5d0*vg-gamasd*term10/1.5d0-0.5d0*term11
      dqgdve=-cox/argd*(dgndve-(vg-qg/cox)*dddve)
      dgndvs=0.5d0*vg*term21-0.4d0*gamasd*term22-
     1   (2.5d0*vs2+vep5*term22)/3.0d0
      dddvs=0.5d0*vg-gamasd*term20/1.5d0-0.5d0*term21
      cgdb=-cox/(argd*vep5)*(dgndve-(vg-qg/cox)*dddve)*dvedvd
      cgsb=-cox/(argd*vsp5)*(dgndvs-(vg-qg/cox)*dddvs)
      cggb=cox*(1.0d0-term1/argd*(0.5d0*term0-vg+qg/cox))
      argn=vg*(term0+term2)/1.5d0-0.5d0*gamasd*term5-0.4d0*term6
      dgndve=vg*term10/1.5d0-0.5d0*gamasd*term11-0.4d0*term12
      dgndvs=vg*term20/1.5d0-0.5d0*gamasd*term21-0.4d0*term22
      qb=-gamasd*cox*argn/argd
      cbdb=-cox/(vep5*argd)*(qb/cox*dddve+gamasd*dgndve)*dvedvd
      cbsb=-cox/(vsp5*argd)*(qb/cox*dddvs+gamasd*dgndvs)
      cbgb=-cox/argd*(gamasd*(term0+term2)/1.5d0+qb/cox*term1)
      go to 2000
c
c  finish special cases
c
 1100 if (vg.gt.0.0d0) go to 1110
      qg=cox*vg
      cggb=cox
      go to 1120
 1110 gamma2=gamasd*0.5d0
      sqarg=dsqrt(gamma2*gamma2+vg)
      qg=gamasd*cox*(sqarg-gamma2)
      cggb=0.5d0*cox*gamasd/sqarg
 1120 qb=-qg
      cbgb=-cggb
      cgdb=0.0d0
      cgsb=0.0d0
      cbdb=0.0d0
      cbsb=0.0d0
c
c  finished
c
 2000 qc=-(qg+qb)
 2050 return
      end

      subroutine terr(loct,delnew)
      implicit double precision (a-h,o-z)
c
c     this routine estimates the local truncation error for a particular
c circuit element.  it then computes the appropriate stepsize which
c should be used.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension qcap(1),ccap(1),diff(8),deltmp(7),coef(6)
      equivalence (qcap(1),value(1)),(ccap(1),value(2))
      data coef / 5.000000000d-1, 2.222222222d-1, 1.363636364d-1,
     1            9.600000000d-2, 7.299270073d-2, 5.830903790d-2 /
      data xtwelv / 8.333333333d-2 /
c
c
      tol=reltol*dmax1(dabs(ccap(lx0+loct)),dabs(ccap(lx1+loct)))+abstol
      ctol=reltol*dmax1(dabs(qcap(lx0+loct)),dabs(qcap(lx1+loct)),
     1   chgtol)/delta
      tol=dmax1(tol,ctol)
c
c  determine divided differences
c
      go to (6,5,4,3,2,1), iord
    1 diff(8)=qcap(lx7+loct)
    2 diff(7)=qcap(lx6+loct)
    3 diff(6)=qcap(lx5+loct)
    4 diff(5)=qcap(lx4+loct)
    5 diff(4)=qcap(lx3+loct)
    6 diff(3)=qcap(lx2+loct)
      diff(2)=qcap(lx1+loct)
      diff(1)=qcap(lx0+loct)
      istop=iord+1
      do 10 i=1,istop
      deltmp(i)=delold(i)
   10 continue
   20 do 30 i=1,istop
      diff(i)=(diff(i)-diff(i+1))/deltmp(i)
   30 continue
      istop=istop-1
      if (istop.eq.0) go to 100
      do 40 i=1,istop
      deltmp(i)=deltmp(i+1)+delold(i)
   40 continue
      go to 20
c
c  diff(1) contains divided difference
c
  100 const=coef(iord)
      if ((method.eq.1).and.(iord.eq.2)) const=xtwelv
      del=trtol*tol/dmax1(abstol,const*dabs(diff(1)))
      if (iord.eq.1) go to 200
      if (iord.ge.3) go to 150
      del=dsqrt(del)
      go to 200
  150 del=dexp(dlog(del)/dble(iord))
  200 delnew=dmin1(delnew,del)
      return
      end

      integer function indxx(node1,node2)
      implicit double precision (a-h,o-z)
c
c     this routine maps a (row, column) matrix term specification into
c the offset from the origin of the matrix storage at which the term is
c actually located.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      if (node1.eq.1) go to 100
      if (node2.eq.1) go to 100
c
      n1=nodplc(irswpr+node1)
      n2=nodplc(icswpr+node2)
      if (n1-n2) 10,10,30
c
c     search col n2
c
   10 loc=n2
   15 loc=nodplc(irpt+loc)
      if (loc.eq.0) go to 100
      if (nodplc(irowno+loc)-n1) 15,20,15
   20 indxx=loc
      return
c
c     search row n1
c
   30 loc=n1
   35 loc=nodplc(jcpt+loc)
      if (loc.eq.0) go to 100
      if (nodplc(jcolno+loc)-n2) 35,40,35
   40 indxx=loc
      return
c
c     unused location
c
  100 indxx=1
      return
      end

      subroutine undefi(array,length)
      implicit double precision (a-h,o-z)
c
      dimension array(1)
c     this routine undefines the memory locations indicated by array(1)
c through array(length).
c
      data aundef /2h.u/
      if (length.eq.0) return
      do 10 i=1,length
      array(i)=aundef
   10 continue
      return
      end

      subroutine pheadr(aheadr)
      implicit double precision (a-h,o-z)
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
c int3 (not used) is strictly for alignment.  f77 on unix craps out.
      integer int2,int3,nodpl2(128)
      equivalence (value(1),nodpl2(1))
      equivalence (value(1),nodplc(1),cvalue(1))
      dimension aheadr(10)
c
c  put out the header records onto the post-processing file
c  routine is used for all analysis modes (mode=1,2,3)
c
      dimension xtype(2)
      data xtype /4htime,4hfreq/
      data ablnk,aletv,aleti /1h ,1hv,1hi/
c
c file structure for post-processor
c
c record 1  title card (80 bytes), date (8 bytes), time (8 bytes) total-96 bytes
c record 2  number of output variables (including "sweep" variable)
c record 3  integer '4' (2 bytes)
c record 4  names of each output variable (8 bytes ea.)
c record 5  type of each output       0-no type
c                                     1-time
c                                     2-frequency
c                                     3-voltage
c                                     4-current
c                                     5-output noise
c                                     6-input noise
c                                     7-hd2    |
c                                     8-hd3    |
c                                     9-dim2   }   distortion outputs
c                                    10-sim2   |
c                                    11-dim3   |
c record 6  the location of each variable within each sweep point.
c           (normally just 1,2,3,4,... but needed if outputs are mixed up)
c record 6a 24 characters that are the plot title if record 3 is a '4'.
c record 7  output at first sweep point
c record 8  output at second sweep point
c record 9  .
c           .
c           .
c last record
c
c
      call getm8(ibuff,12)
      call copy8(aheadr(1),value(ibuff+1),10)
      value(ibuff+11)=adate
      value(ibuff+12)=atime
      call fwrite(value(ibuff+1),48)
      numout=nunods+jelcnt(9)
c force nused to be allocated by useless usage.
      int2 = numout
      int3 = numout
      info=4
      call getm8(inames,numout)
      call getm4(itypes,numout)
      call getm4(iseqs,numout)
      itype2=itypes*2
      iseq2=iseqs*2
      iknt=1
      nodpl2(iseq2+1)=1
c
c dc transfer curve (mode = 1):
c
      if(mode.ne.1) go to 10
      loc=itcelm(1)
      locv=nodplc(loc+1)
      value(inames+1)=value(locv)
      anam=ablnk
      call move(anam,1,value(locv),1,1)
      ityp=0
c voltage transfer becomes type 3 and current transfer becomes 4.
      if(anam.eq.aletv) ityp=3
      if(anam.eq.aleti) ityp=4
      nodpl2(itype2+1)=ityp
      go to 20
   10 value(inames+1)=xtype(mode-1)
      nodpl2(itype2+1)=mode-1
   20 do 30 i=2,nunods
      nodpl2(itype2+i)=3
      nodpl2(iseq2+i)=i
      value(inames+i)=ablnk
      ipos=1
      call alfnum(nodplc(junode+i),value(inames+i),ipos)
   30 continue
      loc=locate(9)
      iknt=nunods
   40 if(loc.eq.0) go to 50
      iknt=iknt+1
      nodpl2(itype2+iknt)=4
      nodpl2(iseq2+iknt)=iknt
      locv=nodplc(loc+1)
      value(inames+iknt)=value(locv)
      loc=nodplc(loc)
      go to 40
   50 int2=numout
      call fwrite(int2,1)
      int2=info
      call fwrite(int2,1)
      nwds=numout*4
      call fwrite(value(inames+1),nwds)
      call fwrite(nodpl2(itype2+1),numout)
      call fwrite(nodpl2(iseq2+1),numout)
      call fwrite(aprog(1),12)
      call clrmem(ibuff)
      call clrmem(inames)
      call clrmem(itypes)
      call clrmem(iseqs)
      return
      end

      subroutine codgen
      implicit double precision (a-h,o-z)
c
c     this routine generates machine instructions (for the cdc 6400) to
c lu-factor and solve the set of circuit equations.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
      logical memptr
      return
      end

      subroutine sorstp(itlim)
      implicit double precision (a-h,o-z)
c
c     this routine uses the source stepping method to solve the dc
c     operating point
c
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      bound=1.0d0/64
      fractn=1.0d0/16
c
c  step down sources
c
   10 fractn=fractn*2.0d0
      sfactr=sfactr*fractn
      if (sfactr.lt.bound) go to 100
      initf=2
      call iter8(itlim)
      rstats(6)=rstats(6)+iterno
      if (igoof.ne.0) go to 10
      fractn=2.0d0
c
c  step up sources
c
   20 sfactr=sfactr*fractn
      if (sfactr.le.1.0d0) go to 30
      sfactr=1.0d0
   30 initf=3
      call iter8(itlim)
      rstats(6)=rstats(6)+iterno
      if ((igoof.eq.0).and.(sfactr.eq.1.0d0)) go to 200
      if (igoof.eq.0) go to 20
c
c  step down if step up failed
c
   40 fractn=dsqrt(fractn)
      if (fractn.lt.1.0001d0) go to 100
      sfactr=sfactr/fractn
      initf=3
      call iter8(itlim)
      rstats(6)=rstats(6)+iterno
      if (igoof.ne.0) go to 40
      go to 20
c
c   finish with source stepping method
c
  100 igoof=1
      write(iofile,110)
  110 format('0 source stepping method failed')
  200 initf=2
      return
      end

      subroutine alter
      implicit double precision (a-h,o-z)
c
c     this routine changes the element or device parameters
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
      logical memptr
c
      integer xxor
      dimension lnod(50),lval(50)
      dimension chtitl(4)
      data chtitl / 8hchange f,8hollowing,8h paramet,8hers     /
      data lnod /10,14,16, 8,15,16,15,16,13, 8,
     1           18,38,27,35, 8, 8,35, 5, 5, 5,
     2            5, 5, 5, 5, 0, 0, 0, 0, 0, 0,
     3           21,21,21,21,21,21,21,21,21,21,
     4            8, 8, 8, 8, 8, 0, 0, 0, 0, 0 /
      data lval / 5, 4, 4, 2, 1, 1, 1, 1, 4, 4,
     1            3, 4, 4,16, 1, 1, 9, 2, 1, 1,
     2           19,55,17,46, 0, 0, 0, 0, 0, 0,
     3            1, 1, 1, 1, 1,17,17,17,17,17,
     4            1, 1, 1, 1, 1, 0, 0, 0, 0, 0 /
c
      call title (0,lwidth,1,chtitl)
      do 350 id=1,24
      loc=locate(id)
   10 if (loc.eq.0) go to 350
      if (nodplc(loc+lnod(id)-2).ne.numcyc) go to 300
      locv=nodplc(loc+1)
      loc1=locate(id)
   50 if (loc1.eq.0) go to 400
      if (nodplc(loc1+lnod(id)-2).ne.0) go to 400
      locv1=nodplc(loc1+1)
      if (xxor(value(locv),value(locv1)).eq.0) go to 100
      loc1=nodplc(loc1)
      go to 50
c
c  copy changed values to the original tables
c
c  copy real part
c
  100 call copy8(value(locv),value(locv1),lval(id))
      write (iofile,110) value(locv1)
  110 format ('********      ',a8,'      ********')
c
c  treat non-node tables specially
c
  200 if (id.ge.11) go to 300
      go to (300,210,220,300,230,240,230,240,260,260), id
  210 if (nodplc(loc+4).eq.1) go to 300
      if (memptr(nodplc(loc1+7))) call clrmem(nodplc(loc1+7))
      call cpytb8(loc+7,loc1+7)
      go to 300
  220 if (nodplc(loc+4).eq.1) go to 300
      if (memptr(nodplc(loc1+10))) call clrmem(nodplc(loc1+10))
      call cpytb8(loc+10,loc1+10)
      go to 300
  230 itab=5
      go to 250
  240 itab=6
  250 if (id.le.6) go to 255
      if (memptr(nodplc(loc1+itab+1))) call clrmem(nodplc(loc1+itab+1))
      call cpytb4(loc+itab+1,loc1+itab+1)
  255 if (memptr(nodplc(loc1+itab+2))) call clrmem(nodplc(loc1+itab+2))
      call cpytb4(loc+itab+2,loc1+itab+2)
      if (memptr(nodplc(loc1+itab+3))) call clrmem(nodplc(loc1+itab+3))
      call cpytb8(loc+itab+3,loc1+itab+3)
      if (memptr(nodplc(loc1+itab+4))) call clrmem(nodplc(loc1+itab+4))
      call cpytb8(loc+itab+4,loc1+itab+4)
      if (memptr(nodplc(loc1+itab+5))) call clrmem(nodplc(loc1+itab+5))
      call cpytb4(loc+itab+5,loc1+itab+5)
      if (memptr(nodplc(loc1+itab+6))) call clrmem(nodplc(loc1+itab+6))
      call cpytb8(loc+itab+6,loc1+itab+6)
      go to 300
  260 if (memptr(nodplc(loc1+5))) call clrmem(nodplc(loc1+5))
      call cpytb8(loc+5,loc1+5)
c
  300 loc=nodplc(loc)
      go to 10
  350 continue
      write (iofile,360)
  360 format (//)
      go to 500
c
  400 write (iofile,401) value(nodplc(loc1+1))
  401 format ('0*error*:  parameter change failed',/,
     1        '0*******:  ',a8,' is not in the original circuit')
      nogo=1
c
  500 return
      end

      subroutine cmeyer (vgs0,vgd0,vgb0,von0,vdsat0,vgs1,vgd1,vgb1,
     1   covlgs,covlgd,covlgb,cgs0,cgd0,cgb0,cgs1,cgd1,cgb1)
      implicit double precision (a-h,o-z)
c
c     this routine computes the mosfet overlap capacitances as functions
c of the device terminal voltages.
c
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=mosarg 3/15/83
      common /mosarg/ vto,beta,gamma,phi,phib,cox,xnsub,xnfs,xd,xj,xld,
     1   xlamda,uo,uexp,vbp,utra,vmax,xneff,xl,xw,vbi,von,vdsat,qspof,
     2   beta0,beta1,cdrain,xqco,xqc,fnarrw,fshort,lev
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
      indax=1
      vgs=vgs1
      vgd=vgd1
      vgb=vgb1
      vons=von
      vbs=vgs-vgb
      vdbsat=vdsat-vbs
      vdb=vgb-vgd
   10 vds=vgs-vgd
      vgbt=vgs-vons
      if (vgbt.gt.-phi) go to 100
      cgb=cox+covlgb
      cgd=covlgd
      cgs=covlgs
      go to 430
c
c
  100 if (vgbt.gt.-phi/2.0d0) go to 200
      cgb=-vgbt*cox/phi+covlgb
      cgd=covlgd
      cgs=covlgs
      go to 430
c
c
  200 if (vgbt.gt.0.0d0) go to 300
      cgb=-vgbt*cox/phi+covlgb
      cgd=covlgd
      cgs=cox/(7.5d-1*phi)*vgbt+cox/1.5d0+covlgs
      go to 430
c
c
  300 if (vdbsat.gt.vdb) go to 400
      cgb=covlgb
      cgd=covlgd
      cgs=cox/1.5d0+covlgs
      go to 430
c
c
  400 vddif=2.0d0*vdbsat-vdb
      vddif1=vdbsat-vdb-1.0d-12
      vddif2=vddif*vddif
      cgd=cox*(1.0d0-vdbsat*vdbsat/vddif2)/1.5d0+covlgd
      cgs=cox*(1.0d0-vddif1*vddif1/vddif2)/1.5d0+covlgs
      cgb=covlgb
c
c
  430 go to (440,560), indax
  440 indax=2
      cgs1=cgs
      cgd1=cgd
      cgb1=cgb
      vgs=vgs0
      vgd=vgd0
      vgb=vgb0
      vons=von0
      vbs=vgs-vgb
      vdbsat=vdsat0-vbs
      vdb=vgb-vgd
      go to 10
c
c
  560 cgs0=cgs
      cgd0=cgd
      cgb0=cgb
c
c  finished
c
 1000 return
      end

c spice version 2g.6  sccsid=ovtpvt.ma 3/15/83
      subroutine ovtpvt
      implicit double precision (a-h,o-z)
c
c
c     this routine generates the requested tabular listings of analysis
c results.  it calls plot to generate line-printer plots.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      complex cval
      dimension prform(3)
      dimension subtit(4,3)
      data subtit / 8hdc trans, 8hfer curv, 8hes      , 8h        ,
     1              8htransien, 8ht analys, 8his      , 8h        ,
     2              8hac analy, 8hsis     , 8h        , 8h         /
      data prform / 8h(1pe11.3, 8h,2x,8e00, 8h.00)     /
      data aper,rprn / 1h., 1h) /
c
      call second(t1)
      if (icalc.le.0) go to 1000
      call crunch
      if (nogo.lt.0) go to 1000
c
c  construct format statement to be used for printing the outputs
c
      ifract=max0(numdgt-1,0)
      ifwdth=ifract+9
      ipos=15
      call alfnum(ifwdth,prform,ipos)
      call move(prform,ipos,aper,1,1)
      ipos=ipos+1
      call alfnum(ifract,prform,ipos)
      call move(prform,ipos,rprn,1,1)
c
      noprln=min0(8,(lwidth-12)/ifwdth)
      if (mode-2) 50,60,300
   50 numout=jelcnt(41)+1
      go to 70
   60 numout=jelcnt(42)+1
c
c  dc and transient analysis printing
c
   70 loc=locate(30+mode)
   80 if (loc.eq.0) go to 200
      kntr=min0(noprln,nodplc(loc+3))
      if (kntr.le.0) go to 120
      call title(1,lwidth,1,subtit(1,mode))
      call setprn(loc)
c
c  get buffer space
c
      call getm8(locx,npoint)
      call getm8(locy,kntr*npoint)
c
c  interpolate outputs
c
      call ntrpl8(locx,locy,numpnt)
c
c  print outputs
c
      do 100 i=1,numpnt
      xvar=value(locx+i)
      locyt=locy
      do 90 k=1,kntr
      yvar(k)=value(locyt+i)
      locyt=locyt+npoint
   90 continue
      write (iofile,prform) xvar,(yvar(k),k=1,kntr)
  100 continue
      write (iofile,111)
  111 format(1hy)
      call clrmem(locx)
      call clrmem(locy)
  120 loc=nodplc(loc)
      go to 80
c
c  dc and transient analysis plotting
c
  200 loc=locate(35+mode)
  210 if (loc.eq.0) go to 250
      kntr=nodplc(loc+3)
      if (kntr.le.0) go to 220
      locv=nodplc(loc+1)
      call title(1,lwidth,1,subtit(1,mode))
      call setplt(loc)
c
c     get buffer space
c
      call getm8(locx,npoint)
      call getm8(locy,kntr*npoint)
c
c  interpolate outputs and load plot buffers
c
      call ntrpl8(locx,locy,numpnt)
      call plot(numpnt,locx,locy,locv)
      call clrmem(locx)
      call clrmem(locy)
  220 loc=nodplc(loc)
      go to 210
c
c  fourier analysis
c
  250 if (mode.eq.1) go to 1000
      if (nfour.eq.0) go to 1000
      if (nogo.ne.0) go to 1000
      call fouran
      go to 1000
c
c  ac analysis printing
c
  300 numout=jelcnt(43)+jelcnt(44)+jelcnt(45)+1
      do 599 id=33,35
      loc=locate(id)
  320 if (loc.eq.0) go to 599
      kntr=min0(noprln,nodplc(loc+3))
      if (kntr.le.0) go to 595
      call title(1,lwidth,1,subtit(1,mode))
      call setprn(loc)
c
c  print ac outputs
c
      lout=loutpt
      do 590 i=1,icalc
      xvar=dble(real(cvalue(lout+1)))
      do 500 k=1,kntr
      iseq=itab(k)
      iseq=nodplc(iseq+4)
      cval=cvalue(lout+iseq)
      ktype=itype(k)
      go to (450,450,430,440,450,450), ktype
  430 yvar(k)=dble(real(cval))
      go to 500
  440 yvar(k)=dble(aimag(cval))
      go to 500
  450 call magphs(cval,xmag,xphs)
      go to (460,460,430,440,470,465), ktype
  460 yvar(k)=xmag
      go to 500
  465 yvar(k)=20.0d0*dlog10(xmag)
      go to 500
  470 yvar(k)=xphs
  500 continue
      lout=lout+numout
  580 write (iofile,prform) xvar,(yvar(k),k=1,kntr)
  590 continue
      write (iofile,111)
  595 loc=nodplc(loc)
      go to 320
  599 continue
c
c  ac analysis plotting
c
      do 760 id=38,40
      loc=locate(id)
  610 if (loc.eq.0) go to 760
      kntr=nodplc(loc+3)
      if (kntr.le.0) go to 750
      locv=nodplc(loc+1)
      call title(1,lwidth,1,subtit(1,mode))
      call setplt(loc)
c
      call getm8(locx,icalc)
      call getm8(locy,kntr*icalc)
c
c     load plot buffers
c
      lout=loutpt
      do 710 i=1,icalc
      xvar=dble(real(cvalue(lout+1)))
      locyt=locy
      do 700 k=1,kntr
      iseq=itab(k)
      iseq=nodplc(iseq+4)
      cval=cvalue(lout+iseq)
      ktype=itype(k)
      go to (670,670,650,660,670,670), ktype
  650 yvr=dble(real(cval))
      go to 695
  660 yvr=dble(aimag(cval))
      go to 695
  670 call magphs(cval,xmag,xphs)
      go to (680,680,650,660,690,685), ktype
  680 yvr=dlog10(xmag)
      go to 695
  685 yvr=20.0d0*dlog10(xmag)
      go to 695
  690 yvr=xphs
  695 value(locyt+i)=yvr
      locyt=locyt+icalc
  700 continue
      value(locx+i)=xvar
      lout=lout+numout
  710 continue
      call plot(icalc,locx,locy,locv)
      call clrmem(locx)
      call clrmem(locy)
  750 loc=nodplc(loc)
      go to 610
  760 continue
c
c  finished
c
 1000 call clrmem(loutpt)
      call second(t2)
      rstats(11)=rstats(11)+t2-t1
      return
      end

      subroutine putnod(node)
      implicit double precision (a-h,o-z)
c
c     this routine adds 'node' to the list of user input nodes in table
c junode.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      jknt=0
   10 jknt=jknt+1
      if (jknt.gt.nunods) go to 20
      if (node-nodplc(junode+jknt)) 20,100,10
   20 k=nunods+1
      call extmem(junode,1)
      if (k.le.jknt) go to 30
      call copy4(nodplc(junode+jknt),nodplc(junode+jknt+1),k-jknt)
      k=jknt
   30 nodplc(junode+k)=node
      nunods=nunods+1
c
c  finished
c
  100 return
      end

      subroutine acasol
      implicit double precision (a-h,o-z)
c
c     this routine evaluates the response of the adjoint circuit by
c doing a forward/backward substitution step using the transpose of the
c circuit equation coefficient matrix.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c  evaluates adjoint response by doing forward/backward substitution on
c  the transpose of the y matrix
c
c  forward substitution
c
      do 20 i=2,nstop
      loc=i
      iord=nodplc(icswpf+i)
   10 loc=nodplc(irpt+loc)
      if (nodplc(irowno+loc).ge.i) go to 15
      j=nodplc(irowno+loc)
      jord=nodplc(icswpf+j)
      call cmult(value(lynl+loc),value(imynl+loc),
     1     value(lvn+jord),value(imvn+jord),xreal,ximag)
      value(lvn+iord)=value(lvn+iord)-xreal
      value(imvn+iord)=value(imvn+iord)-ximag
      go to 10
   15 jord=nodplc(irswpf+i)
      locnn=indxx(jord,iord)
      call cdiv(value(lvn+iord),value(imvn+iord),value(lynl+locnn),
     1     value(imynl+locnn),value(lvn+iord),value(imvn+iord))
   20 continue
c
c  backward substitution
c
      i=nstop
   30 i=i-1
      if (i.le.1) go to 60
      iord=nodplc(icswpf+i)
      loc=i
   35 loc=nodplc(irpt+loc)
   40 if (nodplc(irowno+loc).ne.i) go to 35
   50 loc=nodplc(irpt+loc)
      if (loc.eq.0) go to 30
      j=nodplc(irowno+loc)
      jord=nodplc(icswpf+j)
      call cmult(value(lynl+loc),value(imynl+loc),
     1     value(lvn+jord),value(imvn+jord),xreal,ximag)
      value(lvn+iord)=value(lvn+iord)-xreal
      value(imvn+iord)=value(imvn+iord)-ximag
      go to 50
c
c  reorder solution vector
c
   60 do 70 i=1,nstop
      j=nodplc(irswpr+i)
      k=nodplc(icswpf+j)
      value(ndiag+i)=value(lvn+k)
      value(ndiag+i+nstop)=value(imvn+k)
   70 continue
      call copy8(value(ndiag+1),value(lvn+1),nstop)
      call copy8(value(ndiag+1+nstop),value(imvn+1),nstop)
      do 120 i=2,nstop
      cvalue(lcvn+i)=cmplx(sngl(value(lvn+i)),sngl(value(imvn+i)))
  120 continue
      cvalue(lcvn+1)=cmplx(0.0e0,0.0e0)
c
c  finished
c
      return
      end

c spice version 2g.6  sccsid=dctran.ma 3/15/83
      subroutine dctran
      implicit double precision (a-h,o-z)
c
c
c     this routine controls the dc transfer curve, dc operating point,
c and transient analyses.  the variables mode and modedc (defined below)
c determine exactly which analysis is performed.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=cje 3/15/83
      common /cje/ maxtim,itime,icost
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
      logical memptr
c
c
      dimension subtit(4,2)
      dimension avhdr(3),avfrm(4)
      data avhdr / 8h( (2x,a4, 8h,3x,a7,3, 5hx)//) /
      data avfrm / 8h( (1h ,a, 8h1,i3,1h), 8h,f10.4,3, 4hx)/) /
      data anode, avltg / 4hnode, 7hvoltage /
      data subtit / 8hsmall si, 8hgnal bia, 8hs soluti, 8hon      ,
     1              8hinitial , 8htransien, 8ht soluti, 8hon      /
      data lprn /1h(/
      data ablnk, aletr, alett /1h , 1hr, 1ht /
c
c      the variables *mode*, *modedc*, and *initf* are used by spice to
c keep track of the state of the analysis.  the values of these flags
c (and the corresponding meanings) are as follows:
c
c        flag    value    meaning
c        ----    -----    -------
c
c        mode      1      dc analysis (subtype defined by *modedc*)
c                  2      transient analysis
c                  3      ac analysis (small signal)
c
c        modedc    1      dc operating point
c                  2      initial operating point for transient analysis
c                  3      dc transfer curve computation
c
c        initf     1      converge with 'off' devices allowed to float
c                  2      initialize junction voltages
c                  3      converge with 'off' devices held 'off'
c                  4      store small-signal parameters away
c                  5      first timepoint in transient analysis
c                  6      prediction step
c
c note:  *modedc* is only significant if *mode* = 1.
c
c
c  initialize
c
      call second(t1)
      sfactr=1.0d0
c.. don't take any chances with lx3, set to large number
      lx3=20000000
      lx2=20000000
c.. see if lx3 and lx2 tables are needed
      nolx2=0
      nolx3=0
   20 loctim=5
c
c.. post-processing initialization
c
      if(ipostp.eq.0) go to 25
      numcur=jelcnt(9)
      numpos=nunods+numcur
      call getm8(ibuff,numpos)
      numpos=numpos*4
      if(numcur.eq.0) go to 25
      loc=locate(9)
      loccur=nodplc(loc+6)-1
c
c...  set up format
c
   25 nvprln=4+(lwidth-72)/19
      nvprln=min0(nvprln,ncnods-1)
      ipos=2
      call alfnum(nvprln,avfrm,ipos)
      ipos=2
      call alfnum(nvprln,avhdr,ipos)
c...  allocate storage
      if (mode.eq.2) go to 35
      need=4*nstop+nttbr+nxtrm
      call avlm8(navl)
      if(need.le.navl) go to 30
c...  not enough memory for dc operating point analysis
      write(iofile,26) need,navl
   26 format('0insufficient memory available for dc analysis.',/
     1' memory required ',i6,', memory available ',i6,'.')
      nogo=1
      go to 1100
   30 call getm8(lvnim1,nstop)
      call getm8(lvn,nstop+nttbr)
      call slpmem(lvn,nstop)
      call getm8(lx0,nxtrm)
      call getm8(lvntmp,nstop)
      if (modedc.ne.3) go to 45
   35 call getm8(lx1,nxtrm)
      if(nolx2.eq.0) call getm8(lx2,nxtrm)
      if (mode.ne.2) go to 40
      if(nolx3.eq.0) call getm8(lx3,nxtrm)
      call getm8(ltd,0)
   40 call getm8(loutpt,0)
   45 call crunch
   50 if (mode.eq.2) go to 500
      time=0.0d0
      ag(1)=0.0d0
      call sorupd
      if (modedc.eq.3) go to 300
c
c
c  ....  single point dc analysis
c
c
c  compute dc operating point
c
  100 if (itl6.gt.0) go to 105
      initf=2
      call iter8(itl1)
      rstats(6)=rstats(6)+iterno
      if (igoof.ne.0) go to 150
      go to 110
  105 call sorstp(itl6)
      rstats(6)=rstats(6)+iterno
      if (igoof.ne.0) go to 150
  110 if (modedc.ne.1) go to 120
      initf=4
      call diode
      call bjt
      call jfet
      call mosfet
c
c  print operating point
c
  120 if ((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 1000
      call title(-1,lwidth,1,subtit(1,modedc))
      write (iofile,avhdr) (anode,avltg,i=1,nvprln)
      write (iofile,avfrm) (lprn,nodplc(junode+i),value(lvnim1+i),
     1  i=2,ncnods)
      go to 1000
c
c  no convergence
c
  150 nogo=1
      write (iofile,151)
  151 format('1*error*:  no convergence in dc analysis'/'0last node vol'
     1   ,'tages:'/)
      write (iofile,avhdr) (anode,avltg,i=1,nvprln)
      write (iofile,avfrm) (lprn,nodplc(junode+i),value(lvnim1+i),
     1  i=2,ncnods)
      go to 1000
c
c  ....  dc transfer curves
c
  300 numout=jelcnt(41)+1
      if(ipostp.ne.0) call pheadr(atitle)
      itemp=itcelm(1)
      locs=nodplc(itemp+1)
      anam=value(locs)
      call move(anam,2,ablnk,1,7)
      irdctc=0
      irdct2=0
      itdctc=0
      itdct2=0
      if (anam.eq.aletr) irdctc=1
      if (anam.eq.alett) itdctc=1
      temval=value(locs+1)
      icvfl2=1
      if(itcelm(2).eq.0) go to 310
      itemp=itcelm(2)
      locs2=nodplc(itemp+1)
      anam=value(locs2)
      call move(anam,2,ablnk,1,7)
      if (anam.eq.aletr) irdct2=1
      if (anam.eq.alett) itdct2=1
      temv2=value(locs2+1)
      value(locs2+1)=tcstar(2)
      temp=dabs((tcstop(2)-tcstar(2))/tcincr(2))+0.5d0
      icvfl2=idint(temp)+1
      icvfl2=max0(icvfl2,1)
  310 delta=tcincr(1)
      do 320 i=1,7
      delold(i)=delta
  320 continue
      icvfl1=icvflg/icvfl2
      value(locs+1)=tcstar(1)
      if ((itdctc.ne.1).and.(itdct2.ne.1)) go to 325
      itemno=3
      if (itdctc.eq.1) value(itemps+itemno)=value(locs+1)
      if (itdct2.eq.1) value(itemps+itemno)=value(locs2+1)
      call tmpupd
  325 if (irdctc.eq.1) value(locs+1)=1.0d0/value(locs+1)
      if (irdct2.eq.1) value(locs2+1)=1.0d0/value(locs2+1)
      icalc=0
      ical2=0
      loctim=3
  340 initf=2
      call iter8(itl1)
      rstats(4)=rstats(4)+iterno
      call copy8(value(lx0+1),value(lx1+1),nxtrm)
      if(nolx2.eq.0) call copy8(value(lx0+1),value(lx2+1),nxtrm)
      if (igoof.ne.0) go to 450
      go to 360
  350 call getcje
      if ((maxtim-itime).le.limtim) go to 460
      initf=6
      call iter8(itl2)
      rstats(4)=rstats(4)+iterno
      if (igoof.ne.0) go to 340
c
c  store outputs
c
  360 call extmem(loutpt,numout)
      loco=loutpt+icalc*numout
      icalc=icalc+1
      ical2=ical2+1
      value(loco+1)=value(locs+1)
      if (irdctc.eq.1) value(loco+1)=1.0d0/value(loco+1)
      loc=locate(41)
  370 if (loc.eq.0) go to 400
      if (nodplc(loc+5).ne.0) go to 380
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      iseq=nodplc(loc+4)
      value(loco+iseq)=value(lvnim1+node1)-value(lvnim1+node2)
      loc=nodplc(loc)
      go to 370
  380 iptr=nodplc(loc+2)
      iptr=nodplc(iptr+6)
      iseq=nodplc(loc+4)
      value(loco+iseq)=value(lvnim1+iptr)
      loc=nodplc(loc)
      go to 370
c
c  increment source value
c
  400 if(ipostp.eq.0) go to 410
      value(ibuff+1)=value(locs+1)
      call copy8(value(lvnim1+2),value(ibuff+2),nunods-1)
      if(numcur.ne.0) call copy8(value(lvnim1+loccur+1),
     1  value(ibuff+nunods+1),numcur)
      call fwrite(value(ibuff+1),numpos)
  410 if (icalc.ge.icvflg) go to 490
      if(ical2.ge.icvfl1) go to 480
      if(nolx2.ne.0) go to 420
      call ptrmem(lx2,itemp)
      call ptrmem(lx1,lx2)
      go to 430
  420 call ptrmem(lx1,itemp)
  430 call ptrmem(lx0,lx1)
      call ptrmem(itemp,lx0)
      value(locs+1)=tcstar(1)+dble(ical2)*delta
      if (itdctc.ne.1) go to 440
      value(itemps+itemno-1)=value(itemps+itemno)
      value(itemps+itemno)=value(locs+1)
      call tmpupd
  440 if (irdctc.eq.1) value(locs+1)=1.0d0/value(locs+1)
      go to 350
c
c  no convergence
c
  450 itemp=itcelm(1)
      loce=nodplc(itemp+1)
      write (iofile,451) value(loce),value(locs+1)
  451 format('1*error*:  no convergence in dc transfer curves at ',a8,
     1   ' = ',1pd10.3/'0last node voltages:'/)
      write (iofile,avhdr) (anode,avltg,i=1,nvprln)
      write (iofile,avfrm) (lprn,nodplc(junode+i),value(lvnim1+i),
     1  i=2,ncnods)
      go to 470
  460 write (iofile,461)
  461 format('0*error*:  cpu time limit exceeded ... analysis stopped'/)
      go to 470
  462 write(iofile,463)
  463 format('0*error*:   temperature sweep should be the second sweep
     1source, change the order and re-execute'/)
  470 nogo=1
      go to 490
c... reset first sweep variable ... step second
  480 ical2=0
      value(locs+1)=tcstar(1)
      if (irdctc.eq.1) value(locs+1)=1.0d0/value(locs+1)
      if (itdctc.eq.1) go to 462
      value(locs2+1)=value(locs2+1)+tcincr(2)
      if (irdct2.eq.1) value(locs2+1)=1.0d0/value(locs2+1)
      if (itdct2.ne.1) go to 340
      value(itemps+itemno-1)=value(itemps+itemno)
      value(itemps+itemno)=value(locs2+1)
      call tmpupd
      go to 340
c
c  finished with dc transfer curves
c
  490 value(locs+1)=temval
      if(itcelm(2).ne.0) value(locs2+1)=temv2
      if ((itdctc.eq.0).and.(itdct2.eq.0)) go to 1000
      value(itemps+itemno-1)=value(itemps+itemno)
      if (itdctc.eq.1) value(itemps+itemno)=temval
      if (itdct2.eq.1) value(itemps+itemno)=temv2
      write (iofile,492)
  492 format (/,'0*****0 return to original temperature 0*****0',/)
      call tmpupd
      itemno=1
      call relmem(itemps,2)
      if(ipostp.eq.0) go to 1000
      call fwrite(value(ibuff+1),numpos)
      go to 1000
c
c  ....  transient analysis
c
  500 numout=jelcnt(42)+1
      if(ipostp.ne.0) call pheadr(atitle)
c...  limit delmax if no energy-storage elements
      numese=jelcnt(2)+jelcnt(3)+jelcnt(11)+jelcnt(12)+jelcnt(13)
     1   +jelcnt(14)
      if (numese.eq.0) delmax=dmin1(delmax,tstep)
      initf=5
      iord=1
      loctim=9
      icalc=0
      numtp=0
      numrtp=0
      numnit=0
      time=0.0d0
      ibkflg=1
      delbkp=delmax
      nbkpt=1
      delta=delmax
      do 510 i=1,7
      delold(i)=delta
  510 continue
      delnew=delta
      delmin=1.0d-9*delmax
      go to 650
c
c  increment time, update sources, and solve next timepoint
c
  600 time=time+delta
      call sorupd
      if (nogo.ne.0) go to 950
      call getcje
      if ((maxtim-itime).le.limtim) go to 920
      if ((itl5.ne.0).and.(numnit.ge.itl5)) go to 905
      call comcof
      if (initf.ne.5) initf=6
      itrlim=itl4
      if ((numtp.eq.0).and.(nosolv.ne.0)) itrlim=itl1
      call iter8(itrlim)
      numnit=numnit+iterno
      numtp=numtp+1
      if (numtp.ne.1) go to 605
      if(nolx2.eq.0) call copy8(value(lx1+1),value(lx2+1),nxtrm)
      if(nolx3.eq.0) call copy8(value(lx1+1),value(lx3+1),nxtrm)
c.. note that time-point is cut when itrlim exceeded regardless
c.. of which time-step contol is specified thru 'lvltim'.
  605 if (igoof.eq.0) go to 610
      jord=iord
      iord=1
      if (jord.ge.5) call clrmem(lx7)
      if (jord.ge.4) call clrmem(lx6)
      if (jord.ge.3) call clrmem(lx5)
      if ((jord.ge.2).and.(method.ne.1)) call clrmem(lx4)
      igoof=0
      time=time-delta
      delta=delta/8.0d0
      go to 620
  610 delnew=delta
      if (numtp.eq.1) go to 630
      call trunc(delnew)
      if (delnew.ge.(0.9d0*delta)) go to 630
      time=time-delta
      delta=delnew
  620 numrtp=numrtp+1
      ibkflg=0
      delold(1)=delta
      if (delta.ge.delmin) go to 600
      time=time+delta
      go to 900
c
c  determine order of integration method
c
c...  skip if trapezoidal algorithm used
  630 if ((method.eq.1).and.(iord.eq.2)) go to 650
      if (numtp.eq.1) go to 650
      ordrat=1.05d0
      if (iord.gt.1) go to 635
      iord=2
      call trunc(delnew)
      iord=1
      if ((delnew/delta).le.ordrat) go to 650
      if (maxord.le.1) go to 650
      iord=2
      if (method.eq.1) go to 650
      call getm8(lx4,nxtrm)
      go to 650
  635 if (iord.lt.maxord) go to 640
      iord=iord-1
      call trunc(delnew)
      iord=iord+1
      if ((delnew/delta).le.ordrat) go to 650
      go to 642
  640 iord=iord-1
      call trunc(delnew)
      iord=iord+1
      if ((delnew/delta).le.ordrat) go to 645
  642 iord=iord-1
      if (iord.eq.1) call clrmem(lx4)
      if (iord.eq.2) call clrmem(lx5)
      if (iord.eq.3) call clrmem(lx6)
      if (iord.eq.4) call clrmem(lx7)
      go to 650
  645 iord=iord+1
      call trunc(delnew)
      iord=iord-1
      if ((delnew/delta).le.ordrat) go to 650
      iord=iord+1
      if (iord.eq.2) call getm8(lx4,nxtrm)
      if (iord.eq.3) call getm8(lx5,nxtrm)
      if (iord.eq.4) call getm8(lx6,nxtrm)
      if (iord.eq.5) call getm8(lx7,nxtrm)
c
c  store outputs
c
  650 if ((time+delta).le.tstart) go to 685
      if ((numtp.eq.0).and.(nosolv.ne.0)) go to 685
      call extmem(loutpt,numout)
      loco=loutpt+icalc*numout
      icalc=icalc+1
      value(loco+1)=time
      loc=locate(42)
  670 if (loc.eq.0) go to 682
      if (nodplc(loc+5).ne.0) go to 680
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      iseq=nodplc(loc+4)
      value(loco+iseq)=value(lvnim1+node1)-value(lvnim1+node2)
      loc=nodplc(loc)
      go to 670
  680 iptr=nodplc(loc+2)
      iptr=nodplc(iptr+6)
      iseq=nodplc(loc+4)
      value(loco+iseq)=value(lvnim1+iptr)
      loc=nodplc(loc)
      go to 670
  682 if(ipostp.eq.0) go to 684
      value(ibuff+1)=time
      call copy8(value(lvnim1+2),value(ibuff+2),nunods-1)
      if(numcur.ne.0) call copy8(value(lvnim1+loccur+1),
     1  value(ibuff+nunods+1),numcur)
      call fwrite(value(ibuff+1),numpos)
  684 continue
c
c  update transmission line delay table
c
  685 if (jelcnt(17).eq.0) go to 694
      call sizmem(ltd,ltdsiz)
      numtd=ltdsiz/ntlin
      if (numtd.le.3) go to 689
      baktim=time-tdmax
      if (baktim.lt.0.0d0) go to 689
      lcntr=0
      ltemp=ltd
      do 686 i=1,numtd
      if (value(ltemp+1).ge.baktim) go to 687
      ltemp=ltemp+ntlin
      lcntr=lcntr+1
  686 continue
      go to 689
  687 if (lcntr.le.2) go to 689
      lcntr=lcntr-2
      nwords=lcntr*ntlin
      ltemp=ltemp-ntlin-ntlin
      call copy8(value(ltemp+1),value(ltd+1),ltdsiz-nwords)
      call relmem(ltd,nwords)
      call sizmem(ltd,ltdsiz)
  689 call extmem(ltd,ntlin)
      ltdptr=ltd+ltdsiz
      value(ltdptr+1)=time
      loc=locate(17)
  690 if (loc.eq.0) go to 693
      locv=nodplc(loc+1)
      z0=value(locv+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      ibr1=nodplc(loc+8)
      ibr2=nodplc(loc+9)
      lspot=nodplc(loc+30)+ltdptr
      if ((initf.eq.5).and.(nosolv.ne.0)) go to 691
      value(lspot)=value(lvnim1+node3)-value(lvnim1+node4)
     1   +value(lvnim1+ibr2)*z0
      value(lspot+1)=value(lvnim1+node1)-value(lvnim1+node2)
     1   +value(lvnim1+ibr1)*z0
      go to 692
  691 value(lspot)=value(locv+7)+value(locv+8)*z0
      value(lspot+1)=value(locv+5)+value(locv+6)*z0
  692 loc=nodplc(loc)
      go to 690
c
c  add two *fake* backpoints to ltd for interpolation near time=0.0d0
c
  693 if (numtd.ne.0) go to 694
      call extmem(ltd,ntlin+ntlin)
      call copy8(value(ltd+1),value(ltd+ntlin+1),ntlin)
      call copy8(value(ltd+1),value(ltd+2*ntlin+1),ntlin)
      value(ltd+2*ntlin+1)=time
      value(ltd+ntlin+1)=time-delta
      value(ltd+1)=time-delta-delta
c
c  rotate state vector storage
c
c.. time-point accepted
  694 call copy8(delold(1),delold(2),6)
      delta=delnew
      delold(1)=delta
      go to (710,706,702,698,696,696), iord
  696 call ptrmem(lx7,itemp)
      call ptrmem(lx6,lx7)
      go to 700
  698 call ptrmem(lx6,itemp)
  700 call ptrmem(lx5,lx6)
      go to 704
  702 call ptrmem(lx5,itemp)
  704 call ptrmem(lx4,lx5)
      go to 708
  706 if (method.eq.1) go to 710
      call ptrmem(lx4,itemp)
  708 call ptrmem(lx3,lx4)
      go to 713
  710 if(nolx3.eq.0) go to 712
      if(nolx2.eq.0) go to 711
      call ptrmem(lx1,itemp)
      go to 714
  711 call ptrmem(lx2,itemp)
      call ptrmem(lx1,lx2)
      go to 714
  712 call ptrmem(lx3,itemp)
  713 call ptrmem(lx2,lx3)
      call ptrmem(lx1,lx2)
  714 call ptrmem(lx0,lx1)
      call ptrmem(itemp,lx0)
c
c  check breakpoints
c
  750 if (ibkflg.eq.0) go to 760
c.. just accepted analysis at breakpoint
      jord=iord
      iord=1
      if (jord.ge.5) call clrmem(lx7)
      if (jord.ge.4) call clrmem(lx6)
      if (jord.ge.3) call clrmem(lx5)
      if ((jord.ge.2).and.(method.ne.1)) call clrmem(lx4)
      ibkflg=0
      nbkpt=nbkpt+1
      if (nbkpt.gt.numbkp) go to 950
      temp=dmin1(delbkp,value(lsbkpt+nbkpt)-time)
      delta=dmin1(delta,0.1d0*temp,delmax)
      if (numtp.eq.0) delta=delta/10.0d0
      delold(1)=delta
      go to 600
  760 del1=value(lsbkpt+nbkpt)-time
      if ((1.01d0*delta).le.del1) go to 600
      ibkflg=1
      delbkp=delta
      delta=del1
      delold(1)=delta
      go to 600
c
c  transient analysis failed
c
  900 write (iofile,901)
  901 format('1*error*:  internal timestep too small in transient analys
     1is'/)
      go to 910
  905 write (iofile,906) itl5
  906 format('1*error*:  transient analysis iterations exceed limit of '
     1,i5,/'0this limit may be overridden using the itl5 parameter on th
     2e .option card')
  910 write (iofile,911) time,delta,numnit
  911 format(1h0,10x,'time = ',1pd12.5,';  delta = ',d12.5,';  numnit =
     1',i6/)
      write (iofile,916)
  916 format(1h0/'0last node voltages:'/)
      write (iofile,avhdr) (anode,avltg,i=1,nvprln)
      write (iofile,avfrm) (lprn,nodplc(junode+i),value(lvnim1+i),
     1  i=2,ncnods)
      go to 930
  920 write (iofile,921) time
  921 format('0*error*:  cpu time limit exceeded in transient analysis '
     1   ,'at time = ',1pd13.6/)
  930 nogo=1
c
c  finished with transient analysis
c
  950 rstats(10)=rstats(10)+numnit
      rstats(30)=rstats(30)+numtp
      rstats(31)=rstats(31)+numrtp
      rstats(32)=rstats(32)+numnit
      if(ipostp.eq.0) go to 1000
      if (ipostp.ne.0) call clsraw
c
c  return unneeded memory
c
 1000 if (mode.eq.2) go to 1010
      if (modedc.ne.3) go to 1100
 1010 call clrmem(lvnim1)
      call clrmem(lx0)
      call clrmem(lvn)
      call clrmem(lx1)
      if (memptr(macins)) call clrmem(macins)
      if(nolx2.eq.0) call clrmem(lx2)
      call clrmem(lvntmp)
      if ((mode.eq.1).and.(modedc.eq.3)) go to 1020
      if(nolx3.eq.0) call clrmem(lx3)
      if (mode.eq.1) go to 1020
      call clrmem(ltd)
      if (iord.eq.1) go to 1020
      if (method.eq.1) go to 1020
      call clrmem(lx4)
      if (iord.eq.2) go to 1020
      call clrmem(lx5)
      if (iord.eq.3) go to 1020
      call clrmem(lx6)
      if (iord.eq.4) go to 1020
      call clrmem(lx7)
 1020 call extmem(loutpt,2*numout)
 1100 if(ipostp.ne.0) call clrmem(ibuff)
      call second(t2)
      rstats(loctim)=rstats(loctim)+t2-t1
      return
      end

      integer function nxtevn(n)
c
c.. function returns the smallest value nxtevn greater than or equal to
c.. n which is evenly divisible by 'nwd4, nwd8, and nwd16' as defined
c.. in setmem
c
      nxtevn=((n+3)/4)*4
      return
      end

      subroutine moseq2(vds,vbs,vgs,gm,gds,gmbs,
     1   qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      implicit double precision (a-h,o-z)
c
c     this routine evaluates the drain current, its derivatives and
c     the charges associated with the gate, channel and bulk
c     for mosfets
c
c spice version 2g.6  sccsid=mosarg 3/15/83
      common /mosarg/ vto,beta,gamma,phi,phib,cox,xnsub,xnfs,xd,xj,xld,
     1   xlamda,uo,uexp,vbp,utra,vmax,xneff,xl,xw,vbi,von,vdsat,qspof,
     2   beta0,beta1,cdrain,xqco,xqc,fnarrw,fshort,lev
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c
      dimension a4(4),b4(4),x4(8),poly4(8),sig1(4),sig2(4)
      data sig1 / 1.0d0, -1.0d0, 1.0d0, -1.0d0/,
     1     sig2 / 1.0d0,  1.0d0,-1.0d0, -1.0d0/
c
c     icharg=1 causes charges to be computed
c     icharg=0 bypasses the computation of charges
c
      icharg=1
      if (mode.ne.1.and.xqco.le.0.5d0) go to 100
      icharg=0
      if (xqco.gt.0.5d0) go to 100
      if (modedc.eq.2.and.nosolv.ne.0) icharg=1
      if (initf.eq.4) icharg=1
c
c  compute some useful quantities
c
  100 if (vbs.gt.0.0d0) go to 110
      sarg=dsqrt(phi-vbs)
      tsarg=sarg+sarg
      dsrgdb=-0.5d0/sarg
      d2sdb2=+0.5d0*dsrgdb/(phi-vbs)
      go to 120
  110 sphi=dsqrt(phi)
      sphi3=phi*sphi
      sarg=sphi/(1.0d0+0.5d0*vbs/phi)
      tsarg=sarg+sarg
      dsrgdb=-0.5d0*sarg*sarg/sphi3
      d2sdb2=-dsrgdb*sarg/sphi3
  120 if ((vds-vbs).lt.0.0d0) go to 130
      barg=dsqrt(phi+vds-vbs)
      dbrgdb=-0.5d0/barg
      d2bdb2=+0.5d0*dbrgdb/(phi+vds-vbs)
      go to 200
  130 barg=sphi/(1.0d0+0.5d0*(vbs-vds)/phi)
      dbrgdb=-0.5d0*barg*barg/sphi3
      d2bdb2=-dbrgdb*barg/sphi3
c
c  calculate threshold voltage (von)
c     narrow-channel effect
c
  200 factor=0.125d0*fnarrw*twopi*epssil/cox*xl
      eta=1.0d0+factor
      vbin=vbi+factor*(phi-vbs)
      if (gamma.le.0.0d0) go to 215
      if (xnsub.le.0.0d0) go to 215
      xwd=xd*barg
      xws=xd*sarg
c
c     short-channel effect with vds .ne. 0.0d0
c
      argss=0.0d0
      argsd=0.0d0
      dbargs=0.0d0
      dbargd=0.0d0
      dgdvds=0.0d0
      dgddb2=0.0d0
      if (xj.le.0.0d0) go to 205
      argxs=1.0d0+2.0d0*xws/xj
      args=dsqrt(argxs)
      argss=0.5d0*xj/xl*(args-1.0d0)
      argxd=1.0d0+2.0d0*xwd/xj
      argd=dsqrt(argxd)
      argsd=0.5d0*xj/xl*(argd-1.0d0)
  205 gamasd=gamma*(1.0d0-argss-argsd)
      gamass=gamma*(1.0d0-2.0d0*argss)
      dbxwd=xd*dbrgdb
      dbxws=xd*dsrgdb
      if (xj.le.0.0d0) go to 210
      dbargs=0.5d0/xl*dbxws/args
      dbargd=0.5d0/xl*dbxwd/argd
      dasdb2=-xd*( d2sdb2+dsrgdb*dsrgdb*xd/(xj*argxs) )/(xl*args)
      daddb2=-xd*( d2bdb2+dbrgdb*dbrgdb*xd/(xj*argxd) )/(xl*argd)
      dgddb2=-0.5d0*gamma*(dasdb2+daddb2)
  210 dgddvb=-gamma*(dbargs+dbargd)
      dgsdvb=-2.0d0*gamma*dbargs
      if (xj.le.0.0d0) go to 220
      ddxwd=-dbxwd
      dgdvds=-gamma*0.5d0/xl*ddxwd/argd
      go to 220
  215 gamasd=gamma
      gamass=gamma
      gammad=gamma
      dgddvb=0.0d0
      dgsdvb=0.0d0
      dgdvds=0.0d0
      dgddb2=0.0d0
  220 von=vbin+gamasd*sarg
c     write(iofile,221) von,vbin,vbi,gamasd,argss,argsd,xj
  221 format ('0msg1:'/1p7d10.2)
      vth=von
      vdsat=0.0d0
  225 if (xnfs.eq.0.0d0.or.cox.eq.0.0d0) go to 230
      cfs=charge*xnfs
      cdonco=-(gamasd*dsrgdb+dgddvb*sarg)+factor
      xn=1.0d0+cfs/cox*xw*xl+cdonco
      von=von+vt*xn
c     write (iofile,226) von,cdonco,xn,cfs,xd
  226 format(' msg2:'/1p6d10.2)
      argg=1.0d0/(vt*xn)
      vgst=vgs-von
      go to 300
  230 vgst=vgs-von
      if (vgs.gt.von) go to 300
c
c  cutoff region
c
      gds=0.0d0
      go to 1050
c
c  compute some more useful quantities
c
  300 sarg3=sarg*sarg*sarg
      sbiarg=dsqrt(phib)
      gammad=gamasd
      dgdvbs=dgddvb
      body=barg*barg*barg-sarg3
      gdbdv=2.0d0*gammad*(barg*barg*dbrgdb-sarg*sarg*dsrgdb)
      dodvbs=-factor+dgdvbs*sarg+gammad*dsrgdb
      if (xnfs.eq.0.0d0) go to 400
      if (cox.eq.0.0d0) go to 410
      dxndvb=2.0d0*dgdvbs*dsrgdb+gammad*d2sdb2+dgddb2*sarg
      dodvbs=dodvbs+vt*dxndvb
      dxndvd=dgdvds*dsrgdb
      dodvds=dgdvds*sarg+vt*dxndvd
c
c  evaluate effective mobility and its derivatives
c
  400 if (cox.le.0.0d0) go to 410
      udenom=vgst
      if (udenom.le.vbp) go to 410
      ufact=dexp(uexp*dlog(vbp/udenom))
      ueff=uo*ufact
      dudvgs=-ufact*uexp/udenom
      dudvds=0.0d0
      dudvbs=uexp*ufact*dodvbs/vgst
      go to 500
  410 ufact=1.0d0
      ueff=uo
      dudvgs=0.0d0
      dudvds=0.0d0
      dudvbs=0.0d0
c
c     evaluate saturation voltage and its derivatives according to
c     grove-frohman equation
c
  500 vgsx=vgs
      gammad=gamasd/eta
      dgdvbs=dgddvb
      if (xnfs.ne.0.0d0.and.cox.ne.0.0d0)
     1   vgsx=dmax1(vgs,von)
  505 if (gammad.le.0.0d0) go to 535
      gammd2=gammad*gammad
      argv=(vgsx-vbin)/eta+phi-vbs
      if (argv.le.0.0d0) go to 540
      arg=dsqrt(1.0d0+4.0d0*argv/gammd2)
      vdsat=(vgsx-vbin)/eta+gammd2*(1.0d0-arg)/2.0d0
      vdsat=dmax1(vdsat,0.0d0)
  510 if (icharg.eq.0) go to 530
      arg1=gammd2/(eta*eta)
      arg2=vds-0.5d0*arg1
      argsq=(arg2+0.5d0*arg1+phi-vbs)*arg1
      if (argsq.ge.0.0d0) go to 515
      vpof=vth
      go to 520
  515 vpof=vbin+eta*(arg2+0.5d0*arg1+dsqrt(argsq))
  520 argv1=(vpof-vbin)/eta+phi-vbs
      if (argv1.gt.0.0d0) go to 525
      vdsat1=0.0d0
      go to 530
  525 arg1=dsqrt(1.0d0+4.0d0*argv1/gammd2)
      vdsat1=(vpof-vbin)/eta+gammd2*(1.0d0-arg1)/2.0d0
      vdsat1=dmax1(vdsat1,0.0d0)
  530 dsdvgs=(1.0d0-1.0d0/arg)/eta
      dsdvbs=(gammad*(1.0d0-arg)+2.0d0*argv/(gammad*arg))/eta*dgdvbs+
     1       1.0d0/arg+factor*dsdvgs
      go to 545
  535 vdsat=dmax1((vgsx-vbin)/eta,0.0d0)
      vpof=dmax1((eta*vds+vbin),0.0d0)
      vdsat1=dmax1((vpof-vbin)/eta,0.0d0)
      dsdvgs=1.0d0
      dsdvbs=0.0d0
      go to 545
  540 vdsat=0.0d0
      vpof=vth
      vdsat1=0.0d0
      dsdvgs=0.0d0
      dsdvbs=0.0d0
c
c     store vdsat as above in vpof (pinch-off)
c
  545 if (vmax.le.0.0d0) go to 600
c
c     evaluate saturation voltage and its derivatives according to
c     baum's theory of scattering velocity saturation
c
      gammd2=gammad*gammad
      v1=(vgsx-vbin)/eta+phi-vbs
      v2=phi-vbs
      xv=vmax*xl/ueff
      a1=gammad/0.75d0
      b1=-2.0d0*(v1+xv)
      c1=-2.0d0*gammad*xv
      d1=2.0d0*v1*(v2+xv)-v2*v2-4.0d0/3.0d0*gammad*sarg3
      a=-b1
      b=a1*c1-4.0d0*d1
      c=-d1*(a1*a1-4.0d0*b1)-c1*c1
      r=-a*a/3.0d0+b
      s=2.0d0*a*a*a/27.0d0-a*b/3.0d0+c
      r3=r*r*r
      s2=s*s
      p=s2/4.0d0+r3/27.0d0
      p0=dabs(p)
      p2=dsqrt(p0)
      if (p.ge.0.0d0) go to 550
      ro=dsqrt(s2/4.0d0+p0)
      ro=dlog(ro)/3.0d0
      ro=dexp(ro)
      fi=datan(-2.0d0*p2/s)
      y3=2.0d0*ro*dcos(fi/3.0d0)-a/3.0d0
      go to 560
  550 p3=dexp(dlog(dabs(-s/2.0d0+p2))/3.0d0)
      p4=dexp(dlog(dabs(-s/2.0d0-p2))/3.0d0)
      y3=p3+p4-a/3.0d0
  560 iknt=0
      a3=dsqrt(a1*a1/4.0d0-b1+y3)
      b3=dsqrt(y3*y3/4.0d0-d1)
      do 570 i=1,4
      a4(i)=a1/2.0d0+sig1(i)*a3
      b4(i)=y3/2.0d0+sig2(i)*b3
      delta4=a4(i)*a4(i)/4.0d0-b4(i)
      if (delta4.lt.0.0d0) go to 570
      iknt=iknt+1
      x4(iknt)=-a4(i)/2.0d0+dsqrt(delta4)
      iknt=iknt+1
      x4(iknt)=-a4(i)/2.0d0-dsqrt(delta4)
  570 continue
      jknt=0
      do 580 j=1,iknt
      if (x4(j).le.0.0d0) go to 580
      poly4(j)=x4(j)*x4(j)*x4(j)*x4(j)+a1*x4(j)*x4(j)*x4(j)
      poly4(j)=poly4(j)+b1*x4(j)*x4(j)+c1*x4(j)+d1
      if (dabs(poly4(j)).gt.1.0d-6) go to 580
      jknt=jknt+1
      if (jknt.gt.1) go to 575
      xvalid=x4(j)
  575 if (x4(j).gt.xvalid) go to 580
      xvalid=x4(j)
  580 continue
      if (jknt.gt.0) go to 590
      ivmflg=ivmflg+1
      go to 600
  590 vdsat=xvalid*xvalid+vbs-phi
c
c  evaluate effective channel length and its derivatives
c
  600 if (vds.eq.0.0d0) go to 610
      gammad=gamasd
      if ((vbs-vdsat).gt.0.0d0) go to 601
      bsarg=dsqrt(vdsat-vbs+phi)
      dbsrdb=-0.5d0/bsarg
      go to 602
  601 bsarg=sphi/(1.0d0+0.5d0*(vbs-vdsat)/phi)
      dbsrdb=-0.5d0*bsarg*bsarg/sphi3
  602 bodys=bsarg*bsarg*bsarg-sarg3
      gdbdvs=2.0d0*gammad*(bsarg*bsarg*dbsrdb-sarg*sarg*dsrgdb)
      if (vmax.gt.0.0d0) go to 603
      if (xnsub.eq.0.0d0) go to 610
      if (xlamda.gt.0.0d0) go to 610
      argv=(vds-vdsat)/4.0d0
      sargv=dsqrt(1.0d0+argv*argv)
      arg=dsqrt(argv+sargv)
      xlfact=xd/(xl*vds)
      xlamda=xlfact*arg
      dldsat=vds*xlfact*arg/(8.0d0*sargv)
      go to 605
  603 argv=(vgsx-vbin)/eta-vdsat
      xdv=xd/dsqrt(xneff)
      xlv=vmax*xdv/(2.0d0*ueff)
      vqchan=argv-gammad*bsarg
      dqdsat=-1.0d0+gammad*dbsrdb
      vl=vmax*xl
      dfunds=vl*dqdsat-ueff*vqchan
      dfundg=(vl-ueff*vdsat)/eta
      dfundb=-vl*(1.0d0+dqdsat-factor/eta)+
     1        ueff*(gdbdvs-dgdvbs*bodys/1.5d0)/eta
      dsdvgs=-dfundg/dfunds
      dsdvbs=-dfundb/dfunds
      if (xnsub.eq.0.0d0) go to 610
      if (xlamda.gt.0.0d0) go to 610
      argv=dmax1(vds-vdsat,0.0d0)
      xls=dsqrt(xlv*xlv+argv)
      dldsat=xdv/(2.0d0*xls)
      xlfact=xdv/(xl*vds)
      xlamda=xlfact*(xls-xlv)
      dldsat=dldsat/xl
  605 dldvgs=dldsat*dsdvgs
      dldvds=-xlamda+dldsat
      dldvbs=dldsat*dsdvbs
      go to 620
  610 dldvgs=0.0d0
      dldvds=0.0d0
      dldvbs=0.0d0
c
c     limit channel shortening at punch-through
c
  620 xwb=xd*sbiarg
      xld=xl-xwb
      clfact=1.0d0-xlamda*vds
      dldvds=-xlamda-dldvds
      xleff=xl*clfact
      deltal=xlamda*vds*xl
      if (xnsub.eq.0.0d0) xwb=0.25d-6
      if (xleff.ge.xwb) go to 700
      xleff=xwb/(1.0d0+(deltal-xld)/xwb)
      clfact=xleff/xl
      dfact=xleff*xleff/(xwb*xwb)
      dldvgs=dfact*dldvgs
      dldvds=dfact*dldvds
      dldvbs=dfact*dldvbs
c
c  evaluate effective beta (effective kp)
c
  700 beta1=beta*ufact/clfact
c
c  test for mode of operation and branch appropriately
c
      gammad=gamasd
      dgdvbs=dgddvb
      if (vds.gt.1.0d-8) go to 730
      if (vgs.gt.von) go to 720
      if ((xnfs.ne.0.0d0).and.(cox.ne.0.0d0)) go to 710
      gds=0.0d0
      go to 1050
c
  710 gds=beta1*(von-vbin-gammad*sarg)*dexp(argg*(vgs-von))
      go to 1050
c
c
  720 gds=beta1*(vgs-vbin-gammad*sarg)
      go to 1050
c
  730 if (vgs.gt.von) go to 900
c
c  subthreshold region
c
      if (vdsat.gt.0.0d0) go to 830
      gds=0.0d0
      if (vgs.gt.vth) go to 1020
      go to 1050
  830 vdson=dmin1(vdsat,vds)
      if (vds.le.vdsat) go to 850
      barg=bsarg
      dbrgdb=dbsrdb
      body=bodys
      gdbdv=gdbdvs
  850 cdson=beta1*((von-vbin-eta*vdson*0.5d0)*vdson-gammad*body/1.5d0)
      didvds=beta1*(von-vbin-eta*vdson-gammad*barg)
      gdson=-cdson*dldvds/clfact-beta1*dgdvds*body/1.5d0
      if (vds.lt.vdsat) gdson=gdson+didvds
      gbson=-cdson*dldvbs/clfact
     1      +beta1*(dodvbs*vdson+factor*vdson-dgdvbs*body/1.5d0-gdbdv)
      if (vds.gt.vdsat) gbson=gbson+didvds*dsdvbs
      expg=dexp(argg*(vgs-von))
      cdrain=cdson*expg
      gmw=cdrain*argg
      gm=gmw
      if (vds.gt.vdsat) gm=gmw+didvds*dsdvgs*expg
      gds=gdson*expg-gm*dodvds-gmw*(vgs-von)*dxndvd/xn
      gmbs=gbson*expg-gm*dodvbs-gmw*(vgs-von)*dxndvb/xn
      go to 1020
c
c
  900 if (vds.gt.vdsat) go to 1000
c
c  linear region
c
      cdrain=beta1*((vgs-vbin-eta*vds/2.0d0)*vds-gammad*body/1.5d0)
      arg=cdrain*(dudvgs/ufact-dldvgs/clfact)
      gm=arg+beta1*vds
      arg=cdrain*(dudvds/ufact-dldvds/clfact)
      gds=arg+beta1*(vgs-vbin-eta*vds-
     1   gammad*barg-dgdvds*body/1.5d0)
      arg=cdrain*(dudvbs/ufact-dldvbs/clfact)
      gmbs=arg-beta1*(gdbdv+dgdvbs*body/1.5d0-factor*vds)
      go to 1020
c
c  saturation region
c
 1000 cdrain=beta1*((vgs-vbin-eta*vdsat/2.0d0)*vdsat-gammad*bodys/1.5d0)
      arg=cdrain*(dudvgs/ufact-dldvgs/clfact)
      gm=arg+beta1*vdsat+
     1   beta1*(vgs-vbin-eta*vdsat-gammad*bsarg)*dsdvgs
      gds=-cdrain*dldvds/clfact-beta1*dgdvds*bodys/1.5d0
      arg=cdrain*(dudvbs/ufact-dldvbs/clfact)
      gmbs=arg-beta1*(gdbdvs+dgdvbs*bodys/1.5d0-factor*vdsat)+
     1     beta1*(vgs-vbin-eta*vdsat-gammad*bsarg)*dsdvbs
c
c     compute charges for "on" region
c
 1020 if (icharg.eq.0) go to 1500
      if (vgs.le.vth) go to 1070
      call mqspof(vds,vbs,vgs,vpof,vdsat1,vth,vbin,gamasd,
     1   qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      go to 2000
c
c  finish special cases
c
 1050 cdrain=0.0d0
      gm=0.0d0
      gmbs=0.0d0
 1070 xqc=xqco
      if (icharg.eq.0) go to 1500
      call mosq2(vds,vbs,vgs,vdsat,vth,vbin,gamasd,cox,phi,
     1   qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      qspof=0.0d0
      go to 2000
c
c  finished
c
 1500 qg=0.0d0
      qb=0.0d0
      qc=0.0d0
      qspof=0.0d0
 2000 return
      end

      subroutine dcdcmp
      implicit double precision (a-h,o-z)
c
c     this routine swaps rows and columns in the coefficient matrix accor-
c ding to the numerical pivoting and minimum fillin terms.it then performs
c an in-place lu factorization of the coefficient matrix.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=debug 3/15/83
      common/debug/ idebug(20)
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      call second(t1)
      if (ipiv.le.0) go to 12
      if (idebug(11).le.0) go to  3
      call dmpmat(6hdcdcmp)
      idebug(11)=idebug(11)-1
    3 do 10 i=2,nstop
      no=0
      loc=nodplc(jcpt+i)
    5 if (loc.eq.0) go to 7
      no=no+1
      loc=nodplc(jcpt+loc)
      go to 5
    7 nodplc(numoff+i)=no
      no=0
      loc=nodplc(irpt+i)
    8 if (loc.eq.0) go to 9
      no=no+1
      loc=nodplc(irpt+loc)
      go to 8
    9 nodplc(nmoffc+i)=no
   10 continue
   12 n=1
c
c     find next pivot
c
   15 n=n+1
      if (ipiv.gt.0) go to 20
      if (idebug(13).le.0) go to 17
      call dmpmat(6hdcdcm2)
      idebug(13)=idebug(13)-1
   17 if (idebug(14).le.0) go to 18
      if (mode.ne.2) go to 18
      call dmpmat(6hdcdcm3)
      idebug(14)=idebug(14)-1
   18 if (idebug(15).le.0.or.icalc.le.10) go to 19
      call dmpmat(6hdcdcm4)
      idebug(15)=idebug(15)-1
   19 nxti=n
      nxtj=n
      go to 120
c
c     search the coresponding column for max entry
c
   20 vmax=0.0d0
      loci=n
   25 loci=nodplc(irpt+loci)
      if (loci.eq.0) go to 50
      i=nodplc(irowno+loci)
      if (i.lt.n) go to 25
   30 if (dabs(value(lvn+loci)).le.vmax) go to 25
      vmax=dabs(value(lvn+loci))
      go to 25
   50 if (vmax.gt.pivtol) go to 60
      write(iofile,51) n,vmax
   51 format('0*error*:  maximum entry in this column at step ',i4,' (',
     1   1pd12.6,') is less than pivtol')
      igoof=1
      return
   60 epsrel=dmax1(pivrel*vmax,pivtol)
      if (n.ge.nstop) go to 200
      if (ipiv.le.0) go to 120
c
c     pivoting on the diagonal
c
      minop=100000
      nxti=0
      do 70 i=n,nstop
      i1=nodplc(irswpf+i)
      j1=nodplc(icswpf+i)
      ispot=indxx(i1,j1)
      if (ispot.eq.1) go to 70
      if (dabs(value(lvn+ispot)).lt.epsrel) go to 70
      nop=(nodplc(numoff+i)-1)*(nodplc(nmoffc+i)-1)
      if (nop.ge.minop) go to 70
      minop=nop
      nxti=i
      nxtj=i
      if (minop.le.0) go to 95
   70 continue
      if (nxti.le.0) go to 75
      if (nxti-n) 120,120,100
c
c     pivoting on the entire matrix
c
   75 do 90 i=n,nstop
      loc=i
   80 loc=nodplc(jcpt+loc)
      if (loc.eq.0) go to 90
      j=nodplc(jcolno+loc)
      if (j.lt.n) go to 80
      if (dabs(value(lvn+loc)).lt.epsrel) go to 80
      nop=(nodplc(numoff+i)-1)*(nodplc(nmoffc+j)-1)
      if (nop.ge.minop) go to 80
      minop=nop
      nxti=i
      nxtj=j
      if (minop.le.0) go to 95
   90 continue
      if (nxti.gt.0) go to 95
      write (iofile,92)
   92 format('0*abort*:  pivot not in dcdcmp')
      igoof=1
      go to 200
   95 if (nxti.eq.n.and.nxtj.eq.n) go to 120
      if (nxti.eq.n) go to 105
c
c     a pivot has been found
c
  100 load=nodplc(irswpf+nxti)
      lr=nodplc(irswpf+n)
      nodplc(irswpf+nxti)=lr
      nodplc(irswpr+lr)=nxti
      nodplc(irswpf+n)=load
      nodplc(irswpr+load)=n
      noff=nodplc(numoff+nxti)
      nodplc(numoff+nxti)=nodplc(numoff+n)
      nodplc(numoff+n)=noff
      if (nxtj.eq.n) go to 110
  105 load=nodplc(icswpf+nxtj)
      lc=nodplc(icswpf+n)
      nodplc(icswpf+nxtj)=lc
      nodplc(icswpr+lc)=nxtj
      nodplc(icswpf+n)=load
      nodplc(icswpr+load)=n
      noff=nodplc(nmoffc+nxtj)
      nodplc(nmoffc+nxtj)=nodplc(nmoffc+n)
      nodplc(nmoffc+n)=noff
  110 call swapij(nxti,n,nxtj,n)
      nxti=n
      nxtj=n
c
c     calculate contribution from nxti, nxtj and find fill-ins
c
  120 if (n.ge.nstop) go to 200
      n1=nodplc(irswpf+nxti)
      n2=nodplc(icswpf+nxtj)
      locnn=indxx(n1,n2)
      if (ipiv.le.0 .and. dabs(value(lvn+locnn)).lt.pivtol) go to 220
c
c     down col j
c
      locr=nodplc(irpt+locnn)
  125 if (locr.eq.0) go to 180
      i=nodplc(irowno+locr)
      value(lvn+locr)=value(lvn+locr)/value(lvn+locnn)
      locc=nodplc(jcpt+locnn)
c
c     for each column element look up row nxti
c
  130 if (locc.eq.0) go to 170
      j=nodplc(jcolno+locc)
c
c     check for fill-in (i,j)
c
      if (ipiv.le.0) go to 135
      call sizmem(jcpt,isize1)
      call reserv(i,j)
      call sizmem(jcpt,isize2)
      if (isize1.eq.isize2) go to 135
      call extmem(lvn,1)
      nttbr=nttbr+1
      value(lvn+nstop+nttbr)=0.0d0
c
c     locate element (i,j)
c
  135 if (j.lt.i) go to 145
      locij=locc
  140 locij=nodplc(irpt+locij)
      if (nodplc(irowno+locij).eq.i) go to 155
      go to 140
  145 locij=locr
  150 locij=nodplc(jcpt+locij)
      if (nodplc(jcolno+locij).eq.j) go to 155
      go to 150
  155 value(lvn+locij)=value(lvn+locij)-
     1                  value(lvn+locc)*value(lvn+locr)
  160 locc=nodplc(jcpt+locc)
      go to 130
  170 locr=nodplc(irpt+locr)
      if (ipiv.le.0) go to 125
      nodplc(numoff+i)=nodplc(numoff+i)-1
      go to 125
c
c     reduce nmoffc for each element in col nxti
c
  180 if (ipiv.le.0) go to 15
      locc=nodplc(jcpt+locnn)
  185 if (locc.eq.0) go to 15
      j=nodplc(jcolno+locc)
      nodplc(nmoffc+j)=nodplc(nmoffc+j)-1
      locc=nodplc(jcpt+locc)
      go to 185
c
c     done
c
  200 if (ipiv.eq.0) go to 210
      if (idebug(17).le.0) go to 202
      call dmpmat(6hdcdcm5)
      idebug(17)=idebug(17)-1
  202 call matloc
      rstats(49)=rstats(49)+1.0d0
      ipiv=0
      if (lvlcod.eq.2) lvlcod=3
      ifill=nttbr-nttar
      perspa=100.0d0*(1.0d0-dble(nttbr)/dble(nstop*nstop))
c
c  calculation of operation count (operation := `*' or `/'):
c
c     noffr := off-diagonal elements in row, not including diagonal,
c                counting only those elements in the remainder matrix
c     noffc := off-diagonal elements in column, not including diagonal,
c                counting only those elements in the remainder matrix
c
c     then we have
c
c        lu decomposition     requires sigma(2,nstop-1) {noffc + noffc*noffr}
c        forward substitution          sigma(2,nstop-1) {noffc + 1}   +   1
c        backward substitution         sigma(2,nstop-1) {noffr}
c
c     which sums to
c
c               sigma(2,nstop-1) {noffc + noffc*noffr + (noffc+1) + noffr} + 1
c         or
c               sigma(2,nstop-1) {noffc*(noffr+2) + noffr + 1}   +   1
c
      iops=1
      nstop1=nstop-1
      do 205 i=2,nstop1
      noffr=nodplc(numoff+i)-1
      noffc=nodplc(nmoffc+i)-1
      iops=iops+noffr+noffc*(noffr+2)+1
  205 continue
      rstats(20)=nstop
      rstats(21)=nttar
      rstats(22)=nttbr
      rstats(23)=ifill
      rstats(24)=0.0d0
      rstats(25)=nttbr
      rstats(26)=iops
      rstats(27)=perspa
      go to 215
  210 if (idebug(18).le.0) go to 212
      call dmpmat(6hdcdcm6)
      idebug(18)=idebug(18)-1
  212 if (idebug(19).le.0.or.icalc.le.10) go to 215
      call dmpmat(6hdcdcm7)
      idebug(19)=idebug(19)-1
  215 call second(t2)
      rstats(50)=rstats(50)+t2-t1
       return
  220 ipiv=1
      write(iofile,221) n,nxti,nxtj,iterno,time
  221 format(' pivot change on fly: n= ',i5,' nxti= ',i5,' nxtj= ',
     1       i5,' iterno= ',i5,' time= ',1pd12.5)
      rstats(49)=rstats(49)+1.0d0
      go to 20
      end

      subroutine fetlim(vnew,vold,vto)
      implicit double precision (a-h,o-z)
c
c     this routine limits the per-iteration change of fet voltages.
c
c
c      three regions of operation are identified:
c
c                  v < vto        definitely off
c            vto <= v <= vto+3.5d0    off or on depending on vbs
c        vto+3.5d0 < v              definitely on
c
      vtsthi=dabs(2.0d0*(vold-vto))+2.0d0
      vtstlo=vtsthi/2.0d0+2.0d0
      vtox=vto+3.5d0
      delv=vnew-vold
c
      if (vold.lt.vto) go to 300
      if (vold.lt.vtox) go to 200
c
c  on ...
c
      if (delv.gt.0.0d0) go to 120
c...  going off
      if (vnew.lt.vtox) go to 110
      if (-delv.le.vtstlo) go to 500
      vnew=vold-vtstlo
      go to 500
  110 vnew=dmax1(vnew,vto+2.0d0)
      go to 500
c...  staying on
  120 if (delv.lt.vtsthi) go to 500
      vnew=vold+vtsthi
      go to 500
c
c  middle region ...
c
  200 if (delv.gt.0.0d0) go to 210
c...  decreasing
      vnew=dmax1(vnew,vto-0.5d0)
      go to 500
c...  increasing
  210 vnew=dmin1(vnew,vto+4.0d0)
      go to 500
c
c  off ...
c
  300 if (delv.gt.0.0d0) go to 310
      if (-delv.le.vtsthi) go to 500
      vnew=vold-vtsthi
      go to 500
  310 vtemp=vto+0.5d0
      if (vnew.gt.vtemp) go to 320
      if (delv.le.vtstlo) go to 500
      vnew=vold+vtstlo
      go to 500
  320 vnew=vtemp
c
c  finished
c
  500 return
      end

      subroutine extmem(ipntr,ksize)
      implicit double precision (a-h,o-z)
      dimension ipntr(1)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      logical memptr
c
c***  extmem - extend size of existing block
c
c
c...  check for valid pointer
      if (memptr(ipntr(1))) go to 10
      memerr=5
      call errmem(2,memerr,ipntr(1))
   10 isize=ksize*istack(ltab+5)
c...  check for valid size
      if (isize.ge.0) go to 20
      memerr=2
      call errmem(2,memerr,ipntr(1))
c...  check if enough space already there
   20 if ((istack(ltab+2)-istack(ltab+3)).ge.isize) go to 40
      need=nxtevn(isize)-memavl
      if (need.le.0) go to 30
c...  insufficient space -- bump memory size
      need=nxtmem(need)
      icore=icore+need
      call memory
      if(memerr.ne.0) call errmem(2,memerr,ipntr(1))
      ltab1=ldval-ntab
      istack(ltab1+2)=istack(ltab1+2)+need
c...  relocate block entry table
      nwords=numblk*ntab
      cpyknt=cpyknt+dble(nwords)
      call copy4(istack(loctab+1),istack(loctab+need+1),nwords)
      loctab=loctab+need
      ldval=ldval+need
      memavl=memavl+need
      ltab=ltab+need
c...  move blocks to make space
   30 continue
      call comprs(0,ltab)
      call comprs(1,ltab)
   40 jsize=istack(ltab+3)
      istack(ltab+3)=istack(ltab+3)+isize
      memavl=memavl-(nxtevn(istack(ltab+3))-nxtevn(jsize))
      call memadj
      return
      end

      subroutine outdef(ifld,mode,loct,ltype)
      implicit double precision (a-h,o-z)
c
c     this routine constructs the internal list element for an output
c variable defined on some input card.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      integer xxor
      dimension aout(19),aopts(5)
      data aout / 4hv   , 4hvm  , 4hvr  , 4hvi  , 4hvp  , 4hvdb ,
     1            4hi   , 4him  , 4hir  , 4hii  , 4hip  , 4hidb ,
     2            4honoi, 4hinoi, 4hhd2 , 4hhd3 , 4hdim2, 4hsim2,
     3            4hdim3 /
      data aopts / 1hm, 1hr, 1hi, 1hp, 1hd /
      data alprn, acomma, ablnk, aletv / 1h(, 1h,, 1h , 1hv /
c
      if (nodplc(icode+ifld).ne.1) go to 300
      anam=value(ifield+ifld)
      call move(anam,5,ablnk,1,4)
      do 10 i=1,19
      if (xxor(anam,aout(i)).ne.0) go to 10
      idout=i
      go to 20
   10 continue
      go to 300
c
c  further error checking
c
   20 if (mode.ge.3) go to 25
c...  dc or tran
      if ((idout.ne.1).and.(idout.ne.7)) go to 300
      go to 38
   25 if (mode.ge.4) go to 30
c...  ac
      if (idout.ge.13) go to 300
      go to 38
   30 if (mode.eq.5) go to 35
c...  noise
      if ((idout.ne.13).and.(idout.ne.14)) go to 300
      go to 38
c...  distortion
   35 if (idout.lt.15) go to 300
   38 ktype=0
      ltype=idout
      if (idout.lt.7) go to 40
      ktype=1
      ltype=ltype-6
      if (idout.lt.13) go to 40
      ktype=idout-11
      ltype=1
c
c  voltage output
c
   40 id=40+mode
      if (ktype.ne.0) go to 100
      if (nodplc(icode+ifld+1).ne.0) go to 300
      ifld=ifld+1
      n1=value(ifield+ifld)
      if (n1.lt.0) go to 300
      if(n1.gt.9999) go to 300
      n2=0
      adelim=value(idelim+ifld)
      if (adelim.eq.acomma) go to 45
      if (adelim.ne.ablnk) go to 50
   45 if (nodplc(icode+ifld+1).ne.0) go to 300
      ifld=ifld+1
      n2=value(ifield+ifld)
      if (n2.lt.0) go to 300
      if(n2.gt.9999) go to 300
   50 outnam=ablnk
      ipos=1
      call alfnum(n1,outnam,ipos)
      ipos=5
      call alfnum(n2,outnam,ipos)
      call find(outnam,id,loct,0)
      nodplc(loct+2)=n1
      nodplc(loct+3)=n2
      go to 400
c
c  current output
c
  100 if (ktype.ne.1) go to 200
      if (nodplc(icode+ifld+1).ne.1) go to 300
      ifld=ifld+1
      avsrc=value(ifield+ifld)
      achek=avsrc
      call move(achek,2,ablnk,1,7)
      if (achek.ne.aletv) go to 300
      call find(avsrc,id,loct,0)
      call find(avsrc,9,nodplc(loct+2),0)
      nodplc(loct+5)=1
      go to 400
c
c  noise or distortion outputs
c
  200 id=44
      if (ktype.ge.4) id=id+1
      if (value(idelim+ifld).ne.alprn) go to 220
      if (nodplc(icode+ifld+1).ne.1) go to 300
      ifld=ifld+1
      atype=value(ifield+ifld)
      call move(atype,2,ablnk,1,7)
      do 210 i=1,5
      if (atype.ne.aopts(i)) go to 210
      ltype=i+1
      go to 220
  210 continue
      go to 300
  220 call find(anam,id,loct,0)
      nodplc(loct+2)=0
      nodplc(loct+5)=ktype
      go to 400
c
c  errors
c
  300 igoof=1
c
c  finished
c
  400 return
      end

      subroutine subckt
      implicit double precision (a-h,o-z)
c
c     this routine drives the expansion of subcircuit calls.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
c... avoid 'call by value' problems, make inodi, inodx arrays
c... in routines which receive them as parameters ]]]
      locx=locate(19)
   10 if (locx.eq.0) go to 300
      locs=nodplc(locx+3)
      asnam=value(iunsat+locs)
      call fndnam(asnam,locx-1,locx+3,20)
      if (nogo.ne.0) go to 300
      locs=nodplc(locx+3)
c
c  check for recursion
c
      isbptr=nodplc(locx-1)
   20 if (isbptr.eq.0) go to 30
      if (locs.eq.nodplc(isbptr+3)) go to 260
      isbptr=nodplc(isbptr-1)
      go to 20
c
c
   30 call sizmem(nodplc(locx+2),nxnod)
      call sizmem(nodplc(locs+2),nssnod)
      if (nxnod.ne.nssnod) go to 250
      call getm4(inodx,nssnod)
      call getm4(inodi,nssnod)
      itemp=nodplc(locs+2)
      call copy4(nodplc(itemp+1),nodplc(inodx+1),nssnod)
      itemp=nodplc(locx+2)
      call copy4(nodplc(itemp+1),nodplc(inodi+1),nxnod)
c
c  add elements of subcircuit to nominal circuit
c
      loc=nodplc(locs+3)
  100 if (loc.eq.0) go to 200
      id=nodplc(loc-1)
      if (id.eq.20) go to 110
      call find(dble(jelcnt(id)),id,loce,1)
      nodplc(loce-1)=locx
      call addelt(loce,loc,id,inodx,inodi,nxnod)
  110 loc=nodplc(loc)
      go to 100
c
c
  200 call clrmem(inodx)
      call clrmem(inodi)
      locx=nodplc(locx)
      go to 10
c
c  errors
c
  250 locv=nodplc(locx+1)
      axnam=value(locv)
      locv=nodplc(locs+1)
      asnam=value(locv)
      write (iofile,251) axnam,asnam
  251 format('0*error*:  ',a8,' has different number of nodes than ',a8/
     1)
      nogo=1
      go to 300
  260 locsv=nodplc(locs+1)
      asnam=value(locsv)
      write (iofile,261) asnam
  261 format('0*error*:  subcircuit ',a8,' is defined recursively'/)
      nogo=1
c
c  finished
c
  300 return
      end

      subroutine getmx(ipntr,ksize,iwsize)
      implicit double precision (a-h,o-z)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      logical memptr
      dimension ipntr(1)
c
c***  getmem - get block
c
c
      isize=ksize*iwsize
c...  check for valid size
      if (isize.ge.0) go to 5
      memerr=2
      call errmem(3,memerr,ipntr(1))
c...  check for attempt to reallocate existing block
    5 if (.not.memptr(ipntr(1))) go to 8
      memerr=3
      call errmem(3,memerr,ipntr(1))
    8 jsize=nxtevn(isize)
      call comprs(0,ldval)
c...  check if enough space already there
      need=jsize+ntab-memavl
      if (need.le.0) go to 10
c...  insufficient space -- bump memory size
      need=nxtmem(need)
      icore=icore+need
      call memory
      if(memerr.ne.0) call errmem(3,memerr,ipntr(1))
      ltab1=ldval-ntab
      istack(ltab1+2)=istack(ltab1+2)+need
c...  relocate block entry table
      nwords=numblk*ntab
      cpyknt=cpyknt+dble(nwords)
      call copy4(istack(loctab+1),istack(loctab+need+1),nwords)
      loctab=loctab+need
      ldval=ldval+need
      memavl=memavl+need
c...  a block large enough now exists -- allocate it
   10 ltab1=ldval-ntab
      morg=istack(ltab1+1)
      msiz=istack(ltab1+2)
      muse=istack(ltab1+3)
      muse=nxtevn(muse)
      madr=istack(ltab1+4)
c...  construct new table entry
   15 istack(ltab1+2)=muse
      loctab=loctab-ntab
      nwords=numblk*ntab
      cpyknt=cpyknt+dble(nwords)
      call copy4(istack(loctab+ntab+1),istack(loctab+1),nwords)
      numblk=numblk+1
      memavl=memavl-ntab
      istack(ltab1+1)=morg+muse
      istack(ltab1+2)=msiz-muse-ntab
c...  set user size into table entry for this block
   20 istack(ltab1+3)=isize
      istack(ltab1+4)=locf(ipntr(1))
      istack(ltab1+5)=iwsize
      istack(ltab1+6)=0
      memavl=memavl-jsize
      ipntr(1)=istack(ltab1+1)/iwsize
      call memadj
      return
      end

      subroutine limvds(vnew,vold)
      implicit double precision (a-h,o-z)
c
c     this routine limits the per-iteration change of fet vds.
c
      if (vold.lt.3.5d0) go to 200
c
      if (vnew.le.vold) go to 100
      vnew=dmin1(vnew,3.0d0*vold+2.0d0)
      go to 500
  100 if (vnew.lt.3.5d0) vnew=dmax1(vnew,2.0d0)
      go to 500
c
  200 if (vnew.le.vold) go to 300
      vnew=dmin1(vnew,4.0d0)
      go to 500
  300 vnew=dmax1(vnew,-0.5d0)
c
  500 return
      end

      subroutine runcon(id)
      implicit double precision (a-h,o-z)
c
c     this routine processes run control cards.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cje 3/15/83
      common /cje/ maxtim,itime,icost
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=debug 3/15/83
      common/debug/ idebug(20)
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
      dimension iprnt(5),limits(4),itrlim(6),contol(6),dflts(4)
      equivalence (iprnt(1),iprnta),(limits(1),limtim),(itrlim(1),itl1),
     1   (contol(1),gmin),(dflts(1),defl)
c
c
      integer xxor
c
c  print/plot keywords
c
      dimension aopt(5)
      dimension aopts(34),lsetop(5)
      dimension aide(20)
      data aopt / 2hdc, 2htr, 2hac, 2hno, 2hdi /
c
c  options card keywords
c
      data aopts / 6hacct  , 6hlist  , 6hnomod , 6hnode  , 6hopts  ,
     1             6hitl1  , 6hitl2  , 6hitl3  , 6hitl4  , 6hitl5  ,
     2             6hitl6  , 6hlimtim, 6hlimpts, 6hlvlcod, 6hlvltim,
     3             6hgmin  , 6hreltol, 6habstol, 6hvntol , 6htrtol ,
     4             6hchgtol, 6htnom  , 6hnumdgt, 6hmaxord, 6hmethod,
     5             6hnopage, 6hmu    , 6hcptime, 6hdefl  , 6hdefw  ,
     6             6hdefad , 6hdefas , 6hpivtol, 6hpivrel /
      data lsetop / 1 ,1, 0, 1, 1 /
c
c
      data aide / 1hr,1hc,1hl,1hk,1hg,1he,1hf,1hh,1hv,1hi,1hd,1hq,1hj,
     1   1hm,1hs,1hy,1ht,4htemp,1hx,0.0d0 /
      data alsde,alsoc,alsli / 3hdec, 3hoct, 3hlin /
      data atrap, agear, auic / 4htrap, 4hgear, 3huic /
      data ablnk, ain, aout / 1h , 2hin, 3hout /
      data amiss / 8h*missing /
      data ams / 2hms /
      data minpts / 1 /
c
c
      go to (1200,1100,1650,6000,6000,1700,6000,1600,1550,2000,3600,
     1   3500,6000,1750,1300,1500,1800,4000,4100,4200,5900), id
c
c  dc transfer curves
c
 1100 ifld=2
      icvflg=0
      inum=1
 1105 anam=value(ifield+ifld)
      if(inum.gt.2) go to 6000
      id=0
      call move(anam,2,ablnk,1,7)
      if (anam.eq.aide(1)) id=1
      if (anam.eq.aide(9)) id=9
      if (anam.eq.aide(10)) id=10
      if (anam.eq.aide(17)) go to 1108
      if (id.eq.0) go to 1130
      call find(value(ifield+ifld),id,itcelm(inum),0)
      go to 1115
 1108 anam=value(ifield+ifld)
      call move(anam,5,ablnk,1,4)
      if (anam.ne.aide(18)) go to 1130
      id=18
      call find(anam,id,itcelm(inum),1)
      locs=nodplc(itcelm(inum)+1)
      nodplc(itcelm(inum)+2)=0
      value(locs)=anam
      value(locs+1)=value(itemps+1)
      call extmem(itemps,2)
      value(itemps+2)=value(itemps+1)
 1115 ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1130
      tcstar(inum)=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1130
      tcstop(inum)=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1130
      tcincr(inum)=value(ifield+ifld)
      if (tcincr(inum).eq.0.0d0) go to 1130
      temp=(tcstop(inum)-tcstar(inum))/tcincr(inum)
      if (temp.gt.0.0d0) go to 1110
      tcincr(inum)=-tcincr(inum)
      temp=-temp
 1110 itemp=idint(temp+0.5d0)+1
      itemp=max0(itemp,minpts)
      if(inum.eq.1) icvflg=itemp
      if(inum.eq.2) icvflg=itemp*icvflg
      ifld=ifld+1
      inum=2
      if(nodplc(icode+ifld)) 6000,1130,1105
 1130 write (iofile,1131)
      icvflg=0
 1131 format('0warning:  missing parameter(s) ... analysis omitted'/)
      go to 6000
c
c  frequency specification
c
 1200 ifld=2
      if (nodplc(icode+2)) 1250,1250,1210
 1210 id=0
      if (value(ifield+ifld).eq.alsde) id=1
      if (value(ifield+ifld).eq.alsoc) id=2
      if (value(ifield+ifld).eq.alsli) id=3
      if (id.eq.0) go to 1240
      idfreq=id
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1250
      if (value(ifield+ifld).le.0.0d0) go to 1250
      fincr=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1250
      if (value(ifield+ifld).le.0.0d0) go to 1250
      fstart=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1250
      if (value(ifield+ifld).le.0.0d0) go to 1250
      fstop=value(ifield+ifld)
      if (fstart.gt.fstop) go to 1260
      jacflg=fincr
      if (idfreq-2) 1215,1220,1235
 1215 fincr=dexp(xlog10/fincr)
      go to 1230
 1220 fincr=dexp(xlog2/fincr)
 1230 temp=dlog(fstop/fstart)/dlog(fincr)
      jacflg=idint(temp+0.999d0)+1
 1235 jacflg=max0(jacflg,minpts)
      if (idfreq.ne.3) go to 6000
      fincr=(fstop-fstart)/dble(max0(jacflg-1,1))
      go to 6000
 1240 write (iofile,1241) value(ifield+ifld)
 1241 format('0warning:  unknown frequency function:  ',a8,' ... analys'
     1   ,'is omitted'/)
      go to 6000
 1250 write (iofile,1251)
 1251 format('0warning:  frequency parameters incorrect ... analysis om'
     1   ,'itted'/)
      go to 6000
 1260 write (iofile,1261)
 1261 format('0warning:  start freq > stop freq ... analysis omitted'/)
      go to 6000
c
c  time specification
c
 1300 ifld=2
      if (nodplc(icode+ifld).ne.0) go to 1430
      if (value(ifield+ifld).le.0.0d0) go to 1430
      tstep=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1430
      if (value(ifield+ifld).le.0.0d0) go to 1430
      tstop=value(ifield+ifld)
      tstart=0.0d0
      delmax=tstop/50.0d0
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1310
      if (value(ifield+ifld).lt.0.0d0) go to 1430
      tstart=value(ifield+ifld)
      delmax=(tstop-tstart)/50.0d0
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1310
      if (value(ifield+ifld).le.0.0d0) go to 1430
      delmax=value(ifield+ifld)
      ifld=ifld+1
 1310 if (nodplc(icode+ifld).ne.1) go to 1320
      if (value(ifield+ifld).ne.auic) go to 1320
      nosolv=1
 1320 if (tstart.gt.tstop) go to 1440
      if (tstep.gt.tstop) go to 1430
      jtrflg=idint((tstop-tstart)/tstep+0.5d0)+1
      jtrflg=max0(jtrflg,minpts)
      go to 6000
 1430 write (iofile,1431)
 1431 format('0warning:  time parameters incorrect ... analysis omitted'
     1   /)
      go to 6000
 1440 write (iofile,1441)
 1441 format('0warning:  start time > stop time ... analysis omitted'/)
      go to 6000
c
c  transfer function
c
 1500 kssop=1
      ifld=2
      if (nodplc(icode+ifld).ne.1) go to 1530
      call outdef(ifld,1,kovar,ktype)
      if (igoof.ne.0) go to 1530
      if (ktype.ne.1) go to 1540
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.1) go to 1530
      anam=value(ifield+ifld)
      call move(anam,2,ablnk,1,7)
      id=0
      if (anam.eq.aide(9)) id=9
      if (anam.eq.aide(10)) id=10
      if (id.eq.0) go to 1530
      call find(value(ifield+ifld),id,kinel,0)
      kidin=id
      go to 6000
 1530 kovar=0
      kinel=0
      write (iofile,1131)
      igoof=0
      go to 6000
 1540 kovar=0
      kinel=0
      write (iofile,1541)
 1541 format('0warning:  illegal output variable ... analysis omitted'/)
      igoof=0
      go to 6000
c
c  operating point
c
 1550 kssop=1
      go to 6000
c
c  noise analysis
c
 1600 ifld=2
      if (nodplc(icode+ifld).ne.1) go to 1610
      call outdef(ifld,2,nosout,ntype)
      if (igoof.ne.0) go to 1610
      if (ntype.ne.1) go to 1610
      if (nodplc(nosout+5).ne.0) go to 1610
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.1) go to 1620
      anam=value(ifield+ifld)
      call move(anam,2,ablnk,1,7)
      id=0
      if (anam.eq.aide(9)) id=9
      if (anam.eq.aide(10)) id=10
      if (id.eq.0) go to 1620
      call find(value(ifield+ifld),id,nosin,0)
      nosprt=0
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 1605
      nosprt=dmax1(0.0d0,value(ifield+ifld))
 1605 inoise=1
      go to 6000
 1610 write (iofile,1611)
 1611 format('0warning:  voltage output unrecognizable ... analysis omit
     1ted'/)
      igoof=0
      go to 6000
 1620 write (iofile,1621)
 1621 format('0warning:  invalid input source ... analysis omitted'/)
      igoof=0
      go to 6000
c
c  distortion analysis
c
 1650 ifld=2
      if (nodplc(icode+ifld).ne.1) go to 1660
      anam=value(ifield+ifld)
      call move(anam,2,ablnk,1,7)
      if (anam.ne.aide(1)) go to 1660
      call find(value(ifield+ifld),1,idist,0)
      idprt=0
      skw2=0.9d0
      refprl=1.0d-3
      spw2=1.0d0
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 6000
      idprt=value(ifield+ifld)
      idprt=max0(idprt,0)
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 6000
      if (value(ifield+ifld).le.0.001d0) go to 1670
      if (value(ifield+ifld).gt.0.999d0) go to 1670
      skw2=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 6000
      if (value(ifield+ifld).lt.1.0d-10) go to 1670
      refprl=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 6000
      if (value(ifield+ifld).lt.0.001d0) go to 1670
      spw2=value(ifield+ifld)
      go to 6000
 1660 write (iofile,1661)
 1661 format('0warning:  distortion load resistor missing ... analysis '
     1   ,'omitted'/)
      go to 6000
 1670 idist=0
      write (iofile,1671)
 1671 format('0warning:  distortion parameters incorrect ... analysis o'
     1   ,'mitted'/)
      go to 6000
c
c  fourier analysis
c
 1700 ifld=2
      if (nodplc(icode+ifld).ne.0) go to 1720
      if (value(ifield+ifld).le.0.0d0) go to 1720
      forfre=value(ifield+ifld)
 1705 ifld=ifld+1
      if (nodplc(icode+ifld).ne.1) go to 1710
      call outdef(ifld,2,loct,ltype)
      if (igoof.ne.0) go to 1720
      if (ltype.ne.1) go to 1720
      call extmem(ifour,1)
      nfour=nfour+1
      nodplc(ifour+nfour)=loct
      go to 1705
 1710 if (nfour.ge.1) go to 6000
 1720 write (iofile,1721)
 1721 format('0warning:  fourier parameters incorrect ... analysis omit'
     1   ,'ted'/)
      igoof=0
      nfour=0
      call clrmem(ifour)
      call getm4(ifour,0)
      go to 6000
c
c  sensitivity analysis
c
 1750 kssop=1
      ifld=1
 1760 ifld=ifld+1
      if (nodplc(icode+ifld).ne.1) go to 6000
      call outdef(ifld,1,loct,ltype)
      if (igoof.ne.0) go to 1780
      if (ltype.ne.1) go to 1780
      call extmem(isens,1)
      nsens=nsens+1
      nodplc(isens+nsens)=loct
      go to 1760
 1780 write (iofile,1781)
 1781 format('0warning:  output variable unrecognizable ... analysis om'
     1   ,'mitted'/)
      igoof=0
      nsens=0
      call clrmem(isens)
      call getm4(isens,0)
      go to 6000
c
c  temperature variation
c
 1800 ifld=1
 1810 ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 6000
      if (value(ifield+ifld).le.-223.0d0) go to 1810
      call extmem(itemps,1)
      numtem=numtem+1
      value(itemps+numtem)=value(ifield+ifld)
      go to 1810
c
c  options card
c
 2000 ifld=1
 2010 ifld=ifld+1
 2020 if (nodplc(icode+ifld)) 6000,2010,2030
 2030 anam=value(ifield+ifld)
      do 2040 i=1,5
      if (anam.ne.aopts(i)) go to 2040
      iprnt(i)=lsetop(i)
      ifld=ifld+1
      if(nodplc(icode+ifld).ne.0) go to 2020
      iprnt(i)=value(ifield+ifld)
      go to 2010
 2040 continue
      if (anam.eq.aopts(25)) go to 2110
      if (anam.eq.aopts(26)) go to 2120
      if (anam.eq.aopts(27)) go to 2130
      if (anam.eq.aopts(28)) go to 2150
      if (anam.eq.aopts(33)) go to 2200
      if (anam.eq.aopts(34)) go to 2250
      if (nodplc(icode+ifld+1).ne.0) go to 2510
      ifld=ifld+1
      aval=value(ifield+ifld)
      do 2050 i=6,11
      if (anam.ne.aopts(i)) go to 2050
      if(aval.le.0.0d0.and.i.ne.10) go to 2510
      itrlim(i-5)=aval
      go to 2010
 2050 continue
      if (aval.le.0.0d0) go to 2510
      do 2060 i=12,15
      if (anam.ne.aopts(i)) go to 2060
      limits(i-11)=aval
      go to 2010
 2060 continue
      do 2070 i=16,21
      if (anam.ne.aopts(i)) go to 2070
      contol(i-15)=aval
      go to 2010
 2070 continue
      do 2075 i=29,32
      if(anam.ne.aopts(i)) go to 2075
      dflts(i-28)=aval
      go to 2010
 2075 continue
      if (anam.ne.aopts(22)) go to 2080
      if (aval.lt.-223.0d0) go to 2510
      value(itemps+1)=aval
      go to 2010
 2080 if (anam.ne.aopts(23)) go to 2100
      ndigit=aval
      if (ndigit.le.7) go to 2090
      ndigit=7
      write (iofile,2081) ndigit
 2081 format('0warning:  numdgt may not exceed',i2,
     1 ';  maximum value assumed'/)
 2090 numdgt=ndigit
      go to 2010
 2100 if (anam.ne.aopts(24)) go to 2500
      n=aval
      if ((n.le.1).or.(n.ge.7)) go to 2510
      maxord=n
      go to 2010
 2110 if (nodplc(icode+ifld+1).ne.1) go to 2510
      ifld=ifld+1
      anam=value(ifield+ifld)
      call move(anam,5,ablnk,1,4)
      jtype=0
      if (anam.eq.atrap) jtype=1
      if (anam.eq.agear) jtype=2
      if (jtype.eq.0) go to 2510
      method=jtype
      go to 2010
 2120 nopage=1
      go to 2010
 2130 ifld=ifld+1
      if(nodplc(icode+ifld)) 6000,2140,2030
 2140 aval=value(ifield+ifld)
      if(aval.lt.0.0d0.or.aval.gt.0.500001d0) go to 2510
      xmu=aval
      go to 2010
 2150 ifld=ifld+1
      if(nodplc(icode+ifld)) 6000,2160,2030
 2160 aval=value(ifield+ifld)
      maxtim=aval
      go to 2010
 2200 ifld=ifld+1
      if (nodplc(icode+ifld)) 6000,2210,2030
 2210 aval=value(ifield+ifld)
      if (aval.gt.1.0d0) go to 2510
      pivtol=aval
      go to 2010
 2250 ifld=ifld+1
      if (nodplc(icode+ifld)) 6000,2260,2030
 2260 aval=value(ifield+ifld)
      if (aval.gt.1.0d0) go to 2510
      pivrel=aval
      go to 2010
 2500 write (iofile,2501) anam
 2501 format('0warning:  unknown option:  ',a8,' ... ignored'/)
      go to 2010
 2510 write (iofile,2511) anam
 2511 format('0warning:  illegal value specified for option:  ',a8,' ...
     1 ignored'/)
      go to 2010
c
c  print card
c
 3500 iprpl=0
      go to 3610
c
c  plot (and print) card
c
 3600 iprpl=1
 3610 ifld=2
 3613 anam=amiss
      if (nodplc(icode+ifld).ne.1) go to 3950
      anam=value(ifield+ifld)
      ms=0
      if (xxor(anam,ams).ne.0) go to 3615
      ms=1
      ifld=3
      if (nodplc(icode+ifld).ne.1) go to 3970
      anam=value(ifield+ifld)
 3615 call move(anam,3,ablnk,1,6)
      do 3620 i=1,5
      if (anam.ne.aopt(i)) go to 3620
      ktype=i
      go to 3630
 3620 continue
      go to 3950
 3630 id=30+5*iprpl+ktype
      call find(dble(jelcnt(id)),id,loc,1)
      nodplc(loc+2)=ktype
      if (ms.eq.0) go to 3635
      locv=nodplc(loc+1)
      value(locv)=0.0d0
 3635 numout=0
 3640 ifld=ifld+1
      if (nodplc(icode+ifld)) 3900,3640,3650
 3650 call outdef(ifld,ktype,loct,ltype)
      if (igoof.ne.0) go to 3970
      if (iprpl.eq.0) go to 3660
      plimlo=0.0d0
      plimhi=0.0d0
      if (nodplc(icode+ifld+1).ne.0) go to 3660
      if (nodplc(icode+ifld+2).ne.0) go to 3660
      plimlo=value(ifield+ifld+1)
      plimhi=value(ifield+ifld+2)
      ifld=ifld+2
 3660 numout=numout+1
      lspot=loc+2*numout+2
      nodplc(lspot)=loct
      nodplc(lspot+1)=ltype
      if (iprpl.eq.0) go to 3670
      locv=nodplc(loc+1)
      lspot=locv+2*numout-1
      value(lspot)=plimlo
      value(lspot+1)=plimhi
 3670 if (numout.eq.8) go to 3900
      go to 3640
 3900 nodplc(loc+3)=numout
      if (iprpl.eq.0) go to 6000
c...  propogate plot limits downward
      if (numout.le.1) go to 6000
      locv=nodplc(loc+1)
      lspot=locv+2*numout-1
      plimlo=value(lspot)
      plimhi=value(lspot+1)
      i=numout-1
 3905 lspot=lspot-2
      if (value(lspot).ne.0.0d0) go to 3910
      if (value(lspot+1).ne.0.0d0) go to 3910
      value(lspot)=plimlo
      value(lspot+1)=plimhi
      go to 3920
 3910 plimlo=value(lspot)
      plimhi=value(lspot+1)
 3920 i=i-1
      if (i.ge.1) go to 3905
      go to 6000
c
c     errors
c
 3950 write (iofile,3951) anam
 3951 format('0warning:  unknown analysis mode:  ',a8,
     1  ' ... line ignored'/)
      go to 6000
 3970 write (iofile,3971)
 3971 format('0warning:  unrecognizable output variable on above line'/)
      igoof=0
      go to 3640
c
c  width card
c
 4000 ifld=1
 4010 ifld=ifld+1
      if (nodplc(icode+ifld).ne.1) go to 6000
 4020 anam=value(ifield+ifld)
      if (anam.ne.ain) go to 4040
      ifld=ifld+1
      if (nodplc(icode+ifld)) 6000,4030,4020
 4030 iwidth=value(ifield+ifld)
      iwidth=min0(max0(iwidth,10),120)
      go to 4010
 4040 if (anam.ne.aout) go to 6000
      ifld=ifld+1
      if (nodplc(icode+ifld)) 6000,4050,4020
 4050 lwidth=dmin1(dmax1(value(ifield+ifld),72.0d0),132.0d0)
      go to 4010
c
c  nodeset statement
c
 4100 ifld=1
 4110 ifld=ifld+1
      if(nodplc(icode+ifld)) 6000,4120,4110
 4120 nodnum=value(ifield+ifld)
      if(nodnum.le.0) go to 4190
      ifld=ifld+1
      if(nodplc(icode+ifld)) 4180,4130,4170
 4130 call sizmem(nsnod,nic)
      call extmem(nsnod,1)
      call extmem(nsval,1)
      nodplc(nsnod+nic+1)=nodnum
      value(nsval+nic+1)=value(ifield+ifld)
      go to 4110
c
c  errors on .nodeset statement
c
 4170 write(iofile,4171) value(ifield+ifld)
 4171 format('0warning: out-of-place non-numeric field ',a8,
     1 ' skipped'/)
      go to 4110
 4180 write(iofile,4181) nodnum
 4181 format('0warning: initial value missing for node ',i5,/)
      go to 6000
 4190 write(iofile,4191)
 4191 format('0warning: attempt to specify initial condition for ',
     1 'ground ingnored',/)
      ifld=ifld+1
      if(nodplc(icode+ifld)) 6000,4110,4170
c
c  initial conditions statement
c
 4200 ifld=1
 4210 ifld=ifld+1
      if(nodplc(icode+ifld)) 6000,4220,4210
 4220 nodnum=value(ifield+ifld)
      if(nodnum.le.0) go to 4290
      ifld=ifld+1
      if(nodplc(icode+ifld)) 4280,4230,4270
 4230 call sizmem(icnod,nic)
      call extmem(icnod,1)
      call extmem(icval,1)
      nodplc(icnod+nic+1)=nodnum
      value(icval+nic+1)=value(ifield+ifld)
      go to 4210
c
c  errors on .ic statement
c
 4270 write(iofile,4271) value(ifield+ifld)
 4271 format('0warning: out-of-place non-numeric field ',a8,
     1 ' skipped'/)
      go to 4210
 4280 write(iofile,4281) nodnum
 4281 format('0warning: initial value missing for node ',i5,/)
      go to 6000
 4290 write(iofile,4291)
 4291 format('0warning: attempt to specify initial condition for ',
     1 'ground ignored',/)
      ifld=ifld+1
      if(nodplc(icode+ifld)) 6000,4210,4270
c
c     :debug: statement
c     sample debug line: .:debug: 5=3 17=5
c
 5900 ifld=1
 5910 ifld=ifld+1
      if (nodplc(icode+ifld)) 6000,5920,5910
 5920 index=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld)) 6000,5930,5910
 5930 ival=value(ifield+ifld)
      if (index.lt.1) go to 5910
      if (index.gt.20) go to 5910
      write(iofile,5931) index,ival
 5931 format(' *debug*:  runcon - idebug(',i2,') set to ',i10)
      idebug(index)=ival
      go to 5910
c
c  finished
c
 6000 return
      end

      subroutine moseq3(vds,vbs,vgs,gm,gds,gmbs,
     1   qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      implicit double precision (a-h,o-z)
c
c     this routine evaluates the drain current, its derivatives and
c     the charges associated with the gate, channel and bulk
c     for mosfets based on semi-empirical equations
c
c spice version 2g.6  sccsid=mosarg 3/15/83
      common /mosarg/ vto,beta,gamma,phi,phib,cox,xnsub,xnfs,xd,xj,xld,
     1   xlamda,uo,uexp,vbp,utra,vmax,xneff,xl,xw,vbi,von,vdsat,qspof,
     2   beta0,beta1,cdrain,xqco,xqc,fnarrw,fshort,lev
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c
      equivalence (xlamda,alpha),(vbp,theta),(uexp,eta),(utra,xkappa)
      data coeff0/0.0631353d0/,coeff1/0.8013292d0/,coeff2/-0.01110777d0/
c
c     icharg=1 causes charges to be computed
c     icharg=0 bypasses the computation of charges
c
c     icharg=1
c     if (mode.ne.1) go to 10
c     icharg=0
c     if (modedc.eq.2.and.nosolv.ne.0) icharg=1
c     if (initf.eq.4) icharg=1
c
c     reference cdrain equations to source and
c     charge equations to bulk
c
10    continue
      icharg=0
      vgb=vgs-vbs
      vfb=vbi-phi
      vdsat=0.0d0
      qg=0.0d0
      qb=0.0d0
      qc=0.0d0
      cgdb=0.0d0
      cbdb=0.0d0
      onxl=1.0d0/xl
      eta=eta/(xl*xl*xl)
c
c.....square root term
c
      if ( vbs.gt.0.0d0 ) go to 120
      phibs=phi-vbs
      sqphbs=dsqrt(phibs)
      dsqdvb=-0.5d0/sqphbs
      go to 200
120   continue
      sqphis=dsqrt(phi)
      sqphs3=phi*sqphis
      sqphbs=sqphis/(1.0d0+vbs/(phi+phi))
      phibs=sqphbs*sqphbs
      dsqdvb=-phibs/(sqphs3+sqphs3)
c
c.....short channel effect factor
c
200   continue
      if ( (xj.eq.0.0d0).or.(xd.eq.0.0d0) ) go to 210
      wps=xd*sqphbs
      onxj=1.0d0/xj
      xjonxl=xj*onxl
      djonxj=xld*onxj
      wponxj=wps*onxj
      wconxj=coeff0+coeff1*wponxj+coeff2*wponxj*wponxj
      wcs=wconxj*xj
      arga=wconxj+djonxj
      argc=wponxj/(1.0d0+wponxj)
      argb=dsqrt(1.0d0-argc*argc)
      fshort=1.0d0-xjonxl*(arga*argb-djonxj)
      dwpdvb=xd*dsqdvb
      dadvb=(coeff1+coeff2*(wponxj+wponxj))*dwpdvb*onxj
      dbdvb=-argc*argc*(1.0d0-argc)*dwpdvb/(argb*wps)
      dfsdvb=-xjonxl*(dadvb*argb+arga*dbdvb)
      go to 220
210   continue
      fshort=1.0d0
      dfsdvb=0.0d0
      wcs=0.05d-6
c
c.....body effect
c
220   continue
      gammas=gamma*fshort
      fbodys=0.5d0*gammas/(sqphbs+sqphbs)
      fbody=fbodys+fnarrw
      onfbdy=1.0d0/(1.0d0+fbody)
      dfbdvb=-fbodys*dsqdvb/sqphbs+fbodys*dfsdvb/fshort
      qbonco=gammas*sqphbs+fnarrw*phibs
      dqbdvb=gammas*dsqdvb+gamma*dfsdvb*sqphbs-fnarrw
c
c.....static feedback effect
c
      vbix=vbi-eta*vds
c
c.....threshold voltage
c
      vth=vbix+qbonco
      dvtdvd=-eta
      dvtdvb=dqbdvb
c
c.....joint weak inversion and strong inversion
c
      von=vth
      if ( xnfs.eq.0.0d0 ) go to 250
           csonco=charge*xnfs*xl*xw/cox
           cdonco=qbonco/(phibs+phibs)
           xn=1.0d0+csonco+cdonco
           von=vth+vt*xn
           dxndvb=dqbdvb/(phibs+phibs)-qbonco*dsqdvb/(phibs*sqphbs)
           dvodvd=dvtdvd
           dvodvb=dvtdvb+vt*dxndvb
           go to 300
c
c.....cutoff region
c
250   continue
      if ( vgs.gt.von ) go to 300
      cdrain=0.0d0
      gm=0.0d0
      gds=0.0d0
      gmbs=0.0d0
      if ( icharg.ne.0 ) go to 800
      go to 1000
c
c.....device is on
c
300   continue
      vgsx=dmax1(vgs,von)
c
c.....mobility modulation by gate voltage
c
      onfg=1.0d0+theta*(vgsx-vth)
      fgate=1.0d0/onfg
      us=uo*fgate
      dfgdvg=-theta*fgate*fgate
      dfgdvd=-dfgdvg*dvtdvd
      dfgdvb=-dfgdvg*dvtdvb
c
c.....saturation voltage
c
      vdsat=(vgsx-vth)*onfbdy
      vpof=vdsat
      if ( vmax.gt.0.0d0 ) go to 310
      dvsdvg=onfbdy
      dvsdvd=-dvsdvg*dvtdvd
      dvsdvb=-dvsdvg*dvtdvb-vdsat*dfbdvb*onfbdy
      go to 400
  310 vdsc=xl*vmax/us
      onvdsc=1.0d0/vdsc
      arga=(vgsx-vth)*onfbdy
      argb=dsqrt(arga*arga+vdsc*vdsc)
      vdsat=arga+vdsc-argb
      dvsdga=(1.0d0-arga/argb)*onfbdy
      dvsdvg=dvsdga-(1.0d0-vdsc/argb)*vdsc*dfgdvg*onfg
      dvsdvd=-dvsdvg*dvtdvd
      dvsdvb=-dvsdvg*dvtdvb-arga*dvsdga*dfbdvb
c
c.....current factors in linear region
c
400   continue
      vdsx=dmin1(vds,vdsat)
      if ( vdsx.eq.0.0d0 ) go to 900
      cdo=vgsx-vth-0.5d0*(1.0d0+fbody)*vdsx
      dcodvg=1.0d0
      if (vds.lt.vdsat) dcodvd=-dvtdvd-0.5d0*(1.0d0+fbody)
      dcodvb=-dvtdvb-0.5d0*dfbdvb*vdsx
c
c.....normalized drain current
c
410   continue
      cdnorm=cdo*vdsx
      gm=vdsx
      gds=vgsx-vth-(1.0d0+fbody+dvtdvd)*vdsx
      gmbs=dcodvb*vdsx
c
c.....drain current without velocity saturation effect
c
      cd1=beta*cdnorm
      beta=beta*fgate
      cdrain=beta*cdnorm
      gm=beta*gm+dfgdvg*cd1
      gds=beta*gds+dfgdvd*cd1
      gmbs=beta*gmbs
c
c.....velocity saturation factor
c
      if ( vmax.eq.0.0d0 ) go to 500
      fdrain=1.0d0/(1.0d0+vdsx*onvdsc)
      fd2=fdrain*fdrain
      arga=fd2*vdsx*onvdsc*onfg
      dfddvg=-dfgdvg*arga
      dfddvd=-dfgdvd*arga-fd2*onvdsc
      dfddvb=-dfgdvb*arga
c
c.....drain current
c
      gm=fdrain*gm+dfddvg*cdrain
      gds=fdrain*gds+dfddvd*cdrain
      gmbs=fdrain*gmbs+dfddvb*cdrain
      cdrain=fdrain*cdrain
      beta=beta*fdrain
c
c.....channel length modulation
c
500   continue
      if ( vds.le.vdsat ) go to 700
      if ( vmax.eq.0.0d0 ) go to 510
      if (alpha.eq.0.0d0) go to 700
      cdsat=cdrain
      gdsat=cdsat*(1.0d0-fdrain)*onvdsc
      gdsat=dmax1(1.0d-12,gdsat)
      gdoncd=gdsat/cdsat
      gdonfd=gdsat/(1.0d0-fdrain)
      gdonfg=gdsat*onfg
      dgdvg=gdoncd*gm-gdonfd*dfddvg+gdonfg*dfgdvg
      dgdvd=gdoncd*gds-gdonfd*dfddvd+gdonfg*dfgdvd
      dgdvb=gdoncd*gmbs-gdonfd*dfddvb+gdonfg*dfgdvb
c
      emax=cdsat*onxl/gdsat
      emoncd=emax/cdsat
      emongd=emax/gdsat
      demdvg=emoncd*gm-emongd*dgdvg
      demdvd=emoncd*gds-emongd*dgdvd
      demdvb=emoncd*gmbs-emongd*dgdvb
c
      arga=0.5d0*emax*alpha
      argc=xkappa*alpha
      argb=dsqrt(arga*arga+argc*(vds-vdsat))
      delxl=argb-arga
      dldvd=argc/(argb+argb)
      dldem=0.5d0*(arga/argb-1.0d0)*alpha
      ddldvg=dldem*demdvg
      ddldvd=dldem*demdvd-dldvd
      ddldvb=dldem*demdvb
      go to 520
510   continue
      delxl=dsqrt(xkappa*(vds-vdsat)*alpha)
      dldvd=0.5d0*delxl/(vds-vdsat)
      ddldvg=0.0d0
      ddldvd=-dldvd
      ddldvb=0.0d0
c
c.....punch through approximation
c
520   continue
      if ( delxl.le.(0.5d0*xl) ) go to 600
      wcs2=wcs*wcs
      delxl=xl-(xl**2/(4.0d0*delxl))
      arga=4.0d0*(xl-delxl)**2/xl**2
      ddldvg=ddldvg*arga
      ddldvd=ddldvd*arga
      ddldvb=ddldvb*arga
       dldvd= dldvd*arga
c
c.....saturation region
c
600   continue
      dlonxl=delxl*onxl
      xlfact=1.0d0/(1.0d0-dlonxl)
      cdrain=cdrain*xlfact
      diddl=cdrain/(xl-delxl)
      gm=gm*xlfact+diddl*ddldvg
      gds0=gds*xlfact+diddl*ddldvd
      gmbs=gmbs*xlfact+diddl*ddldvb
      gm=gm+gds0*dvsdvg
      gmbs=gmbs+gds0*dvsdvb
      gds=gds0*dvsdvd+diddl*dldvd
c
c.....finish strong inversion case
c
700   continue
      if ( vgs.ge.von ) go to 750
c
c.....weak inversion
c
                onxn=1.0d0/xn
                ondvt=onxn/vt
                wfact=dexp( (vgs-von)*ondvt )
                cdrain=cdrain*wfact
                gms=gm*wfact
                gmw=cdrain*ondvt
                gm=gmw
                if (vds.gt.vdsat) gm=gm+gds0*dvsdvg*wfact
                gds=gds*wfact+(gms-gmw)*dvodvd
                gmbs=gmbs*wfact+(gms-gmw)*dvodvb
     1                         -gmw*(vgs-von)*onxn*dxndvb
c
c.....charge computation
c
  750 continue
      if (icharg.eq.0) go to 1000
      if (vgs.le.vth) go to 800
      call mqspof(vds,vbs,vgs,vpof,vdsat1,vth,vbin,gamasd,
     1   qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      go to 2000
c
c.....charge computation for vgs<vth
c
800   continue
      xqc=xqco
      call mosq3(vds,vbs,vpof,vdsat1,vth,vbin,gamasd,cox,phi,
     1   qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      qspof=0.0d0
      go to 2000
c
c.....special case of vds=0.0d0
c
900   continue
      beta=beta*fgate
      cdrain=0.0d0
      gm=0.0d0
      gds=beta*(vgsx-vth)
      gmbs=0.0d0
           if ( (xnfs.ne.0.0d0).and.(vgs.lt.von) )
     1          gds=gds*dexp((vgs-von)/(vt*xn))
      if (icharg.eq.0) go to 1000
      call mosq3(vds,vbs,vpof,vdsat1,vth,vbin,gamasd,cox,phi,
     1   qg,qc,qb,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
1000  qspof=0.0d0
c
c.....done
c
 2000 return
      end

c spice version 2g.6  sccsid=readin.ma 3/22/83
      subroutine readin
      implicit double precision (a-h,o-z)
c
c
c     this routine drives the input processing of spice.  element cards
c and device models are handled by this routine.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=line 3/15/83
      common /line/ achar,afield(15),oldlin(15),kntrc,kntlim
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=cje 3/15/83
      common /cje/ maxtim,itime,icost
c spice version 2g.6  sccsid=debug 3/15/83
      common/debug/ idebug(20)
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c  control card identifiers
c
      dimension aide(20),nnods(20),ntnods(20),l2nod(24)
      dimension numic(4)
      dimension aidm(7),ipolar(7),modid(7),ipar(5),ampar(115)
      dimension titinp(4)
      dimension aidc(22)
      data titinp / 8hinput li, 8hsting   , 8h        , 8h         /
      data naidc / 22 /
      data aidc / 8hac      , 8hdc      , 8hdistorti, 8hend     ,
     1            8hends    , 8hfourier , 8hmodel   , 8hnoise   ,
     2            8hop      , 8hoptions , 8hplot    , 8hprint   ,
     3            8hsubckt  , 8hsensitiv, 8htransien, 8htf      ,
     4            8htemperat, 8hwidth   , 8hnodeset , 8hic      ,
     5            8h:debug: , 8halter   /
c
c  element card identifiers, keywords, and information
c
      data aide / 1hr,1hc,1hl,1hk,1hg,1he,1hf,1hh,1hv,1hi,1hd,1hq,1hj,
     1   1hm,1hs,1hy,1ht,0.0d0,1hx,0.0d0 /
      data alsac,alspu,alsex,alssi /2hac,2hpu,2hex,2hsi/
      data alsoff,alsdc,alspw / 3hoff,2hdc,3hpw  /
      data alsz0,alszo,alsnl,alsf,alstd / 2hz0,2hzo,2hnl,1hf,2htd /
      data alsl,alsw,alsas,alsad,alspd,alsps,alsrds,alsrss,alsxqc
     1   /1hl,1hw,2has,2had,2hpd,2hps,3hnrd,3hnrs,3hxqc/
      data alszx /2hzx/
      data alssf / 4hsf   /
      data apoly, aic, area / 4hpoly, 2hic, 4harea /
      data alstc / 2htc /
      data numic / 1, 2, 2, 3 /
      data ablnk, aper / 1h , 1h. /
      data nnods / 2,2,2,0,2,2,2,2,2,2,2,3,3,4,4,4,4,0,0,0 /
      data ntnods / 2,2,2,0,2,2,2,2,2,2,3,6,5,6,4,4,4,0,0,0 /
      data l2nod / 8,12,14, 6,13,14,13,14,11, 6,
     1            16,36,25,33, 6, 6,33, 0, 3, 3,
     2             3, 3, 3, 3 /
c
c  model card keywords
c
      data aidm /1hd,3hnpn,3hpnp,3hnjf,3hpjf,4hnmos,4hpmos/
      data ipolar /0,1,-1,1,-1,1,-1/
      data modid /1,2,2,3,3,4,4/
      data ipar / 0, 14, 60, 72, 114/
      data ampar /
     1   6his    ,6hrs    ,6hn     ,6htt    ,6hcjo   ,6hvj    ,6hm     ,
     2   6heg    ,6hxti   ,6hkf    ,6haf    ,6hfc    ,6hbv    ,6hibv   ,
     1   6his    ,6hbf    ,6hnf    ,6hvaf   ,6hikf   ,6hise   ,6hne    ,
     2   6hbr    ,6hnr    ,6hvar   ,6hikr   ,6hisc   ,6hnc    ,6h0     ,
     3   6h0     ,6hrb    ,6hirb   ,6hrbm   ,6hre    ,6hrc    ,6hcje   ,
     4   6hvje   ,6hmje   ,6htf    ,6hxtf   ,6hvtf   ,6hitf   ,6hptf   ,
     5   6hcjc   ,6hvjc   ,6hmjc   ,6hxcjc  ,6htr    ,6h0     ,6h0     ,
     6   6h0     ,6h0     ,6hcjs   ,6hvjs   ,6hmjs   ,6hxtb   ,6heg    ,
     7   6hxti   ,6hkf    ,6haf    ,6hfc    ,
     1   6hvto   ,6hbeta  ,6hlambda,6hrd    ,6hrs    ,6hcgs   ,6hcgd   ,
     2   6hpb    ,6his    ,6hkf    ,6haf    ,6hfc    ,
     1   6hlevel ,6hvto   ,6hkp    ,6hgamma ,6hphi   ,6hlambda,6hrd    ,
     2   6hrs    ,6hcbd   ,6hcbs   ,6his    ,6hpb    ,6hcgso  ,6hcgdo  ,
     3   6hcgbo  ,6hrsh   ,6hcj    ,6hmj    ,6hcjsw  ,6hmjsw  ,6hjs    ,
     4   6htox   ,6hnsub  ,6hnss   ,6hnfs   ,6htpg   ,6hxj    ,6hld    ,
     5   6huo    ,6hucrit ,6huexp  ,6hutra  ,6hvmax  ,6hneff  ,6hxqc   ,
     6   6hkf    ,6haf    ,6hfc    ,6hdelta ,6htheta ,6heta   ,6hkappa ,
     7   0.0d0   /
c
c  initialize variables
c
      call second(t1)
      call zero4(idebug,20)
      call getlin
      if (keof.ne.0) go to 6000
      call copy8(afield,atitle,10)
      call getm4(ielmnt,0)
      call getm8(itemps,1)
      value(itemps+1)=27.0d0
      itemno=1
      nopage=0
      call title(-1,72,1,titinp)
      iwidth=80
      do 5 i=1,8
      achar=ablnk
      call move(achar,1,atitle(10),i,1)
      if(achar.eq.ablnk) go to 8
    5 continue
      write(iofile,6)
    6 format('0warning:  input line-width set to 72 columns because',/
     11x,'possible sequencing appears in cols 73-80')
      iwidth=72
    8 do 10 i=1,15
      afield(i)=ablnk
   10 continue
      call copy8(afield,oldlin,15)
      call getm4(isbckt,0)
      nsbckt=0
      call getm8(iunsat,0)
      nunsat=0
      numalt=0
      numcyc=0
      lwidth=132
      iprnta=0
      iprntl=0
      iprntm=1
      iprntn=0
      iprnto=0
      gmin=1.0d-12
      pivtol=1.0d-13
      pivrel=1.0d-3
      reltol=0.001d0
      abstol=1.0d-12
      vntol=1.0d-6
      trtol=7.0d0
      chgtol=1.0d-14
      defl=1.0d-4
      defw=1.0d-4
      defad=0.0d0
      defas=0.0d0
      numdgt=4
      numtem=1
      itl1=100
      itl2=50
      itl3=4
      itl4=10
      itl5=5000
      itl6=0
      limtim=2
      limpts=201
      lvlcod=1
      lvltim=2
      method=1
      xmu=0.5d0
      maxord=2
      nosolv=0
      icvflg=0
      itcelm(2)=0
      idist=0
      idprt=0
      inoise=0
      jacflg=0
      jtrflg=0
      call getm4(ifour,0)
      nfour=0
      call getm4(nsnod,0)
      call getm8(nsval,0)
      call getm4(icnod,0)
      call getm8(icval,0)
      kinel=0
      kovar=0
      kssop=0
      nosprt=0
      nsens=0
      call getm4(isens,0)
      numnod=0
      ncnods=0
      nunods=0
      call zero4(locate,50)
      call zero4(jelcnt,50)
      insize=50
      call getm8(ifield,insize)
      call getm4(icode,insize)
      call getm8(idelim,insize)
      call getm4(icolum,insize)
      go to 50
c
c  error entry
c
   40 nogo=1
c
c  read and decode next card in input deck
c
   50 igoof=0
      call card
      if (keof.ne.0) go to 5000
      if (igoof.ne.0) go to 40
      if (nodplc(icode+1).eq.0) go to 95
      anam=value(ifield+1)
      call move(anam,2,ablnk,1,7)
      if (anam.ne.aper) go to 70
      call move(anam,1,value(ifield+1),2,7)
      call keysrc(aidc,naidc,anam,id)
      if (id.le.0) go to 90
      if (id.eq.4) go to 5000
      if (id.eq.5) go to 800
      if (id.eq.7) go to 500
      if (id.eq.13) go to 700
      if (id.eq.22) numalt=numalt+1
      if (nsbckt.ge.1) go to 85
      if (id.ne.22) call runcon(id)
      if (igoof.ne.0) go to 40
      go to 50
   70 id=0
   80 id=id+1
      if (id.gt.20) go to 90
      if (anam.eq.aide(id)) go to 100
      go to 80
   85 write (iofile,86)
   86 format('0warning:  above line not allowed within subcircuit -- ',
     1   'ignored'/)
      go to 50
   90 write (iofile,91) value(ifield+1)
   91 format('0*error*:  unknown data card:  ',a8/)
      go to 40
   95 write (iofile,96)
   96 format('0*error*:  unrecognizable data card'/)
      go to 40
c
c  element and device cards
c
  100 call find(value(ifield+1),id,loc,1)
      locv=nodplc(loc+1)
      if (id.eq.4) go to 140
      if (id.eq.19) go to 900
      istop=nnods(id)+1
      if (nodplc(loc+l2nod(id)).ne.0) go to 113
      do 110 i=2,istop
      if (nodplc(icode+i).ne.0) go to 410
      if (value(ifield+i).lt.0.0d0) go to 400
  110 nodplc(loc+i)=value(ifield+i)
      go to 115
  113 do 114 i=2,istop
      nodplc(loc+i)=0
  114 continue
  115 go to (120,130,130,140,150,150,180,180,200,200,300,300,300,300,
     1   390,390,350,390,390,390), id
c
c  resistor
c
  120 if (nodplc(icode+4).ne.0) go to 420
      if (value(ifield+4).eq.0.0d0) go to 480
      value(locv+2)=value(ifield+4)
      ifld=4
  122 ifld=ifld+1
      if (nodplc(icode+ifld)) 50,122,124
  124 anam=value(ifield+ifld)
      if (anam.ne.alstc) go to 460
      ifld=ifld+1
      if (nodplc(icode+ifld)) 50,126,124
  126 value(locv+3)=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld)) 50,128,124
  128 value(locv+4)=value(ifield+ifld)
      go to 50
c
c  capacitor or inductor
c
  130 iknt=0
      ltab=7
      if (id.eq.3) ltab=10
      if (nodplc(icode+4)) 420,131,132
  131 if (value(ifield+4).le.0.0d0) go to 420
      value(locv+1)=value(ifield+4)
      nodplc(loc+4)=1
      ifld=5
      if (nodplc(icode+ifld)) 50,420,139
  132 call getm8(nodplc(loc+ltab),0)
      anam=value(ifield+4)
      if (anam.ne.apoly) go to 450
      ifld=4
  134 ifld=ifld+1
      if (nodplc(icode+ifld)) 50,136,138
  136 call extmem(nodplc(loc+ltab),1)
      iknt=iknt+1
      ispot=nodplc(loc+ltab)+iknt
      value(ispot)=value(ifield+ifld)
      go to 134
  138 if (iknt.eq.0) go to 420
  139 anam=value(ifield+ifld)
      if (anam.ne.aic) go to 460
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 50
      value(locv+2)=value(ifield+ifld)
      go to 50
c
c  mutual inductance
c
  140 if (nodplc(icode+2).ne.1) go to 430
      anam=value(ifield+2)
      call move(anam,2,ablnk,1,7)
      if (anam.ne.aide(3)) go to 430
      call extnam(value(ifield+2),nodplc(loc+2))
      if (nodplc(icode+3).ne.1) go to 430
      anam=value(ifield+3)
      call move(anam,2,ablnk,1,7)
      if (anam.ne.aide(3)) go to 430
      call extnam(value(ifield+3),nodplc(loc+3))
      if (nodplc(icode+4).ne.0) go to 420
      xk=value(ifield+4)
      if (xk.le.0.0d0) go to 420
      if (xk.le.1.0d0) go to 145
      xk=1.0d0
      write (iofile,141)
  141 format('0warning:  coefficient of coupling reset to 1.0d0'/)
  145 value(locv+1)=xk
      go to 50
c
c  voltage controlled (nonlinear) sources
c
  150 ndim=1
      ifld=3
      if (nodplc(icode+4)) 410,156,152
  152 anam=value(ifield+4)
      if (anam.ne.apoly) go to 450
      if (nodplc(icode+5).ne.0) go to 420
      ndim=value(ifield+5)
      if (ndim.le.0) go to 420
      ifld=5
  156 nodplc(loc+4)=ndim
      ltab=id+1
      nssnod=2*ndim
      nmat=4*ndim
      if (id.eq.6) nmat=4+2*ndim
      call getm4(nodplc(loc+ltab),nssnod)
      call getm4(nodplc(loc+ltab+1),nmat)
      call getm8(nodplc(loc+ltab+2),0)
      call getm8(nodplc(loc+ltab+3),ndim)
      call getm4(nodplc(loc+ltab+4),ndim)
      call getm8(nodplc(loc+ltab+5),ndim)
      ispot=nodplc(loc+ltab+5)
      call zero8(value(ispot+1),ndim)
      lnod=nodplc(loc+ltab)
      do 158 i=1,nssnod
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 410
      if (value(ifield+ifld).lt.0.0d0) go to 400
      nodplc(lnod+i)=value(ifield+ifld)
  158 continue
  160 iknt=0
  162 ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 164
      call extmem(nodplc(loc+ltab+2),1)
      iknt=iknt+1
      ispot=nodplc(loc+ltab+2)+iknt
      value(ispot)=value(ifield+ifld)
      go to 162
  164 if (iknt.eq.0) go to 420
      if (nodplc(icode+ifld).ne.1) go to 170
      anam=value(ifield+ifld)
      if (anam.ne.aic) go to 460
      do 168 i=1,ndim
      ifld=ifld+1
      if (nodplc(icode+ifld)) 170,166,420
  166 ispot=nodplc(loc+ltab+5)+i
      value(ispot)=value(ifield+ifld)
  168 continue
  170 if (ndim.ne.1) go to 50
      if (iknt.ne.1) go to 50
      call extmem(nodplc(loc+ltab+2),1)
      ispot=nodplc(loc+ltab+2)
      value(ispot+2)=value(ispot+1)
      value(ispot+1)=0.0d0
      go to 50
c
c  current controlled (nonlinear) sources
c
  180 ndim=1
      ifld=3
      if (nodplc(icode+4).ne.1) go to 470
      anam=value(ifield+4)
      if (anam.ne.apoly) go to 182
      ifld=5
      if (nodplc(icode+5).ne.0) go to 420
      ndim=value(ifield+5)
      if (ndim.le.0) go to 420
  182 nodplc(loc+4)=ndim
      ltab=id-1
      nmat=2*ndim
      if (id.eq.8) nmat=4+ndim
      call getm4(nodplc(loc+ltab),ndim)
      call getm4(nodplc(loc+ltab+1),nmat)
      call getm8(nodplc(loc+ltab+2),0)
      call getm8(nodplc(loc+ltab+3),ndim)
      call getm4(nodplc(loc+ltab+4),ndim)
      call getm8(nodplc(loc+ltab+5),ndim)
      ispot=nodplc(loc+ltab+5)
      call zero8(value(ispot+1),ndim)
      do 184 i=1,ndim
      ifld=ifld+1
      if (nodplc(icode+ifld).ne.1) go to 470
      anam=value(ifield+ifld)
      call move(anam,2,ablnk,1,7)
      if (anam.ne.aide(9)) go to 470
      call extnam(value(ifield+ifld),loct)
      ispot=nodplc(loc+ltab)+i
      nodplc(ispot)=loct
  184 continue
      go to 160
c
c  independent sources
c
  200 ifld=3
      call getm8(nodplc(loc+5),0)
  210 ifld=ifld+1
  215 if (nodplc(icode+ifld)) 50,220,230
  220 if (ifld.gt.4) go to 210
  225 value(locv+1)=value(ifield+ifld)
      go to 210
  230 anam=value(ifield+ifld)
      if (anam.ne.alsdc) go to 235
      ifld=ifld+1
      if (nodplc(icode+ifld)) 50,225,230
  235 if (anam.ne.alsac) go to 260
      value(locv+2)=1.0d0
      ifld=ifld+1
      if (nodplc(icode+ifld)) 50,240,230
  240 value(locv+2)=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld)) 50,250,230
  250 value(locv+3)=value(ifield+ifld)
      go to 210
  260 id=0
      call move(anam,3,ablnk,1,6)
      if (anam.eq.alspu) id=1
      if (anam.eq.alssi) id=2
      if (anam.eq.alsex) id=3
      if (anam.eq.alspw) id=4
      if (anam.eq.alssf) id=5
      if (id.eq.0) go to 450
      nodplc(loc+4)=id
      iknt=0
  270 ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 280
      call extmem(nodplc(loc+5),1)
      iknt=iknt+1
      ispot=nodplc(loc+5)+iknt
      value(ispot)=value(ifield+ifld)
      go to 270
  280 aval=0.0d0
      if (id.ne.4) go to 285
c...  for pwl source function, force even number of input values
      ibit=0
      if(iknt.ne.(iknt/2)*2) ibit=1
      aval=value(ispot)
      if (ibit.eq.0) go to 290
      call extmem(nodplc(loc+5),1)
      aval=value(ispot-1)
      iknt=iknt+1
      ispot=nodplc(loc+5)+iknt
      value(ispot)=aval
      go to 290
  285 if (iknt.ge.7) go to 215
  290 call extmem(nodplc(loc+5),2)
      ispot=nodplc(loc+5)+iknt
      value(ispot+1)=0.0d0
      value(ispot+2)=aval
      iknt=iknt+2
      go to 285
c
c  device cards
c
  300 value(locv+1)=1.0d0
      if (id.ne.14) go to 305
      value(locv+1)=0.0d0
      value(locv+11)=0.0d0
      value(locv+12)=0.0d0
      value(locv+13)=1.0d0
      value(locv+14)=1.0d0
      value(locv+15)=0.0d0
  305 locm=loc+ntnods(id)+2
      ifld=nnods(id)+2
c
c  temporarily (until modchk) put bjt's substrate node into nodplc(loc+5)
c
      if(id.ne.12) go to 308
      if(nodplc(icode+5).ne.0) go to 308
      ifld=6
      if (nodplc(loc+l2nod(id)).ne.0) go to 306
      nodplc(loc+5)=value(ifield+5)
      go to 308
  306 nodplc(loc+5)=0
  308 continue
c
c    reserve device internal nodes,read device geometry parameters
c    and initial conditions
c
      if (nodplc(icode+ifld).ne.1) go to 440
      call extnam(value(ifield+ifld),nodplc(locm))
  310 ifld=ifld+1
      if (nodplc(icode+ifld)) 50,325,315
  315 anam=value(ifield+ifld)
      if (anam.ne.alsoff) go to 320
      nodplc(locm+1)=1
      go to 310
  320 if (anam.ne.area) go to 330
      ifld=ifld+1
      if (nodplc(icode+ifld)) 50,325,315
  325 if (value(ifield+ifld).le.0.0d0) go to 420
      if (id.eq.14) go to 343
      value(locv+1)=value(ifield+ifld)
      go to 310
  330 if (anam.ne.aic) go to 341
      iknt=0
      icloc=0
      if (id.eq.14) icloc=3
      maxknt=numic(id-10)
  335 ifld=ifld+1
      if (nodplc(icode+ifld)) 50,340,315
  340 iknt=iknt+1
      if (iknt.gt.maxknt) go to 335
      value(locv+icloc+iknt+1)=value(ifield+ifld)
      go to 335
  341 if (id.ne.14) go to 460
      ispot=0
      if (anam.eq.alsl) ispot=1
      if (anam.eq.alsw) ispot=2
      if (anam.eq.alsad) ispot=3
      if (anam.eq.alszx) ispot=3
      if (anam.eq.alsas) ispot=4
      if (anam.eq.alspd) ispot=11
      if (anam.eq.alsps) ispot=12
      if (anam.eq.alsrds) ispot=13
      if (anam.eq.alsrss) ispot=14
      if (anam.eq.alsxqc) ispot=15
      if (ispot.eq.0) go to 460
      ifld=ifld+1
      if (nodplc(icode+ifld)) 50,342,315
  342 if (value(ifield+ifld).le.0.0d0) go to 420
      value(locv+ispot)=value(ifield+ifld)
      go to 310
  343 iknt=0
  344 iknt=iknt+1
      if(value(ifield+ifld).le.0.0d0) go to 420
      if(iknt.gt.15) go to 490
      if(iknt.eq.5) iknt=11
      value(locv+iknt)=value(ifield+ifld)
      ifld=ifld+1
      if(nodplc(icode+ifld)) 345,344,345
  345 if(nodplc(icode+ifld)) 50,50,315
c
c  transmission lines
c
  350 ifld=5
      xnl=0.25d0
      tfreq=0.0d0
  355 ifld=ifld+1
      if (nodplc(icode+ifld)) 378,355,360
  360 anam=value(ifield+ifld)
      if (anam.eq.aic) go to 364
      if (anam.eq.alsnl) go to 370
      if (anam.eq.alsf) go to 374
      id=0
      if (anam.eq.alsz0) id=1
      if (anam.eq.alszo) id=1
      if (anam.eq.alstd) id=2
      if (id.eq.0) go to 460
      ifld=ifld+1
      if (nodplc(icode+ifld)) 378,362,360
  362 if (value(ifield+ifld).le.0.0d0) go to 420
      value(locv+id)=value(ifield+ifld)
      go to 355
  364 iknt=0
  366 ifld=ifld+1
      if (nodplc(icode+ifld)) 378,368,360
  368 iknt=iknt+1
      if (iknt.gt.4) go to 366
      value(locv+iknt+4)=value(ifield+ifld)
      go to 366
  370 ifld=ifld+1
      if (nodplc(icode+ifld)) 378,372,360
  372 if (value(ifield+ifld).le.0.0d0) go to 420
      xnl=value(ifield+ifld)
      go to 355
  374 ifld=ifld+1
      if (nodplc(icode+ifld)) 378,376,360
  376 if (value(ifield+ifld).le.0.0d0) go to 420
      tfreq=value(ifield+ifld)
      go to 355
  378 if (value(locv+1).ne.0.0d0) go to 380
      write (iofile,379)
  379 format('0*error*:  z0 must be specified'/)
      go to 40
  380 if (value(locv+2).ne.0.0d0) go to 50
      if (tfreq.ne.0.0d0) go to 382
      write (iofile,381)
  381 format('0*error*:  either td or f must be specified'/)
      go to 40
  382 value(locv+2)=xnl/tfreq
      go to 50
c
c  elements not yet implemented
c
  390 write (iofile,391)
  391 format('0*error*:  element type not yet implemented'/)
      go to 40
c
c  element card errors
c
  400 write (iofile,401)
  401 format('0*error*:  negative node number found'/)
      go to 40
  410 write (iofile,411)
  411 format('0*error*:  node numbers are missing'/)
      go to 40
  420 write (iofile,421)
  421 format('0*error*:  value is missing or is nonpositive'/)
      go to 40
  430 write (iofile,431)
  431 format('0*error*:  mutual inductance references are missing'/)
      go to 40
  440 write (iofile,441)
  441 format('0*error*:  model name is missing'/)
      go to 40
  450 write (iofile,451) anam
  451 format('0*error*:  unknown source function:  ',a8)
      go to 40
  460 write (iofile,461) anam
  461 format('0*error*:  unknown parameter:  ',a8/)
      go to 40
  470 write (iofile,471)
  471 format('0*error*:  voltage source not found on above line'/)
      go to 40
  480 write (iofile,481)
  481 format('0*error*:  value is zero'/)
      go to 40
  490 write(iofile,491)
  491 format('0*error*:  extra numerical data on mosfet card'/)
      go to 40
c
c  model card
c
  500 if (nodplc(icode+2).ne.1) go to 650
      if (nodplc(icode+3).ne.1) go to 650
      id=0
  510 id=id+1
      if (id.gt.7) go to 660
      if (value(ifield+3).ne.aidm(id)) go to 510
      ipol=ipolar(id)
      jtype=modid(id)
      id=jtype+20
      call find(value(ifield+2),id,loc,1)
      nodplc(loc+2)=ipol
      locv=nodplc(loc+1)
  520 locm=ipar(jtype)
      nopar=ipar(jtype+1)-locm
      ifld=3
  530 ifld=ifld+1
      if (nodplc(icode+ifld)) 50,530,560
  560 anam=value(ifield+ifld)
      if(jtype.eq.2) anam=alias(anam)
      iknt=0
  570 iknt=iknt+1
      if (iknt.gt.nopar) go to 670
      if (anam.ne.ampar(locm+iknt)) go to 570
      ifld=ifld+1
      if (nodplc(icode+ifld)) 50,580,560
  580 value(locv+iknt)=value(ifield+ifld)
      ifld=ifld+1
      if (nodplc(icode+ifld)) 50,590,560
  590 iknt=iknt+1
      if (iknt.gt.nopar) go to 530
      if (ablnk.ne.ampar(locm+iknt)) go to 530
      go to 580
c
c  model card errors
c
  650 write (iofile,651)
  651 format('0*error*:  model type is missing'/)
      go to 40
  660 write (iofile,661) value(ifield+3)
  661 format('0*error*:  unknown model type:  ',a8/)
      go to 40
  670 write (iofile,671) anam
  671 format('0*error*:  unknown model parameter:  ',a8,/)
      nogo=1
      go to 530
c
c  subcircuit definition
c
  700 if (nodplc(icode+2).ne.1) go to 780
      call find(value(ifield+2),20,loc,1)
      call extmem(isbckt,1)
      nsbckt=nsbckt+1
      nodplc(isbckt+nsbckt)=loc
      ifld=2
      if (nodplc(icode+3).ne.0) go to 790
      call getm4(nodplc(loc+2),0)
      iknt=0
  710 ifld=ifld+1
      if (nodplc(icode+ifld)) 50,720,710
  720 call extmem(nodplc(loc+2),1)
      iknt=iknt+1
      ispot=nodplc(loc+2)+iknt
      if (value(ifield+ifld).le.0.0d0) go to 770
      nodplc(ispot)=value(ifield+ifld)
      node=nodplc(ispot)
      i=iknt-1
  730 if (i.eq.0) go to 710
      ispot=ispot-1
      if (nodplc(ispot).eq.node) go to 760
      i=i-1
      go to 730
  760 write (iofile,761) node
  761 format('0*error*:  subcircuit definition duplicates node ',i5,/)
      go to 40
  770 write (iofile,771)
  771 format('0*error*:  nonpositive node number found in subcircuit ',
     1   'definition'/)
      go to 40
  780 write (iofile,781)
  781 format('0*error*:  subcircuit name missing'/)
      go to 40
  790 write (iofile,791)
  791 format('0*error*:  subcircuit nodes missing'/)
      go to 40
c
c  .ends processing
c
  800 if (nsbckt.eq.0) go to 890
      iknt=1
      if (nodplc(icode+2).le.0) go to 820
      anam=value(ifield+2)
      iknt=nsbckt
  810 loc=nodplc(isbckt+iknt)
      locv=nodplc(loc+1)
      anams=value(locv)
      if (anam.eq.anams) go to 820
      iknt=iknt-1
      if (iknt.ne.0) go to 810
      go to 880
  820 irel=nsbckt-iknt+1
      call relmem(isbckt,irel)
      nsbckt=nsbckt-irel
      go to 50
  880 write (iofile,881) anam
  881 format('0*error*:  unknown subcircuit name:  ',a8/)
      go to 40
  890 write (iofile,891)
  891 format('0warning:  no subcircuit definition known -- line ignored'
     1/)
      go to 50
c
c  subcircuit call
c
  900 call getm4(nodplc(loc+2),0)
      ifld=1
      iknt=0
  910 ifld=ifld+1
      if (nodplc(icode+ifld).ne.0) go to 920
      call extmem(nodplc(loc+2),1)
      iknt=iknt+1
      ispot=nodplc(loc+2)+iknt
      if (value(ifield+ifld).lt.0.0d0) go to 400
      nodplc(ispot)=value(ifield+ifld)
      go to 910
  920 if (iknt.eq.0) go to 410
      if (nodplc(icode+ifld).ne.1) go to 990
      call extnam(value(ifield+ifld),nodplc(loc+3))
      go to 50
  990 write (iofile,991)
  991 format('0*error*:  subcircuit name missing'/)
      go to 40
c
c  end
c
 5000 if (nsbckt.eq.0) go to 5010
      nsbckt=0
      write (iofile,5001)
 5001 format('0*error*:  .ends  card missing'/)
      nogo=1
 5010 call clrmem(ifield)
      call clrmem(icode)
      call clrmem(idelim)
      call clrmem(icolum)
      call clrmem(isbckt)
      if (nfour.eq.0) call clrmem(ifour)
      if (nsens.eq.0) call clrmem(isens)
 6000 call second(t2)
      rstats(1)=t2-t1
      return
      end

      subroutine reserv (node1,node2)
      implicit double precision (a-h,o-z)
c
c     this routine records the fact that the (node1, node2) element of
c the circuit equation coefficient matrix is nonzero.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      logical memptr
c
      if (nogo.ne.0) go to 300
c...  test for ground
      if (node1.eq.1) go to 300
      if (node2.eq.1) go to 300
c
c     reserve (node1,node2) in row node1 at col posn node2
c
      loc=node1
   10 locj=loc
      loc=nodplc(jcpt+loc)
      if (loc.eq.0) go to 20
      if (nodplc(jcolno+loc)-node2) 10,300,20
   20 call sizmem(jcpt,isize)
      newloc=isize+1
      nodplc(numoff+node1)=nodplc(numoff+node1)+1
      nodplc(nmoffc+node2)=nodplc(nmoffc+node2)+1
      call extmem(jcpt,1)
      call extmem(jcolno,1)
      nodplc(jcpt+locj)=newloc
      nodplc(jcpt+newloc)=loc
      nodplc(jcolno+newloc)=node2
c
c     reserve (node1,node2) in col node2 at row posn node1
c
      loc=node2
   30 loci=loc
      loc=nodplc(irpt+loc)
      if (loc.eq.0) go to 40
      if (nodplc(irowno+loc)-node1) 30,300,40
   40 call extmem(irpt,1)
      call extmem(irowno,1)
      nodplc(irpt+loci)=newloc
      nodplc(irpt+newloc)=loc
      nodplc(irowno+newloc)=node1
c
c     mark diagonal
c
      if (node1.ne.node2) go to 300
      if (memptr(ndiag)) nodplc(ndiag+node1)=1
c
c     finished
c
  300 return
      end

      subroutine keysrc(keytab,lentab,tstwrd,index)
      implicit double precision (a-h,o-z)
      double precision keytab
c
c     this routine searches the keyword table 'keytab' for the possible
c entry 'tstwrd'.  abbreviations are considered as matches.
c
      dimension keytab(lentab)
      integer xxor
      data ablnk / 1h  /
c
c
      index=0
      lenwrd=0
      achar=ablnk
      do 10 i=1,8
      call move(achar,8,tstwrd,i,1)
      if (achar.eq.ablnk) go to 20
      lenwrd=lenwrd+1
   10 continue
c
   20 if (lenwrd.eq.0) go to 40
      tstchr=ablnk
      call move(tstchr,8,tstwrd,1,1)
   30 index=index+1
      if (index.gt.lentab) go to 40
      akey=ablnk
      call move(akey,1,keytab(index),1,lenwrd)
      if (xxor(akey,tstwrd).eq.0) go to 50
      go to 30
c
   40 index=-1
   50 return
      end

      subroutine clrmem(ipntr)
      implicit double precision (a-h,o-z)
      dimension ipntr(1)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      logical memptr
c
c***  clrmem - release block
c
c
c...  check that pointer is valid
      if (memptr(ipntr(1))) go to 10
      memerr=5
      call errmem(1,memerr,ipntr(1))
   10 msiz=istack(ltab+2)
      muse=istack(ltab+3)
      memavl=memavl+nxtevn(muse)+istack(ltab+6)
c...  assumption:  first allocated block is never cleared.
      ltab1=ltab-ntab
      istack(ltab1+2)=istack(ltab1+2)+msiz
c...  reposition the block table
      nwords=ltab-loctab
      cpyknt=cpyknt+dble(nwords)
      call copy4(istack(loctab+1),istack(loctab+ntab+1),nwords)
      numblk=numblk-1
      loctab=loctab+ntab
      memavl=memavl+ntab
      ltab1=ldval-ntab
      istack(ltab1+2)=istack(ltab1+2)+ntab
      ipntr(1)=2**30-1
      call memadj
      return
      end

      subroutine modchk
      implicit double precision (a-h,o-z)
c
c     this routine performs one-time processing of device model para-
c meters and prints out a device model summary.  it also reserves the
c additional nodes required by nonzero device extrinsic resistances.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension itab(50),atable(12)
      dimension cpar(2),btable(12)
      dimension antype(4),aptype(4)
      dimension ipar(5),ampar(115),defval(115),ifmt(115),ivchk(115)
      dimension titled(4),titleb(4),titlej(4),titlem(4)
      data titled / 8hdiode mo, 8hdel para, 8hmeters  , 8h         /
      data titleb / 8hbjt mode, 8hl parame, 8hters    , 8h         /
      data titlej / 8hjfet mod, 8hel param, 8heters   , 8h         /
      data titlem / 8hmosfet m, 8hodel par, 8hameters , 8h         /
      data antype /1h ,3hnpn,3hnjf,4hnmos/
      data aptype /1h ,3hpnp,3hpjf,4hpmos/
      data ipar /0,14,60,72,114/
      data cpar / 3hc2 ,3hc4 /
      data aundef /2h.u/
      data ampar /
     1   6his    ,6hrs    ,6hn     ,6htt    ,6hcjo   ,6hvj    ,6hm     ,
     2   6heg    ,6hxti   ,6hkf    ,6haf    ,6hfc    ,6hbv    ,6hibv   ,
     1   6his    ,6hbf    ,6hnf    ,6hvaf   ,6hikf   ,6hise   ,6hne    ,
     2   6hbr    ,6hnr    ,6hvar   ,6hikr   ,6hisc   ,6hnc    ,6h0     ,
     3   6h0     ,6hrb    ,6hirb   ,6hrbm   ,6hre    ,6hrc    ,6hcje   ,
     4   6hvje   ,6hmje   ,6htf    ,6hxtf   ,6hvtf   ,6hitf   ,6hptf   ,
     5   6hcjc   ,6hvjc   ,6hmjc   ,6hxcjc  ,6htr    ,6h0     ,6h0     ,
     6   6h0     ,6h0     ,6hcjs   ,6hvjs   ,6hmjs   ,6hxtb   ,6heg    ,
     7   6hxti   ,6hkf    ,6haf    ,6hfc    ,
     1   6hvto   ,6hbeta  ,6hlambda,6hrd    ,6hrs    ,6hcgs   ,6hcgd   ,
     2   6hpb    ,6his    ,6hkf    ,6haf    ,6hfc    ,
     1   6hlevel ,6hvto   ,6hkp    ,6hgamma ,6hphi   ,6hlambda,6hrd    ,
     2   6hrs    ,6hcbd   ,6hcbs   ,6his    ,6hpb    ,6hcgso  ,6hcgdo  ,
     3   6hcgbo  ,6hrsh   ,6hcj    ,6hmj    ,6hcjsw  ,6hmjsw  ,6hjs    ,
     4   6htox   ,6hnsub  ,6hnss   ,6hnfs   ,6htpg   ,6hxj    ,6hld    ,
     5   6huo    ,6hucrit ,6huexp  ,6hutra  ,6hvmax  ,6hneff  ,6hxqc   ,
     6   6hkf    ,6haf    ,6hfc    ,6hdelta ,6htheta ,6heta   ,6hkappa ,
     7   0.0d0   /
      data defval /
     1   1.0d-14,  0.0d0,  1.0d0,2*0.0d0,  1.0d0,  0.5d0, 1.11d0,
     2     3.0d0,  0.0d0,  1.0d0,  0.5d0,  0.0d0, 1.0d-3,
     1   1.0d-16,100.0d0,  1.0d0,3*0.0d0,  1.5d0,2*1.0d0,3*0.0d0,
     2     2.0d0,  0.0d0,  1.0d0,6*0.0d0, 0.75d0, 0.33d0,2*0.0d0,
     3   4*0.0d0, 0.75d0, 0.33d0,  1.0d0,6*0.0d0, 0.75d0,2*0.0d0,
     4    1.11d0,  3.0d0,  0.0d0,  1.0d0,  0.5d0,
     1    -2.0d0, 1.0d-4,5*0.0d0,  1.0d0,1.0d-14,  0.0d0,  1.0d0,
     2     0.5d0,
     1     1.0d0,  0.0d0, 2.0d-5,  0.0d0,  0.6d0,5*0.0d0,1.0d-14,
     2     0.8d0,5*0.0d0,  0.5d0,  0.0d0, 0.33d0,5*0.0d0,  1.0d0,
     3   2*0.0d0,600.0d0, 1.0d+4,3*0.0d0,  1.0d0,  1.0d0,  0.0d0,
     4     1.0d0,  0.5d0,3*0.0d0,  0.2d0,
     5     0.0d0/
      data ifmt /
     1   4,1,1,2,2,1,1,1,1,2,1,1,2,2,
     2   4,3,3,2,2,2,1,3,3,2,2,2,1,0,0,1,2,1,1,1,2,1,1,2,2,2,2,1,2,1,
     2   1,1,2,0,0,0,0,2,1,1,2,1,1,2,2,2,
     3   3,4,1,1,1,2,2,1,2,2,1,1,
     4   3,3,4,1,1,2,1,1,2,2,2,1,2,2,2,1,2,1,2,1,2,2,2,2,2,1,2,2,
     4   1,2,1,1,2,1,1,2,1,1,1,1,1,1,
     5   0/
      data ivchk /
     1   0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     2   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     2   0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,
     3   -1,0,0,0,0,0,0,0,0,0,0,0,
     4   0,-1,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,-1,
     4   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     5   0/
c
c
      tnom=value(itemps+1)+ctok
      xkt=boltz*tnom
      vt=xkt/charge
      xni=1.45d16
      egfet=1.16d0-(7.02d-4*tnom*tnom)/(tnom+1108.0d0)
      nummod=jelcnt(21)+jelcnt(22)+jelcnt(23)+jelcnt(24)
      if (nummod.eq.0) go to 1000
c
c  special preprocessing for mosfet models
c
      loc=locate(24)
    5 if (loc.eq.0) go to 35
      locv=nodplc(loc+1)
      type=nodplc(loc+2)
c
c     default parameters for higher level mos models
c
      lev=value(locv+1)
      if (value(locv+1).eq.aundef) lev=1
      if (value(locv+23).ne.aundef) xnsub=value(locv+23)*1.0d6
      if (value(locv+22).eq.aundef.and.lev.gt.1) value(locv+22)=1.0d-7
      if (value(locv+22).eq.aundef) go to 33
      cox=epsox/value(locv+22)
c
c     compute kp, if not input, using default mobility 600 cm**2/v*sec
c
      if (value(locv+3).ne.aundef) go to 10
      if (value(locv+29).eq.aundef) value(locv+29)=600.0d0
      value(locv+3)=value(locv+29)*cox*1.0d-4
   10 if (value(locv+23).eq.aundef) go to 33
      if (xnsub.le.xni) go to 30
c
c     nsub nonzero => process oriented model
c
      if (value(locv+5).eq.aundef) value(locv+5)=
     1   dmax1((2.0d0*vt*dlog(xnsub/xni)),0.1d0)
      fermis=type*0.5d0*value(locv+5)
      wkfng=3.2d0
      if (value(locv+26).eq.aundef) value(locv+26)=1.0d0
      if (value(locv+26).eq.0.0d0) go to 15
c
c  polysilicon gate
c
      fermig=type*value(locv+26)*0.5d0*egfet
      wkfng=3.25d0+0.5d0*egfet-fermig
   15 wkfngs=wkfng-(3.25d0+0.5d0*egfet+fermis)
      if (value(locv+4).eq.aundef)
     1   value(locv+4)=dsqrt(2.0d0*epssil*charge*xnsub)/cox
c
c     computed vto
c
      if (value(locv+2).ne.aundef) go to 20
      if (value(locv+24).eq.aundef) value(locv+24)=0.0d0
      value(locv+44)=wkfngs-value(locv+24)*1.0d4*charge/cox
      value(locv+2)=value(locv+44)
     1   +type*(value(locv+4)*dsqrt(value(locv+5))+value(locv+5))
      go to 25
c
c     measured vto has been input
c
   20 value(locv+44)=value(locv+2)
     1   -type*(value(locv+4)*dsqrt(value(locv+5))+value(locv+5))
   25 value(locv+45)=dsqrt((epssil+epssil)/(charge*xnsub))
      go to 33
   30 value(locv+23)=0.0d0
      write (iofile,31) value(locv)
   31 format('0*error*:  nsub <= ni in mosfet model ',a8,/)
      nogo=1
c
c   special processing for mos3: limit kappa>0,
c   set to zero lambda,ucrit,uexp and utar
c
   33 if (lev.ne.3) go to 34
      if (value(locv+42).eq.aundef) value(locv+42)=0.2d0
      value(locv+6)=0.0d0
      value(locv+30)=0.0d0
      value(locv+31)=0.0d0
      value(locv+32)=0.0d0
   34 loc=nodplc(loc)
      go to 5
c
c     cycle thru devices
c
   35 kntlim=lwidth/11
      do 390 id=1,4
      if (jelcnt(id+20).eq.0) go to 390
      locm=ipar(id)
      nopar=ipar(id+1)-locm
      do 45 i=1,nopar
      if (ifmt(locm+i).ge.3) go to 40
      itab(i)=0
      go to 45
   40 itab(i)=ifmt(locm+i)-2
   45 continue
c
c  assign default values
c
      loc=locate(id+20)
   50 if (loc.eq.0) go to 70
      locv=nodplc(loc+1)
      do 65 i=1,nopar
      if (value(locv+i).eq.aundef) go to 62
      if (ivchk(locm+i).lt.0) go to 55
      if (value(locv+i).lt.0.0d0) go to 62
   55 if (itab(i).ne.0) go to 65
      itab(i)=ifmt(locm+i)
      go to 65
   62 value(locv+i)=defval(locm+i)
   65 continue
      loc=nodplc(loc)
      go to 50
c
c     limit model values
c
   70 go to (80,85,90,95), id
c...  diodes
   80 loc=locate(21)
   82 if (loc.eq.0) go to 130
      locv=nodplc(loc+1)
      value(locv+7)=dmin1(value(locv+7),0.9d0)
      value(locv+8)=dmax1(value(locv+8),0.1d0)
      value(locv+11)=dmax1(value(locv+11),0.1d0)
      value(locv+12)=dmin1(value(locv+12),0.95d0)
      loc=nodplc(loc)
      go to 82
c...  bipolar transistors
   85 loc=locate(22)
   87 if (loc.eq.0) go to 130
      locv=nodplc(loc+1)
      value(locv+23)=dmin1(value(locv+23),0.9d0)
      if (value(locv+24).eq.0.0d0) value(locv+28)=0.0d0
      value(locv+31)=dmin1(value(locv+31),0.9d0)
      value(locv+32)=dmin1(value(locv+32),1.0d0)
      value(locv+40)=dmin1(value(locv+40),0.9d0)
      value(locv+42)=dmax1(value(locv+42),0.1d0)
      value(locv+45)=dmax1(value(locv+45),0.1d0)
      value(locv+46)=dmin1(value(locv+46),0.9999d0)
      loc=nodplc(loc)
      if (value(locv+18).eq.0.0d0) value(locv+18)=value(locv+16)
      if (value(locv+16).ge.value(locv+18)) go to 87
      write(iofile,89) value(locv)
   89 format('0warning:  minimum base resistance (rbm) is less than '
     1       ,'total (rb) for model ',a8,/10x,' rbm set equal to rb',/)
      value(locv+18)=value(locv+16)
      go to 87
c...  jfets
   90 loc=locate(23)
   92 if (loc.eq.0) go to 130
      locv=nodplc(loc+1)
      value(locv+11)=dmax1(value(locv+11),0.1d0)
      value(locv+12)=dmin1(value(locv+12),0.95d0)
      loc=nodplc(loc)
      go to 92
c...  mosfets
   95 loc=locate(24)
   97 if (loc.eq.0) go to 130
      locv=nodplc(loc+1)
c
  100 value(locv+37)=dmax1(value(locv+37),0.1d0)
      value(locv+38)=dmin1(value(locv+38),0.95d0)
      if (value(locv+23).le.0.0d0) go to 120
      cj=dsqrt(epssil*charge*value(locv+23)*1.0d6/
     1   (2.0d0*value(locv+12)))
      if (value(locv+9).le.0.0d0) go to 105
      itab(9)=2
  105 if (value(locv+10).le.0.0d0) go to 110
      itab(10)=2
      go to 115
  110 if (value(locv+17).le.0.0d0) value(locv+17)=cj
      itab(17)=2
  115 if ((value(locv+7).le.0.0d0).and.
     1    (value(locv+8).le.0.0d0)) go to 120
      itab(7)=2
      itab(8)=2
  120 if (value(locv+6).ge.0.2d0) write (iofile,121) value(locv)
  121 format ('0warning:  the value of lambda for mosfet model ',a8,/,
     1   ' is unusually large and might cause nonconvergence',/)
      if (lev.ne.2) value(locv+35)=1.0d0
      if (lev.ne.3) go to 125
      itab(40)=1
      itab(41)=1
      itab(42)=1
      itab(43)=1
  125 loc=nodplc(loc)
      go to 97
c
c     print model parameters
c
  130 if (iprntm.eq.0) go to 360
      locs=locate(id+20)
  140 kntr=0
      loc=locs
      go to (150,160,170,180), id
  150 call title(0,lwidth,1,titled)
      go to 200
  160 call title(0,lwidth,1,titleb)
      go to 200
  170 call title(0,lwidth,1,titlej)
      go to 200
  180 call title(0,lwidth,1,titlem)
  200 if (loc.eq.0) go to 210
      if (kntr.lt.kntlim) go to 220
  210 locn=loc
      go to 240
  220 kntr=kntr+1
      locv=nodplc(loc+1)
      atable(kntr)=value(locv)
  230 loc=nodplc(loc)
      go to 200
  240 write (iofile,241) (atable(k),k=1,kntr)
  241 format(//11x,12(2x,a8))
      if (id.eq.1) go to 300
      kntr=0
      loc=locs
  250 if (loc.eq.0) go to 260
      if (kntr.ge.kntlim) go to 260
      kntr=kntr+1
      atable(kntr)=antype(id)
      if (nodplc(loc+2).eq.-1) atable(kntr)=aptype(id)
      loc=nodplc(loc)
      go to 250
  260 write (iofile,261) (atable(k),k=1,kntr)
  261 format('0type',4x,12(4x,a6))
  300 do 340 i=1,nopar
      if (itab(i).eq.0) go to 340
      kntr=0
      iccflg=0
      loc=locs
  310 if (loc.eq.0) go to 320
      if (kntr.ge.kntlim) go to 320
      locv=nodplc(loc+1)
      kntr=kntr+1
      if (iccflg.ne.0) go to 313
      if (id.ne.2) go to 315
      if ((i.ne.6).and.(i.ne.12)) go to 315
      if (value(locv+i).le.1.0d0) go to 315
      iccflg=i/6
  313 btable(kntr)=value(locv+i)
      value(locv+i)=value(locv+i)*value(locv+1)
  315 atable(kntr)=value(locv+i)
      loc=nodplc(loc)
      go to 310
  320 if (itab(i).eq.2) go to 330
      write (iofile,321) ampar(locm+i),(atable(k),k=1,kntr)
  321 format(1h0,a8,12f10.3)
      go to 340
  330 write (iofile,331) ampar(locm+i),(atable(k),k=1,kntr)
  331 format(1h0,a8,1p12d10.2)
      if (iccflg.eq.0) go to 340
      write (iofile,321) cpar(iccflg),(btable(k),k=1,kntr)
  340 continue
      if (locn.eq.0) go to 390
      locs=locn
      go to 140
c
c  special  treatment for c2 & c4 in the bjt model
c  when no model parameter print
c
  360 if (id.ne.2) go to 390
      loc=locate(id+20)
  370 if (loc.eq.0) go to 390
      locv=nodplc(loc+1)
      if (value(locv+6).ge.1.0d0)
     1   value(locv+6)=value(locv+6)*value(locv+1)
      if (value(locv+12).ge.1.0d0)
     1   value(locv+12)=value(locv+12)*value(locv+1)
      loc=nodplc(loc)
      go to 370
  390 continue
c
c  process model parameters
c
c  diodes
c
  400 loc=locate(21)
  410 if (loc.eq.0) go to 420
      locv=nodplc(loc+1)
      if (value(locv+2).ne.0.0d0) value(locv+2)=1.0d0/value(locv+2)
      pb=value(locv+6)
      xm=value(locv+7)
      fc=value(locv+12)
      value(locv+12)=fc*pb
      xfc=dlog(1.0d0-fc)
      value(locv+15)=pb*(1.0d0-dexp((1.0d0-xm)*xfc))/(1.0d0-xm)
      value(locv+16)=dexp((1.0d0+xm)*xfc)
      value(locv+17)=1.0d0-fc*(1.0d0+xm)
      csat=value(locv+1)
      vte=value(locv+3)*vt
      value(locv+18)=vte*dlog(vte/(root2*csat))
      bv=value(locv+13)
      if (bv.eq.0) go to 418
      cbv=value(locv+14)
      if (cbv.ge.csat*bv/vt) go to 412
      cbv=csat*bv/vt
      write (iofile,411) value(locv),cbv
  411 format('0warning:  in diode model ',a8,' ibv increased to ',1pe10.
     1   3,11x,'to resolve incompatibility with specified is'/)
      xbv=bv
      go to 416
  412 tol=reltol*cbv
      xbv=bv-vt*dlog(1.0d0+cbv/csat)
      iter=0
  413 xbv=bv-vt*dlog(cbv/csat+1.0d0-xbv/vt)
      xcbv=csat*(dexp((bv-xbv)/vt)-1.0d0+xbv/vt)
      if (dabs(xcbv-cbv).le.tol) go to 416
      iter=iter+1
      if (iter.lt.25) go to 413
      write (iofile,415) xbv,xcbv
  415 format('0warning:  unable to match forward and reverse diode regio
     1ns',/,11x,'bv = ',1pd10.3,' and ibv = ',d10.3,/)
  416 value(locv+13)=xbv
  418 loc=nodplc(loc)
      go to 410
c
c  bipolar transistor models
c
  420 loc=locate(22)
  430 if (loc.eq.0) go to 440
      locv=nodplc(loc+1)
      if (value(locv+4).ne.0.0d0) value(locv+4)=1.0d0/value(locv+4)
      if (value(locv+5).ne.0.0d0) value(locv+5)=1.0d0/value(locv+5)
      if (value(locv+10).ne.0.0d0) value(locv+10)=1.0d0/value(locv+10)
      if (value(locv+11).ne.0.0d0) value(locv+11)=1.0d0/value(locv+11)
      if (value(locv+19).ne.0.0d0) value(locv+19)=1.0d0/value(locv+19)
      if (value(locv+20).ne.0.0d0) value(locv+20)=1.0d0/value(locv+20)
      if (value(locv+26).ne.0.0d0) value(locv+26)=1.0d0/value(locv+26)
     1   /1.44d0
      value(locv+28)=value(locv+28)/rad*value(locv+24)
      if (value(locv+35).ne.0.0d0) value(locv+35)=1.0d0/value(locv+35)
     1   /1.44d0
      pe=value(locv+22)
      xme=value(locv+23)
      pc=value(locv+30)
      xmc=value(locv+31)
      fc=value(locv+46)
      value(locv+46)=fc*pe
      xfc=dlog(1.0d0-fc)
      value(locv+47)=pe*(1.0d0-dexp((1.0d0-xme)*xfc))/(1.0d0-xme)
      value(locv+48)=dexp((1.0d0+xme)*xfc)
      value(locv+49)=1.0d0-fc*(1.0d0+xme)
      value(locv+50)=fc*pc
      value(locv+51)=pc*(1.0d0-dexp((1.0d0-xmc)*xfc))/(1.0d0-xmc)
      value(locv+52)=dexp((1.0d0+xmc)*xfc)
      value(locv+53)=1.0d0-fc*(1.0d0+xmc)
      csat=value(locv+1)
      value(locv+54)=vt*dlog(vt/(root2*csat))
      loc=nodplc(loc)
      go to 430
c
c  jfet models
c
  440 loc=locate(23)
  450 if (loc.eq.0) go to 460
      locv=nodplc(loc+1)
      if (value(locv+4).ne.0.0d0) value(locv+4)=1.0d0/value(locv+4)
      if (value(locv+5).ne.0.0d0) value(locv+5)=1.0d0/value(locv+5)
      pb=value(locv+8)
      xm=0.5d0
      fc=value(locv+12)
      value(locv+12)=fc*pb
      xfc=dlog(1.0d0-fc)
      value(locv+13)=pb*(1.0d0-dexp((1.0d0-xm)*xfc))/(1.0d0-xm)
      value(locv+14)=dexp((1.0d0+xm)*xfc)
      value(locv+15)=1.0d0-fc*(1.0d0+xm)
      csat=value(locv+9)
      value(locv+16)=vt*dlog(vt/(root2*csat))
      loc=nodplc(loc)
      go to 450
c
c  mosfet models
c
  460 loc=locate(24)
  470 if (loc.eq.0) go to 600
      locv=nodplc(loc+1)
      type=nodplc(loc+2)
      if (value(locv+7).ne.0.0d0) value(locv+7)=1.0d0/value(locv+7)
      if (value(locv+8).ne.0.0d0) value(locv+8)=1.0d0/value(locv+8)
      if (value(locv+16).ne.0.0d0) value(locv+16)=1.0d0/value(locv+16)
      value(locv+23)=value(locv+23)*1.0d6
      value(locv+24)=value(locv+24)*1.0d4
      value(locv+25)=value(locv+25)*1.0d4
      if (value(locv+22).ne.0.0d0) value(locv+22)=epsox/value(locv+22)
      value(locv+29)=value(locv+29)*1.0d-4
      if (lev.eq.3) go to 472
      value(locv+30)=value(locv+30)*1.0d2
      go to 473
c
c   move mos3 parameters : theta from locations locv+40 to locv+30
c                          eta                       41         31
c                          kappa                     42         32
c   and replace locv+6 by (xd)**2
c
  472 value(locv+39)=value(locv+39)
     1   *0.25d0*twopi*epssil/value(locv+22)
      value(locv+30)=value(locv+40)
      value(locv+31)=value(locv+41)*8.15d-22/value(locv+22)
      value(locv+32)=value(locv+42)
      if (value(locv+23).gt.0.0d0)
     1    value(locv+6)=(epssil+epssil)/(charge*value(locv+23))
c
c   noise parameters
c
  473 pb=value(locv+12)
      xm=0.5d0
      fc=value(locv+38)
      value(locv+38)=fc*pb
      xfc=dlog(1.0d0-fc)
      value(locv+40)=pb*(1.0d0-dexp((1.0d0-xm)*xfc))/(1.0d0-xm)
      value(locv+41)=dexp((1.0d0+xm)*xfc)
      value(locv+42)=1.0d0-fc*(1.0d0+xm)
      value(locv+43)=-1.0d0
      value(locv+44)=value(locv+2)-
     1   type*value(locv+4)*dsqrt(value(locv+5))
  475 if (value(locv+22).ne.0.0d0.and.lev.ne.3)
     1   value(locv+30)=value(locv+30)*epssil/value(locv+22)
      loc=nodplc(loc)
      go to 470
c
c  reserve additional nodes
c
c  diodes
c
  600 loc=locate(11)
  610 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) go to 700
      locm=nodplc(loc+5)
      locm=nodplc(locm+1)
      if (value(locm+2).eq.0.0d0) go to 620
      numnod=numnod+1
      nodplc(loc+4)=numnod
      go to 630
  620 nodplc(loc+4)=nodplc(loc+2)
  630 loc=nodplc(loc)
      go to 610
c
c  transistors
c
  700 loc=locate(12)
  710 if ((loc.eq.0).or.(nodplc(loc+36).ne.0)) go to 800
      nodplc(loc+30)=nodplc(loc+5)
      locm=nodplc(loc+8)
      locm=nodplc(locm+1)
      if (value(locm+16).eq.0.0d0) go to 720
      numnod=numnod+1
      nodplc(loc+6)=numnod
      go to 730
  720 nodplc(loc+6)=nodplc(loc+3)
  730 if (value(locm+20).eq.0.0d0) go to 740
      numnod=numnod+1
      nodplc(loc+5)=numnod
      go to 750
  740 nodplc(loc+5)=nodplc(loc+2)
  750 if (value(locm+19).eq.0.0d0) go to 760
      numnod=numnod+1
      nodplc(loc+7)=numnod
      go to 770
  760 nodplc(loc+7)=nodplc(loc+4)
  770 loc=nodplc(loc)
      go to 710
c
c  jfets
c
  800 loc=locate(13)
  810 if ((loc.eq.0).or.(nodplc(loc+25).ne.0)) go to 900
      locm=nodplc(loc+7)
      locm=nodplc(locm+1)
      if (value(locm+4).eq.0.0d0) go to 820
      numnod=numnod+1
      nodplc(loc+5)=numnod
      go to 830
  820 nodplc(loc+5)=nodplc(loc+2)
  830 if (value(locm+5).eq.0.0d0) go to 840
      numnod=numnod+1
      nodplc(loc+6)=numnod
      go to 850
  840 nodplc(loc+6)=nodplc(loc+4)
  850 loc=nodplc(loc)
      go to 810
c
c  mosfets
c
  900 loc=locate(14)
  910 if (loc.eq.0) go to 1000
      locm=nodplc(loc+8)
      locm=nodplc(locm+1)
      locv=nodplc(loc+1)
      xleff=value(locv+1)-2.0d0*value(locm+28)
      if (xleff.gt.0.0d0) go to 915
      write(iofile,911) value(locv),value(locm)
  911 format('0*error*:  effective channel length of ',a8,' less than ',
     1   'zero.',/' check value of ld for model ',a8)
      if (nodplc(loc+33).ne.0) go to 960
  915 if ((value(locm+7).eq.0.0d0).and.
     1    (value(locm+16).eq.0.0d0)) go to 920
      numnod=numnod+1
      nodplc(loc+6)=numnod
      go to 930
  920 nodplc(loc+6)=nodplc(loc+2)
  930 if ((value(locm+8).eq.0.0d0).and.
     1    (value(locm+16).eq.0.0d0)) go to 940
      numnod=numnod+1
      nodplc(loc+7)=numnod
      go to 950
  940 nodplc(loc+7)=nodplc(loc+4)
  950 ad=value(locv+3)
      as=value(locv+4)
      if ((ad.le.0.0d0).or.(as.le.0.0d0)
     1   .and.value(locm+11).le.0.0d0)
     2   value(locm+11)=1.0d-14
  960 loc=nodplc(loc)
      go to 910
c
c  transmission lines
c
 1000 loc=locate(17)
 1010 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) go to 2000
      numnod=numnod+1
      nodplc(loc+6)=numnod
      numnod=numnod+1
      nodplc(loc+7)=numnod
      loc=nodplc(loc)
      go to 1010
c
c  finished
c
 2000 return
      end

      subroutine setmem(ipntr,ksize)
      implicit double precision (a-h,o-z)
c
c     this routine performs dynamic memory management.  it is used in
c     spice2, and useable in any program.
c
c     memory is managed within an array selected by the calling program.
c     one may either dimension this array to the 'maxmem' size, or more
c     desirably, find the address of the first available word of memory
c     above your program, and dimension your array to '1'.  passing the
c     address of the first data word available permits the manager to
c     use 'illegal' indices into the data area.
c
c     this routine must have access to an integer function called 'locf'
c     which returns the address of its argument.  addresses as used by this
c     program refer to 'integer' addresses, not byte addresses.
c
c entry points:
c      setmem - set initial memory
c      getm4  - get block for table of integers
c      getm8  - get block for table of floating point variables
c      getm16 - get block for table of complex variables
c      relmem - release part of block
c      extmem - extend size of existing block
c      sizmem - determine size of existing block
c      clrmem - release block
c      ptrmem - reset memory pointer
c      crunch - force memory compaction
c      avlm4  - amount of space available (integers)
c      avlm8  - amount of space available (real)
c      avlm16 - amount of space available (complex)
c
c calling sequences:
c      call setmem(imem(1),maxmem)
c      call setmem(imem(1),maxmem,kfamwa)  cdc machines running under
c                                          calidoscope kfamwa is the address
c                                          of the first available word
c      call getm4 (ipntr,blksiz)  where blksize is the number of entries
c      call getm8 (ipntr,blksiz)
c      call getm16(ipntr,blksiz)
c      call relmem(ipntr,relsiz)
c      call extmem(ipntr,extsiz)  extsiz is the number of entries to be added
c      call sizmem(ipntr,blksiz)
c      call clrmem(ipntr)
c      call ptrmem(ipntr1,ipntr2)
c      call avlm4(ispace)
c      call avlm8(ispace)
c      call avlm16(ispace)
c      call crunch
c      call slpmem(ipntr,slpsiz)  express desire for *slpsiz* extra entries
c
c
c general comments:
c      for each block which is allocated, a multi-word entry is maintained
c in a table kept in high memory, of the form
c
c        word      contents
c        ----      --------
c
c          1       index of imem(.) into origin of block
c                    i.e. contents of pointer (used for error check)
c          2       block size (in words)
c          3       number of words in use
c          4       address of variable containing block origin
c          5       number of words used per table entry
c          6       slop size (in words)
c
c      all allocated blocks are an 'even' (nxtevn) number of words in length,
c where a 'word' is the storage unit required for an 'integer' variable.
c      since block repositioning may be necessary, the convention that
c only one variable contain a block origin should be observed.
c      for *getmem*, *ipntr* is set such that *array(ipntr+1)* is the
c first word of the allocated block.  'ipntr' is set to address the first
c entry of the table when used with the appropriate variable type, i.e.,
c nodplc(ipntr+1), value(ipntr+1), or cvalue(ipntr+1).
c      for *clrmem*, *ipntr* is set to 'invalid' to enable rapid detection
c of an attempt to use a cleared block.
c      if any fatal errors are found, a message is printed and a flag
c set inhibiting further action until *setmem* is called.  (in this
c context, insufficient memory is considered a fatal error.)
c      throughout this routine, *ldval* always contains the subscript of
c the last addressable word of memory, *memavl* always contains the
c number of available words of memory, *numblk* always contains the
c number of allocated blocks, and istack(*loctab* +1) always contains
c the first word of the block table.
c
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
      dimension ipntr(1)
c
      logical memptr
      complex cvalue(32)
      equivalence (value(1),cvalue(1))
      external locf
c
c...  approximate time required to copy *nwords* integer values
c
c  nxtevn rounds the number up to the next 'even' value.  the value
c  used for this 'even' number is the smallest number into which one
c  can divide nwd4,nwd8,and nwd16.
c
c
c  nxtmem  returns next higher memory size
c
c
c
c***  setmem - set initial memory
c
      nwd4=1
      nwd8=locf(value(2))-locf(value(1))
      nwd16=locf(cvalue(2))-locf(cvalue(1))
      memerr=0
      nevn=nxtevn(1)
c     check that nxtevn function returns a number divisible by
c     nwd4, nwd8, nwd16; also check that the memory increment
c     nxtmem(.) is an integer multiple of nxtevn(1)
      icheck=mod(nevn,nwd4)+mod(nevn,nwd8)+mod(nevn,nwd16)+
     1  mod(nxtmem(1),nevn)
      if(icheck.eq.0) go to 2
      memerr=1
      call errmem(6,memerr,ipntr(1))
    2 cpyknt=0.0d0
      ifamwa=locf(ipntr(1))
      maxmem=ksize
      ntab=nxtevn(6)
c... add 'lorg' to an address and you get the 'istack' index to that word
      lorg=1-locf(istack(1))
      ifwa=ifamwa+lorg-1
      nwoff=locf(ipntr(1))+lorg-1
      icore=nxtmem(1)
c... don't take chances, back off from 'end of memory' by nxtevn(1)
      ldval=ifwa+nxtmem(1)-nxtevn(1)
      memavl=ldval-ntab-ifwa
      maxcor=0
      maxuse=0
      call memory
      if(memerr.ne.0) call errmem(6,memerr,ipntr(1))
      numblk=1
      loctab=ldval-ntab
      istack(loctab+1)=0
      istack(loctab+2)=memavl
      istack(loctab+3)=0
      istack(loctab+4)=-1
      istack(loctab+5)=1
      istack(loctab+6)=0
      return
      end

      subroutine mosfet
      implicit double precision (a-h,o-z)
c
c     this routine processes mosfets for dc and transient analyses.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=mosarg 3/15/83
      common /mosarg/ vto,beta,gamma,phi,phib,cox,xnsub,xnfs,xd,xj,xld,
     1   xlamda,uo,uexp,vbp,utra,vmax,xneff,xl,xw,vbi,von,vdsat,qspof,
     2   beta0,beta1,cdrain,xqco,xqc,fnarrw,fshort,lev
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=debug 3/15/83
      common/debug/ idebug(20)
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension vbdo(1),vbso(1),vgso(1),vdso(1),cdo(1),cbso(1),cbdo(1),
     1   gmo(1),gdso(1),gmbso(1),gbdo(1),gbso(1),
     2   qb(1),cqb(1),qg(1),cqg(1),qd(1),cqd(1),
     3   cggbo(1),cgdbo(1),cgsbo(1),cbgbo(1),cbdbo(1),cbsbo(1),
     4   cgbo(1),cgdo(1),cgso(1),vono(1),vdsato(1)
      dimension qbd(1),cqbd(1),qbs(1),cqbs(1),
     1          qgs(1),cqgs(1),qgd(1),cqgd(1),qgb(1),cqgb(1)
      equivalence (vbdo (1),value( 1)),(vbso (1),value( 2)),
     1            (vgso (1),value( 3)),(vdso (1),value( 4)),
     2            (cdo  (1),value( 5)),(cbso (1),value( 6)),
     3            (cbdo (1),value( 7)),(gmo  (1),value( 8)),
     4            (gdso (1),value( 9)),(gmbso(1),value(10)),
     5            (gbdo (1),value(11)),(gbso (1),value(12)),
     6            (qb   (1),qgs  ( 1), value(13)),
     7            (cqb  (1),cqgs ( 1), value(14)),
     8            (qg   (1),qgd  ( 1), value(15)),
     9            (cqg  (1),cqgd ( 1), value(16)),
     a            (qd   (1),qgb  ( 1), value(17)),
     b            (cqd  (1),cqgb ( 1), value(18)),
     c            (cggbo(1),cgbo  (1), value(19)),
     d            (cgdbo(1),cgdo  (1), value(20)),
     e            (cgsbo(1),cgso  (1), value(21)),
     f            (cbgbo(1),vono  (1), value(22)),
     g            (cbdbo(1),vdsato(1), value(23)),
     h            (cbsbo(1),           value(24))
      equivalence (qbd  (1),value(25)),(cqbd (1),value(26)),
     1            (qbs  (1),value(27)),(cqbs (1),value(28))
c
c
      loc=locate(14)
   10 if ((loc.eq.0).or.(nodplc(loc+33).ne.0)) return
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      node4=nodplc(loc+5)
      node5=nodplc(loc+6)
      node6=nodplc(loc+7)
      locm=nodplc(loc+8)
      ioff=nodplc(loc+9)
      type=nodplc(locm+2)
      locm=nodplc(locm+1)
      loct=nodplc(loc+26)
c
c  dc model parameters
c
      xj=value(locm+27)
      xld=value(locm+28)
      xl=value(locv+1)-2.0d0*xld
      xw=value(locv+2)
      devmod=value(locv+8)
      vto=type*value(locm+2)
      vdsat=type*value(locv+10)
      vinit=value(locm+43)
      ad=value(locv+3)
      as=value(locv+4)
      pd=value(locv+11)
      ps=value(locv+12)
      if (value(locm+21).eq.0.0d0.
     1   or.ad.eq.0.0d0.or.as.eq.0.0d0) go to 12
      cdsat=value(locm+21)*ad
      cssat=value(locm+21)*as
      go to 15
   12 cdsat=value(locm+11)
      cssat=value(locm+11)
   15 if ((value(locm+7).le.0.0d0).and.
     1              (value(locm+8).le.0.0d0)) go to 17
      gdpr=value(locm+7)
      gspr=value(locm+8)
      go to 19
   17 gdpr=value(locm+16)/value(locv+13)
      gspr=value(locm+16)/value(locv+14)
   19 covlgs=value(locm+13)*xw
      covlgd=value(locm+14)*xw
      covlgb=value(locm+15)*xl
      lev=value(locm+1)
c
c     mos1, mos2 and mos3 model parameters
c
      beta=value(locm+3)*xw/xl
      gamma=value(locm+4)
      phi=value(locm+5)
      xlamda=value(locm+6)
      phib=value(locm+12)
      cox=value(locm+22)*xw*xl
      xnsub=value(locm+23)
      xnfs=value(locm+25)
      uo=value(locm+29)
      vbp=value(locm+30)
      uexp=value(locm+31)
      utra=value(locm+32)
      vbi=type*value(locm+44)
      xd=value(locm+45)
      vmax=value(locm+33)
      xneff=value(locm+34)
      xqco=value(locm+35)
      fnarrw=value(locm+39)
      if (lev.eq.3) fnarrw=fnarrw/xw
c
c     initialization
c
      icheck=1
      ibypas=0
      go to (100,20,30,50,60,70), initf
   20 if (ioff.ne.0) go to 40
      vds=type*value(locv+5)
      vgs=type*value(locv+6)
      vbs=type*value(locv+7)
      if (vds.ne.0.0d0) go to 300
      if (vgs.ne.0.0d0) go to 300
      if (vbs.ne.0.0d0) go to 300
      if ((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 300
      vbs=vinit
      vgs=vto
      vds=0.0d0
      go to 300
   30 if (ioff.eq.0) go to 100
   40 vbs=0.0d0
      vgs=0.0d0
      vds=0.0d0
      go to 300
   50 vbs=vbso(lx0+loct)
      vgs=vgso(lx0+loct)
      vds=vdso(lx0+loct)
      go to 300
   60 vbs=vbso(lx1+loct)
      vgs=vgso(lx1+loct)
      vds=vdso(lx1+loct)
      go to 300
   70 xfact=delta/delold(2)
      vbso(lx0+loct)=vbso(lx1+loct)
      vbs=(1.0d0+xfact)*vbso(lx1+loct)-xfact*vbso(lx2+loct)
      vgso(lx0+loct)=vgso(lx1+loct)
      vgs=(1.0d0+xfact)*vgso(lx1+loct)-xfact*vgso(lx2+loct)
      vdso(lx0+loct)=vdso(lx1+loct)
      vds=(1.0d0+xfact)*vdso(lx1+loct)-xfact*vdso(lx2+loct)
      vbdo(lx0+loct)=vbso(lx0+loct)-vdso(lx0+loct)
      cdo(lx0+loct)=cdo(lx1+loct)
      cbso(lx0+loct)=cbso(lx1+loct)
      cbdo(lx0+loct)=cbdo(lx1+loct)
      gmo(lx0+loct)=gmo(lx1+loct)
      gdso(lx0+loct)=gdso(lx1+loct)
      gmbso(lx0+loct)=gmbso(lx1+loct)
      gbdo(lx0+loct)=gbdo(lx1+loct)
      gbso(lx0+loct)=gbso(lx1+loct)
      cggbo(lx0+loct)=cggbo(lx1+loct)
      cgdbo(lx0+loct)=cgdbo(lx1+loct)
      cgsbo(lx0+loct)=cgsbo(lx1+loct)
      cbgbo(lx0+loct)=cbgbo(lx1+loct)
      cbdbo(lx0+loct)=cbdbo(lx1+loct)
      cbsbo(lx0+loct)=cbsbo(lx1+loct)
      go to 110
c
c  compute new nonlinear branch voltages
c
  100 vbs=type*(value(lvnim1+node4)-value(lvnim1+node6))
      vgs=type*(value(lvnim1+node2)-value(lvnim1+node6))
      vds=type*(value(lvnim1+node5)-value(lvnim1+node6))
  110 vbd=vbs-vds
      vgd=vgs-vds
      vgdo=vgso(lx0+loct)-vdso(lx0+loct)
      delvbs=vbs-vbso(lx0+loct)
      delvbd=vbd-vbdo(lx0+loct)
      delvgs=vgs-vgso(lx0+loct)
      delvds=vds-vdso(lx0+loct)
      delvgd=vgd-vgdo
      if (devmod.lt.0.0d0) go to 120
      cdhat=cdo(lx0+loct)-gbdo(lx0+loct)*delvbd+gmbso(lx0+loct)*delvbs
     1   +gmo(lx0+loct)*delvgs+gdso(lx0+loct)*delvds
      go to 130
  120 cdhat=cdo(lx0+loct)-(gbdo(lx0+loct)-gmbso(lx0+loct))*delvbd
     1   -gmo(lx0+loct)*delvgd+gdso(lx0+loct)*delvds
  130 cbhat=cbso(lx0+loct)+cbdo(lx0+loct)+gbdo(lx0+loct)*delvbd
     1   +gbso(lx0+loct)*delvbs
c
c  bypass if solution has not changed
c
      if (initf.eq.6) go to 200
      tol=reltol*dmax1(dabs(vbs),dabs(vbso(lx0+loct)))+vntol
      if (dabs(delvbs).ge.tol) go to 200
      tol=reltol*dmax1(dabs(vbd),dabs(vbdo(lx0+loct)))+vntol
      if (dabs(delvbd).ge.tol) go to 200
      tol=reltol*dmax1(dabs(vgs),dabs(vgso(lx0+loct)))+vntol
      if (dabs(delvgs).ge.tol) go to 200
      tol=reltol*dmax1(dabs(vds),dabs(vdso(lx0+loct)))+vntol
      if (dabs(delvds).ge.tol) go to 200
      tol=reltol*dmax1(dabs(cdhat),dabs(cdo(lx0+loct)))+abstol
      if (dabs(cdhat-cdo(lx0+loct)).ge.tol) go to 200
      tol=reltol*dmax1(dabs(cbhat),dabs(cbso(lx0+loct)+cbdo(lx0+loct)))
     1   +abstol
      if (dabs(cbhat-(cbso(lx0+loct)+cbdo(lx0+loct))).ge.tol) go to 200
      vbs=vbso(lx0+loct)
      vbd=vbdo(lx0+loct)
      vgs=vgso(lx0+loct)
      vds=vdso(lx0+loct)
      vgd=vgs-vds
      vgb=vgs-vbs
      cd=cdo(lx0+loct)
      cbs=cbso(lx0+loct)
      cbd=cbdo(lx0+loct)
      cdrain=devmod*(cd+cbd)
      gm=gmo(lx0+loct)
      gds=gdso(lx0+loct)
      gmbs=gmbso(lx0+loct)
      gbd=gbdo(lx0+loct)
      gbs=gbso(lx0+loct)
      devmod=value(locv+8)
      if (mode.ne.1) go to 135
      if ((modedc.eq.2).and.(nosolv.ne.0)) go to 135
      if (xqco.gt.0.5d0) go to 742
      go to 850
  135 if (xqco.le.0.5d0) go to 140
      cgb=cgbo(lx0+loct)
      cgd=cgdo(lx0+loct)
      cgs=cgso(lx0+loct)
      vgs1=vgso(lx1+loct)
      vgb1=vgs1-vbso(lx1+loct)
      vgd1=vgs1-vdso(lx1+loct)
      go to 735
  140 cggb=cggbo(lx0+loct)
      cgdb=cgdbo(lx0+loct)
      cgsb=cgsbo(lx0+loct)
      cbgb=cbgbo(lx0+loct)
      cbdb=cbdbo(lx0+loct)
      cbsb=cbsbo(lx0+loct)
      xqc=value(locv+15)
      ibypas=1
      go to 755
c
c  limit nonlinear branch voltages
c
  200 von=type*value(locv+9)
      if (vdso(lx0+loct).lt.0.0d0) go to 205
      call fetlim(vgs,vgso(lx0+loct),von)
      vds=vgs-vgd
      call limvds(vds,vdso(lx0+loct))
      vgd=vgs-vds
      go to 210
  205 call fetlim(vgd,vgdo,von)
      vds=vgs-vgd
      call limvds(-vds,-vdso(lx0+loct))
      vgs=vgd+vds
  210 if (vds.lt.0.0d0) go to 220
      vcrit=vt*dlog(vt/(root2*cssat))
      call pnjlim(vbs,vbso(lx0+loct),vt,vcrit,icheck)
      vbd=vbs-vds
      go to 300
  220 vcrit=vt*dlog(vt/(root2*cdsat))
      call pnjlim(vbd,vbdo(lx0+loct),vt,vcrit,icheck)
      vbs=vbd+vds
c
c  determine dc current and derivatives
c
  300 vbd=vbs-vds
      vgd=vgs-vds
      vgb=vgs-vbs
      if (vbs.gt.0.0d0) go to 310
      gbs=cssat/vt
      cbs=gbs*vbs
      gbs=gbs+gmin
      go to 320
  310 evbs=dexp(vbs/vt)
      gbs=cssat*evbs/vt+gmin
      cbs=cssat*(evbs-1.0d0)
  320 if (vbd.gt.0.0d0) go to 330
      gbd=cdsat/vt
      cbd=gbd*vbd
      gbd=gbd+gmin
      go to 400
  330 evbd=dexp(vbd/vt)
      gbd=cdsat*evbd/vt+gmin
      cbd=cdsat*(evbd-1.0d0)
c
c  compute drain current and derivatives
c
  400 if (vds.lt.0.0d0) go to 450
c
c  normal mode
c
      devmod=1.0d0
      value(locv+8)=devmod
      go to (405,410,415), lev
  405 call moseq1(vds,vbs,vgs,gm,gds,gmbs)
      go to 460
  410 call moseq2(vds,vbs,vgs,gm,gds,gmbs,
     1   qgate,qchan,qbulk,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      go to 460
  415 call moseq3(vds,vbs,vgs,gm,gds,gmbs,
     1   qgate,qchan,qbulk,cggb,cgdb,cgsb,cbgb,cbdb,cbsb)
      go to 460
c
c  inverse mode
c
  450 devmod=-1.0d0
      value(locv+8)=devmod
      go to (452,453,454), lev
  452 call moseq1(-vds,vbd,vgd,gm,gds,gmbs)
      go to 460
  453 call moseq2(-vds,vbd,vgd,gm,gds,gmbs,
     1   qgate,qchan,qbulk,cggb,cgsb,cgdb,cbgb,cbsb,cbdb)
      go to 460
  454 call moseq3(-vds,vbd,vgd,gm,gds,gmbs,
     1   qgate,qchan,qbulk,cggb,cgsb,cgdb,cbgb,cbsb,cbdb)
  460 value(locv+9)=type*von
      value(locv+10)=type*vdsat
      if (xqco.le.0.5d0) value(locv+15)=xqc
c
c  compute equivalent drain current source
c
  490 cd=devmod*cdrain-cbd
      if (mode.ne.1) go to 500
      if ((modedc.eq.2).and.(nosolv.ne.0)) go to 500
      if (initf.eq.4) go to 500
      go to 650
c
c  charge storage elements
c
c.. bulk-drain and bulk-source depletion capacitances
c
  500 czbd=0.0d0
      czbs=0.0d0
      czbdsw=0.0d0
      czbssw=0.0d0
      if ((value(locm+9).eq.0.0d0).or.(value(locm+10).eq.0.0d0))
     1   go to 505
      czbd=value(locm+9)
      czbs=value(locm+10)
      go to 510
  505 if (value(locm+17).eq.0.0d0) go to 510
      czbd=value(locm+17)*ad
      czbs=value(locm+17)*as
  510 if (value(locm+19).eq.0.0d0) go to 515
      czbdsw=value(locm+19)*pd
      czbssw=value(locm+19)*ps
  515 phib=value(locm+12)
      xmj=value(locm+18)
      xmjsw=value(locm+20)
      twop=phib+phib
      fcpb=value(locm+38)
      fcpb2=fcpb*fcpb
      f1=value(locm+40)
      f2=value(locm+41)
      f3=value(locm+42)
      czsf2=czbs/f2
      czswf2=czbssw/f2
      czdf2=czbd/f2
      czdwf2=czbdsw/f2
      if (vbs.ge.fcpb) go to 520
      arg=1.0d0-vbs/phib
      sarg=dexp(-xmj*dlog(arg))
      sargsw=dexp(-xmjsw*dlog(arg))
      qbs(lx0+loct)=phib*(czbs*(1.0d0-arg*sarg)/(1.0d0-xmj)
     1                +czbssw*(1.0d0-arg*sargsw)/(1.0d0-xmjsw))
      capbs=czbs*sarg+czbssw*sargsw
      go to 525
  520 qbs(lx0+loct)=f1*(czbs+czbssw)+f3*(vbs-fcpb)*(czsf2+czswf2)
     1    +(vbs*vbs-fcpb*fcpb)*(czsf2*xmj+czswf2*xmjsw)
      capbs=f3*(czsf2+czswf2)+vbs/phib*(czsf2*xmj+czswf2*xmjsw)
  525 if (vbd.ge.fcpb) go to 530
      arg=1.0d0-vbd/phib
      sarg=dexp(-xmj*dlog(arg))
      sargsw=dexp(-xmjsw*dlog(arg))
      qbd(lx0+loct)=phib*(czbd*(1.0d0-arg*sarg)/(1.0d0-xmj)
     1              +czbdsw*(1.0d0-arg*sargsw)/(1.0d0-xmjsw))
      capbd=czbd*sarg+czbdsw*sargsw
      go to 560
  530 qbd(lx0+loct)=f1*(czbd+czbdsw)+f3*(vbd-fcpb)*(czdf2+czdwf2)
     1    +(vbd*vbd-fcpb*fcpb)*(czdf2*xmj+czdwf2*xmjsw)
      capbd=f3*(czdf2+czdwf2)+vbd/phib*(czdf2*xmj+czdwf2*xmjsw)
c
  560 if (xqco.le.0.5d0) go to 650
      if ((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 650
      if (initf.ne.4) go to 600
      go to 705
c
cc    calculate equivalent conductances and currents for
cc    depletion capacitors
c
  600 if (initf.ne.5) go to 610
      qbd(lx1+loct)=qbd(lx0+loct)
      qbs(lx1+loct)=qbs(lx0+loct)
  610 call intgr8(geq,ceq,capbd,loct+24)
      gbd=gbd+geq
      cbd=cbd+cqbd(lx0+loct)
      cd=cd-cqbd(lx0+loct)
      call intgr8(geq,ceq,capbs,loct+26)
      gbs=gbs+geq
      cbs=cbs+cqbs(lx0+loct)
      if (initf.ne.5) go to 650
      cqbd(lx1+loct)=cqbd(lx0+loct)
      cqbs(lx1+loct)=cqbs(lx0+loct)
c
c  check convergence
c
  650 if (initf.ne.3) go to 660
      if (ioff.ne.0) go to 680
  660 if (icheck.eq.1) go to 670
      tol=reltol*dmax1(dabs(cdhat),dabs(cd))+abstol
      if (dabs(cdhat-cd).ge.tol) go to 670
      tol=reltol*dmax1(dabs(cbhat),dabs(cbs+cbd))+abstol
      if (dabs(cbhat-(cbs+cbd)).le.tol) go to 680
  670 noncon=noncon+1
  680 vbso(lx0+loct)=vbs
      vbdo(lx0+loct)=vbd
      vgso(lx0+loct)=vgs
      vdso(lx0+loct)=vds
      cdo(lx0+loct)=cd
      cbso(lx0+loct)=cbs
      cbdo(lx0+loct)=cbd
      gmo(lx0+loct)=gm
      gdso(lx0+loct)=gds
      gmbso(lx0+loct)=gmbs
      gbdo(lx0+loct)=gbd
      gbso(lx0+loct)=gbs
      if (xqco.le.0.5d0) go to 690
      vono(lx0+loct)=von
      vdsato(lx0+loct)=vdsat
      go to 700
  690 cggbo(lx0+loct)=cggb
      cgdbo(lx0+loct)=cgdb
      cgsbo(lx0+loct)=cgsb
      cbgbo(lx0+loct)=cbgb
      cbdbo(lx0+loct)=cbdb
      cbsbo(lx0+loct)=cbsb
      go to 750
c
c     xqco > 0.5d0 use meyer"s capacitor model
c
  700 if (mode.ne.1) go to 705
      if ((modedc.eq.2).and.(nosolv.ne.0)) go to 705
      if (initf.eq.4) go to 705
      go to 742
c
c     calculate meyer's capacitors
c
  705 von1=von
      vgs1=vgs
      vgd1=vgd
      vgb1=vgs-vbs
      vdsat1=vdsat
      if ((mode.ne.2).or.(initf.eq.5)) go to 710
      von1=vono(lx1+loct)
      vgs1=vgso(lx1+loct)
      vgd1=vgs1-vdso(lx1+loct)
      vgb1=vgs1-vbso(lx1+loct)
      vdsat1=vdsato(lx1+loct)
  710 if (devmod.lt.0.0d0) go to 715
      call cmeyer (vgs1,vgd1,vgb1,von1,vdsat1,vgs,vgd,vgb,
     1   covlgs,covlgd,covlgb,cgs1,cgd1,cgb1,cgs,cgd,cgb)
      go to 720
  715 call cmeyer (vgd1,vgs1,vgb1,von1,vdsat1,vgd,vgs,vgb,
     1   covlgd,covlgs,covlgb,cgd1,cgs1,cgb1,cgd,cgs,cgb)
  720 cgs=0.5d0*(cgs+cgs1)
      cgd=0.5d0*(cgd+cgd1)
      cgb=0.5d0*(cgb+cgb1)
c
c     store small-signal parameters (for meyer"s model)
c
      if (mode.ne.1) go to 730
      if (initf.ne.4) go to 730
      value(lx0+loct+24)=capbd
      value(lx0+loct+26)=capbs
      value(lx0+loct+12)=cgs-covlgs
      value(lx0+loct+14)=cgd-covlgd
      value(lx0+loct+16)=cgb-covlgb
      go to 1000
cc
  730 if (initf.ne.6) go to 735
      qgs(lx0+loct)=(1.0d0+xfact)*qgs(lx1+loct)-xfact*qgs(lx2+loct)
      qgd(lx0+loct)=(1.0d0+xfact)*qgd(lx1+loct)-xfact*qgd(lx2+loct)
      qgb(lx0+loct)=(1.0d0+xfact)*qgb(lx1+loct)-xfact*qgb(lx2+loct)
      go to 745
  735 qgs(lx0+loct)=(vgs-vgs1)*cgs
      qgd(lx0+loct)=(vgd-vgd1)*cgd
      qgb(lx0+loct)=(vgb-vgb1)*cgb
      if((mode.ne.2).or.(initf.eq.5))go to 740
      qgs(lx0+loct)=qgs(lx0+loct)+qgs(lx1+loct)
      qgd(lx0+loct)=qgd(lx0+loct)+qgd(lx1+loct)
      qgb(lx0+loct)=qgb(lx0+loct)+qgb(lx1+loct)
  740 if((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 742
      if (initf.ne.5) go to 745
      qgs(lx0+loct)=cgs*vgs
      qgd(lx0+loct)=cgd*vgd
      qgb(lx0+loct)=cgb*vgb
      qgs(lx1+loct)=qgs(lx0+loct)
      qgd(lx1+loct)=qgd(lx0+loct)
      qgb(lx1+loct)=qgb(lx0+loct)
c
c     initialize to zero charge conductances and current
c
  742 gcgs=0.0d0
      ceqgs=0.0d0
      gcgd=0.0d0
      ceqgd=0.0d0
      gcgb=0.0d0
      ceqgb=0.0d0
      go to  870
cc
 745  if(cgs.eq.0.0d0) value(lx0+loct+13)=0.0d0
      if(cgd.eq.0.0d0) value(lx0+loct+15)=0.0d0
      if(cgb.eq.0.0d0) value(lx0+loct+17)=0.0d0
cc
cc    calculate equivalent conductances and currents for
cc    meyer"s capacitors
cc
      call intgr8(gcgs,ceqgs,cgs,loct+12)
      call intgr8(gcgd,ceqgd,cgd,loct+14)
      call intgr8(gcgb,ceqgb,cgb,loct+16)
      ceqgs=ceqgs-gcgs*vgs+ag(1)*qgs(lx0+loct)
      ceqgd=ceqgd-gcgd*vgd+ag(1)*qgd(lx0+loct)
      ceqgb=ceqgb-gcgb*vgb+ag(1)*qgb(lx0+loct)
      if (initf.ne.5) go to 870
      cqgs(lx1+loct)=cqgs(lx0+loct)
      cqgd(lx1+loct)=cqgd(lx0+loct)
      cqgb(lx1+loct)=cqgb(lx0+loct)
      go to 870
c
c.. bulk and channel charge (plus overlaps)
c
  750 if (mode.ne.1) go to 755
      if ((modedc.eq.2).and.(nosolv.ne.0)) go to 755
      if (initf.eq.4) go to 755
      go to 850
  755 if (devmod.eq.-1.0d0) go to 760
      call moscap(vgd,vgs,vgb,covlgd,covlgs,covlgb,
     1   capbd,capbs,cggb,cgdb,cgsb,cbgb,cbdb,cbsb,
     2   gcggb,gcgdb,gcgsb,gcbgb,gcbdb,gcbsb,
     3   gcdgb,gcddb,gcdsb,gcsgb,gcsdb,gcssb,
     4   qgate,qchan,qbulk,qdrn,qsrc)
      go to 780
  760 call moscap(vgs,vgd,vgb,covlgs,covlgd,covlgb,
     1   capbs,capbd,cggb,cgsb,cgdb,cbgb,cbsb,cbdb,
     2   gcggb,gcgsb,gcgdb,gcbgb,gcbsb,gcbdb,
     3   gcsgb,gcssb,gcsdb,gcdgb,gcdsb,gcddb,
     4   qgate,qchan,qbulk,qsrc,qdrn)
  780 if (ibypas.eq.1) go to 860
      qg(lx0+loct)=qgate
      qd(lx0+loct)=qdrn-qbd(lx0+loct)
      qb(lx0+loct)=qbulk+qbd(lx0+loct)+qbs(lx0+loct)
c
c  store small-signal parameters
c
  790 if ((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 850
      if (initf.ne.4) go to 800
      value(lx0+loct+18)=cggb
      value(lx0+loct+19)=cgdb
      value(lx0+loct+20)=cgsb
      value(lx0+loct+21)=cbgb
      value(lx0+loct+22)=cbdb
      value(lx0+loct+23)=cbsb
      value(lx0+loct+24)=capbd
      value(lx0+loct+26)=capbs
      go to 1000
c
c  transient analysis
c
  800 if (initf.ne.5) go to 810
      qb(lx1+loct)=qb(lx0+loct)
      qg(lx1+loct)=qg(lx0+loct)
      qd(lx1+loct)=qd(lx0+loct)
c.. integrate qb
  810 call intgr8(geq,ceq,0.0d0,loct+12)
c.. integrate qg
      call intgr8(geq,ceq,0.0d0,loct+14)
c.. integrate qd
      call intgr8(geq,ceq,0.0d0,loct+16)
      go to 860
c
c     initialize to zero charge conductances and current
c
  850 ceqqg=0.0d0
      ceqqb=0.0d0
      ceqqd=0.0d0
      gcdgb=0.0d0
      gcddb=0.0d0
      gcdsb=0.0d0
      gcsgb=0.0d0
      gcsdb=0.0d0
      gcssb=0.0d0
      gcggb=0.0d0
      gcgdb=0.0d0
      gcgsb=0.0d0
      gcbgb=0.0d0
      gcbdb=0.0d0
      gcbsb=0.0d0
      go to 900
c
c     evaluate equivalent charge currents
c
  860 cgate=cqg(lx0+loct)
      cqbulk=cqb(lx0+loct)
      cqdrn=cqd(lx0+loct)
      ceqqg=cgate-gcggb*vgb+gcgdb*vbd+gcgsb*vbs
      ceqqb=cqbulk-gcbgb*vgb+gcbdb*vbd+gcbsb*vbs
      ceqqd=cqdrn-gcdgb*vgb+gcddb*vbd+gcdsb*vbs
      if (initf.ne.5) go to 900
      cqb(lx1+loct)=cqb(lx0+loct)
      cqg(lx1+loct)=cqg(lx0+loct)
      cqd(lx1+loct)=cqd(lx0+loct)
      go to 900
c
cc   do the mapping from meyer"s capacitor model into the charge
cc   oriented model
cc
  870 ceqqg=ceqgs+ceqgb+ceqgd
      ceqqb=-ceqgb
      ceqqd=-ceqgd
      gcbdb=0.0d0
      gcbsb=0.0d0
      gcdsb=0.0d0
      gcsdb=0.0d0
      gcgdb=-gcgd
      gcgsb=-gcgs
      gcbgb=-gcgb
      gcdgb=-gcgd
      gcsgb=-gcgs
      gcssb=gcgs
      gcddb=gcgd
      gcggb=gcgd+gcgs+gcgb
c
c     store charge storage info for meyer's cap in lx table
c
      cgbo(lx0+loct)=cgb
      cgso(lx0+loct)=cgs
      cgdo(lx0+loct)=cgd
c
c  load current vector
c
  900 ceqbs=type*(cbs-(gbs-gmin)*vbs)
      ceqbd=type*(cbd-(gbd-gmin)*vbd)
      ceqqg=type*ceqqg
      ceqqb=type*ceqqb
      ceqqd=type*ceqqd
      xnrm=1.0d0
      xrev=0.0d0
      if (devmod.lt.0.0d0) go to 910
      cdreq=type*(cdrain-gds*vds-gm*vgs-gmbs*vbs)
      go to 920
  910 xnrm=0.0d0
      xrev=1.0d0
      cdreq=-type*(cdrain-gds*(-vds)-gm*vgd-gmbs*vbd)
  920 value(lvn+node2)=value(lvn+node2)-ceqqg
      value(lvn+node4)=value(lvn+node4)-ceqbs-ceqbd-ceqqb
      value(lvn+node5)=value(lvn+node5)-cdreq+ceqbd-ceqqd
      value(lvn+node6)=value(lvn+node6)+cdreq+ceqbs
     1   +ceqqg+ceqqb+ceqqd
c
c  load y matrix
c
      locy=lvn+nodplc(loc+27)
      value(locy)=value(locy)+gdpr
      locy=lvn+nodplc(loc+28)
      value(locy)=value(locy)+gcggb
      locy=lvn+nodplc(loc+29)
      value(locy)=value(locy)+gspr
      locy=lvn+nodplc(loc+30)
      value(locy)=value(locy)+gbd+gbs-gcbgb-gcbdb-gcbsb
      locy=lvn+nodplc(loc+31)
      value(locy)=value(locy)+gdpr+gds+gbd+xrev*(gm+gmbs)+gcddb
      locy=lvn+nodplc(loc+32)
      value(locy)=value(locy)+gspr+gds+gbs+xnrm*(gm+gmbs)+gcssb
      locy=lvn+nodplc(loc+10)
      value(locy)=value(locy)-gdpr
      locy=lvn+nodplc(loc+11)
      value(locy)=value(locy)-gcggb-gcgdb-gcgsb
      locy=lvn+nodplc(loc+12)
      value(locy)=value(locy)+gcgdb
      locy=lvn+nodplc(loc+13)
      value(locy)=value(locy)+gcgsb
      locy=lvn+nodplc(loc+14)
      value(locy)=value(locy)-gspr
      locy=lvn+nodplc(loc+15)
      value(locy)=value(locy)+gcbgb
      locy=lvn+nodplc(loc+16)
      value(locy)=value(locy)-gbd+gcbdb
      locy=lvn+nodplc(loc+17)
      value(locy)=value(locy)-gbs+gcbsb
      locy=lvn+nodplc(loc+18)
      value(locy)=value(locy)-gdpr
      locy=lvn+nodplc(loc+19)
      value(locy)=value(locy)+(xnrm-xrev)*gm+gcdgb
      locy=lvn+nodplc(loc+20)
      value(locy)=value(locy)-gbd+(xnrm-xrev)*gmbs-
     1   gcdgb-gcddb-gcdsb
      locy=lvn+nodplc(loc+21)
      value(locy)=value(locy)-gds-xnrm*(gm+gmbs)+gcdsb
      locy=lvn+nodplc(loc+22)
      value(locy)=value(locy)-(xnrm-xrev)*gm+gcsgb
      locy=lvn+nodplc(loc+23)
      value(locy)=value(locy)-gspr
      locy=lvn+nodplc(loc+24)
      value(locy)=value(locy)-gbs-(xnrm-xrev)*gmbs-
     1   gcsgb-gcsdb-gcssb
      locy=lvn+nodplc(loc+25)
      value(locy)=value(locy)-gds-xrev*(gm+gmbs)+gcsdb
 1000 loc=nodplc(loc)
      go to 10
      end

      subroutine getcje
      implicit double precision (a-h,o-z)
c spice version 2g.6  sccsid=cje 3/15/83
      common /cje/ maxtim,itime,icost
      call second(xtime)
      itime=xtime
      return
      end

      subroutine swapij(i1,i2,j1,j2)
      implicit double precision (a-h,o-z)
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c     swap rows i1 and i2
c
      loc1=nodplc(jcpt+i1)
      loc2=nodplc(jcpt+i2)
      nodplc(jcpt+i1)=loc2
      nodplc(jcpt+i2)=loc1
c
c     check if end of row
c
    5 if (loc1.le.0.and.loc2.le.0) go to 80
c
c     check swap type
c
      if (loc1.eq.0) go to 20
      if (loc2.eq.0) go to 10
      if (nodplc(jcolno+loc1)-nodplc(jcolno+loc2)) 10,15,20
   10 ktype=-1
      j=nodplc(jcolno+loc1)
      go to 25
   15 ktype=0
      j=nodplc(jcolno+loc1)
      go to 25
   20 ktype=1
      j=nodplc(jcolno+loc2)
c
c     find pointer to entry (i1,j)
c
   25 loc=j
   30 lsav1=loc
      loc=nodplc(irpt+loc)
      if (loc.eq.0) go to 40
      if ((nodplc(irowno+loc)-i1).lt.0) go to 30
c
c     find pointer to entry (i2,j)
c
   40 loc=j
   45 lsav2=loc
      loc=nodplc(irpt+loc)
      if (loc.eq.0) go to 55
      if ((nodplc(irowno+loc)-i2).lt.0) go to 45
c
c     branch for col j in row i1, in both row i1 and i2, or in row i2
c
   55 if (ktype) 60,70,75
c
c     entry (i1,j)
c
   60 if (lsav1.eq.lsav2) go to 65
      loc=nodplc(irpt+lsav2)
      nodplc(irpt+lsav2)=loc1
      nodplc(irpt+lsav1)=nodplc(irpt+loc1)
      nodplc(irpt+loc1)=loc
   65 nodplc(irowno+loc1)=i2
      loc1=nodplc(jcpt+loc1)
      go to 5
c
c     entries (i1,j) and (i2,j)
c
   70 nodplc(irpt+lsav1)=loc2
      nodplc(irpt+lsav2)=loc1
      loc=nodplc(irpt+loc1)
      nodplc(irpt+loc1)=nodplc(irpt+loc2)
      nodplc(irpt+loc2)=loc
      nodplc(irowno+loc1)=i2
      nodplc(irowno+loc2)=i1
      loc1=nodplc(jcpt+loc1)
      loc2=nodplc(jcpt+loc2)
      go to 5
c
c     entry (i2,j)
c
   75 if (lsav1.eq.lsav2) go to 78
      loc=nodplc(irpt+lsav1)
      nodplc(irpt+lsav1)=loc2
      nodplc(irpt+lsav2)=nodplc(irpt+loc2)
      nodplc(irpt+loc2)=loc
   78 nodplc(irowno+loc2)=i1
      loc2=nodplc(jcpt+loc2)
      go to 5
c
c     swap columns j1 and j2
c
   80 loc1=nodplc(irpt+j1)
      loc2=nodplc(irpt+j2)
      nodplc(irpt+j1)=loc2
      nodplc(irpt+j2)=loc1
c
c     check for end of column
c
   85 if (loc1.le.0.and.loc2.le.0) go to 160
c
c     check swap type
c
      if (loc1.eq.0) go to 100
      if (loc2.eq.0) go to 90
      if (nodplc(irowno+loc1)-nodplc(irowno+loc2)) 90,95,100
   90 ktype=-1
      i=nodplc(irowno+loc1)
      go to 105
   95 ktype=0
      i=nodplc(irowno+loc1)
      go to 105
  100 ktype=1
      i=nodplc(irowno+loc2)
c
c     find pointer to entry (i,j1)
c
  105 loc=i
  110 lsav1=loc
      loc=nodplc(jcpt+loc)
      if (loc.eq.0) go to 120
      if ((nodplc(jcolno+loc)-j1).lt.0) go to 110
c
c     find pointer to entry (i,j2)
c
  120 loc=i
  125 lsav2=loc
      loc=nodplc(jcpt+loc)
      if(loc.eq.0) go to 135
      if ((nodplc(jcolno+loc)-j2).lt.0) go to 125
c
c     branch for row i in col j1, in both col"s j1 and j2, or in col j2
c
  135 if (ktype) 140,150,155
c
c     entry (i,j1)
c
  140 if (lsav1.eq.lsav2) go to 145
      loc=nodplc(jcpt+lsav2)
      nodplc(jcpt+lsav2)=loc1
      nodplc(jcpt+lsav1)=nodplc(jcpt+loc1)
      nodplc(jcpt+loc1)=loc
  145 nodplc(jcolno+loc1)=j2
      loc1=nodplc(irpt+loc1)
      go to 85
c
c     entries (i1,j) and (i2,j)
c
  150 nodplc(jcpt+lsav1)=loc2
      nodplc(jcpt+lsav2)=loc1
      loc=nodplc(jcpt+loc1)
      nodplc(jcpt+loc1)=nodplc(jcpt+loc2)
      nodplc(jcpt+loc2)=loc
      nodplc(jcolno+loc1)=j2
      nodplc(jcolno+loc2)=j1
      loc1=nodplc(irpt+loc1)
      loc2=nodplc(irpt+loc2)
      go to 85
c
c     entry (i,j2)
c
  155 if (lsav1.eq.lsav2) go to 158
      loc=nodplc(jcpt+lsav1)
      nodplc(jcpt+lsav1)=loc2
      nodplc(jcpt+lsav2)=nodplc(jcpt+loc2)
      nodplc(jcpt+loc2)=loc
  158 nodplc(jcolno+loc2)=j1
      loc2=nodplc(irpt+loc2)
      go to 85
  160 return
      end

      subroutine memadj
      implicit double precision (a-h,o-z)
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
   50 maxuse=max0(maxuse,(ldval-memavl-ifwa))
      memdec=2*nxtmem(1)
      if (memavl.lt.memdec) return
c...  compress current allocations of memory
      call comprs(0,ldval)
c...  adjust memory size
      memdel=0
   60 icore=icore-memdec
      memdel=memdel+memdec
      memavl=memavl-memdec
      if (memavl.ge.memdec) go to 60
      ltab1=ldval-ntab
      istack(ltab1+2)=istack(ltab1+2)-memdel
c...  relocate block entry table
      nwords=numblk*ntab
      cpyknt=cpyknt+dble(nwords)
      call copy4(istack(loctab+1),istack(loctab-memdel+1),nwords)
      loctab=loctab-memdel
      ldval=ldval-memdel
      call memory
      return
      end

      subroutine outnam(loc,ktype,string,ipos)
      implicit double precision (a-h,o-z)
c
c     this routine constructs the 'name' for the output variable indi-
c cated by loc, adding the characters to the character array 'string',
c beginning with the position marked by ipos.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
      dimension string(1)
      dimension aout(19),lenout(19),aopt(5),lenopt(5)
      data aout / 6hv     , 6hvm    , 6hvr    , 6hvi    , 6hvp    ,
     1            6hvdb   , 6hi     , 6him    , 6hir    , 6hii    ,
     2            6hip    , 6hidb   , 6honoise, 6hinoise, 6hhd2   ,
     1            6hhd3   , 6hdim2  , 6hsim2  , 6hdim3   /
      data lenout / 1,2,2,2,2,3,1,2,2,2,2,3,6,6,3,3,4,4,4 /
      data aopt / 5hmag  , 5hreal , 5himag , 5hphase, 5hdb    /
      data lenopt / 3,4,4,5,2 /
      data alprn, acomma, arprn, ablnk / 1h(, 1h,, 1h), 1h  /
c
c
      ioutyp=nodplc(loc+5)
      if (ioutyp.ge.2) go to 10
      lout=ktype+ioutyp*6
      go to 20
   10 lout=ioutyp+11
   20 call move(string,ipos,aout(lout),1,lenout(lout))
      ipos=ipos+lenout(lout)
      if (ioutyp.ge.2) go to 200
      call move(string,ipos,alprn,1,1)
      ipos=ipos+1
      if (ioutyp.ne.0) go to 100
      node1=nodplc(loc+2)
      call alfnum(nodplc(junode+node1),string,ipos)
      node2=nodplc(loc+3)
      if (node2.eq.1) go to 30
      call move(string,ipos,acomma,1,1)
      ipos=ipos+1
      call alfnum(nodplc(junode+node2),string,ipos)
   30 call move(string,ipos,arprn,1,1)
      ipos=ipos+1
      go to 1000
c
  100 locv=nodplc(loc+1)
      anam=value(locv)
      achar=ablnk
      do 110 i=1,8
      call move(achar,1,anam,i,1)
      if (achar.eq.ablnk) go to 120
      call move(string,ipos,achar,1,1)
      ipos=ipos+1
  110 continue
  120 call move(string,ipos,arprn,1,1)
      ipos=ipos+1
      go to 1000
c
  200 if (ktype.eq.1) go to 1000
      call move(string,ipos,alprn,1,1)
      ipos=ipos+1
      call move(string,ipos,aopt(ktype-1),1,lenopt(ktype-1))
      ipos=ipos+lenopt(ktype-1)
      call move(string,ipos,arprn,1,1)
      ipos=ipos+1
c
c  finished
c
 1000 return
      end

      subroutine shlsrt(a,n)
      implicit double precision (a-h,o-z)
c
c     this routine sorts the array a using a shell sort algorithm.
c
      dimension a(n)
      integer h
c
c
c...  compute best starting step size
      h=1
   10 h=3*h+1
      if (h.lt.n) go to 10
c...  back off two times
      h=(h-1)/3
      h=(h-1)/3
      h=max0(h,1)
c
c  shell sort
c
   20 j=h+1
      go to 60
   30 i=j-h
c...  ak = record key;  ar = record
      ak=a(j)
      ar=ak
   40 if (ak.ge.a(i)) go to 50
      a(i+h)=a(i)
      i=i-h
      if (i.ge.1) go to 40
   50 a(i+h)=ar
      j=j+1
   60 if (j.le.n) go to 30
      h=(h-1)/3
      if (h.ne.0) go to 20
      return
      end

      subroutine update(vinit,loct,node1,node2,nupda,icheck)
      implicit double precision (a-h,o-z)
c
c     this routine updates and limits the controlling variables for the
c nonlinear controlled sources.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      go to (40,10,40,20,30,50), initf
   10 vnew=vinit
      go to 70
   20 vnew=value(lx0+loct)
      go to 70
   30 vnew=value(lx1+loct)
      go to 70
   40 vnew=value(lvnim1+node1)-value(lvnim1+node2)
      go to 60
   50 call copy8(value(lx1+loct),value(lx0+loct),nupda)
      xfact=delta/delold(2)
      vnew=(1.0d0+xfact)*value(lx1+loct)-xfact*value(lx2+loct)
   60 if (dabs(vnew).le.1.0d0) go to 80
      delv=vnew-value(lx0+loct)
      if (dabs(delv).le.0.1d0) go to 80
      vlim=dmax1(dabs(0.1d0*value(lx0+loct)),0.1d0)
      vnew=value(lx0+loct)+dsign(dmin1(dabs(delv),vlim),delv)
      go to 70
   70 icheck=1
   80 value(lx0+loct)=vnew
      return
      end

      subroutine slpmem(ipntr,ksize)
      implicit double precision (a-h,o-z)
c
c      this routine may be used to define a certain amount of `slop' to
c be associated with a particular table managed by the memory manager.
c this *slop* is defined as a number of entries in the table for which
c space is to be held ***if possible*** during compaction of the managed
c area of memory.  this feature can eliminate the overhead incurred by
c alternatively extending more than one table at a time.  (for example,
c if the program contains a code sequence
c
c                  do 100 i=1,500
c                     ...
c                  call extmem(table1,1)
c                     ...
c                  call extmem(table2,1)
c                     ...
c              100 continue
c
c then the overhead incurred by this memory manager can be reduced to
c essentially nothing if prior to the above code sequence the program
c executes
c
c                  call slpmem(table1,20)
c                  call slpmem(table2,20)
c
c where `20' is a typical number (for the above example, the memory-to-
c memory copying overhead of the memory manager would be reduced by a
c factor of 20).
c
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
      dimension ipntr(1)
      islp=nxtevn(ksize)
      call extmem(ipntr,islp)
      islp=islp*istack(ltab+5)
      istack(ltab+3)=istack(ltab+3)-islp
      memavl=memavl+istack(ltab+6)
      istack(ltab+6)=islp
      return
      end

c spice version 2g.6  sccsid=root.ma 3/15/83
      program spice
c...  cray notes:
c.. change data filnam to 5lspice
c.. change call overlay .. remove last zero
c.. change ??????program to subroutine in all but this overlay
c.. delete overlay spice,0,0 card below
c..
      implicit double precision (a-h,o-z)
c
c
c spice version 2g.6  sccsid=root.ma 3/15/83
c
c     spice is an electronic circuit simulation program that was deve-
c loped by the integrated circuits group of the electronics research
c laboratory and the department of electrical engineering and computer
c sciences at the university of california, berkeley, california.  the
c program spice is available free of charge to any interested party.
c the sale, resale, or use of this program for profit without the
c express written consent of the department of electrical engineering
c and computer sciences, university of california, berkeley, california,
c is forbidden.
c
c
c     the present version is based on the spice2 program versions 2e.3
c and 2f.1 developed at the university of california berkeley and the
c hewlett-packard spice version 2.7.
c     this version is designed to be transportable on most computers
c with an ansi fortran compiler and enough memory space for code and
c data. the memory manager uses the function 'locf' to find the
c address of a pointer; this function must be provided.
c
c
c implementation notes:
c
c     subroutines mclock and mdate return the time (as hh:mm:ss) and
c the date (as dd mmm yy), respectively.  subroutine getcje returns in
c common block /cje/ various attributes of the current job environment.
c spice expects getcje to set /cje/ variables maxtim, itime, and icost.
c maxtim is the maximum cpu time in seconds, itime is the elapsed cpu
c time in seconds, and icost is the job cost in cents.
c subroutine memory is used to change the number of memory words
c allocated to spice.  if the amount of memory allocated to a jobstep
c is fixed, subroutine memory need not be changed.
c     subroutine second(t) returns the time in seconds and is used
c for timing purposes. it must be provided where not available.
c     ifamwa (set in a data statement below) should be set to the
c address of the first available word of memory (following overlays, if
c any).  the proper value should be easily obtainable from any load map.
c ifamwa is used only on computers where the program (spice) can change
c the allocated memory dynamically at run time according to circuit size.
c (see also comments under subroutine setmem).
c     all berkeley spice2.f release versions do not implement the ifamwa
c feature due to its dependence on operating system.
c     with the exception of most flags, all data in spice are stored in
c the form of managed tables allocated in the /blank/ array value().
c array value() can be redimensioned in the main program according to
c memory availability at each user site. it should be noted again that
c the program dynamically manages its data within the bounds of array
c value().
c     the vax release versions assume the virtual memory feature and
c dimension value() to 200,000 double precision words.
c     the cdc and ibm versions dimension value() to 20000 real or
c real*8 words, respectively.
c     spice is particularly well-suited to being run using a one-level
c overlay structure beginning with routines spice (the overlay root),
c readin, errchk, setup, dctran, dcop, acan, and ovtpvt.  the order of
c the routines in this listing corresponds to that structure.  note
c that if cdc explicit overlaying is to be used, an overlay directive
c card must be inserted before the first line of each of the just-named
c routines.
c
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=miscel 3/15/83
      common /miscel/ atime,aprog(3),adate,atitle(10),defl,defw,defad,
     1  defas,rstats(50),iwidth,lwidth,nopage
c spice version 2g.6  sccsid=line 3/15/83
      common /line/ achar,afield(15),oldlin(15),kntrc,kntlim
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=mosarg 3/15/83
      common /mosarg/ vto,beta,gamma,phi,phib,cox,xnsub,xnfs,xd,xj,xld,
     1   xlamda,uo,uexp,vbp,utra,vmax,xneff,xl,xw,vbi,von,vdsat,qspof,
     2   beta0,beta1,cdrain,xqco,xqc,fnarrw,fshort,lev
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=flags 3/15/83
      common /flags/ iprnta,iprntl,iprntm,iprntn,iprnto,limtim,limpts,
     1   lvlcod,lvltim,itl1,itl2,itl3,itl4,itl5,itl6,igoof,nogo,keof
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=memmgr 3/15/83
      common /memmgr/ cpyknt,istack(1),lorg,icore,maxcor,maxuse,memavl,
     1   ldval,numblk,loctab,ltab,ifwa,nwoff,ntab,maxmem,memerr,nwd4,
     2   nwd8,nwd16
c spice version 2g.6  sccsid=dc 3/15/83
      common /dc/ tcstar(2),tcstop(2),tcincr(2),icvflg,itcelm(2),kssop,
     1   kinel,kidin,kovar,kidout
c spice version 2g.6  sccsid=ac 3/15/83
      common /ac/ fstart,fstop,fincr,skw2,refprl,spw2,jacflg,idfreq,
     1   inoise,nosprt,nosout,nosin,idist,idprt
c spice version 2g.6  sccsid=tran 3/15/83
      common /tran/ tstep,tstop,tstart,delmax,tdmax,forfre,jtrflg
c spice version 2g.6  sccsid=outinf 3/15/83
      common /outinf/ xincr,string(15),xstart,yvar(8),itab(8),itype(8),
     1   ilogy(8),npoint,numout,kntr,numdgt
c spice version 2g.6  sccsid=cje 3/15/83
      common /cje/ maxtim,itime,icost
c spice version 2g.6  sccsid=debug 3/15/83
      common/debug/ idebug(20)
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
c
      dimension acctit(4)
      dimension remain(4)
      data ablnk /1h  /
      data acctit / 8hjob stat, 8histics s, 8hummary  , 8h         /
      data ahdr1,ahdr2,ahdr3 / 8h  spice ,8h2g.6    ,8h3/15/83     /
c
c
      ipostp=0
c     check if a raw data file should be written
c     open file if so required
      if  (iargc().gt.0) ipostp=iopraw()
      maxmem=2*200000
      maxtim=1e8
      icost=0
      iofile=6
c
c  initialization
c
      aprog(1)=ahdr1
      aprog(2)=ahdr2
      aprog(3)=ahdr3
      achar=ablnk
      keof=0
      call xtime(atime)
      call xdate(adate)
      boltz=1.3806226d-23
      charge=1.6021918d-19
      ctok=273.15d0
      eps0=8.854214871d-12
      epssil=11.7d0*eps0
      epsox=3.9d0*eps0
      twopi=8.0d0*datan2(1.0d0,1.0d0)
      rad=360.0d0/twopi
      xlog2=dlog(2.0d0)
      xlog10=dlog(10.0d0)
      root2=dsqrt(2.0d0)
      nodata=1
c
c  begin job
c
   10 if (keof.eq.1) go to 1000
      call getcje
      call second(time1)
      icost1=icost
      igoof=0
      mode=0
      nogo=0
      call setmem(nodplc(1),maxmem)
      if (nogo.ne.0) go to 1000
      call zero8(rstats,50)
c
c  read remainder of data deck and check for input errors
c
      call readin
      if (nogo.ne.0) go to 300
      if (keof.eq.1) go to 1000
      nodata=0
   50 call errchk
      if (nogo.ne.0) go to 300
      call setup
      if (nogo.ne.0) go to 300
c
c  change parameters and re-analisis
c
      if (numcyc.eq.0) go to 90
   70 if (numcyc.ge.numalt) go to 310
      numcyc=numcyc+1
      call alter
      if (nogo.ne.0) go to 305
c
c  cycle through temperatures
c
   90 itemno=1
      if (numtem.eq.1) go to 110
  100 if (itemno.eq.numtem) go to 70
      itemno=itemno+1
      call tmpupd
c
c  dc transfer curves
c
  110 if (icvflg.eq.0) go to 150
c...  see routine *dctran* for explanation of *mode*, etc.
      mode=1
      modedc=3
      call dctran
      call ovtpvt
      if (nogo.ne.0) go to 300
c
c  small signal operating point
c
  150 if (kssop.gt.0) go to 170
      if (jacflg.ne.0) go to 170
      if ((icvflg+jtrflg).gt.0) go to 250
  170 mode=1
      modedc=1
      call dctran
      if (nogo.ne.0) go to 300
      call dcop
      if (nogo.ne.0) go to 300
c
c  ac small signal analysis
c
  200 if (jacflg.eq.0) go to 250
      mode=3
      call acan
      call ovtpvt
      if (nogo.ne.0) go to 300
c
c  transient analysis
c
  250 if (jtrflg.eq.0) go to 100
      mode=1
      modedc=2
      call dctran
      if (nogo.ne.0) go to 300
      call dcop
      if (nogo.ne.0) go to 300
      mode=2
      call dctran
      call ovtpvt
      if (nogo.ne.0) go to 300
      go to 100
c
c  job concluded
c
  300 write (iofile,301)
  301 format(1h0,9x,'***** job aborted')
      nodata=0
      go to 320
  305 write (iofile,306)
  306 format (1h0,9x,'***** this parameter change is illegal')
  310 write (iofile,311)
  311 format(1h0,/,9x,'job concluded')
c
c  job accounting
c
  320 continue
      numel=0
      do 360 i=1,18
  360 numel=numel+jelcnt(i)
      numtem=max0(numtem-1,1)
      idist=min0(idist,1)
      if (iprnta.eq.0) go to 800
      call title(-1,lwidth,1,acctit)
      write (iofile,361) nunods,ncnods,numnod,numel,(jelcnt(i),i=11,14)
  361 format('   nunods ncnods numnod numel  diodes  bjts  jfets  mfets'
     1   //,i9,2i7,i6,i8,i6,2i7)
      write (iofile,371) numtem,icvflg,jtrflg,jacflg,inoise,idist,nogo
  371 format(/'0  numtem icvflg jtrflg jacflg inoise  idist   nogo'/,
     1   2h0 ,7i7)
      write (iofile,381) rstats(20),rstats(21),rstats(22),rstats(23),
     1   rstats(26),rstats(27)
  381 format(/'0  nstop   nttbr   nttar   ifill    iops    perspa'//,
     1   1x,5f8.0,f9.3)
      write (iofile,391) rstats(30),rstats(31),rstats(32),maxmem,maxuse,
     1   cpyknt
  391 format(/'0  numttp  numrtp  numnit  maxmem  memuse  copyknt',//,
     1   2x,3f8.0,2x,i6,2x,i6,2x,f8.0)
      write (iofile,401) (rstats(i),i=1,6),rstats(50),rstats(49),
     1   rstats(46),(rstats(i),i=7,11)
  401 format(/,
     1   1h0,9x,'readin  ',12x,f10.2/,
     2   1h0,9x,'setup   ',12x,f10.2/,
     3   1h0,9x,'trcurv  ',12x,f10.2,10x,f6.0/,
     4   1h0,9x,'dcan    ',12x,f10.2,10x,f6.0/,
     5   1h0,9x,'dcdcmp  ',12x,f10.3,10x,f6.0/,
     6   1h0,9x,'dcsol   ',12x,f10.3/,
     7   1h0,9x,'acan    ',12x,f10.2,10x,f6.0/,
     8   1h0,9x,'tranan  ',12x,f10.2,10x,f6.0/,
     9   1h0,9x,'output  ',12x,f10.2)
      write (iofile,402) rstats(45),rstats(48),rstats(47),rstats(44),
     1   rstats(43)
  402 format(
     1   1h0,9x,'load    ',12x,f10.3/,
     2   1h0,9x,'codgen  ',12x,f10.3,10x,f6.0/,
     3   1h0,9x,'codexc  ',12x,f10.3/,
     4   1h0,9x,'macins  ',12x,f10.3)
  800 call getcje
      call second(time2)
      et=time2-time1
      tcost=dble(icost-icost1)/100.0d0
      if (iprnta.eq.0) go to 810
      ohead=et-(rstats(1)+rstats(2)+rstats(3)+rstats(5)+rstats(7)
     1   +rstats(9)+rstats(11))
      write (iofile,801) ohead
  801 format(1h0,9x,'overhead',12x,f10.2)
  810 write (iofile,811) et
  811 format(1h0,9x,'total job time      ',f10.2)
      rstats(33)=cpyknt
      rstats(34)=et
      rstats(35)=tcost
      rstats(36)=ohead
  900 if ((maxtim-itime).ge.limtim) go to 10
      write (iofile,901)
  901 format('1warning:  further analysis stopped due to cpu time limit'
     1/)
 1000 if(nodata.ne.0) write(iofile,1001)
 1001 format(/1x,'input deck (file) contains no data.')
      stop
      end

      subroutine diode
      implicit double precision (a-h,o-z)
c
c     this routine processes diodes for dc and transient analyses.
c
c spice version 2g.6  sccsid=tabinf 3/15/83
      common /tabinf/ ielmnt,isbckt,nsbckt,iunsat,nunsat,itemps,numtem,
     1   isens,nsens,ifour,nfour,ifield,icode,idelim,icolum,insize,
     2   junode,lsbkpt,numbkp,iorder,jmnode,iur,iuc,ilc,ilr,numoff,isr,
     3   nmoffc,iseq,iseq1,neqn,nodevs,ndiag,iswap,iequa,macins,lvnim1,
     4   lx0,lvn,lynl,lyu,lyl,lx1,lx2,lx3,lx4,lx5,lx6,lx7,ld0,ld1,ltd,
     5   imynl,imvn,lcvn,nsnod,nsmat,nsval,icnod,icmat,icval,
     6   loutpt,lpol,lzer,irswpf,irswpr,icswpf,icswpr,irpt,jcpt,
     7   irowno,jcolno,nttbr,nttar,lvntmp
c spice version 2g.6  sccsid=cirdat 3/15/83
      common /cirdat/ locate(50),jelcnt(50),nunods,ncnods,numnod,nstop,
     1   nut,nlt,nxtrm,ndist,ntlin,ibr,numvs,numalt,numcyc
c spice version 2g.6  sccsid=status 3/15/83
      common /status/ omega,time,delta,delold(7),ag(7),vt,xni,egfet,
     1   xmu,sfactr,mode,modedc,icalc,initf,method,iord,maxord,noncon,
     2   iterno,itemno,nosolv,modac,ipiv,ivmflg,ipostp,iscrch,iofile
c spice version 2g.6  sccsid=knstnt 3/15/83
      common /knstnt/ twopi,xlog2,xlog10,root2,rad,boltz,charge,ctok,
     1   gmin,reltol,abstol,vntol,trtol,chgtol,eps0,epssil,epsox,
     2   pivtol,pivrel
c spice version 2g.6  sccsid=blank 3/15/83
      common /blank/ value(200000)
      integer nodplc(64)
      complex cvalue(32)
      equivalence (value(1),nodplc(1),cvalue(1))
c
c
      dimension vdo(1),cdo(1),gdo(1),qd(1),cqd(1)
      equivalence (vdo(1),value(1)),(cdo(1),value(2)),
     1   (gdo(1),value(3)),(qd(1),value(4)),(cqd(1),value(5))
c
c
      loc=locate(11)
   10 if ((loc.eq.0).or.(nodplc(loc+16).ne.0)) return
      locv=nodplc(loc+1)
      node1=nodplc(loc+2)
      node2=nodplc(loc+3)
      node3=nodplc(loc+4)
      locm=nodplc(loc+5)
      ioff=nodplc(loc+6)
      locm=nodplc(locm+1)
      loct=nodplc(loc+11)
c
c  dc model parameters
c
      area=value(locv+1)
      csat=value(locm+1)*area
      gspr=value(locm+2)*area
      vte=value(locm+3)*vt
      bv=value(locm+13)
      vcrit=value(locm+18)
c
c  initialization
c
      icheck=1
      go to (100,20,30,50,60,70),initf
   20 if(mode.ne.1.or.modedc.ne.2.or.nosolv.eq.0) go to 25
      vd=value(locv+2)
      go to 300
   25 if(ioff.ne.0) go to 40
      vd=vcrit
      go to 300
   30 if (ioff.eq.0) go to 100
   40 vd=0.0d0
      go to 300
   50 vd=vdo(lx0+loct)
      go to 300
   60 vd=vdo(lx1+loct)
      go to 300
   70 xfact=delta/delold(2)
      vdo(lx0+loct)=vdo(lx1+loct)
      vd=(1.0d0+xfact)*vdo(lx1+loct)-xfact*vdo(lx2+loct)
      cdo(lx0+loct)=cdo(lx1+loct)
      gdo(lx0+loct)=gdo(lx1+loct)
      go to 110
c
c  compute new nonlinear branch voltage
c
  100 vd=value(lvnim1+node3)-value(lvnim1+node2)
  110 delvd=vd-vdo(lx0+loct)
      cdhat=cdo(lx0+loct)+gdo(lx0+loct)*delvd
c
c  bypass if solution has not changed
c
      if (initf.eq.6) go to 200
      tol=reltol*dmax1(dabs(vd),dabs(vdo(lx0+loct)))+vntol
      if (dabs(delvd).ge.tol) go to 200
      tol=reltol*dmax1(dabs(cdhat),dabs(cdo(lx0+loct)))+abstol
      if (dabs(cdhat-cdo(lx0+loct)).ge.tol) go to 200
      vd=vdo(lx0+loct)
      cd=cdo(lx0+loct)
      gd=gdo(lx0+loct)
      go to 800
c
c  limit new junction voltage
c
  200 vlim=vte+vte
      if(bv.eq.0.0d0) go to 205
      if (vd.lt.dmin1(0.0d0,-bv+10.0d0*vte)) go to 210
  205 call pnjlim(vd,vdo(lx0+loct),vte,vcrit,icheck)
      go to 300
  210 vdtemp=-(vd+bv)
      call pnjlim(vdtemp,-(vdo(lx0+loct)+bv),vte,vcrit,icheck)
      vd=-(vdtemp+bv)
c
c  compute dc current and derivitives
c
  300 if (vd.lt.-5.0d0*vte) go to 310
      evd=dexp(vd/vte)
      cd=csat*(evd-1.0d0)+gmin*vd
      gd=csat*evd/vte+gmin
      go to 330
  310 if(bv.eq.0.0d0) go to 315
      if(vd.lt.-bv) go to 320
  315 gd=-csat/vd+gmin
      cd=gd*vd
      go to 330
  320 evrev=dexp(-(bv+vd)/vt)
      cd=-csat*(evrev-1.0d0+bv/vt)
      gd=csat*evrev/vt
  330 if (mode.ne.1) go to 500
      if ((modedc.eq.2).and.(nosolv.ne.0)) go to 500
      if (initf.eq.4) go to 500
      go to 700
c
c  charge storage elements
c
  500 tau=value(locm+4)
      czero=value(locm+5)*area
      pb=value(locm+6)
      xm=value(locm+7)
      fcpb=value(locm+12)
      if (vd.ge.fcpb) go to 510
      arg=1.0d0-vd/pb
      sarg=dexp(-xm*dlog(arg))
      qd(lx0+loct)=tau*cd+pb*czero*(1.0d0-arg*sarg)/(1.0d0-xm)
      capd=tau*gd+czero*sarg
      go to 520
  510 f1=value(locm+15)
      f2=value(locm+16)
      f3=value(locm+17)
      czof2=czero/f2
      qd(lx0+loct)=tau*cd+czero*f1+czof2*(f3*(vd-fcpb)
     1   +(xm/(pb+pb))*(vd*vd-fcpb*fcpb))
      capd=tau*gd+czof2*(f3+xm*vd/pb)
c
c  store small-signal parameters
c
  520 if ((mode.eq.1).and.(modedc.eq.2).and.(nosolv.ne.0)) go to 700
      if (initf.ne.4) go to 600
      value(lx0+loct+4)=capd
      go to 1000
c
c  transient analysis
c
  600 if (initf.ne.5) go to 610
      qd(lx1+loct)=qd(lx0+loct)
  610 call intgr8(geq,ceq,capd,loct+3)
      gd=gd+geq
      cd=cd+cqd(lx0+loct)
      if (initf.ne.5) go to 700
      cqd(lx1+loct)=cqd(lx0+loct)
c
c  check convergence
c
  700 if (initf.ne.3) go to 710
      if (ioff.eq.0) go to 710
      go to 750
  710 if (icheck.eq.1) go to 720
      tol=reltol*dmax1(dabs(cdhat),dabs(cd))+abstol
      if (dabs(cdhat-cd).le.tol) go to 750
  720 noncon=noncon+1
  750 vdo(lx0+loct)=vd
      cdo(lx0+loct)=cd
      gdo(lx0+loct)=gd
c
c  load current vector
c
  800 cdeq=cd-gd*vd
      value(lvn+node2)=value(lvn+node2)+cdeq
      value(lvn+node3)=value(lvn+node3)-cdeq
c
c  load matrix
c
      locy=lvn+nodplc(loc+13)
      value(locy)=value(locy)+gspr
      locy=lvn+nodplc(loc+14)
      value(locy)=value(locy)+gd
      locy=lvn+nodplc(loc+15)
      value(locy)=value(locy)+gd+gspr
      locy=lvn+nodplc(loc+7)
      value(locy)=value(locy)-gspr
      locy=lvn+nodplc(loc+8)
      value(locy)=value(locy)-gd
      locy=lvn+nodplc(loc+9)
      value(locy)=value(locy)-gspr
      locy=lvn+nodplc(loc+10)
      value(locy)=value(locy)-gd
 1000 loc=nodplc(loc)
      go to 10
      end
